#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####
#
# File modified by Nicolas Schmeltz for Abtey Productions
#
# 02/10/2003 : add 'remise_defaut' and 'clientresponsable'
#
#####




#appeller de l'ecran facture qd on cliq sur l'un
#des 3 boutons de la liste des factures fait par login.cgi
#gere edition, supp et 1er ecran de modif des factures

=pod
	pour modifier ou creer une facture	
=cut

BEGIN {
  unshift @INC, '../lib', '../html';	
}

use strict ;
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Articles;

#print header,start_html(-BGCOLOR => "#ffffff");

#traitement para
my @param=param();

#si pas de para, on quitte
if(!@param){
	print redirect("$CGIADR/login.cgi");
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"

my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;

#pour les factures
if(param('numfact')){$para{'numfact'} =param('numfact');}
#pour les commandes
if(param("toupdate")){$para{"toupdate"} = param("toupdate");}
#pour la transormation propal en commandes
if(param("idpropal")){$para{"idpropal"} = param("idpropal");}
#pour creation d'un client utilisateur
if(param("userid")){$para{"userid"} = param("userid");}


#declaration variables
my $mess='';
my $idmodfam=0;
my $idmodunit=0;
my $ligfamart=0;#les familles d'article
my $ligunit=0;#les units
 

#declaration variables
#recup para		
my $idartic=param("idartic") || 0;
my $login=param("username");
my $type=param("usertype");
my $script = param('script') || 'articles';


#si $idartic et le article $idartic existe pas, il faut traiter
if($idartic && !&compte("idartic","article","idartic = $idartic")){
	print redirect("$CGIADR/articles.cgi?idmod=$idartic&username=$login&usertype=$type&$ch");
	exit(0);
}

#userid de user de la personne connectee
my ($persouserid) = &select_une_lig("userid","utilisateur","userlogin = '$login'");

#maj bdd

#modifier un article
=pod
if(param('modif')){
	$idartic=param('modif');
}
=cut


#suppression d'une famille 
if(param('supp')){
	my $supp=param('supp');
	my ($codfam) = &select_une_lig("codfam","famart","idfamart = '$supp'");
	if(&compte("codfam","article","codfam  = '$codfam'")){
	    #$para{'notexiste'} = $supp;
		$mess = $messfamartsuppnook;
		$supp = 0;
	}
	else{
		&supp("idfamart = $supp",'famart');
		$mess = $messligsuppok;
	}
}

#suppression d'une unit
if(param('suppunit')){
	my $supp=param('suppunit');
	my ($codunit) = &select_une_lig("codunit","unite","idunit = '$supp'");
	print STDERR "$codunit\t$supp\n";
	if(&compte("codunit","article","codunit  = '$codunit'")){
	    #$para{'notexiste'} = $supp;
		$mess = $messunitsuppnook;
		$supp = 0;
	}
	else{
		&supp("idunit = $supp",'unite');
		$mess = $messunitsupp;
	}
}

#affichage permission modif famille
if(param('mod')){
	$idmodfam =param('mod');
	if(!&compte("codfam","famart","idfamart  = '$idmodfam'")){
         $para{'notexiste'} = $idmodfam;
         $idmodfam = 0;
	}
}


#affichage permission modif unit
if(param('modunit')){
	$idmodunit =param('modunit');
	if(!&compte("idunit","unite","idunit = $idmodunit")){
         $para{'notexiste'} = $idmodunit;
         $idmodunit = 0;
	}
}


# pour modifier une famille
if(param('valide')){
   $ligfamart = param('valide');
   #verifier existence de la ligne
	my ($codfam) = &select_une_lig("codfam","famart","idfamart = '$ligfamart'");
	if(!&compte("codfam","article","codfam  = '$codfam'")){
         $para{'notexiste'} = $ligfamart;
         $ligfamart = 0;
	}
}

# pour modifier une unit
if(param('valideunit')){
   $ligunit = param('valideunit');
   #verifier existence de la ligne
	if(!&compte("idunit","unite","idunit = $ligunit")){
         $para{'notexiste'} = $ligunit;
         $ligunit = 0;
	}
}


#autre variable
my ($codart, $desart, $codfam, $qtestk, $pxht, $codunit);

#modif ou cration de l'article
if(param('validercreat') || param('validermodif')){
	#print header,start_html;
	$mess='';
    $codart = param("codartajout");
#	if(!$clientnom){$mess.="$messnomclinotok, "};
	$desart = param("desartajout");
#	if(!$clientrue1){$mess.="$messrueclinotok, "};
	$codfam = param("codfamajout");
#	if(!$clientville){$mess.="$messvilleclinotok, "};
	$qtestk = param("qtestkajout");
#	if(!$clientcp){$mess.="$messcpclinotok, "};
	$pxht = param("pxhtajout");
	# remise optionnelle mais au format dcimal
	$codunit = param("codunitajout");
#	if ( $remise_defaut && !($remise_defaut =~ /^[0-9][0-9]?([,.][0-9][0-9]?)?$/) )
#		{ $mess .= "$messremisenotok, " }
#	else {
#		$remise_defaut =~ s/,/./;
#		param("remise_defautajout" => $remise_defaut);
#	}
#	if(! $statut){$mess.="$messnostatutselect, "};
	#si le article est repertorie et qu'il existe des commandes
	#ou des factures  son nom, son statut doit etre client et non propsect
#	if($idartic && $statut eq $libprospect &&
#		(&compte("numfact","facture","idarticfact = $idartic ") ||
 #              &compte("numcde","commande","nomcli = $idartic ")))
#	{$mess .= "$messstatutnotok, ";}
	#verif que ca est numerique
#	$ca = param("caajout");
#	$ca =~ s/\s+//g;
	#print p "ca = $ca";
#	$ca = ($ca =~ /^Nonrens/ ? 0 : $ca);
#    if ($ca && !($ca =~ /^[+\-]{0,1}[0-9]+[,.]{0,1}[0-9]*$/)){
#		$mess .="$messca, ";
#		}
#	else{
#		$ca =~ s/,/\./;
#		param("caajout" => $ca);
#		}
	#fin ctrl
	my $listechamps='';
	my @val = ();
	if(!$mess){
		@val=(param('codartajout'), param('desartajout'), param('codfamajout'),
			param('qtestkajout'), param('pxhtajout'), param('codunitajout'));
		#push(@val); #,$clientnom,$clientrue1,$clientville,$clientcp,$ca);
        #print p "comm = $val[10]";
		($codart, $desart, $codfam, $qtestk, $pxht, $codunit) = @val;

		#verrification de la non existence du mme enreg
          $listechamps='$codart';
		  my $cond = '';

		  #verifier que l'article n'existe pas deja
		  foreach my $val(split(/,/,$listechamps)){
		  	my $clef = $val;
		  	$val =~ s/(\$\w+)/$1/gee;
		  	$val =~ s/(?<!\\)('|")/\\$1/g;
		  	$clef =~ s/\$//;
		  	if($val && $clef !~ /idartic/){$cond .= "$clef like '$val' and ";}
		  }
		  #print p "cond = $cond";
		  $cond =~ s/and\s*$//;
		  if($idartic){$cond .= "and idartic <> $idartic";}
		  if(my ($cli) = &select_une_lig('idartic','article',$cond)){
		  	$mess .= $messcliexiste;
		  }
          $listechamps='$codart,$desart,$codfam,$qtestk,$pxht,$codunit,$idartic';
	}
	if($mess && !$idartic){
		foreach my $para (@param){
			if ($para =~ /ajout$/){$para{$para} = param($para);}
		}
	}
	if(!$mess){
		#################
		$listechamps  =~ s/\$//g;
		$listechamps = "(".$listechamps.")";
		if(!$idartic){#ajouter
			$idartic = &max("article","idartic") + 1;
			push(@val,$idartic);
			$mess=$messajoutcliok;
			foreach my $val(@val){
				$val="'".$val."'";
			}
			my $listeval="(".join(",",@val).")";
			&insert($listeval,$listechamps,"article");
			}
		else{#modifier un article
			$mess=$messmodartok;
			my %hash=("codart"	=> $codart,
					"desart"	=> $desart,
					"codfam"	=> $codfam ,
					"qtestk"	=> $qtestk,
					"pxht"		=> $pxht,
					"codunit"	=> $codunit);
			#$champs,$idquestion, $refhach,$table )
	 		&maj("idartic = $idartic",\%hash,"article");
	 	}
	 }

}			



#ajouter ou modifer une famille 
if(param('ajouter') || $ligfamart){
	my $app=$ligfamart?"mod":"ajout";
	my $codfam	= param("codfam$app");
	my $desfam	= param("desfam$app");
	#les champs sont ils bien renseigns
	if(!$codfam){$mess.="$messnamecontactnotok, ";}
	if(!$desfam){$mess.="$messnamecontactnotok, ";}

	#if($ligcontact && $mess){$idmodfam = $ligcontact;}
	#ajouter dans le hachade de parametres %para les valeurs d'ajout
	#pour les reafficher
	if($mess){
		foreach my $para (@param){
			if ($para =~ /$app$/){$para{$para} = param($para);}
		}
	}
	if(!$mess){
	#trt para a ajouter
		$ligfamart=$ligfamart?$ligfamart:&max('famart', 'idfamart') + 1;
		my %hash;

		$hash{'codfam'} =$codfam;
        $hash{'desfam'} =$desfam;
		
		my @listechamps=('idfamart', 'codfam', 'desfam');
		my @listeval=($ligfamart,$codfam, $desfam) ;

		foreach my $val (@listeval){
				$val="'".$val."'";
		}
		my $listeval = "(".join(",",@listeval).")";
		my $listechamps = "(".join(",",@listechamps).")";
		if(param('ajouter.x')){
			&insert($listeval,$listechamps,"famart");
			$mess="$messajoutok";
			}
		else{#$libfact<>0, on modifie
			&maj("idfamart = $ligfamart",\%hash,"famart");
		    $mess="$messmodok";
		}
	}
}	

#ajouter ou modifier une unit
if(param('ajouterunit') || $ligunit){
	my $app=$ligunit?"mod":"ajout";
	my $codunit	= param("codunit$app");
	my $desunit = param("desunit$app");
    
	#les champs sont ils bien renseigns
    #if(!$tacheuserid){$mess.="$messuserconcerned, ";}
	#if($ligtache && $mess){$idmodtache = $ligtache;}
	
	#ajouter dans le hachade de parametres %para les valeurs d'ajout
	#pour les reafficher
	if($mess){
		foreach my $para (@param){
			if ($para =~ /$app$/){
			   $para{$para} = param($para);
			}
		}
	}
	if(!$mess){
	#trt para a ajouter
		my %hash;
		$ligunit = $ligunit?$ligunit:&max('unite', 'idunit') + 1;
		$hash{'codunit'} = $codunit;
		$hash{'desunit'} = $desunit;
		my @listechamps=('idunit', 'codunit', 'desunit');
		my @listeval=($ligunit, $codunit, $desunit) ;

	#	foreach my $champs(@param){
	#		if($champs =~ /($app)$/){
	#			my $val=param($champs);
	#			push(@listeval,$val);
	#			$champs =~ s/$app//;
	#			push(@listechamps,$champs);
	#			$hash{$champs}= $val;
	#		}
	#	}
		foreach my $val (@listeval){
				$val="'".$val."'";
		}
		
		my $listeval = "(".join(",",@listeval).")";
		my $listechamps = "(".join(",",@listechamps).")";
		if(param('ajouterunit.x')){
		    #print p "insert";
			&insert($listeval,$listechamps,"unite");
			$mess="$messajoutok";
			}
		else{#$libfact<>0, on modifie
		    #print p "update";
			&maj("idunit = $ligunit",\%hash,"unite");
		    $mess="$messmodok";
		}
	}
}	

#fin ajouter ou modifier une unit

if($idartic){$para{'idartic'} = $idartic;}

##############################	
#preparation liste deroulantes
##############################

#liste des statuts

my %codfamart = ();
tie %codfamart,"Tie::IxHash";
%codfamart =("0" => $messchoice, &liste("famart", "codfam", "desfam", "1", "codfam"));

#liste des commerciaux
my $cond = "1"; #userrole = 'commercial' or userrole = 'admin'";
my %tabunit;
tie %tabunit,"Tie::IxHash";
$tabunit{$nobody}= $nobody;
%tabunit=(%tabunit,&liste("unite","codunit","desunit", $cond,"desunit"));


#liste des utilisateurs pour lequel peruserid a le droit de maj sur les units
my @listenum = &listenum("useridlu","tacheuserdroit",
				"useridli = $persouserid and droitmaj = 2 ", "useridlu");
push(@listenum,$persouserid);
my $listenum = "(".join(",",@listenum).")";
$cond = " userrole <>  'article' and userid in $listenum ";
my %tabuser;
tie %tabuser,"Tie::IxHash";
$tabuser{'0'} = $messchoiceuser;
%tabuser=(%tabuser,&liste("utilisateur","userid","nomcomplet, userrole", $cond,"nomcomplet"));

####################################
#prparation des donnees a afficher
####################################
my @listeligaffich = my @listeunit = ();
my @ramenechamps=();
my $readonly = 0;
#rcupration donnes facture
if($idartic){
	#recup entete	
					# [0]		[1]		[2]		[3]		[4]
  my $listechamps = "idartic, codart, desart, codfam, qtestk, ";
  				#	[5]	[6]	
  $listechamps .= "pxht, codunit";

  my $table = "article";
  my $cond = "idartic = $idartic ";
  @ramenechamps=&select_une_lig($listechamps,$table,$cond);
  #ajouter la ca facture
#   my $totfact = $ramenechamps[19] = &sum("facture","totHT","idarticfact = $ramenechamps[0]") || 0 ;

   foreach my $clef (@ramenechamps){
		$clef =~ s/"/\&quot;/g;		
	}
   #si ca  o, on lui met "non renseigne" comme libelle
#   $ramenechamps[14] = $ramenechamps[14] || $norenseigne;
   
#=pod
   #gerer l'interdiction de modif des champs codart de article
   #s'il existe des factures ou des commandes associs  ce client
   if(&compte("idartic","lig_facture","idartic = $ramenechamps[0] ")) { # ||
#			   &compte("numcde","commande","articid = $ramenechamps[0] ")){
		$readonly = 1;
   }
#=cut
   if(exists $para{"codfamajout"}){

							# [0]			[1]				[2]					[3]			
   	 @ramenechamps = @para{"idarticajout","codartajout","desartajout" , "codfamajout", 
  			# [4]		[5]			[6]		
      "qtestkajout", "pxhtajout", "codunitajout"};
   }

 #recup ligne famart
   $listechamps="idfamart, codfam, desfam";
   $table="famart";
   $cond = 1; #"idfamartartic = $idartic";
   my $order="desfam";
  my ($reflisteligFamart)=&select_lig($listechamps,$table,$cond, $order,0);
  my @liste = @$reflisteligFamart;
  for(my $i=0; $i <@liste; $i++){
  	  my @rangee=@{$liste[$i]};
	  foreach my $clef(@rangee){
		 $clef =~ s/"/\&quot;/g;
	  }
	  my $mod = 0;
	  if ($rangee[0]==$idmodfam){
	  	$mod = 1;
	  }
	  #pas afficher plus de $maxcar en lecture
	  if(!$mod && length($rangee[1])>$maxcar){
	  	          $rangee[1]=substr($rangee[1],0,$maxcar - 4);
					$rangee[1] =~ s/\s+\w+$//;
					$rangee[1] .= " ...";
	  }
	  my $stand = !$mod;
	  $rangee[3] = {"mod" => $mod, "stand" => $stand};
	  push(@listeligaffich,\@rangee);
   }
   
#   #recup lignes units
   
   $listechamps="idunit, codunit, desunit";
   $table="unite";
   $cond = 1; 
   $order="desunit";
   my ($reflisteligUnite)=&select_lig($listechamps,$table,$cond, $order,0);
   @liste = @$reflisteligUnite;
   for(my $i=0; $i <@liste; $i++){
  	  my @rangee=@{$liste[$i]};
	  foreach my $clef(@rangee){
		 $clef =~ s/"/\&quot;/g;
	  }
	  my $mod = 0;
	  if ($rangee[0]==$idmodunit){
	  	$mod = 1;
	  }
	  #pas afficher plus de $maxcar en lecture
	  if(!$mod && length($rangee[1])>$maxcar){
	  	          $rangee[1]=substr($rangee[1],0,$maxcar - 4);
					$rangee[1] =~ s/\s+\w+$//;
					$rangee[1] .= " ...";
	  }
	  my $stand = !$mod;
	  $rangee[3] = {"mod" => $mod, "stand" => $stand};

	  push(@listeunit,\@rangee);
   }
}

#on va definir les $para inexistants pour eviter les erreurs dans le fichier de log

foreach my $val ("idarticajout","codartajout","desartajout" , "codfamajout", 
				"qtestkajout", "pxhtajout", "codunitajout")
{
	if(!exists $para{$val}){$para{$val} = '';}
}

#############################
#affichage facture
#############################
&majArticle($idartic,$type,$login,$titlecreatarticle,\%para,\@ramenechamps,\@listeligaffich,
 \@listeunit,\%codfamart, \%tabunit,\%tabuser, $mess,$readonly,$script);
