#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####
#
# File modified by Nicolas Schmeltz for Abtey Productions
#
# 02/10/2003 : add 'remise_defaut' and 'clientresponsable'
#
#####




#appeller de l'ecran facture qd on cliq sur l'un
#des 3 boutons de la liste des factures fait par login.cgi
#gere edition, supp et 1er ecran de modif des factures

=pod
	pour modifier ou creer une facture	
=cut

BEGIN {
  unshift @INC, '../lib', '../html';	
}

use strict ;
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Clients;

#print header,start_html(-BGCOLOR => "#ffffff");

#traitement para
my @param=param();

#si pas de para, on quitte
if(!@param){
	print redirect("$CGIADR/login.cgi");
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"

my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;

#pour les factures
if(param('numfact')){$para{'numfact'} =param('numfact');}
#pour les commandes
if(param("toupdate")){$para{"toupdate"} = param("toupdate");}
#pour la transormation propal en commandes
if(param("idpropal")){$para{"idpropal"} = param("idpropal");}
#pour creation d'un client utilisateur
if(param("userid")){$para{"userid"} = param("userid");}


#declaration variables
my $mess='';
my $idmodrep=0;
my $idmodtache=0;
my $ligcontact=0;#les contact
my $ligtache=0;#les taches
 

#declaration variables
#recup para		
my $clientid=param("clientid") || 0;
my $login=param("username");
my $type=param("usertype");
my $script = param('script') || 'clients';


#si $clientid et le client $clientid existe pas, il faut traiter
if($clientid && !&compte("clientid","client","clientid = $clientid")){
	print redirect("$CGIADR/clients.cgi?idmod=$clientid&username=$login&usertype=$type&$ch");
	exit(0);
}

#userid de user de la personne connectee
my ($persouserid) = &select_une_lig("userid","utilisateur","userlogin = '$login'");

#maj bdd

#modifier un client
=pod
if(param('modif')){
	$clientid=param('modif');
}
=cut


#suppression d'un contact
if(param('supp')){
	my $supp=param('supp');
	if(&compte("contactid","contactclient","contactid  = $supp")){
		&supp("contactid = $supp",'contactclient');
		$mess = $messligsuppok;
	}
	else{
	    $para{'notexiste'} = $supp;
		$supp = 0;
	}
}

#suppression d'une tache
if(param('supptache')){
	my $supp=param('supptache');
	if(&compte("tacheid","tacheclient","tacheid  = $supp")){
		&supp("tacheid = $supp",'tacheclient');
		$mess = $messtachesupp;
	}
	else{
	    $para{'notexiste'} = $supp;
		$supp = 0;
	}
}

#affichage permission modif contact
if(param('mod')){
	$idmodrep =param('mod');
	if(!&compte("contactid","contactclient","contactid = $idmodrep")){
         $para{'notexiste'} = $idmodrep;
         $idmodrep = 0;
	}
}


#affichage permission modif tache
if(param('modtache')){
	$idmodtache =param('modtache');
	if(!&compte("tacheid","tacheclient","tacheid = $idmodtache")){
         $para{'notexiste'} = $idmodtache;
         $idmodtache = 0;
	}
}


# pour modifier un contact
if(param('valide')){
   $ligcontact = param('valide');
   #verifier existence de la ligne
	if(!&compte("contactid","contactclient","contactid = $ligcontact")){
         $para{'notexiste'} = $ligcontact;
         $ligcontact = 0;
	}
}

# pour modifier une tache
if(param('validetache')){
   $ligtache = param('validetache');
   #verifier existence de la ligne
	if(!&compte("tacheid","tacheclient","tacheid = $ligtache")){
         $para{'notexiste'} = $ligtache;
         $ligtache = 0;
	}
}


#autre variable
my ($clientnom,$clientnom2,$clientrue1,$clientrue2,$clientville,$clientcp,$email,
$tel1,$tel2, $clienttitre,$clientpays,$fax,$statut,$secteur_act,$ca, $soc_mere,$clientcommercial,
$remise_defaut, $clientresponsable);

#modif ou cration de l'entete de client
if(param('validercreat') || param('validermodif')){
	#print header,start_html;
	$mess='';
    $clientnom=param("clientnomajout");
	if(!$clientnom){$mess.="$messnomclinotok, "};
	$clientrue1 =param("clientrue1ajout");
	if(!$clientrue1){$mess.="$messrueclinotok, "};
	$clientville =param("clientvilleajout");
	if(!$clientville){$mess.="$messvilleclinotok, "};
	$clientcp = param("clientcpajout");
	if(!$clientcp){$mess.="$messcpclinotok, "};
	$statut = param("statutajout");
	# remise optionnelle mais au format dcimal
	$remise_defaut = param("remise_defautajout");
	if ( $remise_defaut && !($remise_defaut =~ /^[0-9][0-9]?([,.][0-9][0-9]?)?$/) )
		{ $mess .= "$messremisenotok, " }
	else {
		$remise_defaut =~ s/,/./;
		param("remise_defautajout" => $remise_defaut);
	}
	if(! $statut){$mess.="$messnostatutselect, "};
	#si le client est repertorie et qu'il existe des commandes
	#ou des factures  son nom, son statut doit etre client et non propsect
	if($clientid && $statut eq $libprospect &&
		(&compte("numfact","facture","clientidfact = $clientid ") ||
               &compte("numcde","commande","nomcli = $clientid ")))
	{$mess .= "$messstatutnotok, ";}
	#verif que ca est numerique
	$ca = param("caajout");
	$ca =~ s/\s+//g;
	#print p "ca = $ca";
	$ca = ($ca =~ /^Nonrens/ ? 0 : $ca);
    if ($ca && !($ca =~ /^[+\-]{0,1}[0-9]+[,.]{0,1}[0-9]*$/)){
		$mess .="$messca, ";
		}
	else{
		$ca =~ s/,/\./;
		param("caajout" => $ca);
		}
	#fin ctrl
	my $listechamps='';
	my @val = ();
	if(!$mess){
		@val=(param('clientnom2ajout'),param('emailajout'),param('tel1ajout'),
		param('tel2ajout'),
		param('clienttitreajout'), param('clientpaysajout'),param('faxajout'),
		param('statutajout'), param('secteur_actajout'),param('soc_mereajout'),
		param('commercialajout'), param('remise_defautajout'), param('clientresponsableajout')
		);
		push(@val,$clientnom,$clientrue1,$clientville,$clientcp,$ca);
        #print p "comm = $val[10]";
		($clientnom2,$email,$tel1,$tel2, $clienttitre,$clientpays,$fax,
		$statut,$secteur_act,$soc_mere,$clientcommercial,$remise_defaut,$clientresponsable,
		 $clientnom, $clientrue1,$clientville,$clientcp,$ca) = @val;

		#verrification de la non existence du mme enreg
          $listechamps='$clientnom2,$email,$tel1,$tel2,$clienttitre,$clientpays,$fax,';
		  $listechamps .= '$statut,$secteur_act,$soc_mere, clientcommercial,$remise_defaut,$clientresponsable,';
		  $listechamps .= '$clientnom,$clientrue1,$clientville,$clientcp,$ca,$clientid';
		  my $cond = '';

		  #verifier que le client n'existe pas deja
		  foreach my $val(split(/,/,$listechamps)){
		  	my $clef = $val;
		  	$val =~ s/(\$\w+)/$1/gee;
		  	$val =~ s/(?<!\\)('|")/\\$1/g;
		  	$clef =~ s/\$//;
		  	if($val && $clef !~ /clientid/){$cond .= "$clef like '$val' and ";}
		  }
		  #print p "cond = $cond";
		  $cond =~ s/and\s*$//;
		  if($clientid){$cond .= "and clientid <> $clientid";}
		  if(my ($cli) = &select_une_lig('clientid','client',$cond)){
		  	$mess .= $messcliexiste;
		  }
	}
	if($mess && !$clientid){
		foreach my $para (@param){
			if ($para =~ /ajout$/){$para{$para} = param($para);}
		}
	}
	if(!$mess){
		#################
		$listechamps  =~ s/\$//g;
		$listechamps = "(".$listechamps.")";
		if(!$clientid){#ajouter
			$clientid = &max("client","clientid") + 1;
			push(@val,$clientid);
			$mess=$messajoutcliok;
			foreach my $val(@val){
				$val="'".$val."'";
			}
			my $listeval="(".join(",",@val).")";
			&insert($listeval,$listechamps,"client");
			}
		else{#modifier un client
			$mess=$messmodcliok;
			my %hash=("clientnom2"	=>$clientnom2,
					"email"			=> $email,
					"tel1"			=>$tel1 ,
					"tel2"			=>$tel2,
					"clienttitre"	=>$clienttitre ,
					"clientpays"	=> $clientpays,
			 		"clientnom"		=> $clientnom,
			 		"clientrue1"	=> $clientrue1,
			 		"clientville"	=> $clientville,
			 		"clientcp"		=> $clientcp,
					"fax"			=> $fax,
					"statut"		=> $statut,
					"ca"			=> $ca,
					"secteur_act"	=> $secteur_act,
					"soc_mere"		=> $soc_mere,
					"clientcommercial" => $clientcommercial,
					"remise_defaut"	=> $remise_defaut,
					"clientresponsable"	=> $clientresponsable);
			#$champs,$idquestion, $refhach,$table )
	 		&maj("clientid = $clientid",\%hash,"client");
	 	}
	 }

}			



#ajouter ou modifer un contact
if(param('ajouter') || $ligcontact){
	my $app=$ligcontact?"mod":"ajout";
	my $contactnom=param("contactnom$app");
	my $contacttel=param("contacttel$app");
    my $contactmail=param("contactmail$app");
    my $contactprenom=param("contactprenom$app");
    my $contactfonction=param("contactfonction$app");
	#les champs sont ils bien renseigns
	if(!$contactnom){$mess.="$messnamecontactnotok, ";}

	if($ligcontact && $mess){$idmodrep = $ligcontact;}
	#ajouter dans le hachade de parametres %para les valeurs d'ajout
	#pour les reafficher
	if($mess){
		foreach my $para (@param){
			if ($para =~ /$app$/){$para{$para} = param($para);}
		}
	}
	if(!$mess){
	#trt para a ajouter
		$ligcontact=$ligcontact?$ligcontact:&max('contactclient', 'contactid') + 1;
		my %hash;

		my @listechamps=('contactid','clientid');
		my @listeval=($ligcontact,$clientid) ;
		foreach my $champs(@param){
			if($champs =~ /($app)$/){
				my $val=param($champs);
				push(@listeval,$val);
				$champs =~ s/$app//;
				push(@listechamps,$champs);
				$hash{$champs}= $val;
			}
		}
		foreach my $val (@listeval){
				$val="'".$val."'";
		}
		my $listeval = "(".join(",",@listeval).")";
		my $listechamps = "(".join(",",@listechamps).")";
		if(param('ajouter.x')){
			&insert($listeval,$listechamps,"contactclient");
			$mess="$messajoutok";
			}
		else{#$libfact<>0, on modifie
			&maj("contactid = $ligcontact",\%hash,"contactclient");
		    $mess="$messmodok";
		}
	}
}	

#ajouter ou modifier une tache
if(param('ajoutertache') || $ligtache){
	my $app=$ligtache?"mod":"ajout";
	my $tachelibelle=param("tachelibelle$app");
	#print p "app = $app";
	#print p "lib =$tachelibelle";
	#recup user concerne
	my $tacheuserid = param("tacheuserid$app");
	#rzecuperation de la date
	my $jourf = param("jour$app");
    my $moisf = param("mois$app");
	my $anf = param("an$app");
	my $heuref = param("heure$app");
	my $minf = param("min$app");
    #les champs sont ils bien renseigns
	#verification date valide
	my $datetache='';
	if(!(($anf && $moisf && $jourf) && (my $ok=&verif_date($jourf, $moisf, $anf,1)))){
		$mess .="$messdatetache, ";
	}
	else{$datetache=&calend_sec($jourf, $moisf, $anf);}
	#verif heure valide
	my $heuretache = '';
	if(($heuref ne '') && !($heuref =~ /^\d{1,2}$/ && $heuref >=0 && $heuref <=23)){
	    #print p "heure pas num";
		#print p "heuref = $heuref";
		$mess .= "$messhournotok, ";
	}
	#min entre 0 et 59
	elsif(($minf ne '') && !($minf =~ /^\d{1,2}$/ && $minf >=0 && $minf <=59)){
        #print p "mn pas num";
		$mess .= "$messhournotok, ";
	}
	#l'heure doit etre renseigne si les minutes le sont
    elsif(($minf ne '') && ($heuref eq '')){
	    #print p "heure = $heuref";
        #print p "min sans h";
		$mess .= "$messhournotok, ";
	}
	else{#tout est ok
		$heuref = $heuref || "00";
		#print p "heure = $heuref";
		$minf = $minf || "00";
		#print p "min = $minf";
        $heuref = length($heuref)< 2 ? "0$heuref": $heuref;
        $minf = length($minf)< 2 ? "0$minf": $minf;
        $heuretache ="${heuref}:$minf";
		#print p "heure = $heuretache";
	}
    #lib tache valide ?
	if(!$tachelibelle){$mess.="$messlib, ";}
    if(!$tacheuserid){$mess.="$messuserconcerned, ";}
	if($ligtache && $mess){$idmodtache = $ligtache;}
	#ajouter dans le hachade de parametres %para les valeurs d'ajout
	#pour les reafficher
	if($mess){
		foreach my $para (@param){
			if ($para =~ /$app$/){
			   $para{$para} = param($para);
			}
		}
	}
	if(!$mess){
	#trt para a ajouter
		my $fait = 1;#statut fait ou non fait de la tache
		if($ligtache){($fait) = &select_une_lig("tachefait","tacheclient","tacheid = $ligtache")};
		$ligtache=$ligtache?$ligtache:&max('tacheclient', 'tacheid') + 1;
		my %hash;
		$hash{'tachedate'} =$datetache;
		$hash{'tacheheure'} =$heuretache;
        $hash{'tachefait'} =$fait;
		my @listechamps=('tacheid','clientid','tachedate','tacheheure','tachefait');
		my @listeval=($ligtache,$clientid,$datetache,$heuretache,$fait) ;
        #print p "heure = $heuretache";
		foreach my $champs(@param){
			if($champs =~ /($app)$/ && $champs !~ /jour|an|mois|heure|min/){
				my $val=param($champs);
				push(@listeval,$val);
				$champs =~ s/$app//;
				push(@listechamps,$champs);
				$hash{$champs}= $val;
			}
		}
		foreach my $val (@listeval){
				$val="'".$val."'";
		}
		my $listeval = "(".join(",",@listeval).")";
		my $listechamps = "(".join(",",@listechamps).")";
		if(param('ajoutertache.x')){
		    #print p "insert";
			&insert($listeval,$listechamps,"tacheclient");
			$mess="$messajoutok";
			}
		else{#$libfact<>0, on modifie
		    #print p "update";
			&maj("tacheid = $ligtache",\%hash,"tacheclient");
		    $mess="$messmodok";
		}
	}
}	

#fin ajouter ou modifier une tache

#mettre une tache a fait
if(param("faittache")){
	my $tacheid =param("faittache");
	#verifier que la tache existe
    if(&compte("tacheid","tacheclient","tacheid = $tacheid")){
		&maj("tacheid = $tacheid",{'tachefait' => 2},"tacheclient");
	}
	else{
         $para{'notexiste'} = $tacheid;
         $tacheid = 0;
	}
}

#defaire une tache
if(param("defaittache")){
	my $tacheid =param("defaittache");
	#verifier que la tache existe
	if(&compte("tacheid","tacheclient","tacheid = $tacheid")){
		&maj("tacheid = $tacheid",{'tachefait' => 1},"tacheclient");
	}
	else{
         $para{'notexiste'} = $tacheid;
         $tacheid = 0;
	}
}


if($clientid){$para{'clientid'} = $clientid;}

##############################	
#preparation liste deroulantes
##############################

#liste des statuts

my %statutcli = ();
tie %statutcli,"Tie::IxHash";
%statutcli =("0" => $messchoicestatut, 'client' => $libclient, 'prospect' => $libprospect);

#liste des commerciaux
my $cond = "userrole = 'commercial' or userrole = 'admin'";
my %tabcommercial;
tie %tabcommercial,"Tie::IxHash";
$tabcommercial{$nobody}= $nobody;
$tabcommercial{$boamp}= $boamp;
%tabcommercial=(%tabcommercial,&liste("utilisateur","nomcomplet","nomcomplet", $cond,"nomcomplet"));


#liste des utilisateurs pour lequel peruserid a le droit de maj sur les taches
my @listenum = &listenum("useridlu","tacheuserdroit",
				"useridli = $persouserid and droitmaj = 2 ", "useridlu");
push(@listenum,$persouserid);
my $listenum = "(".join(",",@listenum).")";
$cond = " userrole <>  'client' and userid in $listenum ";
my %tabuser;
tie %tabuser,"Tie::IxHash";
$tabuser{'0'} = $messchoiceuser;
%tabuser=(%tabuser,&liste("utilisateur","userid","nomcomplet, userrole", $cond,"nomcomplet"));

####################################
#prparation des donnees a afficher
####################################
my @listeligaffich = my @listetache = ();
my @ramenechamps=();
my $readonly = 0;
#rcupration donnes facture
if($clientid){
	#recup entete	
					# [0]		[1]		[2]			[3]				[4]
  my $listechamps = "clientid,clientnom,clientnom2 , clienttitre, clientville,";
  					# [5]		[6]			[7]			[8] [9]		[10] [11] [12]
  $listechamps .= " clientrue1, clientcp, clientpays, tel1, tel2, email, fax, statut,";
  			#		[13]		[14] [15]		[16]			[17]			[18]
  $listechamps .= " secteur_act, ca, soc_mere, clientcommercial, remise_defaut, clientresponsable ";

  my $table = " client ";
  my $cond = " clientid = $clientid ";
  @ramenechamps=&select_une_lig($listechamps,$table,$cond);
  #ajouter la ca facture
   my $totfact = $ramenechamps[19] = &sum("facture","totHT","clientidfact = $ramenechamps[0]") || 0 ;

   foreach my $clef (@ramenechamps){
		$clef =~ s/"/\&quot;/g;		
	}
   #si ca  o, on lui met "non renseigne" comme libelle
   $ramenechamps[14] = $ramenechamps[14] || $norenseigne;
   
#=pod
   #gerer l'interdiction de modif des champs identites de client
   #s'il existe des factures ou des commandes associs  ce client
   if(&compte("numfact","facture","clientidfact = $ramenechamps[0] ") ||
			   &compte("numcde","commande","nomcli = $ramenechamps[0] ")){
		%statutcli =( 'client' => $libclient);
		$readonly = 1;
   }
#=cut
   if(exists $para{"statutcliajout"}){

							# [0]			[1]				[2]					[3]			
   	 @ramenechamps = @para{"clientidajout","clientnomajout","clientnom2ajout" , "clienttitreajout",
	 "clientvilleajout", 
  			# [5]			[6]				[7]				[8]					 [9]
      "clientrue1ajout", "clientrue2ajout","clientcpajout", "clientpaysajout", "tel1ajout", 
	  "tel2ajout", "emailajout",
	#		[12]		[13]		[14]			 [15]		[16]
      "faxajout", "statutajout", "secteur_actajout", "caajout", "soc_mereajout",
	  # [17]					[18]			[19]
	  "clientcommercialajout", "remise_defaut", "clientresponsable"};
	  # A vrifier !?!
     $ramenechamps[20] = $totfact;
   }

   #recup ligne contact
   $listechamps="contactid, contactnom, contactprenom, contactfonction, contacttel, contactmail";
   $table="contactclient";
   $cond = "clientid = $clientid";
   my $order="contactid";
  my ($reflisteligContact)=&select_lig($listechamps,$table,$cond, $order,0);
  my @liste = @$reflisteligContact;
  for(my $i=0; $i <@liste; $i++){
  	  my @rangee=@{$liste[$i]};
	  foreach my $clef(@rangee){
		 $clef =~ s/"/\&quot;/g;
	  }
	  my $mod = 0;
	  if ($rangee[0]==$idmodrep){
	  	$mod = 1;
	  }
	  #pas afficher plus de $maxcar en lecture
	  if(!$mod && length($rangee[1])>$maxcar){
	  	          $rangee[1]=substr($rangee[1],0,$maxcar - 4);
					$rangee[1] =~ s/\s+\w+$//;
					$rangee[1] .= " ...";
	  }
	  my $stand = !$mod;
	  $rangee[6] = {"mod" => $mod, "stand" => $stand};
	  push(@listeligaffich,\@rangee);
   }
   
   #recup lignes taches
   #la liste des taches qui s'affiche = seulement celles des users qu'on a le droit de voir
   #liste des utilisateurs que l'on a le droit de voir
   @listenum = &listenum("useridlu","tacheuserdroit","useridli = $persouserid", "useridlu");
   push(@listenum,$persouserid);
   $listenum = "(".join(",",@listenum).")";
   $listechamps="tacheid,  tachelibelle, tacheuserid, tachedate, tacheheure ";
   $table="tacheclient";
   $cond = "clientid = $clientid and tacheuserid in $listenum";
   $order="tacheid";
  my ($reflisteligTache)=&select_lig($listechamps,$table,$cond, $order,0);
  @liste = @$reflisteligTache;
  for(my $i=0; $i <@liste; $i++){
  	  my @rangee=@{$liste[$i]};
	  foreach my $clef(@rangee){
		 $clef =~ s/"/\&quot;/g;
	  }
	  my @date=&sec_calend($rangee[3]);
	  $rangee[3]=join("/",@date);
      my $ind = 5;#indice de l'elem qui contiendra le hachage
	  my $mod = 0;
	  my $tacheuserid = $rangee[2];
	  if ($rangee[0]==$idmodtache){
	  	$mod = 1;
		$rangee[2] = [\%tabuser,$rangee[2],"tacheuseridmod"];
		my $heuremod = $rangee[4];
        @rangee[3,4,5] = split(/\//,$rangee[3]);
        @rangee[6,7] =   split(/:/,$heuremod);
		$ind = 8;
	  }
	  #$listechamps,$table,$cond
	  else{$rangee[2] = join("-",&select_une_lig("nomcomplet, userrole","utilisateur","userid = $rangee[2]"));}


	  my $stand = !$mod;
      #le bouton defaire n'app que si la tache est faite (tachefait = 2)
      #le bouton faire n'app que si la tache est non faite (tachefait = 1)
	  my ($defait) = &select_une_lig("tachefait","tacheclient","tacheid = $rangee[0]");
	  $defait = ($defait == 2) ? 1 : 0;
	  my $fait = !$defait;
	  my $supp = $fait;
	  my $maj = 1;
	  #permission affichage selon les droits de l'utilisateur
      if($persouserid != $tacheuserid){
		my $cond = "useridlu = $tacheuserid and useridli = $persouserid";
		my ($droitsupp,$droitmaj) = &select_une_lig('droitsupp, droitmaj',"tacheuserdroit",$cond);
		if ($droitsupp == 1){$supp = 0;}
		if($droitmaj == 1){$maj = 0;}
      }
	  $rangee[$ind] = {"mod" => $mod, "stand" => $stand,"fait" => $fait,
	  				   "defait" => $defait, "supp" => $supp, "maj" => $maj};
	  push(@listetache,\@rangee);
   }
}

#on va definir les $para inexistants pour eviter les erreurs dans le fichier de log
foreach my $val ("statutajout",'commercialajout','clientnomajout','clientnom2ajout','clienttitreajout',
	'clientrue1ajout','clientrue2ajout','clientcpajout','clientvilleajout','clientpaysajout',
  	'tel1ajout','tel2ajout','emailajout','faxajout','secteur_actajout','caajout','soc_mereajoutajout',
	'remise_defautajout', 'clientresponsableajout')
{
	if(!exists $para{$val}){$para{$val} = '';}
}

#on va definir les $para inexistants pour eviter les erreurs dans le fichier de log
foreach my $val ('heureajout','minajout','tachelibelleajout','contactnomajout','contactfonctionajout',
'contacttelajout','contactprenomajout','contactmailajout'){
	if(!exists $para{$val}){$para{$val} = '';}
}

#############################
#affichage facture
#############################
&majClient($clientid,$type,$login,$titlecreatclient,\%para,\@ramenechamps,\@listeligaffich,
 \@listetache,\%statutcli, \%tabcommercial,\%tabuser, $mess,$readonly,$script);
