#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####


#facture.cgi affiche la liste des factures

=pod
	affiche la liste des factures 	
=cut	
	
#mettre les librairies ds le chemin de perl

BEGIN {
  unshift @INC, '../lib', '../html';	
} 

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Clients;
 
#print header,start_html(-BGCOLOR => "#ffffff");

#traitement para
my @param=param();

#si pas de para, on quitte
if(!@param){
	print redirect("$CGIADR/login.cgi");
	exit(0);
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"

my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;
		


#declaration variables
	
#recup parametres
my $login=param("username");
my $type=param("usertype");
my $idmod=param('idmod')?param('idmod'):0;
my $supp=0;
my $mess='';



#trt des donnees
#suppression d'un client
if(param('supp')){
	$idmod=param('supp');
	#le client a supprimer existe t'il
	if (&compte("clientid","client","clientid = $idmod")){
		if (!(&compte("numfact","facture","clientidfact = $idmod ") ||
				&compte("idpropal","propal","nomcli = $idmod ") ||
				&compte("numcde","commande","nomcli = $idmod ")))
		{
			$mess = $messclientsupp;
			$supp=param('supp');
		}
		else{$mess = $messclientsuppnook;}
	}
	else{
	    $para{'notexiste'} = $supp;
		$supp = 0;
	}
}





#pour la mise en valeur des maj
if($idmod){
	param("suivant.x" => 10);	
}	

########################
#preparation des listes
#########################

#liste de tri par champs
my %tab=();
tie %tab,"Tie::IxHash";
%tab =  ("clientid", $idclient, "clientnom", $name,
"statut", $client_statut,"clientcp",$postal,"secteur_act",$secteuract,
"ca",$casociete,"soc_mere",$socmere,"ca_fact",$cafact
 );

#liste des statuts
my %statutcli = ();
tie %statutcli,"Tie::IxHash";
%statutcli =($all => $all, 'client' => $libclient, 'prospect' => $libprospect);


#liste des commerciaux
my $cond = "userrole = 'commercial' or userrole = 'admin'";
my %tabcommercial;
tie %tabcommercial,"Tie::IxHash";
$tabcommercial{$all}=$all;
$tabcommercial{$nobody}= $nobody;
$tabcommercial{$boamp}=$tabcommercial{$boamp}= $boamp;
%tabcommercial=(%tabcommercial,&liste("utilisateur","nomcomplet","nomcomplet", $cond,"nomcomplet"));

###############################
#construction liste des factures
##############################		

#declaration de variables	

#recuperation des para necc au tri
my $order=param("tri")?param("tri"):"clientid";
$para{"tri"} = $order;
my $orderpcd= param("pcdt");
my $ordersuiv=param("suiv");	
my $nomclitri = param("nomclitri");
my $statuttri = param("statuttri")?param("statuttri"):$all;
my $clientcptri = param("clientcptri");
my $secteur_acttri = param("secteur_acttri");
my $soc_meretri = param("soc_meretri");
my $catri = param("catri");
my $cafacttri = param("cafacttri");
my $commercialtri=param("commercialtri") ? param("commercialtri"):$all;

my $nb=param("nbligtri")?param("nbligtri"):$nblig;
my $chaine = param('chaine');
my $inddeb = 0;
#on force les $para sur une liste deroulante a une valeur
$para{"tri"} = $order;

$para{"statuttri"} = $statuttri;
$para{"commercialtri"} = $commercialtri;

		
#preparation  liste clients  afficher
my $listechamps  = "clientid,clientnom, statut, clientcp,secteur_act, soc_mere, ca, clientcommercial ";
my $table = "client ";
#construction de la condition
$cond = "clientid > 0 " ;


#traitement des para passes pour les tri
if($nomclitri){
   my $nomclitribis = "%".$nomclitri."%";
   $cond .= "and clientnom like  '$nomclitribis' ";
}

if($statuttri ne $all){#dateecheance
  $cond.= " and statut ='$statuttri'";
}

if($secteur_acttri){
   my $secteur_acttribis = "%".$secteur_acttri."%";
   $cond .= "and secteur_act like  '$secteur_acttribis' ";
}

if($soc_meretri){
   my $soc_meretribis = "%".$soc_meretri."%";
   $cond .= "and soc_mere like  '$soc_meretribis' ";
}

if (defined($catri) && $catri =~ /\d+/){#rechercher ent et ent.*
	$catri =~ s/,/\./;
	$catri =~ s/\..*//;
	my $catribis=$catri.".%";
	my $catrimoins1 = $catri - 1;
    my $catriplus1 = $catri + 1;
	$cond .= " and (ca  between $catrimoins1 and $catriplus1) ";
}


if($cafacttri){
    $cafacttri =~ s/,/\./;
	$cafacttri =~ s/\..*//;
	my $cafacttribis=$cafacttri.".%";
	my $cafacttrimoins1 = $cafacttri - 1;
    my $cafacttriplus1 = $cafacttri + 1;
	my $condbis = "client.clientid = facture.clientidfact and ";
	$condbis .= " client.clientid = facture.clientidfact  group by clientid ";
    $condbis .= " having sum(totHT) between  $cafacttrimoins1 and $cafacttriplus1";

	my $tablebis = "facture, client";
    my @liste = &listenum("clientid",$tablebis,$condbis,"clientid");
	@liste = (@liste) ? @liste : (0);
    $condbis = "(";
    foreach my $val (@liste){
      $condbis .= "clientid = $val or ";
   }
   $condbis =~ s/or\s*$/ /;
   $condbis .= ")";
   $cond .= "and $condbis ";
 }

if($commercialtri ne $all){
    if($commercialtri =~ /$nobody/){$cond.= " and clientcommercial = '$nobody'";}
    else{$cond.= " and clientcommercial like '$commercialtri'";}
}

#verifier que idmod question possedent les para de tri, sinon on enleve les criteres de tri
#$listechamps,$table,$cond
if($idmod){
    #verifier qu'idmod existe pour le trt des selcetions
    #d'objet qui n'existe plus
	if(!(&compte("clientid","client","clientid = $idmod"))){
	    $para{'notexiste'} = $idmod;
	    $idmod = &select_pcdtbis($listechamps,$table,$cond, "clientid",$idmod);
		$order =  $para{"tri"} = "clientid";
	}
	my $lig;
	my $condbis=$cond. " and clientid=$idmod";
	if(!(($lig)=&select_une_lig("clientid",$table,$condbis))){
		$cond= " clientid > 0" ;
		foreach my $clef (keys %para){;
			if($clef =~ /tri$/ ){$para{$clef}='';}
		}
	}		
}



#pour positionner sur la fact pcdt la fact supp, en se basant sur l'id	
if($supp){
		$idmod=&select_pcdt($listechamps,$table,$cond,$order,$supp);
		#print p "idmod= $idmod";
		#supprimer les lignes de factures
		&supp("clientid = $supp",'client');
		#supp la facture
		&supp("clientid = $supp",'contactclient');
		#supp les relances associes a la fature
		&supp("clientid = $supp",'tacheclient');
}
		
my ($reftabquestion,$ordersuivbis);
#l'ordre n'est pas le ca_fact
if($order !~ /ca_fact/){
	($reftabquestion,$ordersuivbis)=&select_lig($listechamps,$table,$cond,$order,$idmod);
}
else{#$order = ca_fact, on fait un ordre sur clientid puis on tri
	($reftabquestion,undef)=&select_lig($listechamps,$table,$cond,"clientid",$idmod);
     my @table=@$reftabquestion;
	 my %hash = ();
	 for(my $i=0; $i < @table; $i++){
	 	my @rangee=@{$table[$i]};
		my $rangee = join(";",@rangee);
        my $cond = " clientidfact = $rangee[0] ";
		my $val = &sum("facture","totHT",$cond) || 0 ;
		$hash{$rangee} = $val;
	}
    my @tablecons = sort {$hash{$a} <=> $hash{$b}} keys %hash;
	my @tablebis = ();
	for(my $i=0; $i <@tablecons; $i++){
        #print p "tab = $tablecons[$i]";
		#print p "val = $hash{$tablecons[$i]}";
		my @rangee = split(/;/,$tablecons[$i]);
		if(($rangee[0] == $idmod)){$ordersuivbis=$i;}
		push(@tablebis,\@rangee);
	}
    $reftabquestion =\@tablebis;

}

my @table=@$reftabquestion;
my $taille = @table;
#pour afficher  partir de la question modifier, ajouter ou pour suivant
$ordersuiv=defined($ordersuivbis)?$ordersuivbis:$ordersuiv;

#recuperer numero dans la liste du 1e elem a afficher, du nb de ligne par ecran
#et du 1er elme et du dernier + 1 dans la liste selon ce qui a ete demande et
#deje vu par l'utilisateur

($inddeb,$orderpcd,$ordersuiv,$nb)= &getIndDeb($nb,$idmod,$ordersuiv,$orderpcd,$taille,$chaine,$ch);
#print p " ***nb = $nb";
#print p "***ordersuiv = $ordersuiv";
$para{"nbligtri"} = $nb;




			
#construction d'un tableau contenant juste les enreg a afficher, formater
my @tabAffich=();
for (my $i=$inddeb;$i < ($inddeb + $nb) &&$i<@table;$i++){			
	my @rangee=@{$table[$i]};
    #calcul du ca facture ht
	my $cond = " clientidfact = $rangee[0] ";
	$rangee[8] = &sum("facture","totHT",$cond) || 0 ;
	$rangee[8]=sprintf("%.2f",$rangee[8]);
    $rangee[4]=$rangee[4] || $norenseigne;
    $rangee[5]=$rangee[5] || $norenseigne;
    $rangee[6]=$rangee[6] ?sprintf("%.2f",$rangee[6]): $norenseigne;
	#my ($table,$champs,$cond)=@_;
	my $mod = ($idmod==$rangee[0])?$idmod:0;
	my $stand = !$mod;
	#$count,$table,$cond
	my $supp = !(&compte("numfact","facture","clientidfact = $rangee[0]") ||
               &compte("idpropal","propal","nomcli = $rangee[0]") ||
			   &compte("numcde","commande","nomcli = $rangee[0]")) || 0 ;
	$rangee[9] = { "stand" => $stand, "mod" => $mod, "supp" => $supp };
    push(@tabAffich,\@rangee);
}

#on va definir les $para inexistants pour eviter les erreurs dans le fichier de log
foreach my $val ('nomclitri','clientcptri','secteur_acttri','soc_meretri','catri','cafacttri'){
	if(!exists $para{$val}){$para{$val} = '';}
}


########################
#affichage liste facture
########################

&ListeClients($type,$login,$orderpcd,$ordersuiv,$nb,$taille, $titleconsclient,
               $mess, \@tabAffich, \%para,\%tab,\%statutcli, \%tabcommercial);


		
	

	
		
	



