#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####


#depenses.cgi 
=pod
	ecran d'affichage et de gestion des depenses	 
=cut

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../lib', '../html';	
} 

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Depense;

#print header,start_html(-BGCOLOR => "#ffffff");

#traitement para
my @param=param();
=pod
foreach my $para (@param){
    my $val =param($para);
	print p "para = $para, val = $val";
}
=cut
#si pas de para, on quitte
if(!@param){
	print redirect("$CGIADR/login.cgi");
	exit(0);
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"
#my $par = param('fournisseurtri');
#print p "fourn = $par";
my ($refpara,$ch)=&getParamHash(@param);
=pod
foreach my $para (@param){
    my $val =param($para);
	print p "para = $para, val = $val";
}
=cut


my %para = %$refpara;
my $mess='';		

#recuperation des para d'utilisateurs indisepensables
my $login=param("username");
my $type=param("usertype");
#declaration variables
my $idmod = (param('idmod') || 0) ;
my $supp = my $mod = 0;
my $depenseid=0;



##############################
#traitement maj table depenses
##############################


# modif depenses
if(param('valider')){
  $depenseid = param('valider');
  #si la depense selectionne existe plus
  if(!(&compte("depenseid","depenses","depenseid = $depenseid"))){
      param("toupdate" => $depenseid);
      $depenseid = 0;
  }
  #$mod=1;
}

	
#suppression d'une depense
if(param('supp')){	
	$supp=param('supp');
	$idmod=$supp;
	if(!(&compte("depenseid","depenses","depenseid = $supp"))){
		param("toupdate" => $supp);
		$supp = 0;
	}
}


#ajouter ou modifier une dpense
if(param('ajouter') || $depenseid){
	my $app=$depenseid?"mod":"ajout";
	my $ind=$depenseid?"m":"f";		
	my $datefact;
	my $auto=param("auto");	
	#ctrl lib
	if(!param("libdep$app")){$mess.="$messlib, ";}
	#ctrl prixdep
	my $prixttc=param("MontTTC$app");	
	$prixttc =~ s/\s+//g;	
	if($prixttc && !($prixttc =~ /^[+\-]{0,1}[0-9]+[,.]{0,1}[0-9]*$/)){
		$mess.="$messttc, ";
		}
	else{
		$prixttc =~ s/,/\./;					
	}
	my $prix=param("MontHt$app") ;
	$prix =~ s/\s+//g;
        if($prix && !($prix =~ /^[+\-]{0,1}[0-9]+[,.]{0,1}[0-9]*$/)){
		$mess.="$messht, ";
		}
	else{
		$prix =~ s/,/\./;
	}

        #calcul prix ht % prixttc et vice vera
	if(!$mess && $prix  && ($prixttc  =~ /^[+\-]{0,1}0*[,.]{0,1}0*$/)
	&& $auto){
		$prixttc = $prix * (1 + $tvaconst/100);
	}
	elsif (!$mess && ($prix  =~ /^[+\-]{0,1}0*[,.]{0,1}0*$/) && $prixttc && $auto){
		$prix = $prixttc/(1 + $tvaconst/100);
	}
	param("MontHt$app" => $prix);
	param("MontTTC$app" => $prixttc);
				
	#ctrl date	
	my($jourf,$moisf,$anf)= (param("jour$ind"),param("mois$ind"), param("an$ind"));		
	if(!(($jourf && $moisf &&$anf) && (my $ok=&verif_date($jourf, $moisf, $anf)))){
		$mess.="$messdatedep, ";			
		}
	else{$datefact=&calend_sec($jourf,$moisf,$anf);}
	if($depenseid && $mess){$mod=1;$idmod=$depenseid;}
	if($mess){
		foreach my $para (@param){
			if ($para =~ /($app$|$ind$)/){$para{$para} = param($para);}
		}		
		if($depenseid){		
			$para{'depenseid'} = $depenseid;			
		}
				 	 		
	}	
	if(!$mess){		
		$depenseid=$depenseid?$depenseid:&max('depenses', 'depenseid') + 1;
		$idmod=$depenseid;
		my %hash;
		$hash{'datefact'} = $datefact;
		my @listechamps=('depenseid','datefact');
		my @listeval =($depenseid,$datefact);
		foreach my $champs(@param){
			if($champs =~ /($app)$/ && $champs !~ /MontHtauto/){
				my $val=param($champs);
				push(@listeval,$val);
				$champs =~ s/$1//;
				push(@listechamps,$champs);
				$hash{$champs}= $val;
				}
			}		
		foreach my $val (@listeval){
				$val="'".$val."'";
			}
		my $listeval = "(".join(",",@listeval).")";		
		my $listechamps = "(".join(",",@listechamps).")";
		if($app eq "ajout"){	
			&insert($listeval,$listechamps,'depenses');
			$mess=$messajdepok;
			param("toupdate" => $depenseid);
			#$para{'depenseid'} = $depenseid;
		}
		elsif(&select_une_lig("depenseid","depenses","depenseid = $depenseid")){
			&maj("depenseid = $depenseid",\%hash,"depenses");
			$mess = $messmoddepok;			
		}
	}
	
}


#preparation modification d'une depense

if(param('toupdate')){
	#$mod=1;
	$idmod = $mod = $para{'toupdate'} = param('toupdate');
}
#$para{'toupdate'} = $para{'toupdate'} || 0;
if($idmod){
	param("suivant.x" => 10);#aleatoire
}



########################
#preparation des listes
#########################
#liste de tri
my %tab =();
tie %tab,"Tie::IxHash";
%tab =  ("depenseid", $idsort, "libdep", $wordsort,  
"datefact", $expensedate,"fournisseur",$mansupply,
 "MontHt", $totalwithouttaxsort, 
"MontTTC", $totalwithtaxsort);


################################	
#recuperation des paras de tri
################################

my $somHT = my $somTTC = 0;
my $MontTTCtri=param("MontTTCtri");
my $MontHTtri=param("MontHTtri");
my $numdeptri=param("numdeptri");
my $fournisseurtri=param("fournisseurtri");
#print p "fourn = $fournisseurtri";
my $libdeptri= param("libdeptri");
my $antri= param("antri"); my $moistri = param("moistri"); my $jourtri= param("jourtri");

my $nb=param("nbligtri")?param("nbligtri"):$nblig;
my $order=param("tri")?param("tri"):"depenseid"; $para{"tri"} = $order;
my $chaine = param('chaine');
my ($orderpcd, $ordersuiv)=(param("pcdt"),param("suiv"));
my $inddeb = 0;

#############################
#construction liste depenses
#############################

#preparation ligne sql
my $listechamps = "depenseid, libdep, datefact,MontHt, MontTTC, numcheque,fournisseur ";
my $table = "depenses";
my $cond = "depenseid >= 1";

if ($numdeptri){
	    my @numdeptri = split (/\D+/,$numdeptri);		
		if(@numdeptri){
		  $cond.= " and (";
    	  foreach my $elem (@numdeptri){$cond.= " depenseid like '$elem' or";}
    	  $cond =~ s/or$//;
    	  $cond .= ")";			  
	   }
}
	
if (defined($MontTTCtri) && $MontTTCtri =~ /\d+/){
		$MontTTCtri=~ s/,/\./;
		$MontTTCtri =~ s/\..*//;
		my $MontTTCtribis=$MontTTCtri.".%";
		my $MontTTCmoins1 = $MontTTCtri - 1 ;
    	my $MontTTCplus1 = $MontTTCtri + 1 ;
		#$cond.= " and (MontTTC like '$MontTTCtri' or MontTTC like '$MontTTCtribis')";
		$cond .= " and (MontTTC between $MontTTCmoins1 and $MontTTCplus1)";
}
		
if(defined($MontHTtri) &&  $MontHTtri=~ /\d+/){
	$MontHTtri=~ s/,/\./;
	$MontHTtri =~ s/\..*//;
	my $MontHTtribis=$MontHTtri.".%";
    my $MontHTmoins1=$MontHTtri - 1 ;
    my $MontHTplus1=$MontHTtri + 1 ;
	#$cond.= " and (MontHt like '$MontHTtri' or MontHt like '$MontHTtribis')";
	$cond.= " and (MontHt between $MontHTmoins1 and $MontHTplus1)";
}

if($fournisseurtri){
    my @fournisseurtri = split(/\s+/,$fournisseurtri);
	foreach my $val (@fournisseurtri){
		$cond .= " and fournisseur like '%$val%' ";
	}
	#my $fournisseurtribis="%".$fournisseurtri."%";
	#$cond.= " and fournisseur like '$fournisseurtribis'";
}

if($libdeptri){
    my @libdeptri = split(/\s+/,$libdeptri);
	foreach my $val (@libdeptri){
		$cond .= " and libdep like '%$val%' ";
	}
	#my $libdeptribis = "%".$libdeptri."%";
	#$cond.= " and libdep like '$libdeptribis'";
}
	
if($antri || $moistri || $jourtri){

	my $ch=&date_tri($antri,$moistri,$jourtri, "datefact","depenses");
	$cond.=$ch;
}			



#verifier que idmod question possedent les para de tri, sinon on enleve les criteres de tri
#$listechamps,$table,$cond
if($idmod){

    #si $idmod existe pas, on prend le precedent
#=pod
    if(!(&compte("depenseid","depenses","depenseid = $idmod"))){
        $para{'toupdate'} = $idmod ;
        param('toupdate' => $idmod);
	    $idmod = &select_pcdtbis($listechamps,$table,$cond,"depenseid",$idmod);
		$mod = 0;
		$order =  $para{"tri"} =  "depenseid";
	}
#=cut
	my $lig;
	my $condbis=$cond. " and depenseid=$idmod";
	if(!(($lig)=&select_une_lig("depenseid",$table,$condbis))){
		$cond="depenseid >= 1";
		foreach my $clef (keys %para){
			if($clef =~ /tri$/){$para{$clef}='';}
		}
	}

}
	
if($supp){
		$idmod=&select_pcdt($listechamps,$table,$cond,$order,$supp);
		#print p "idmod= $idmod";
		&supp("depenseid = $supp",'depenses');
		$mess = $messdepsuppok;
}

#en cas de maj ou de demande de maj d'un dep qui existe pas,
#on supp les criteres de tri, et on recherche la dep precdente dans la liste
if(exists $para{'toupdate'} && !&select_une_lig("depenseid","depenses","depenseid = $idmod")){
            $cond="depenseid >= 1";
	    $idmod=&select_pcdtbis("depenseid",$table,$cond,"depenseid",$idmod);
            foreach my $clef (keys %para){
               if($clef =~ /tri$/){$para{$clef}='';}
            }
}
			
#recuperation des lignes
my ($reftabquestion,$ordersuivbis);
($reftabquestion,$ordersuivbis)=
 &select_lig($listechamps,$table,$cond,$order,$idmod);
my @table=@$reftabquestion;
my $taille = @table;
#pour afficher partir de la question modifier, ajouter ou pour suivant
$ordersuiv=defined($ordersuivbis)?$ordersuivbis:$ordersuiv;


#recuperer numero dans la liste du 1e elem a afficher, du nb de ligne par ecran
#et du 1er elme et du dernier + 1 dans la liste selon ce qui a ete demande et
#deje vu par l'utilisateur
($inddeb,$orderpcd,$ordersuiv,$nb)= &getIndDeb($nb,$idmod,$ordersuiv,$orderpcd,$taille,$chaine,$ch);
$para{"nbligtri"} = $nb;

#calcul somme total des depenses
$somHT=sprintf("%.2f",&calculsum($reftabquestion,3));
$somTTC=sprintf("%.2f",&calculsum($reftabquestion,4));


#construction d'un tableau contenant juste les enreg a afficher, formater
my @tabAffich=();
my $toupdate = 0;#pour verifier s'il existe une depense  modifier
for (my $i=$inddeb;$i < ($inddeb + $nb) &&$i<@table;$i++){
	my @rangee=@{$table[$i]};
	($rangee[8],$rangee[9],$rangee[10])= my @date =&sec_calend($rangee[2]);	
	$rangee[2]=join("/",@date);			
	$rangee[3]=sprintf("%.2f",$rangee[3]);
	$rangee[4]=sprintf("%.2f",$rangee[4]);
	if(!$rangee[6]){$rangee[6]=$nosupply;}
	if(!$rangee[5]){$rangee[5]=$nocheque;}
	#############
	my $memod = 0;
	if($rangee[0] == $mod){	     
	     $memod = $rangee[0];
             $toupdate = 1;
	     if(!exists $para{"depenseid"}){	        
	        @para{"depenseid","libdepmod", "datefactmod","MontHtmod", "MontTTCmod", "numchequemod","fournisseurmod"} = 	     
	        @rangee;
	        @para{"jourm","moism","anm"} = @rangee[8 .. 10];
	     }
	}
	########################
	#my $memod = ($idmod==$rangee[0] && $mod)? 1:0;	
	my $modif = ($idmod==$rangee[0] && !$mod) ?$idmod:0;
	my $stand = !$modif;
	my $habit = !$memod;	
	$rangee[11] = {"stand" => $stand, "modif" => $modif,"memod" => $memod, "habit" => $habit};			
    push(@tabAffich,\@rangee);
}
#si la depense a modifier n'existe pas et qu'il n'y a pas
#de depense a creer, $para{"toupdate"} est detruit
if(!$toupdate && exists($para{"toupdate"})  && $para{"toupdate"} > 0){$para{"toupdate"} = 0;}
#=pod
#on va definir les $para inexistants pour eviter les erreurs dans le fichier de log
foreach my $val ('numdeptri','jourtri','moistri','antri','libdeptri','fournisseurtri','MontHTtri',
'MontTTCtri','libdepajout','fournisseurajout','MontHtajout','MontTTCajout','numchequeajout'){
	if(!exists $para{$val}){$para{$val} = '';}
}
#=cut
##########################################
#affichage liste depenses
##########################################
&AffichDepense($type,$login,$orderpcd,$ordersuiv,$nb,$taille,$somHT,$somTTC,
    \@tabAffich,\%para,\%tab,$mess);	

			
