#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####


#editfactmaj.cgi
=pod
	pour creer les factures et leurs duplicata au format pdf
=cut


BEGIN {
  unshift @INC, '../lib', '../html';	
}

use strict ;
use Tie::IxHash;
use Conf;
use lang::Fr;
use Util;
use UNGI::Editfacturemaj;


#selection de toutes les factures
#($listechamps,$table,$cond, $order)
my @listefact = &listenum("numfact","facture","numfact > 0","numfact");


foreach my $numfact (@listefact){
    my @enteteFacture = ();
    my $reftab = ''; my $tauxtva = 0;
	#recup entete
	my $cond="facture.clientidfact = client.clientid  and numfact = $numfact ";
	my $table="facture, client ";
	my $listechamps =  "clientnom, responsablecde, datefact, refcde, clientrue1, clientville, ";
	$listechamps .= " clientcp, datereglement, totHT, totTTC, fraisdeplt, banquereglement, ";
	$listechamps .= " numcheque,contact, clientnom2, clientrue2, clienttitre, clientpays,echeance ";
	@enteteFacture=&select_une_lig($listechamps,$table,$cond);


	#slection des lignes de facture
	$listechamps = "qtefacture, libartic, prixHT, tauxTVA ";
	$table = " lig_facture ";
	$cond= "numfact= $numfact";
	my $order= "ligfact";
	($reftab) = &select_lig($listechamps,$table,$cond, $order);
	my @tab = @$reftab;
	#fin selection lignes facture


	#calcul total taux tva
	my $moytva=0;
	my $qtetot=0;
	for (my $z=0;$z<@tab;$z++){
		my($qtefacture, $libartic, $prixHT, $tauxTVA)=@{$tab[$z]};
		$moytva+=$qtefacture*$tauxTVA;
		$qtetot+=$qtefacture;
	}
	
	if($qtetot){
		$tauxtva=sprintf("%.2f",$moytva/$qtetot*100);
	}

    #facbrication pdf
	&editfact($numfact,\@enteteFacture,$reftab,$tauxtva);

}

	
