#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####


#entrees.cgi pour la connection et sert de pilier car
#c'est l'ecran d'affichage des factures non reglees
 
 
=pod
        script affichage la liste des factures non regles               
=cut
 
#mettre les librairies ds le chemin de perl

BEGIN {
  unshift @INC, '../lib', '../html';	
} 

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Entree;

#print header,start_html(-BGCOLOR => "#ffffff");

my @param=param();

#si pas de para, on quitte
if(!@param){
	print redirect("$CGIADR/login.cgi");
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"

my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;
	
#declaration variables	
#recup parametres
my $login=param("username");
my $type=param("usertype");
my $idmod=param('idmod')?param('idmod'):0;

#pour la mise en valeur des maj
if($idmod){
	param("suivant.x" => 10);	
}

########################
#preparation des listes
#########################

#pour la liste des noms de client
my $liste_champs= "clientnom, clientville, clientcp";
my %tabcli =();
tie %tabcli,"Tie::IxHash";
$tabcli{$all}=$all;	
%tabcli= (%tabcli,&liste("client", "clientid",$liste_champs,"clientid <> 0","clientnom"));

#liste des statuts de facture
my %statfact = ();
tie %statfact,"Tie::IxHash";
#$statfact{$all}=$all;
%statfact=(%statfact,&init_statfact("$LIBAD/statfact.conf"));

#liste de tri par champs
my %tab =();
tie %tab,"Tie::IxHash";
%tab =  ("numfact", $idbillliste, "clientnom", $name,  
"datefact", $billdate, "totHT",$totalwithouttaxsort, 
 "totTTC", $totalwithtaxsort);
 
###################################
#construction liste des entrees
###################################
 
#declaration de variables	
my $somHT=my $somTTC =0;		
#recuperation des para necc au tri
my $order=param("tri")?param("tri"):"numfact";$para{"tri"} = $order;
my $orderpcd= param("pcdt");
my $ordersuiv=param("suiv");	
my $numfacttri=param("numfacttri");
my $clientidtri=param("clientidtri")?param("clientidtri"):$all;
$para{"clientidtri"} =$clientidtri;
my $totTTCtri=param("totTTCtri");
my $totHTtri=param("totHTtri");
my $antri= param("antri"); my $moistri = param("moistri"); my $jourtri= param("jourtri");

my $nb=param("nbligtri")?param("nbligtri"):$nblig;
my $chaine = param('chaine');
my $inddeb = 0;
		
		
#preparation  liste facture  afficher
my $listechamps  = "numfact, clientnom,datefact, totHT, totTTC, statutfact,clientidfact";
my $table = "facture, client";
#construction de la condition
my $cond = " facture.clientidfact = client.clientid and statutfact > 1 " ;

if ($numfacttri){
  my @numfacttri = split (/\D+/,$numfacttri);
  if(@numfacttri){	
    $cond .= " and (";
    foreach my $elem (@numfacttri){$cond.= " numfact like '$elem' or";}
    $cond =~ s/or$//;
    $cond .= ")";
  }
}

if($clientidtri ne $all){#clientid
	$cond.= " and clientidfact='$clientidtri'";
}

if (defined($totTTCtri) && $totTTCtri =~ /\d+/){#rechercher ent et ent.*
	$totTTCtri =~ s/,/\./;
	$totTTCtri =~ s/\..*//;
	my $totTTCtribis=$totTTCtri.".%";
	my $totTTCtrimoins1 = $totTTCtri - 1;
    my $totTTCtriplus1 = $totTTCtri + 1;
	#$cond.= " and (totTTC like '$totTTCtri' or totTTC like '$totTTCtribis' or totTTC like '$totTTCtrimoins1')";
	$cond .= " and (totTTC  between $totTTCtrimoins1 and $totTTCtriplus1) ";
}

if(defined($totHTtri) &&  $totHTtri=~ /\d+/){#rechercher ent et ent.*
	$totHTtri =~ s/,/\./;
	$totHTtri =~ s/\..*//;
	my $totHTtribis=$totHTtri.".%";
	my $totHTtrimoins1 = $totHTtri - 1;
    my $totHTtriplus1 = $totHTtri + 1;
	#$cond.= " and (totHT like '$totHTtri' or totHT like '$totHTtribis')";
    $cond.= " and (totHT between $totHTtrimoins1 and $totHTtriplus1)";

}
	
if($antri || $moistri || $jourtri){
	my $ch=&date_tri($antri,$moistri,$jourtri, "datefact","facture");	
	$cond.=$ch;	
}

#verifier que idmod question possedent les para de tri, sinon on enleve les criteres de tri
#$listechamps,$table,$cond
if($idmod){
    #verifier qu'idmod existe pour le trt des selcetions
    #d'objet qui n'existe plus
	if(!(&compte("numfact","facture","numfact = $idmod"))){
		$para{'notexiste'} = $idmod;
	    $idmod = &select_pcdtbis($listechamps,$table,$cond, "numfact",$idmod);
		$order =  $para{"tri"} = "numfact";
	}


	my $lig;
	my $condbis=$cond. " and numfact=$idmod";
	if(!(($lig)=&select_une_lig("numfact",$table,$condbis))){
		$cond= " facture.clientidfact = client.clientid and statutfact > 1 " ;			
		foreach my $clef (keys %para){
			if($clef =~ /tri$/){$para{$clef}='';}
		}
		#pour se positionner sur l'entree precedent elle qui a t mise  regler
		$idmod = &select_pcdtbis($listechamps,$table,$cond, $order,$idmod);
	}		
}
			
my ($reftabquestion,$ordersuivbis);
($reftabquestion,$ordersuivbis)=&select_lig($listechamps,$table,$cond,$order,$idmod);
my @table=@$reftabquestion;
my $taille = @table;
#pour afficher partir de la question modifier, ajouter ou pour suivant
$ordersuiv=defined($ordersuivbis)?$ordersuivbis:$ordersuiv;

#recuperer numero dans la liste du 1e elem a afficher, du nb de ligne par ecran
#et du 1er elme et du dernier + 1 dans la liste selon ce qui a ete demande et
#deje vu par l'utilisateur
($inddeb,$orderpcd,$ordersuiv,$nb)= &getIndDeb($nb,$idmod,$ordersuiv,$orderpcd,$taille,$chaine,$ch);
$para{"nbligtri"} = $nb;
	
#calcul somme total	
$somHT=sprintf("%.2f",&calculsum($reftabquestion,3));
$somTTC=sprintf("%.2f",&calculsum($reftabquestion,4));		
	
	
#construction d'un tableau contenant juste les enreg a afficher, formater
my @tabAffich=();
for (my $i=$inddeb;$i < ($inddeb + $nb) &&$i<@table;$i++){			
	my @rangee=@{$table[$i]};
	$rangee[5]=$statfact{$rangee[5]};
	my @date=&sec_calend($rangee[2]);
	$rangee[2]=join("/",@date);	
	$rangee[3]=$rangee[3]?$rangee[3]:0;
	$rangee[4]=$rangee[4]?$rangee[4]:0;
	$rangee[3]=sprintf("%.2f",$rangee[3]);
	$rangee[4]=sprintf("%.2f",$rangee[4]);				
	
	my $mod = ($idmod==$rangee[0])?$idmod:0;
	my $stand = !$mod;

	$rangee[7] = {"stand" => $stand, "mod" => $mod };
    push(@tabAffich,\@rangee);
}


#on va definir les $para inexistants pour eviter les erreurs dans le fichier de log
foreach my $val ('numfacttri','nomclitri','jourtri','moistri','antri',
'totHTtri','totTTCtri'){
	if(!exists $para{$val}){$para{$val} = '';}
}


########################
#affichage liste facture
########################

&ListeEntree($type,$login,$orderpcd,$ordersuiv,$nb,$taille, $titleconsentree,
               $somHT,$somTTC,\@tabAffich, \%para,\%tabcli,\%tab);


