#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####


#propal.cgi 
=pod
	ecran d'affichage et de gestion des propal		  
=cut

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../lib', '../html';	
}

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Propal;

#print header,start_html(-BGCOLOR => "#ffffff");

#traitement para
my @param=param();

#si pas de para, on quitte
if(!@param){
	print redirect("$CGIADR/login.cgi");
	exit(0);
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"
my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;
		


#recuperation des para d'utilisateurs indisepensables
my $login=param("username");
my $type=param("usertype");

#declaration variables
my $som= my $somestim = 0;
my $idmod = (param('idmod') || 0);
my $supp = my $mod= 0;
my $numpropal=0;
my $mess = '';


#################################
#maj table propal
#################################



#preparation modif d'une commande	
if(param('valider')){			
	$numpropal=param('valider');	
	#si la propal selectionne existe plus
	if(!(&compte("idpropal","propal","idpropal = $numpropal"))){
		param("toupdate" => $numpropal);
		$numpropal = 0;
	}
}

#editer un commentaire de propal
if(param('editpropal')){
    my $idpropal=param('editpropal');
    my $commentaire = '';
	if(my $existe = &compte("idpropal","propal","idpropal =  $idpropal")){
		if(param("save")){
			my $comment = param("commentaires");
			&maj("idpropal=$idpropal",{'commentaires' => $comment},'propal');
		}
		($commentaire)=&select_une_lig('commentaires','propal',"idpropal=$idpropal");
	}
	else{
		$idmod = &select_pcdtbis("idpropal","propal","idpropal > 0", 'idpropal',$idpropal);
		$idpropal = 0;
	}
	&affichCommentPropal($commentaire,$idpropal,$idmod,$type,$login);
    exit(0);	
}	

#ajouter ou modifier une propal
if(param('ajouter') || $numpropal){
	my $app=$numpropal?"mod":"ajout";
	my $ind=$numpropal?"m":"f";	
	my $datepropal;		
	#ctrl lib
	if(!param("libpropal$app")){$mess.="$messlib, ";}	
	if(!param("nomcli$app")){$mess.="$messname, ";}
	#ctrl prixdep
	my $prix=param("total$app");
	$prix =~ s/\s+//g;	
	if($prix && !($prix =~ /^[+\-]{0,1}[0-9]+[,.]{0,1}[0-9]*$/)){
		$mess.="$messht, ";
		}
	else{
		$prix =~ s/,/\./;			
		param("total$app" => $prix);
	}
	my $estim = param("pourcestim$app");	
	if($estim == -1){$mess .= $messnoestimselect;}	
	#ctrl date	
	my($jourf,$moisf,$anf)= (param("jour$ind"),param("mois$ind"), param("an$ind"));		
	if(!(($jourf && $moisf &&$anf) && (my $ok=&verif_date($jourf, $moisf, $anf)))){
		$mess.="$messdatepropal, ";			
	}
	else{$datepropal=&calend_sec($jourf,$moisf,$anf);}
	if($numpropal && $mess){$mod=1;$idmod=$numpropal;}
	if($mess){
		foreach my $para (@param){
			if ($para =~ /($app$|$ind$)/){$para{$para} = param($para);}
		}
		if($numpropal){		
			$para{'numpropal'} = $numpropal;	
            param("toupdate" => $numpropal);
		}	
		else{param("toupdate" => -1);}
	}	
	if(!$mess){		
		$numpropal=$numpropal?$numpropal:&max('propal', 'idpropal') + 1;
		$idmod=$numpropal;		
		my %hash;
		$hash{'datepropal'} = $datepropal;
		my @listechamps=('idpropal','datepropal');
		my @listeval =($numpropal,$datepropal);
		foreach my $champs(@param){
			if($champs =~ /($app)$/){
				my $val=param($champs);
				push(@listeval,$val);
				$champs =~ s/$1//;
				push(@listechamps,$champs);
				$hash{$champs}= $val;
			}
		}		
		foreach my $val (@listeval){
				$val="'".$val."'";
		}
		my $listeval = "(".join(",",@listeval).")";		
		my $listechamps = "(".join(",",@listechamps).")";

		if($app eq "ajout"){
		    &insert($listeval,$listechamps,'propal');
			$mess=$messajpropalok;
			param("toupdate" => $numpropal);
		}
		elsif(&select_une_lig("idpropal","propal","idpropal = $numpropal")){

			&maj("idpropal = $numpropal",\%hash,"propal");
			$mod = 0;
			$mess =$messmodpropalok; 
		}		
		#suppression de la propal si pourcestim  0
		if($estim == 0){
			$supp = $idmod = $numpropal;
			#param("toupdate" => 0);
			Delete("toupdate");
		}
		#destruction propal et creation cde correspondante si estim  100
		#et redirection vers creation cde
		if($estim == 100 && &select_une_lig("idpropal","propal","idpropal = $numpropal")){
	              print redirect ("$CGIADR/propalcde.cgi?username=$login&usertype=$type&idpropal=$numpropal&creat=10");
				  exit(0);
		}
	}
	
}

#demande modification d'une propal	
if(param('toupdate')){					
	$idmod = $mod=$para{"toupdate"} = param('toupdate');
}

if($idmod){
	param("suivant.x" => 10);
=pod
	if(!(&compte("idpropal","propal","idpropal = $idmod"))){
        $para{'toupdate'} = $idmod ;
        param('toupdate' => $idmod);
	    $idmod = &select_pcdtbis("idpropal","propal","idpropal > 0", 'idpropal',$idmod);
		$mod = 0;
	}
=cut
}


		
######################################
#preapration des listes deroulantes
#####################################

#liste de tri
my %tab = ();
tie %tab,"Tie::IxHash";
%tab =  ("idpropal",$idpropalsort, 
"datepropal", $propaldate,"commercial",$namecommercial,
"pourcestim",$propalestim,"chefprojet",$nameleadproject,"total", $total);


#liste commercial
my $cond = "userrole = \'commercial\' or userrole = \'admin\'";
my (%tabcommercial,%tabcommercialajout);
tie %tabcommercial,"Tie::IxHash";
tie %tabcommercialajout,"Tie::IxHash";
$tabcommercial{$all}=$all;
$tabcommercialajout{$nobody}=$tabcommercial{$nobody}= $nobody;
$tabcommercialajout{$boamp}=$tabcommercial{$boamp}= $boamp;
%tabcommercial=(%tabcommercial,&liste("utilisateur","nomcomplet","nomcomplet", $cond,"nomcomplet"));
%tabcommercialajout=(%tabcommercialajout,&liste("utilisateur","nomcomplet","nomcomplet", $cond,"nomcomplet"));

#liste chefs projets
$cond = "userrole = \'chefprojet\' or userrole = \'admin\'";
my (%tabchef,%tabchefajout);
tie %tabchef,"Tie::IxHash";
tie %tabchefajout,"Tie::IxHash";
$tabchef{$all}=$all;
$tabchefajout{$nobody}=$tabchef{$nobody}=$nobody;
$tabchefajout{$chefprojetencours}=$tabchef{$chefprojetencours}=$chefprojetencours;
%tabchefajout=(%tabchefajout,&liste("utilisateur","nomcomplet","nomcomplet", $cond,"nomcomplet"));
%tabchef=(%tabchef,&liste("utilisateur","nomcomplet","nomcomplet", $cond,"nomcomplet"));

#liste des pourcentage d'estimation
my (%estim, %estimajout) ;
tie %estim,"Tie::IxHash";
tie %estimajout,"Tie::IxHash";
$estim{$all}=$all;
$estimajout{"-1"} = $selectpropalestim;
my @estim = sort {$a <=> $b}(keys %propal);
foreach my $clef (@estim){
	$estim{$clef} =$estimajout{$clef} = "$clef% : $propal{$clef}";
} 

#liste des propspects
my $liste_champs= "clientnom, clientville, clientcp";
my (%tabcli, %tabcliajout);
tie %tabcli,"Tie::IxHash";
tie %tabcliajout,"Tie::IxHash";
$tabcli{$all}=$all;
%tabcli= (%tabcli,&liste("client", "clientid",$liste_champs,0,"clientnom"));
$tabcliajout{"0"} = $messchoicecustomer;
%tabcliajout= (%tabcliajout,&liste("client", "clientid",$liste_champs,0,"clientnom"));


################################
#preparation donnees a afficher
################################

	
#recuperation des paras de tri
my $idpropaltri=param("idpropaltri");
my $totaltri=param("totaltri");
my $libpropaltri = param("libpropaltri");
my $commercialtri=param("commercialtri")?param("commercialtri"):$all;
my $chefprojettri=param("chefprojettri")?param("chefprojettri"):$all;
my $pourcestimtri = param("pourcestimtri")?param("pourcestimtri"):$all;
my $clienttri = param("clienttri")?param("clienttri"):$all;
my $nomclitri = param("nomclitri");
my $antri= param("antri"); my $moistri = param("moistri"); my $jourtri= param("jourtri");
my $nb=param("nbligtri")?param("nbligtri"):$nblig;
my $order=param("tri")?param("tri"):"idpropal";
my ($orderpcd, $ordersuiv)=(param("pcdt"),param("suiv"));
my $chaine = param('chaine');
my $inddeb = 0;

#forcer les para, car sinon le changement de nb de lignes ne marche pas
#la 1ere fois
$para{"commercialtri"} =$commercialtri;
$para{"chefprojettri"} = $chefprojettri;
$para{"pourcestimtri"} = $pourcestimtri;
$para{"clienttri"} = $clienttri;
$para{"tri"} = $order;

#preparation ligne sql
my $listechamps = "idpropal,libpropal, commercial, chefprojet,nomcli, datepropal,pourcestim, total, commentaires";
my $table = "propal";
$cond = "idpropal > 0 " ;

	
if ($totaltri){
	$totaltri=~ s/,/\./;
	$totaltri =~ s/\..*//;
	my $totaltribis=$totaltri.".%";
	$cond.= " and (total like '$totaltri' or total like '$totaltribis')";
}

if($commercialtri ne $all){	
	$cond.= " and commercial like '$commercialtri'";		
}

if($chefprojettri ne $all){
	$cond.= " and chefprojet like '$chefprojettri'";
}

			
if($antri || $moistri || $jourtri){	
	my $ch=&date_tri($antri,$moistri,$jourtri, "datepropal","propal");	
	$cond.=$ch;
}

if ($idpropaltri){
	#print p "idpropal =$idpropaltri"; 
	    my @idpropaltri = split (/\D+/,$idpropaltri);		
		if(@idpropaltri){
		  $cond.= " and (";
    	  foreach my $elem (@idpropaltri){$cond.= " idpropal like '$elem' or";}
    	  $cond =~ s/or$//;
    	  $cond .= ")";		  
	   }
}

if($pourcestimtri ne $all){$cond .= " and pourcestim = '$pourcestimtri'";} 
	
if($libpropaltri){	
    my $libpropaltribis = "%".$libpropaltri."%";
	$cond.= " and libpropal like '$libpropaltribis'";		
}

if($clienttri ne $all){
	$cond.= " and nomcli = $clienttri";
}

#pour une recherche de type comme sur le nom
if($nomclitri){
   my $nomclitribis = "%".$nomclitri."%";
   my @liste = &listenum("clientid","client","clientnom like '$nomclitribis'","clientid");
   @liste = (@liste) ? @liste : (0);
   my $condbis = "(";
   foreach my $val (@liste){
      $condbis .= "nomcli = $val or ";
   }
   $condbis =~ s/or\s*$/ /;
   $condbis .= ")";
   $cond .= "and $condbis ";
}

#verifier que idmod question possedent les para de tri, sinon on enleve les criteres de tri
#$listechamps,$table,$cond
if($idmod){
#verif que la propal correspondant  idmod existe
    if(!(&compte("idpropal","propal","idpropal = $idmod"))){
        $para{'toupdate'} = $idmod ;
        param('toupdate' => $idmod);
	    $idmod = &select_pcdtbis($listechamps,$table,$cond,"idpropal",$idmod);
		$mod = 0;
		$order = $para{"tri"} = "idpropal";
	}
	my $lig;		
	my $condbis=$cond. " and idpropal=$idmod";
	if(!(($lig)=&select_une_lig("idpropal",$table,$condbis))){
		$cond="idpropal >= 1";			
		$idpropaltri = $totaltri=$antri = $moistri = $jourtri = $pourcestimtri = '';
		$chefprojettri=$commercialtri=$all;	
	}	
}

if($supp){
		$idmod=&select_pcdt($listechamps,$table,$cond,$order,$supp);
		&supp("idpropal = $supp",'propal');
		$mess = $messsupppropalok;
}
		
#recuperation des lignes
my ($reftabquestion,$ordersuivbis);
($reftabquestion,$ordersuivbis)=
 &select_lig($listechamps,$table,$cond,$order,$idmod);
my @table=@$reftabquestion;
my $taille = @table;
#pour afficher partir de la question modifier, ajouter ou pour suivant
$ordersuiv=defined($ordersuivbis)?$ordersuivbis:$ordersuiv;


#recuperer numero dans la liste du 1e elem a afficher, du nb de ligne par ecran
#et du 1er elme et du dernier + 1 dans la liste selon ce qui a ete demande et
#deje vu par l'utilisateur
($inddeb,$orderpcd,$ordersuiv,$nb)= &getIndDeb($nb,$idmod,$ordersuiv,$orderpcd,$taille,$chaine,$ch);
$para{"nbligtri"} = $nb;
#print p "nb = $nb";
#print p "ordersuiv = $ordersuiv";

#calcul somme total des propal
#7 = indice total dans @rangee
$som=sprintf("%.2f",&calculsum($reftabquestion,7));
$somestim = sprintf("%.2f",&calculsumestim($reftabquestion,7,6));

#construction d'un tableau contenant juste les enreg a afficher, formater
my @tabAffich=();
my $toupdate = 0;#pour verifier s'il existe une propal  modifier
for (my $i=$inddeb;$i < ($inddeb + $nb) &&$i<@table;$i++){
	my @rangee=@{$table[$i]};
	#formatage date propal
	($rangee[9],$rangee[10],$rangee[11])= my @date =&sec_calend($rangee[5]);
	$rangee[5]=join("/",@date);	

	#formatage somme propal
	$rangee[7]=sprintf("%.2f",$rangee[7]);
	foreach my $val (@rangee[2 .. 4]){
		$val = $val ? $val : "&nbsp";
	}
	my $estimation = $rangee[6];
	$rangee[6] = "$rangee[6]%"; 	
	my $memod = 0;
	if ($mod==$rangee[0]){
	   $memod = 1;
           $toupdate = 1;
	   if(!exists $para{"numpropal"}){
	      @para{"idpropalmod","libpropalmod", "commercialmod", "chefprojetmod","clientmod",
	      "datepropalmod","pourcestimmod", "totalmod", "commentairesmod"} = @rangee;
          @para{"jourm","moism","anm"} = @rangee[9 .. 11];
          $para{"pourcestimmod"} = $estimation;
	  #print p "estim =$para{'pourcestimmod'}";
       }
	}	
	#renseigner le nom du client

	($rangee[12]) = &select_une_lig('clientnom','client',"clientid = $rangee[4]");
	my $modif = ($idmod==$rangee[0] && !$mod) ?$idmod:0;
	my $stand = !$modif;
	my $habit = !$memod;	
	$rangee[13] = {"stand" => $stand, "modif" => $modif,"memod" => $memod, "habit" => $habit};
    push(@tabAffich,\@rangee);
}
#si la propal a modifier n'existe pas et qu'il n'y a pas
#de propal a creer, $para{"toupdate"} est detruit
#if(!$toupdate && exists($para{"toupdate"}) && $para{"toupdate"} > 0){delete $para{"toupdate"} ;}
if(!$toupdate && exists($para{"toupdate"}) && $para{"toupdate"} > 0){ $para{"toupdate"} = 0;}

#on va definir les $para inexistants pour eviter les erreurs dans le fichier de log
foreach my $val ('idpropaltri','totaltri','libpropaltri',
'jourtri','moistri','antri', 'nomclitri','libpropalajout','commentairesajout','totalajout'){
	if(!exists $para{$val}){$para{$val} = '';}
}
##############################
#affichage liste des propals
##############################

&AffichPropal($type,$login,$orderpcd,$ordersuiv,$nb,$taille,$som,$somestim,
    \@tabAffich,\%para,\%tab,\%tabcommercial,\%tabcommercialajout,\%tabchef,\%tabchefajout,
   \%estim,\%estimajout,\%tabcli, \%tabcliajout,$mess);

			
