#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2003 Abtey Productions
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
# http://www.abtey.fr
#
#####

# rens_clifact.cgi renseigne certains champs du client
# fen^etre invisible  l'utilisateur
# lors de la cration/modif d'une facture

=pod
	renseigne les lments par dfaut d'un client dans les factures 	
=cut	
	
#mettre les librairies ds le chemin de perl

BEGIN {
  unshift @INC, '../lib', '../html';	
} 

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
#use lang::Fr;
use Util;
 
sub donothing() {
	print header, "<script \"JavaScript\">window.close();</script>";
	exit(0);
}
#traitement para
my @param = param();

#si pas de para, on quitte
if(!param('codfam') && !param('idartic') && !param('codart')){
	&donothing();
}
my $table = "article";
my $cond = 1;
my $js = "\n<script language=\"JavaScript\">\n";
# Remplir le popup articles
if (param('codfam')) {

	my $codfam = param('codfam');
	if ($codfam ne "-") {
		$cond = "codfam = '$codfam'";
	}
	my $listechamps = "idartic, codart, desart";
	my $order = "desart";
    my ($reflistearticle) = &select_lig($listechamps,"article",$cond, $order);
	$js .= "opener.document.form.poparticle.options.length = 0;\n n = 0;\n";
	$js .= "opt = new Option(\"Select\", \"-1\", true, true);\n\n";
	$js .= "opener.document.form.poparticle.options[n] = opt;\n n++;\n";

	my @listearticle = @$reflistearticle;

	foreach my $k (@listearticle){
		$js .= "opt = new Option(\"$$k[2] ($$k[1])\", \"$$k[0]\", false, false);\n";
		$js .= "opener.document.form.poparticle.options[n] = opt; n++;\n";
	}
	
} elsif (param('codart')) {
	my $codart = param('codart');
	my $listechamps = "codart, desart, pxht";
	$cond = "codart = '$codart'";
	my @res = &select_une_lig($listechamps,$table,$cond);
	if ((@res) == 0) { @res = ("-","","") ;}
	$js .= <<END;
	opener.document.form.libarticajout.value = "$res[1]";
	opener.document.form.prixHTajout.value = "$res[2]";
	opener.document.form.codartajout.value = "$res[0]";
END

}
else {
# Remplir les champs de l'article slectionn
	my $idartic = param('idartic');
	if ($idartic eq "-1") { &donothing() }
	my $listechamps = "codart, desart, pxht";
	$cond = "idartic = '$idartic'";
	my @res = &select_une_lig($listechamps,$table,$cond);
	if ((@res) == 0) { @res = ("-","","") }
	$js .= <<END;
	opener.document.form.libarticajout.value = "$res[1]";
	opener.document.form.prixHTajout.value = "$res[2]";
	opener.document.form.codartajout.value = "$res[0]";
END
}

$js .= "window.close();</script>\n";
print header,start_html;


print $js, "<H1>Recherche en cours ... </H1>", end_html;
