#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####


#utilisateur.cgi pour la liste des utilisateurs, modif, creation


=pod
	liste les utilisateurs	
=cut	

BEGIN {
  unshift @INC, '../lib', '../html';	
} 

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Utilisateur;	


#print header,start_html(-BGCOLOR => "#ffffff");

#declaration variables

#traitement para
my @param=param();

#si pas de para, on quitte
if(!@param){
	print redirect("$CGIADR/login.cgi");
	exit(0);
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"

my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;
	
#recup parametres
my $login=param("username");
my $type=param("usertype");
my $idmod = (param('idmod') || 0);
my $supp=0;
my $mess = '';


#maj table user
#trt des donnees
#suppression d'un utilisateur
if(param('supp')){
	#$cond,$table
	$idmod=param('supp');
	if (&compte("userid","utilisateur","userid = $idmod")){
        $supp=$idmod;
	}
}




#pour la mise en valeur des maj
if($idmod){
	param("suivant.x" => 10);	
}	


########################
#preparation des listes	
########################
#pour la liste des roles	
my %tabuserrole;
tie %tabuserrole,"Tie::IxHash";
$tabuserrole{$all}=$all;	
%tabuserrole= (%tabuserrole,&init_statfact("$LIBAD/usertype.conf"));

#liste de tri par champs
my %tab = ();
tie %tab,"Tie::IxHash";
%tab =  ("userid", $idusersort, "username", $name,  
"userlogin", $loginname, "userrole",$rolesort,"nomcomplet",$wholename);



###############################
#construction liste des factures
##############################
		

#declaration de variables
	
#recuperation des para necc au tri
my $order=param("tri")?param("tri"):"userid"; $para{"tri"} = $order;
my $orderpcd= param("pcdt");
my $ordersuiv=param("suiv");	
my $userlogintri=param("userlogintri");
my $nomcomplettri=param("nomcomplettri");
my $usernametri=param("usernametri");
my $useridtri = param("useridtri");	
my $userroletri=param("userroletri")?param("userroletri"):$all ;
$para{"userroletri"} =$userroletri;
my $nb=param("nbligtri")?param("nbligtri"):$nblig;
my $chaine = param('chaine');
my $inddeb = 0;
		

my $listechamps  = "userid, userlogin, username, userrole,nomcomplet";
my $table = "utilisateur";
#construction de la condition
my $cond = " userid >= 1 " ;

if ($nomcomplettri){
	$cond.= " and nomcomplet like '%$nomcomplettri%'";
}

if ($useridtri){
  my @useridtri = split (/\D+/,$useridtri);
  if(@useridtri){
    $cond .= " and (";
    foreach my $elem (@useridtri){$cond.= " userid like '$elem' or";}
    $cond =~ s/or$//;
    $cond .= ")";
  }
}

if($usernametri){
	$cond.= " and username like '%$usernametri%'";
}

if($userroletri ne $all){
	$cond.= " and userrole='$userroletri'";
}

if($userlogintri ){
	$cond.= " and userlogin like '%$userlogintri%'";
}

	
	
#verifier que idmod question possedent les para de tri, sinon on enleve les criteres de tri
#$listechamps,$table,$cond
if($idmod){
    #verifier qu'idmod existe pour le trt des selcetions
    #d'objet qui n'existe plus
	if(!(&compte("userid","utilisateur","userid = $idmod"))){
	    $para{'notexiste'} = $idmod;
	    $idmod = &select_pcdtbis($listechamps,"utilisateur",$cond, "userid",$idmod);
		$order =  $para{"tri"} = "userid";
	}
	my $lig;
	my $condbis=$cond. " and userid=$idmod";
	if(!(($lig)=&select_une_lig("userid","utilisateur",$condbis))){
		$cond= " userid >= 1 " ;		
		$userroletri = $all;
		$userlogintri = $usernametri = $nomcomplettri = '';
		}		
}

#pour positionner sur la fact pcdt la fact supp, en se basant sur l'id	
if($supp){
		$idmod=&select_pcdt($listechamps,"utilisateur",$cond,$order,$supp);
		#print p "idmod= $idmod";
		#&supp("userid = $supp",'user');
		&supputilisateur($supp);	
		$mess = $messusersuppok;		
}
			
my ($reftabquestion,$ordersuivbis);
($reftabquestion,$ordersuivbis)=&select_lig($listechamps,"utilisateur",$cond,$order,$idmod);
my @table=@$reftabquestion;
my $taille = @table;
#pour afficher partir de la question modifier, ajouter ou pour suivant
$ordersuiv=defined($ordersuivbis)?$ordersuivbis:$ordersuiv;	


#recuperer numero dans la liste du 1e elem a afficher, du nb de ligne par ecran
#et du 1er elme et du dernier + 1 dans la liste selon ce qui a ete demande et
#deje vu par l'utilisateur
($inddeb,$orderpcd,$ordersuiv,$nb)= &getIndDeb($nb,$idmod,$ordersuiv,$orderpcd,$taille,$chaine,$ch);
$para{"nbligtri"} = $nb;

#construction d'un tableau contenant juste les enreg a afficher, formater
my @tabAffich=();
for (my $i=$inddeb;$i < ($inddeb + $nb) &&$i<@table;$i++){
	my @rangee=@{$table[$i]};
	my $modif = ($idmod==$rangee[0])?$idmod:0;
	my $stand = !$modif;
	#pour ne pas autoriser la modofication du mdp d'un utilisateur particulier
	#par ex l'user demo de ignu
	my $mod = ($rangee[1] eq 'admin' ? 0 : 1);
    #my $mod = 1;
	###################
	my $supp = 1;
	if($rangee[1] eq $root){$supp = 0;}
	$rangee[5]= $rangee[2];
	$rangee[5] =~  s/(?<!\\)('|")/\\$1/g;
    $rangee[5] =~ s/"/&quot;/g;
    $rangee[5] =~ s/'/&#039;/g;
	$rangee[6] = {"stand" => $stand, "modif" => $modif, "supp" => $supp ,"mod" => $mod};
    push(@tabAffich,\@rangee);
}



#on va definir les $para inexistants pour eviter les erreurs dans le fichier de log
foreach my $val ('useridtri','userlogintri','nomcomplettri','usernametri'){
	if(!exists $para{$val}){$para{$val} = '';}
}


##############################
#affichage liste utlisteurs
############################

&ListeUtilisateurs($type,$login,$orderpcd,$ordersuiv,$nb,$taille, 
               $mess, \@tabAffich,\%para,\%tab,\%tabuserrole);
			

	




