#####
#
# File modified by Nicolas Schmeltz for Abtey Productions
#
# 02/10/2003 : add 'remise_defaut' and 'clientresponsable'
#
#####



=pod

package de variables pour les factures
propres au theme UNGI

=cut

package UNGI::Clients;

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../../lib','../';	
} 

use strict;
use CGI  qw(:standard);
use Conf;
use Util;
use lang::Fr;
use UNGI::General; 


BEGIN{
	use Exporter;
	use vars qw($VERSION @ISA @EXPORT);
	$VERSION = 1.00;
	@ISA = qw(Exporter);
	@EXPORT= qw(&ListeClients &majClient);
		
}

use vars  @EXPORT;

###########################
#liste des factures
###########################

my $ListeClients = q|
<!-- debut  $ListeFacture -->
    <table width="760" cellspacing="1" cellpadding="0" align="center">
      <tr align="center">
          <TD class="tetiere" align="center">%$id%</TD>
          <TD class="tetiere" height="35">%$name%</TD>
          <TD class="tetiere" height="35">%$client_statut%</TD>
		  <TD class="tetiere" height="35">%$postal%</TD>
		  <TD class="tetiere" height="35">%$client_secteur_activite%</TD>
          <TD class="tetiere" height="35">%$client_societe_mere%</TD>
		  <TD class="tetiere" height="35">%$client_chiffre_affaire%</TD>
		  <TD class="tetiere" height="35">%$namecommercial%</TD>
		  <TD class="tetiere" height="35">%$client_ca_fact%</TD>
          <TD class="tetiere" height="35">%$action%</TD>
      </TR>
     %$liste%
    </table>
	<br>
<form method="post" action="%$CGIADR%/clients.cgi" name="formulaire">
<table>
		<tr>
			<td class="ligne1"> %$detailCient% : </td>
			<td><input type="text" name="nom" value=""></td>
			<td>
				<a href="javascript:detailclient();"><img src="%$HTMLADRUNGICONES%/valider.gif" border="0"></a>
			</td>
    	<tr>
		<tr>
			<td class="ligne1"> %$searchcontact% : </td>
			<td><input type="text" name="nomcontact" value=""></td>
			<td>
				<a href="javascript:cherchcontact('%$login%','%$type%');"><img src="%$HTMLADRUNGICONES%/valider.gif" border="0"></a>
			</td>
    	<tr>
	</table>
<table width="760" align="center">
    <tr align="center">
      <td class="tetiere2">%$searchby%&nbsp;:</td>
    </tr>
  </table>
  <table width="760" dwcopytype="CopyTableRow" align="center" cellpadding="3" cellspacing="1">
    <tr>
      <td class="ligne1">%$namecli%  :
        <input type="text" name="nomclitri"  size="60" value="%$para{nomclitri}%">
      </td>
	  <td class="ligne1">%$client_statut%  :
		%$popupstatutcli%
      </td>
     </tr>
   </table>
   <table width="760" dwcopytype="CopyTableRow" align="center" cellpadding="3" cellspacing="1">
    <tr>
      <td class="ligne1">%$postal%  :
        <input type="text" name="clientcptri"  size="20" value="%$para{clientcptri}%">
      </td>
	  <td class="ligne1">%$client_secteur_activite%  :
		<input type="text" name="secteur_acttri"  size="50" value="%$para{secteur_acttri}%">
      </td>
     </tr>
   </table>
   <table width="760" dwcopytype="CopyTableRow" align="center" cellpadding="3" cellspacing="1">
    <tr>
      <td class="ligne1">%$client_societe_mere%  :
        <input type="text" name="soc_meretri"  size="50" value="%$para{soc_meretri}%">
      </td>
	  <td class="ligne1">%$namecommercial%  :
		%$popupcommercial%
      </td>
    </tr>
   </table>
   <table width="760" dwcopytype="CopyTableRow" align="center" cellpadding="3" cellspacing="1">
    <tr>
	  <td class="ligne1">%$client_chiffre_affaire%  :
		<input type="text" name="catri"  size="20" value="%$para{catri}%">
      </td>
	  <td class="ligne1">%$client_ca_fact%  :
		<input type="text" name="cafacttri"  size="20" value="%$para{cafacttri}%">
      </td>
     </tr>
   </table>
  <br>
  <table width="500" border="0" cellspacing="0" cellpadding="5" align="center" class="ligne3">
    <tr>
      <td align="center">
        <table width="350" align="center">
          <tr> 
            <td><span class="texte4">%$sortby%</span> 
              %$popuptri%
            </td>
          </tr>
        </table>
        <table width="350" align="center">
          <tr> 
            <td class="texte4" align="left" valign="middle">%$linenumber%</td>
            <td> 
              <input type="text" name="nbligtri" value="%$nb%" size="4" maxlength="3">
            </td>
            <td class="texte4" align="center" valign="middle">%$ontotal% %$taille%</td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGICONES%/reload.gif" width="31" height="36">
            </td>
          </tr>
        </table>
        <table width="500" border="0" cellspacing="0" cellpadding="0">
          <tr>
            <td align="center" valign="middle">
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGICONES%/premier.gif" width="31" height="22" align="middle">
            </td>
            <td align="center"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle">
              <input type="image" border="0" name="precedent" src="%$HTMLADRUNGICONES%/gauche.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle">
              <input type="image" border="0" name="suivant" src="%$HTMLADRUNGICONES%/droite.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle">
              <input type="image" border="0" name="dernier" src="%$HTMLADRUNGICONES%/dernier.gif" width="30" height="22" align="middle">
            </td>
          </tr>
        </table>
      </td>
    </tr>
  </table> 
	<input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">
	<input type="hidden" name="pcdt" value="%$orderpcd%">
	<input type="hidden" name="suiv" value="%$ordersuiv%">
	<input type="hidden" name="chaine" value="%$ch%">
	</form>
	%$boutonBasClient%
<!-- fin  $ListeClients -->|;

#hachage regroupant les differentes parties d'une ligne de facture
my %ligClient = ();
tie %ligClient,"Tie::IxHash";;
#une ligne de la liste
$ligClient{'begin'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand -->
<!-- une ligne = 1  ligne de client -->
  <tr align="center"> 
        <td class="numero">%$rangee[0]%</td>
        <td class="texte2">
			<a href="%$CGIADR%/clientmodif.cgi?clientid=%$rangee[0]%&username=%$login%&usertype=%$type%&%$ch%">%$rangee[1]%</a>
		</td>
        <td class="texte3">%$rangee[2]%</td>
        <td class="texte2">%$rangee[3]%</td>
        <td class="texte3">%$rangee[4]%</td>
        <td class="texte2">%$rangee[5]%</td>
        <td class="texte3">%$rangee[6]%</td>
		<td class="texte3">%$rangee[7]%</td>
        <td class="texte3">%$rangee[8]%</td>
        <td class="texte2">
          <table cellspacing="3" cellpadding="0" align="left">
            <tr> 
|;

$ligClient{'modif'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: mod -->
<!-- une ligne = 1  ligne de client en modif -->
<tr align="center"> 
        <td class="couleur">%$rangee[0]%</td>
        <td class="couleur">
			<a href="%$CGIADR%/clientmodif.cgi?clientid=%$rangee[0]%&username=%$login%&usertype=%$type%&%$ch%">%$rangee[1]%</a>
		</td>
        <td class="couleur">%$rangee[2]%</td>
        <td class="couleur">%$rangee[3]%</td>
        <td class="couleur">%$rangee[4]%</td>
        <td class="couleur">%$rangee[5]%</td>
        <td class="couleur">%$rangee[6]%</td>
		<td class="couleur">%$rangee[7]%</td>
        <td class="couleur">%$rangee[8]%</td>
        <td class="texte2"> 
          <table cellspacing="3" cellpadding="0" align="left">
            <tr> 
|;




$ligClient{'1'} = q|
<!-- Forbidden-to: comptable  client -->
<!-- modifier une client -->
				  <td>
				  		<a href="%$CGIADR%/clientmodif.cgi?clientid=%$rangee[0]%&username=%$login%&usertype=%$type%&%$ch%">
                    		<img src="%$HTMLADRUNGICONES%/modifier.gif" border="0"></a>
				  </td>
|;

$ligClient{'2'} = q|
<!-- Forbidden-to: supercommercial -->
<!-- affich_on: supp -->
<!-- supprimer un client -->
                    <td>
						<a href="javascript:suppclient(%$rangee[0]%,'%$login%','%$type%','%$ch%');"><img src="%$HTMLADRUNGICONES%/delete.gif" border="0"></a>
				    </td>
|;

=pod
$ligClient{'3'} = q|
<!-- Forbidden-to: comptable client -->
<!-- commenter un client -->
                  <td align="center" valign="middle">
				  	 <a href="javascript:commentrelance(%$rangee[0]%,'%$login%', '%$type%');">
                    	 <img src="%$HTMLADRUNGICONES%/comment.gif" border="0"></a>
				 </td>
|;
=cut


$ligClient{'end'} = q|
<!-- Restricted-to: anybody -->
<!-- fin lignefacture -->      
                </tr>
              </table>
              <!-- fin barre action -->
            </td>
          </tr>
|; 




my %boutonBasClient =();
tie %boutonBasClient,"Tie::IxHash";
#une ligne de la liste    
     
$boutonBasClient{'begin'} = q|
      <table width="500" cellpadding="0" cellspacing="0" border="0" align="center">
        <tr>|;
      
$boutonBasClient{'1'} = q|
<!-- Forbidden-to: client comptable  --> 
        <td align="center" valign="bottom" colspan="3" height="30">
           <a href="%$CGIADR%/clientmodif.cgi?username=%$login%&usertype=%$type%&%$ch%">
                 <img src="%$HTMLADRUNGICONES%/creercli.gif" border="0">
		   </a>
        </td>|;
        
$boutonBasClient{'2'} = q|
        <td align="center" valign="bottom" height="30">&nbsp;</td>
        <td align="center" valign="bottom" colspan="3" height="30">
            <a href="%$CGIADR%/login.cgi"> 
                 <img src="%$HTMLADRUNGICONES%/quitter2.gif" border="0"> 
			</a> 
        </td>|;

$boutonBasClient{'end'} = q|
      </tr>
    </table>
|;



sub ListeClients{
	my ($type,$login,$orderpcd,$ordersuiv,$nb,$taille,$title,$mess,$reftabAffich,
	$refpara,$reftab,$refstatutcli,$reftabcommercial) = @_;
	#on recupere les variables avec les valeurs necc pour l'affichage
    #et on formate les valeurs pour l'affichage    
	my $ch = '';	
	($refpara,$ch) = &getParam(%$refpara);
	my %para = %$refpara;
	#faire les listes droulantes
    my $popupstatutcli = &getPopup($refstatutcli,$para{"statuttri"},"statuttri");
    my $popuptri = &getPopup($reftab, $para{"tri"},"tri");
	my $popupcommercial =&getPopup($reftabcommercial, $para{"commercialtri"},"commercialtri");
   # my $onload = '';
    my $onload = exists ($para{'notexiste'}) ? $onloadEcran:'';
   #faire la liste des factures a afficher avec seulement les boutons
    #que l'utilisateur a le droit de voir
	my %ligClientDroit=();
    tie %ligClientDroit,"Tie::IxHash";
    #print p "***type = $type";
    %ligClientDroit = &getHashAffich(\%ligClient,$type);
	
    #formater la liste des factures a afficher    
    my $liste = &makeListe($reftabAffich,\%ligClientDroit);
    #afficher creer facture sssi l'utilisateur a le droit de creer une facture
	my %boutonBasCliDroit = ();
	tie %boutonBasCliDroit,"Tie::IxHash";
	%boutonBasCliDroit = &getHashAffich(\%boutonBasClient,$type);
	my $boutonBasClient = join("\n",(values %boutonBasCliDroit));

        
    #construire la page
	my $page = $body.&AffichLig(&affiche_barre($type,\%navigation,'clients'),$type,$login).$titrePage;
	if($mess){$page .= $messPage;} 
	$page .= $ListeClients;
    #$page =~ s/%(\$\w+\{\w*\})%/$1/gee;

	$page =~ s/%(\$\w+(\{\w*\})?)%/$1/gee;

	$page =~ s/%(\$\w+)%/$1/gee;
	&AffichPageWeb($title,$page);
	return;
}


##########################
#modifier/creer un client
##########################

my $enteteClientCreat = q|
<!-- debut  $enteteClientCreat -->
<form method="get" action="%$CGIADR%/clientmodif.cgi" name="formulaire">
     <table width="650" cellpadding="3" cellspacing="1">
      <tr>
      <td class="ligne1"> * %$name% :&nbsp;&nbsp;
	  		<input name="clientnomajout" type="text" value="%$para{clientnomajout}%" size="50">
      </td>
      <td valign="middle" class="ligne1" align="left"> %$client_statut% :
          %$popupstatutcli%
      </td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
		<td class="ligne2">%$name2% :&nbsp;&nbsp;
				<input name="clientnom2ajout" type="text" value="%$para{clientnom2ajout}%" size="50">
		</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne2">%$qualification% :&nbsp;&nbsp;
	  		<input name="clienttitreajout" type="text" value="%$para{clienttitreajout}%" size="50">
	  	</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">* %$street% :
	  		<input name="clientrue1ajout" type="text" value="%$para{clientrue1ajout}%" size="50">
	  	</td>
	  	<td class="ligne1">* %$postal% :
	  		<input name="clientcpajout" type="text" value="%$para{clientcpajout}%" size="20">
	  	</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne2">* %$city% :&nbsp;&nbsp;
	  	   <input name="clientvilleajout" type="text" value="%$para{clientvilleajout}%" size="50">
	  	</td>
	  	<td class="ligne2">%$country% :&nbsp;&nbsp;
	  		<input name="clientpaysajout" type="text" value="%$para{clientpaysajout}%" size="30">
	  	</td>
	  </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">%$telephone% :&nbsp;&nbsp
	  		<input name="tel1ajout" type="text" value="%$para{tel1ajout}%" size="30">
	  	</td>
		<td class="ligne1">%$telephone2% :&nbsp;&nbsp
	  		<input name="tel2ajout" type="text" value="%$para{tel2ajout}%" size="30">
	  	</td>
     </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne2">%$e_mail% :&nbsp;&nbsp;
	  		<input name="emailajout" type="text" value="%$para{emailajout}%" size="50">
	  	</td>
		<td class="ligne2">%$telecopie% :&nbsp;&nbsp;
	  		<input name="faxajout" type="text" value="%$para{faxajout}%" size="30">
	  	</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">%$secteuract% :&nbsp;&nbsp;
	  		<input name="secteur_actajout" type="text" value="%$para{secteur_actajout}%" size="40">
	  	</td>
		<td class="ligne1">%$casociete% :&nbsp;&nbsp;
	  		<input name="caajout" type="text" value="%$para{caajout}%" size="15">
	  	</td>
      </tr>
    </table>
	 <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne2">%$socmere% :&nbsp;&nbsp;
	  		<input name="soc_mereajout" type="text" value="%$para{soc_mereajoutajout}%" size="40">
	  	</td>
      </tr>
    </table>
	<table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">%$namecommercial% :&nbsp;&nbsp;
			%$popupcommercial%
	  	</td>
      </tr>
    </table>
	 <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne2">%$remise% :&nbsp;&nbsp;
	  		<input name="remise_defautajout" type="text" value="%$para{remise_defautajout}%" size="4"> %
	  	</td>
		<td class="ligne2">%$responsable% :&nbsp;&nbsp;
			<input name="clientresponsableajout" type="text" value="%$para{clientresponsableajout}%" size="30">
		</td>
      </tr>
    </table>
    <input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">
	<input type="hidden" name="script" value="%$script%">
	<input type="hidden" name="validercreat" value="10">
	  %$champscache%
    <table width="650" cellpadding="0" cellspacing="0">
      <tr> 
        <td valign="bottom" align="left" height="35" class="texterouge">
          <input type="image" border="0" name="validercreat" src="%$HTMLADRUNGICONES%/validercreat.gif" width="71" height="25">
          %$messcreatclient%
        </td>
      </tr>
    </table> 	
   </form>
   <table width="650" cellpadding="0" cellspacing="0">
       <tr>
          <td valign="bottom" align="left" height="35">
	  	<a href="%$CGIADR%/%$script%.cgi?usertype=%$type%&username=%$login%&%$ch%"><img src="%$HTMLADRUNGICONES%/abandonner.gif" border="0"></a>
	  </td>
      </tr>
  </table>
<!-- fin $enteteClientCreat -->|;

my $enteteClient = q|
<!-- debut  $enteteClient -->
<table width="650" class="ligne3" cellpadding="3" cellspacing="0">
    <tr>
      <td  class="texte4" align="left" width="20%">%$idclient% :</td>
      <td class="textegras">%$clientid%</td>
    </tr>
</table>
<form method="get" action="%$CGIADR%/clientmodif.cgi" name="formulaire">
    %%$ligCoordClient%%
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne2">%$telephone% :&nbsp;&nbsp
	  		<input name="tel1ajout" type="text" value="%%$tel1%%" size="30">
	  	</td>
		<td class="ligne2">%$telephone2% :&nbsp;&nbsp
	  		<input name="tel2ajout" type="text" value="%%$tel2%%" size="30">
	  	</td>
     </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">%$e_mail% :&nbsp;&nbsp;
	  		<input name="emailajout" type="text" value="%%$email%%" size="50">
	  	</td>
		<td class="ligne1">%$telecopie% :&nbsp;&nbsp;
	  		<input name="faxajout" type="text" value="%%$fax%%" size="30">
	  	</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne2">%$secteuract% :&nbsp;&nbsp;
	  		<input name="secteur_actajout" type="text" value="%%$secteur_act%%" size="40">
	  	</td>
		<td class="ligne2">%$casociete% :&nbsp;&nbsp;
	  		<input name="caajout" type="text" value="%%$ca%%" size="15">&nbsp;&euro;
	  	</td>
      </tr>
    </table>
	 <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">%$socmere% :&nbsp;&nbsp;
	  		<input name="soc_mereajout" type="text" value="%%$soc_mere%%" size="40">
	  	</td>
		<td class="ligne2">%$client_ca_fact% :&nbsp;&nbsp;%%$cafact%%&nbsp;&nbsp;&euro;</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">%$namecommercial% :&nbsp;&nbsp;
			%$popupcommercial%
	  	</td>
      </tr>
    </table>
	 <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne2">%$remise% :&nbsp;&nbsp;
	  		<input name="remise_defautajout" type="text" value="%%$remise_defaut%%" size="4"> %
	  	</td>
		<td class="ligne2">%$responsable% :&nbsp;&nbsp;
			<input name="clientresponsableajout" type="text" value="%%$clientresponsable%%" size="30">
		</td>
      </tr>
    </table>
    <input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">
	<input type="hidden" name="script" value="%$script%">
	<input type="hidden" name="validermodif" value="10">
	  %$champscache%
    <table width="650" cellpadding="0" cellspacing="0">
      <tr> 
        <td valign="bottom" align="left" height="35" class="texterouge">
          <input type="image" border="0" name="validermodif" src="%$HTMLADRUNGICONES%/validermodif.gif" width="71" height="25">
          %$messcreatclient%
        </td>
      </tr>
    </table> 	
   </form>
    %%$listeLigContact%%
    <form method="post" action="%$CGIADR%/clientmodif.cgi" name="form">
	<table width="650" border="0" cellspacing="0" cellpadding="0" class="ligne3">
      <tr>
        <td align="center">
          <table width="651" cellpadding="0" cellspacing="2">
            <tr>
              <td colspan="8" class="texte4" align="left" height="13">%$addcontact%</td>
            </tr>
            <tr>
              <td colspan="8" class="tetiere" align="left" height="3"></td>
            </tr>
          </table>
          <table width="650" cellpadding="0" cellspacing="0">
            <tr>
              <td>
                <table width="100%" cellspacing="2" cellpadding="0">
                  <tr>
                    <td height="69"  valign="middle" class="texte4" align="left">
                     *&nbsp;%$namecontact%:
					 <input type="text" name="contactnomajout"  value="%$para{contactnomajout}%" size="50">
		            </td>
                   </tr>
	             </table>
                 <table width="100%" cellspacing="2" cellpadding="0">
                  <tr>
                    <td valign="middle" height="34" class="texte4" align="left">
                       &nbsp;%$firstname% :
                      <input type="text" name="contactprenomajout"  value="%$para{contactprenomajout}%" size="30">
                    </td>
                    <td valign="middle" class="texte4"  align="left">
                      %$fonction% :
                      <input type="text" name="contactfonctionajout" value="%$para{contactfonctionajout}%" size="30">
                    </td>
                  </tr>
                </table>
				<table width="100%" cellspacing="2" cellpadding="0">
                  <tr>
                    <td valign="middle" height="34" class="texte4" align="left">
                       &nbsp;%$telephones% :
                      <input type="text" name="contacttelajout"  value="%$para{contacttelajout}%" size="30">
                    </td>
                    <td valign="middle" class="texte4"  align="left">
                      %$e_mail% :
                      <input type="text" name="contactmailajout" value="%$para{contactmailajout}%" size="30">
                    </td>
                  </tr>
                </table>
              </td>
              <td valign="middle" width="80" align="center" class="message"> 
                <input type="image" name="ajouter" src="%$HTMLADRUNGICONES%/ajouter.gif" border="0" width="39" height="30">
                <span class="texterouge">%$messajout%</span> </td>            
          </table>
        </td>
      </tr>
    </table>
    <input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">
	<input type="hidden" name="script" value="%$script%">
	<input type="hidden" name="ajouter" value="10">
	%$champscache%
	</form>
 <!-- tache client -->
%%$listeLigTache%%
    <form method="post" action="%$CGIADR%/clientmodif.cgi" name="form">
	<table width="650" border="0" cellspacing="0" cellpadding="0" class="ligne3">
      <tr>
        <td align="center">
          <table width="651" cellpadding="0" cellspacing="2">
            <tr>
              <td colspan="8" class="texte4" align="left" height="13">%$addtache%</td>
            </tr>
            <tr>
              <td colspan="8" class="tetiere" align="left" height="3"></td>
            </tr>
          </table>
          <table width="650" cellpadding="0" cellspacing="0">
            <tr>
              <td>
                <table width="100%" cellspacing="2" cellpadding="0">
                  <tr>
                    <td height="69"  valign="middle" class="texte4" align="left">
                     *&nbsp;%$wordsort%:
					 <textarea name="tachelibelleajout" cols="40" wrap="virtual">%$para{tachelibelleajout}%</textarea>
	               </td>
                   <td height="69"  valign="middle" class="texte4" align="left">
                     *&nbsp;%$concerneduser%:
					 %$popupuser%
					 </td>
                   </tr>
	             </table>
                 <table width="100%" cellspacing="2" cellpadding="0">
                  <tr>
                    <td valign="middle" height="34" class="texte4" align="left">
                       &nbsp;%$day%* :
					   <input type="text" name="jourajout" value="%$para{jourajout}%" size="2" maxlength="2">
                    </td>
	                <td valign="middle" height="34" class="texte4" align="left">
                       &nbsp;%$month%* :
					   <input type="text" name="moisajout" value="%$para{moisajout}%" size="2" maxlength="2">
                    </td>
					<td valign="middle" height="34" class="texte4" align="left">
                       &nbsp;%$year%* :
					   <input type="text" name="anajout" value="%$para{anajout}%" size="4" maxlength="4">
                    </td>
	                <td valign="middle" height="34" class="texte4" align="left">
                       &nbsp;%$hour%* :
					   <input type="text" name="heureajout" value="%$para{heureajout}%" size="2" maxlength="2">
                    </td>
					<td valign="middle" height="34" class="texte4" align="left">
                       &nbsp;%$minute%* :
					   <input type="text" name="minajout" value="%$para{minajout}%" size="2" maxlength="2">
                    </td>
                  </tr>
                </table>
              </td>
              <td valign="middle" width="80" align="center" class="message"> 
                <input type="image" name="ajoutertache" src="%$HTMLADRUNGICONES%/ajouter.gif" border="0" width="39" height="30">
                <span class="texterouge">%$messajout%</span></td>
          </table>
        </td>
      </tr>
    </table>
    <input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">
	<input type="hidden" name="script" value="%$script%">
	<input type="hidden" name="ajoutertache" value="10">
	%$champscache%
	</form>
 <!-- fin tache client -->

  <table width="650" cellpadding="0" cellspacing="0">
    </tr>
      <td valign="bottom" align="left">
      	<a href="%$CGIADR%/%$script%.cgi?idmod=%$clientid%&usertype=%$type%&username=%$login%&%$ch%"><img src="%$HTMLADRUNGICONES%/retour.gif" border="0"></a>
        <span class="texterouge">%$messretour%</span>
      </td>
    </tr>
  </table>
<!-- fin  $enteteClient -->|;


#####maj contact########

my $enteteligContact = q|
<!-- debut $enteteligfact -->
<br><br>
    <form method="post" action="%$CGIADR%/clientmodif.cgi">
      <table width="650" cellpadding="3" cellspacing="1">
      <tr>
        <td class="tetiere"  align="center" valign="middle">%$namecontact%</td>
        <td class="tetiere"  align="center" valign="middle">%$firstname%</td>
        <td class="tetiere"  align="center" valign="middle">%$fonction%</td>
        <td class="tetiere"  align="center" valign="middle">%$telephones%</td>
        <td class="tetiere" align="center" valign="middle" >%$e_mail%</td>
        <td class="tetiere"  align="center" valign="middle">%$action%</td>
      </tr>
<!-- fin  $enteteligContact -->|;

my %ligneContact =();
tie %ligneContact,"Tie::IxHash";
$ligneContact{'1'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand -->
<!-- debut $modlig -->
     <TR>
        <TD align="center" valign="middle" class="texte2">%$rangee[1]%</TD>
        <TD align="center" valign="middle" class="texte3">%$rangee[2]% </TD>
        <TD align="center" valign="middle" class="texte2">%$rangee[3]%</TD>
        <TD align="center" valign="middle" class="texte2">%$rangee[4]%</TD>
		<TD align="center" valign="middle" class="texte2"><a href=mailto:%$rangee[5]%>%$rangee[5]%</a></TD>
        <!-- barre action -->
        <TD align="center" class="texte2">
          <table>
            <tr>
              <td align="left" valign="top">
                 <a href="javascript:suppcontact(%$rangee[0]%,'%$login%','%$type%','%$script%','%$ch%');"><img src="%$HTMLADRUNGICONES%/delete.gif" border="0" align="middle"></a>
              </TD>
              <TD align="left" valign="top">
                 <a href="%$CGIADR%/clientmodif.cgi?mod=%$rangee[0]%&username=%$login%&usertype=%$type%&script=%$script%&%$ch%"><img src="%$HTMLADRUNGICONES%/modifier.gif" border="0"></a>
              </TD>
            </TR>
          </table>
        </td>
     </tr>
     <!-- fin barre action -->        
<!-- fin  $modlig -->|;

$ligneContact{'2'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: mod -->
<!-- debut $modligmod -->         
<TR>
	<td colspan="5">		
	<table width="100%">
	<tr>	
        <TD align="center" valign="middle">
        	<input type="text" name="contactnommod" value="%$rangee[1]%" size="20">
        </TD>
        <TD align="center"  valign="middle">
			<input type="text" name="contactprenommod" value="%$rangee[2]%" size="10">
        </TD>
        <TD align="center" valign="middle">
        	<input type="text" name="contactfonctionmod" value="%$rangee[3]%" size="15">
        </TD>
		<TD align="center" valign="middle">
        	<input type="text" name="contacttelmod" value="%$rangee[4]%" size="15">
        </TD>
		<TD align="center" valign="middle">
        	<input type="text" name="contactmailmod" value="%$rangee[5]%" size="15">
        </TD>
        <!-- barre action -->
        <TD align="center">
          <table>
            <tr>
              <TD>
                 <input type="image" name="valide%" src="%$HTMLADRUNGICONES%/valider.gif" border="0">
                 <br><span class="texterouge">%$messmod%</span>
                 <input type="hidden" name="valide" value="%$rangee[0]%">
              </TD>
            </TR>
          </table>
        </td>
       </tr>
       </table>       
      </td>
        <!-- fin barre action -->
</tr>
<!-- fin $modligmod -->|;


my $finlistelig = q|
<input type="hidden" name="usertype" value="%$type%">
<input type="hidden" name="username" value="%$login%">
<input type="hidden" name="script" value="%$script%">
%$champscache%
</table>
</form>|;

########fin maj contact #########

######maj tache#######
my $enteteligTache = q|
<!-- debut $enteteligtache -->
<br><br>
    <form method="post" action="%$CGIADR%/clientmodif.cgi">
      <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	    <td class="tetiere"  align="center" valign="middle">%$wording%</td>
        <td class="tetiere"  align="center" valign="middle">%$concerneduser%</td>
        <td class="tetiere"  align="center" valign="middle">%$date%</td>
        <td class="tetiere"  align="center" valign="middle">%$hour%</td>
        <td class="tetiere"  align="center" valign="middle">%$action%</td>
      </tr>
<!-- fin  $enteteligContact -->|;

my %ligneTache =();
tie %ligneTache,"Tie::IxHash";
$ligneTache{'1'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand -->
<!-- debut $modlig -->
     <TR>
        <TD align="center" valign="middle" class="texte2">%$rangee[1]%</TD>
		<TD align="center" valign="middle" class="texte3">%$rangee[2]% </TD>
        <TD align="center" valign="middle" class="texte3">%$rangee[3]% </TD>
        <TD align="center" valign="middle" class="texte2">%$rangee[4]%</TD>
        <!-- barre action -->
        <TD align="center" class="texte2">
          <table>
            <tr>


<!-- fin $modlig -->|;

$ligneTache{'2'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand, maj -->
<!-- debut mod -->
              <TD align="left" valign="top">
                 <a href="%$CGIADR%/clientmodif.cgi?modtache=%$rangee[0]%&username=%$login%&usertype=%$type%&script=%$script%&%$ch%"><img src="%$HTMLADRUNGICONES%/modifier.gif" border="0"></a>
              </TD>
<!-- fin mod -->|;


$ligneTache{'3'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand, supp -->
<!-- debut supp -->
			  <td align="left" valign="top">
                 <a href="javascript:supptache(%$rangee[0]%,'%$login%','%$type%','%$script%','%$ch%');"><img src="%$HTMLADRUNGICONES%/delete.gif" border="0" align="middle"></a>
              </TD>
<!-- fin  supp -->|;

$ligneTache{'4'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand, fait, maj -->
<!-- debut fait -->
			  <TD align="left" valign="top">
                 <a href="%$CGIADR%/clientmodif.cgi?faittache=%$rangee[0]%&username=%$login%&usertype=%$type%&script=%$script%&%$ch%"><img src="%$HTMLADRUNGICONES%/faire.gif" border="0"></a>
              </TD>
<!-- fin  fait -->|;

$ligneTache{'5'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand, defait, maj -->
<!-- debut defait -->
			  <TD align="left" valign="top">
                 <a href="%$CGIADR%/clientmodif.cgi?defaittache=%$rangee[0]%&username=%$login%&usertype=%$type%&script=%$script%&%$ch%"><img src="%$HTMLADRUNGICONES%/defaire.gif" border="0"></a>
              </TD>
<!-- fin  defait -->|;

$ligneTache{'6'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand -->
<!-- debut fin barre action -->
            </TR>
          </table>
        </td>
     </tr>
<!-- fin fin barre action -->|;


$ligneTache{'7'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: mod -->
<!-- debut $modligmod -->         
<TR>
	<td colspan="5">		
	<table width="100%">
	<tr>
	    <TD align="center" valign="middle">
        	<input type="text" name="tachelibellemod" value="%$rangee[1]%" size="15">
        </TD>
        <TD align="center" valign="middle">
        	%$popup_2%
        </TD>
        <TD align="center" valign="middle">
        	<input type="text" name="jourmod" value="%$rangee[3]%" size="2">
        </TD>
        <TD align="center"  valign="middle">
			<input type="text" name="moismod" value="%$rangee[4]%" size="2">
        </TD>
        <TD align="center" valign="middle">
        	<input type="text" name="anmod" value="%$rangee[5]%" size="4">
        </TD>
        <TD align="center" valign="middle">
        	<input type="text" name="heuremod" value="%$rangee[6]%" size="2">
        </TD>
        <TD align="center"  valign="middle">
			<input type="text" name="minmod" value="%$rangee[7]%" size="2">
        </TD>
        <!-- barre action -->
        <TD align="center">
          <table>
            <tr>
              <TD>
                 <input type="image" name="validetache" src="%$HTMLADRUNGICONES%/valider.gif" border="0">
                 <br><span class="texterouge">%$messmod%</span>
                 <input type="hidden" name="validetache" value="%$rangee[0]%">
              </TD>
            </TR>
          </table>
        </td>
       </tr>
       </table>       
      </td>
        <!-- fin barre action -->
</tr>
<!-- fin $modligmod -->|;


my $finlisteligTache = q|
<input type="hidden" name="usertype" value="%$type%">
<input type="hidden" name="username" value="%$login%">
<input type="hidden" name="script" value="%$script%">
%$champscache%
</table>
</form>|;
######fin maj tache#######

my $ligCoordClientMod = q|
<table width="650" cellpadding="3" cellspacing="1">
      <tr>
      <td class="ligne1"> * %$name% :&nbsp;&nbsp;
	  		<input name="clientnomajout" type="text" value="%%$clientnom%%"  size="50">
      </td>
      <td valign="middle" class="ligne1" align="left"> %$client_statut% :
 		   %$popupstatutcli%
      </td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
		<td class="ligne2">%$name2% :&nbsp;&nbsp;
				<input name="clientnom2ajout" type="text" value="%%$clientnom2%%"  size="50">
		</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">%$qualification% :&nbsp;&nbsp;
	  		<input name="clienttitreajout" type="text" value="%%$clienttitre%%"  size="50">
	  	</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne2">* %$street% :
	  		<input name="clientrue1ajout" type="text" value="%%$clientrue1%%" size="50">
	  	</td>
	  	<td class="ligne2">* %$postal% :
	  		<input name="clientcpajout" type="text" value="%%$clientcp%%" size="20">
	  	</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">* %$city% :&nbsp;&nbsp;
	  	   <input name="clientvilleajout" type="text" value="%%$clientville%%" size="50">
	  	</td>
	  	<td class="ligne1">%$country% :&nbsp;&nbsp;
	  		<input name="clientpaysajout" type="text" value="%%$clientpays%%" size="30">
	  	</td>
	  </tr>
    </table>
|;

my $ligCoordClientNoMod = q|
<table width="650" cellpadding="3" cellspacing="1">
      <tr>
      <td class="ligne1"> * %$name% :&nbsp;&nbsp;
	  		<input name="clientnomajout" type="text" value="%%$clientnom%%"  size="50">
      </td>
 		<td valign="middle" class="ligne1" align="left"> %$client_statut% : %%$statut%%
          <input type="hidden" name="statutajout"  value="%%$statut%%">
      </td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
		<td class="ligne2">%$name2% :&nbsp;&nbsp;
				<input name="clientnom2ajout" type="text" value="%%$clientnom2%%"  size="50">
		</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">%$qualification% :&nbsp;&nbsp;
	  		<input name="clienttitreajout" type="text" value="%%$clienttitre%%"  size="50">
	  	</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne2">* %$street% :
	  		<input name="clientrue1ajout" type="text" value="%%$clientrue1%%" size="50">
	  	</td>
	  	<td class="ligne2">* %$postal% :
	  		<input name="clientcpajout" type="text" value="%%$clientcp%%" size="20">
	  	</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">* %$city% :&nbsp;&nbsp;
	  	   <input name="clientvilleajout" type="text" value="%%$clientville%%" size="50">
	  	</td>
	  	<td class="ligne1">%$country% :&nbsp;&nbsp;
	  		<input name="clientpaysajout" type="text" value="%%$clientpays%%" size="30">
	  	</td>
	  </tr>
    </table>
|;


#hachage pour le message du bouton retour
my %messretour = ('clients' => $messretourlisteclient,
				  'factmodif' => $messretourmajfact,
				  'propal' => $messretourmajpropal,
				  'commande' => $messretourmajcde,
				  'taches' => $messretourmajtache
				  );
				  
				  
sub majClient{
	my ($clientid,$type,$login,$title,$refpara,$refenteteClient,$reflisteligContact,
	$reflistetache,$reflistestatut,$reftabcommercial ,$reftabuser,$mess,$readonly,$script)=@_;
	#on recupere les variables avec les valeurs necc pour l'affichage
    #et on formate les valeurs pour l'affichage
	my $ch = '';	
	($refpara,$ch) = &getParam(%$refpara);
	my %para = %$refpara;	
	my $champscache = &getHidden(%para);
	if(exists $para{"toupdate"}){
	   $champscache .= &AffichLig($hidden,"toupdate",$para{"toupdate"});
	   $ch .= "&toupdate=$para{toupdate}";
	}
	#faire les listes deroulantes				
    my @num=(12,16);

    #pour une facture qu'on cre, on force la valeur selectionne
    #de la liste deroulante sur la valeur selectionnee lors de la creation ratee

    my ($statutcli,$clientcommercial) =
     ($para{"statutajout"}, $para{"commercialajout"});

    my $messretour = $messretour{$script};
    #si la facture existe, on force les listes deroulantes sur les valeurs
    #de la facture 
    if($clientid){
		($statutcli,$clientcommercial)=@$refenteteClient[@num];
	}
	########
	my $user = 0;
    ########
	my $popupstatutcli = &getPopup($reflistestatut,$statutcli,"statutajout");
    my $popupcommercial = &getPopup($reftabcommercial,$clientcommercial,"commercialajout");
    my $popupuser = &getPopup($reftabuser,$user,"tacheuseridajout");
	#my $onload = '';
	my $onload = exists ($para{'notexiste'}) ? $onloadEcran:'';
	#construction de la page
	my $page=$body.&AffichLig(&affiche_barre($type,\%navigation,'clients'),$type,$login).$titrePage;
	if($mess){$page .= $messPage;}
	if($clientid){
		$page .= &ModifierClient($clientid,$refenteteClient,$reflisteligContact,$reflistetache,\%para,$type,$readonly);
	}
	else{$page .= &CreerClient(\%para);}
	$page =~ s/%(\$\w+)%/$1/gee;
	&AffichPageWeb($title,$page);
	return;
} 


#pour modifier une facture
sub ModifierClient{
	my ($numfact,$refenteteClient,$reflisteligContact,$reflistetache,$refpara,$type,$readonly)=@_;
	my %para = %$refpara;
	#recup valeurs entete
	my ($clientid,$clientnom,$clientnom2 , $clienttitre, $clientville,
       $clientrue1, $clientcp, $clientpays, $tel1, $tel2, $email,$fax,
	   $statut, $secteur_act, $ca, $soc_mere,$clientcommercial, 
	   $remise_defaut, $clientresponsable, $cafact)=@$refenteteClient;
	

    foreach my $val($ca,$cafact){
      $val = &formatNombre($val);
    }
	my $ligCoordClient = $readonly?$ligCoordClientNoMod:$ligCoordClientMod;
	#date d'une tache en ajout = date du jour par defaut
	if(!exists $para{"jourajout"} && !exists $para{"moisajout"} && !exists $para{"anajout"}){
            ($para{"jourajout"},$para{"moisajout"},$para{"anajout"}) = &sec_calend(time);
	}
	my $onload = '';
    #if($para{"readonly"}){
	my $page .=$enteteClient;

	#liste des lignes contact
    my $listeLigContact = '';
	if(my @lignes = @$reflisteligContact){
		my %ligLigneDroit=();
        tie %ligLigneDroit,"Tie::IxHash";
        %ligLigneDroit = &getHashAffich(\%ligneContact,$type);
        #formater la liste des factures a afficher
        $listeLigContact = &makeListe($reflisteligContact,\%ligLigneDroit);
        $listeLigContact = $enteteligContact.$listeLigContact.$finlistelig;
        $page =~ s/%%\$listeLigContact%%/$listeLigContact/;
    }
    #liste des taches
    my $listeLigTache = '';
    if(my @lignes = @$reflistetache){
		my %ligLigneDroit=();
        tie %ligLigneDroit,"Tie::IxHash";
        %ligLigneDroit = &getHashAffich(\%ligneTache,$type);
        #formater la liste des factures a afficher
        $listeLigTache = &makeListe($reflistetache,\%ligLigneDroit);
        $listeLigTache = $enteteligTache.$listeLigTache.$finlisteligTache;
        $page =~ s/%%\$listeLigTache%%/$listeLigTache/;
    }
    $page =~ s/%%\$ligCoordClient%%/$ligCoordClient/;
	#pour ajouter une ligne de facture
	$page =~ s/%%(\$\w+)%%/$1/gee;
	$page =~ s/%(\$\w+\{\w+\})%/$1/gee;
	#sub sur %% pour substituer seulement les valeurs passees,
	#sinon substitue les valeurs non passees par ''!
    return $page;
}


#pour creer une facture
sub CreerClient{
	my ($refpara) = @_;
	my %para = %$refpara;	

    my $page .=$enteteClientCreat;
    $page =~ s/%(\$\w+\{\w+\})%/$1/gee;
    $page  =~ s/%%(\$\w+)%%/$1/gee;
    return $page;
}


1;
END{}
