=pod

package de variables pour les factures
propres au theme UNGI

=cut

package UNGI::DetailClients;

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../../lib','../';	
} 

use strict;
use CGI  qw(:standard);
use Conf;
use Util;
use lang::Fr;
use UNGI::General; 


BEGIN{
	use Exporter;
	use vars qw($VERSION @ISA @EXPORT);
	$VERSION = 1.00;
	@ISA = qw(Exporter);
	@EXPORT= qw(&AffichClients &affichNoClient);
		
}

use vars  @EXPORT;



##########################
#modifier/creer un client
##########################

my $enteteClient = q|
<!-- debut  $enteteClient -->
<table width="650" class="ligne3" cellpadding="3" cellspacing="0">
    <tr>
      <td  class="texte4" align="left" width="20%">%$idclient% :</td>
      <td class="textegras">%$clientid%</td>
    </tr>
</table>

<table width="650" cellpadding="3" cellspacing="1">
      <tr>
        <td class="ligne1">%$name%&nbsp;:&nbsp;%$clientnom%</td>
 		<td valign="middle" class="ligne1" align="left"> %$client_statut% : %$statut%</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
		<td class="ligne2">%$name2%&nbsp;:&nbsp;%$clientnom2%</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">%$qualification%;&nbsp;%$clienttitre%:&nbsp</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne2">* %$street% : %$clientrue1%</td>
	  	<td class="ligne2">* %$postal% : %$clientcp%</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">%$city% : %$clientville%</td>
	  	<td class="ligne1">%$country% :%$clientpays%</td>
	  </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne2">%$telephone%&nbsp;:&nbsp;%$tel1%</td>
		<td class="ligne2">%$telephone2%&nbsp;:&nbsp;%$tel2%</td>
     </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">%$e_mail%&nbsp;:&nbsp;%$email%</td>
		<td class="ligne1">%$telecopie%&nbsp;:&nbsp;%$fax%</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne2">%$secteuract%&nbsp;:&nbsp;%$secteur_act%</td>
		<td class="ligne2">%$casociete%&nbsp;:%$ca%&nbsp;</td>
	  </tr>
    </table>
	 <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">%$socmere%&nbsp;:&nbsp;%$soc_mere%</td>
		<td class="ligne2">%$client_ca_fact% :&nbsp;&nbsp;%$cafact%&nbsp;&nbsp;&euro;</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">%$namecommercial%&nbsp;:&nbsp;%$clientcommercial%</td>
      </tr>
    </table>
    <form method="post" action="%$CGIADR%/detailclient.cgi">
	<table width="500" border="0" cellspacing="0" cellpadding="0">
          <tr>
            <td align="center" valign="middle">
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGICONES%/premier.gif" width="31" height="22" align="middle">
            </td>
            <td align="center"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle">
              <input type="image" border="0" name="precedent" src="%$HTMLADRUNGICONES%/gauche.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle">
              <input type="image" border="0" name="suivant" src="%$HTMLADRUNGICONES%/droite.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle">
              <input type="image" border="0" name="dernier" src="%$HTMLADRUNGICONES%/dernier.gif" width="30" height="22" align="middle">
            </td>
          </tr>
    </table>
	<input type="hidden" name="clientid" value="%$clientid%">
    <input type="hidden" name="nom" value="%$clientnom%">
	</form>
<!-- fin  $enteteClient -->|;

########fin maj contact #########


sub AffichClients{
	my ($clientid,$clientnom,$clientnom2,$clienttitre,$clientville,$clientrue1,$clientcp,
	$clientpays,$tel1,$tel2,$email, $fax,$statut,$secteur_act,$ca, $soc_mere,$clientcommercial)
    = @_;

	(my $page = $enteteClient) =~ s/%(\$\w+)%/$1/gee;
	&AffichPageWeb('',$page);
    return;
}

my $fenNoClient = q|
<HTML>
    <HEAD>
      <TITLE>commentaires</TITLE>
    </HEAD>
    <BODY BGCOLOR="#ffffff">
    Il n'y a pas de Client dont le nom exacte est : %$nom%!
      <form>
        <input type="button" value="cliquez ici pour fermer" onClick="self.close();">
      </form>
   </BODY>
  </HTML>|;

=head2 affichNoClient

affiche un message disant qu'il n'y a pas de client dont le nom est $nom

=cut

sub affichNoClient{
	my ($nom) = @_;
    (my $page = $fenNoClient) =~ s/%(\$\w+)%/$1/gee;
	print header;
	print $page;
	return;
}


1;
END{}
