=pod

package de variables pour les entrees
propres au theme UNGI

=cut

package UNGI::Entree;

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../../lib','../';	
} 

use strict;
use CGI  qw(:standard);
use Conf;
use Util;
use lang::Fr;
use UNGI::General; 


BEGIN{
	use Exporter;
	use vars qw($VERSION @ISA @EXPORT);
	$VERSION = 1.00;
	@ISA = qw(Exporter);
	@EXPORT= qw(&ListeEntree &majEntree);	
		
}

use vars  @EXPORT;

###########################
#liste des entrees
###########################

my $ListeFacture = q|
<!-- debut  $ListeFacture -->
    <table width="760" cellspacing="1" cellpadding="0" align="center">
      <tr align="center">
          <TD class="tetiere" align="center">%$id%</TD>
          <TD class="tetiere" height="35">%$name%</TD>
          <TD class="tetiere" height="35">%$date%</TD>
          <TD class="tetiere" height="35"> %$totalwithouttax% &euro;</TD>
          <TD class="tetiere" height="35"> %$totalwithtax% &euro;</TD>
          <TD class="tetiere" height="35">%$billstatus%</TD> 
          <TD class="tetiere" height="35">%$action%</TD>
      </TR>
     %$liste%
     <tr align="center"> 
        <td class="tetiere" colspan="3" height="20">%$sum% &euro;</td>        
        <td class="tetiere" height="20">%$sumHT%</td>
        <td class="tetiere" height="20">%$sumTTC%</td>
        <td class="tetiere" colspan="2" height="20">&nbsp;</td>
      </tr>
    </table>
    <br>   
<form method="post" action="%$CGIADR%/entrees.cgi" name="formulaire">
<table width="760" align="center">
    <tr align="center"> 
      <td class="tetiere2">%$searchby%&nbsp;:</td>
    </tr>
  </table>
  <table width="760" dwcopytype="CopyTableRow" align="center" cellpadding="3" cellspacing="1">
    <tr> 
      <td class="ligne1"> %$id%&nbsp;: 
        <input type="text" name="numfacttri"  size="10" value="%$para{numfacttri}%">
      </td>
      <td class="ligne1"><span class="ligne1"><span class="ligne1">%$name%  : </span> </span>
        %$popupcli%         
      </td>
    </tr>
  </table>
  <table width="760" align="center" cellpadding="3" cellspacing="1">
    <tr> 
      <td class="ligne2" width="320"> %$billdate% (JJ/MM/AAAA) : 
        <input type="text" name="jourtri"  size="2" maxlength="2" value="%$para{jourtri}%">
        <input type="text" name="moistri"  size="2" maxlength="2" value="%$para{moistri}%">
        <input type="text" name="antri"  size="4" maxlength="4" value="%$para{antri}%">
      </td>      
    </tr>
  </table>
  <table width="760" align="center" cellpadding="3" cellspacing="1">
    <tr> 
      <td class="ligne1" width="320">%$totalwithouttax% &euro; :
        <input type="text" name="totHTtri"  size="20" value="%$para{totHTtri}%">
      </td>
      <td class="ligne1" width="320">  %$totalwithtax% &euro; :
        <input type="text" name="totTTCtri"  size="20" value="%$para{totTTCtri}%">
      </td>      
    </tr>
    <tr> 
      <td class="tetiere2" colspan="2" height="10"></td>
    </tr>
  </table>
  <br>
  <table width="500" border="0" cellspacing="0" cellpadding="5" align="center" class="ligne3">
    <tr>
      <td align="center">
        <table width="350" align="center">
          <tr> 
            <td><span class="texte4">%$sortby%</span> 
              %$popuptri%
            </td>
          </tr>
        </table>
        <table width="350" align="center">
          <tr> 
            <td class="texte4" align="left" valign="middle">%$linenumber% :</td>
            <td> 
              <input type="text" name="nbligtri" value="%$nb%" size="4" maxlength="3">
            </td>
            <td class="texte4" align="center" valign="middle">%$ontotal% %$taille%</td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGICONES%/reload.gif" width="31" height="36">
            </td>
          </tr>
        </table>
        <table width="500" border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGICONES%/premier.gif" width="31" height="22" align="middle">
            </td>
            <td align="center"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="precedent" src="%$HTMLADRUNGICONES%/gauche.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="suivant" src="$HTMLADRUNGICONES%/droite.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="dernier" src="%$HTMLADRUNGICONES%/dernier.gif" width="30" height="22" align="middle">
            </td>
          </tr>
        </table>        
      </td>
    </tr>
  </table> 
	<input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">
	<input type="hidden" name="pcdt" value="%$orderpcd%">
	<input type="hidden" name="suiv" value="%$ordersuiv%">
	<input type="hidden" name="chaine" value="%$ch%">
	</form>
	<table width="500" cellpadding="0" cellspacing="0" border="0" align="center">
        <tr>          
        <td align="center" valign="bottom" height="30">&nbsp;</td>
        <td align="center" valign="bottom" colspan="3" height="30">
            <a href="%$CGIADR%/login.cgi"><img src="%$HTMLADRUNGICONES%/quitter2.gif" border="0"></a>
        </td>
      </tr>
     </table>
<!-- fin  $ListeFacture -->|;

#hachage regroupant les differentes parties d'une ligne de facture
my %ligFacture = ();
tie %ligFacture,"Tie::IxHash";;
#une ligne de la liste
$ligFacture{'begin'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand -->
<!-- une ligne = 1  ligne de facture -->
  <tr align="center"> 
        <td class="numero">%$rangee[0]%</td>
        <td class="texte2">
			<a href="%$CGIADR%/clientmodif.cgi?clientid=%$rangee[6]%&username=%$login%&usertype=%$type%">%$rangee[1]%</a>
		</td>
        <td class="texte3">%$rangee[2]%</td>
        <td class="texte2">%$rangee[3]%</td>
        <td class="texte3">%$rangee[4]%</td>
        <td class="texte2">%$rangee[5]%</td>        
        <td class="texte2"> 
          <table cellspacing="3" cellpadding="0" align="left">
            <tr> 
|;

$ligFacture{'modif'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: mod -->
<!-- une ligne = 1  ligne de facture en modif --> 
<tr align="center"> 
        <td class="couleur">%$rangee[0]%</td>
        <td class="couleur">
			<a href="%$CGIADR%/clientmodif.cgi?clientid=%$rangee[6]%&username=%$login%&usertype=%$type%">%$rangee[1]%</a>
		</td>
        <td class="couleur">%$rangee[2]%</td>
        <td class="couleur">%$rangee[3]%</td>
        <td class="couleur">%$rangee[4]%</td>
        <td class="couleur">%$rangee[5]%</td>        
        <td class="texte2"> 
          <table cellspacing="3" cellpadding="0" align="left">
            <tr> 
|;

$ligFacture{'1'} = q|
<!-- Restricted-to: anybody -->
<!-- editer une facture -->
                  <td>                  	
				  	 <a href="%$CGIADR%/editfact.cgi?edit=%$rangee[0]%&username=%$login%&usertype=%$type%&script=entrees" target="coucou"><img src="%$HTMLADRUNGICONES%/voir.gif" border="0"></a>
				  </td>
|;





$ligFacture{'2'} = q|
<!-- Forbidden-to: comptable commercial chefprojet chargeprojet supercommercial client -->
<!-- regler une facture -->
				  <td> 
				  		<a href="%$CGIADR%/regler.cgi?numfact=%$rangee[0]%&username=%$login%&usertype=%$type%&%$ch%"> 
                    		<img src="%$HTMLADRUNGICONES%/regler2.gif" border="0"></a>						 
				  </td>
|;


$ligFacture{'3'} = q|
<!-- Restricted-to: anybody -->
<!-- dupliquer une facture -->
                  <td align="center" valign="middle"> 
				  	 <a href="%$CGIADR%/editfact.cgi?duplicata=%$rangee[0]%&username=%$login%&usertype=%$type%&script=entrees" target="coucou">
                    	 <img src="%$HTMLADRUNGICONES%/duplibouton.gif" border="0"></a> 					 
				 </td>				 
|;

$ligFacture{'end'} = q|
<!-- Restricted-to: anybody -->
<!-- fin lignefacture -->      
                </tr>
              </table>
              <!-- fin barre action -->
            </td>
          </tr>
|;       



sub ListeEntree{	
	my ($type,$login,$orderpcd,$ordersuiv,$nb,$taille,$title,$sumHT,$sumTTC,$reftabAffich,
	$refpara,$reftabcli,$reftab) = @_;
	#on recupere les variables avec les valeurs necc pour l'affichage
    #et on formate les valeurs pour l'affichage    
	my $ch = '';	
	($refpara,$ch) = &getParam(%$refpara);
	my %para = %$refpara;
	#faire les listes droulantes	
    my $popupcli = &getPopup($reftabcli,$para{"clientidtri"},"clientidtri");
    my $popuptri = &getPopup($reftab, $para{"tri"},"tri");   
	#my $onload = '';
	my $onload = exists ($para{'notexiste'}) ? $onloadEcran:'';
    #faire la liste des factures a afficher avec seulement les boutons 
    #que l'utilisateur a le droit de voir
	my %ligFactureDroit=();
    tie %ligFactureDroit,"Tie::IxHash";
    
    %ligFactureDroit = &getHashAffich(\%ligFacture,$type);
    #formater la liste des factures a afficher    
    my $liste = &makeListe($reftabAffich,\%ligFactureDroit);    
    #remplir avec les valeurs la ligne des sommes, formatees 
    foreach my $val ($sumHT,$sumTTC){ 
      $val = &formatNombre($val);      
    }   
    
    #construire la page
	my $page = $body.&AffichLig(&affiche_barre($type,\%navigation,'entrees'),$type,$login).$titrePage;
	 
	$page .= $ListeFacture;     
	$page =~ s/%(\$\w+(\{\w*\})?)%/$1/gee;
	$page =~ s/%(\$\w+)%/$1/gee;
	&AffichPageWeb($title,$page);
	return;
}


##############################
#mise a regler d'une entree
##############################

my $affichRegler = q|
<!-- debut $affichRegler -->
<form method="post" action="%$CGIADR%/regler.cgi" enctype="application/x-www-form-urlencoded">
    <table width="650" class="ligne3" cellpadding="3" cellspacing="0">
      <TR >         
        <TD  class="texte4" align="left" width="20%">%$idbill% :</TD>
        <TD class="textegras">%$numfact%</TD>
        <TD  class="texte4" align="left" width="20%">%$namecli% </TD>
        <TD class="textegras"> %$clientnom%</TD>         
      </tr>
    </table>
    <table width="650" class="ligne3" cellpadding="3" cellspacing="0">
      <tr> 
        <TD class="texte4" align="left" width="20%"> 
           %$responsable% : 
		</TD>
        <TD class="textegras">  %$responsablecde%</TD>        
        <TD class="texte4" align="left" width="20%"> 
		   %$contactfact%  : 
		</TD>
        <TD class="textegras"> %$contact% </TD>         
      </TR>
      <TR > 
        <TD class="texte4" align="left" width="20%">%$idorder% :</TD>
        <TD class="textegras"> %$refcde% </TD>          
        <TD class="texte4" align="left" width="20%"> 
           %$billstatus% :
		 </TD>
        <TD class="textegras"> %$statutfact%</TD>           
    </tr>
    </table>
    <table width="650" class="ligne3" cellpadding="3" cellspacing="0">
    <TR> 
        <TD class="texte4" align="left"> 
        	%$billdate%
        </TD>
        <TD class="texte1" align="right">%$day% :</TD>
        <TD class="textegras" align="left"> %$jourf% </TD>           
        <TD class="texte1" align="right">%$month% :</TD>
        <TD class="textegras" align="left">%$moisf%</TD>            
        <TD class="texte1" align="right">%$year%:</TD>          
        <TD class="textegras" align="left"> %$anf%</TD>         
      </TR>
    </table>    
    <table width="650" class="ligne3" cellpadding="3" cellspacing="0">
      <tr> 
        <TD class="texte4" align="left" width="20%"> 
           %$totalwithouttax% &euro;: 
		</TD>
        <TD class="textegras">%$totHT%</TD>
        <TD class="texte4" align="left" width="20%">%$totalwithtax% &euro;:</TD>
        <TD class="textegras">%$totTTC%</TD>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">    
        <TD valign="middle" class="ligne1" align="left">%$pricemovement% &euro;:         
          <input type="text" name="fraisdepltmod"  value="%$fraisdeplt%">
        </TD>           
      </TR>      
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <TR> 
        <td class="ligne2"> %$modepaiement% :
          %$popupmodepai%
        </td>
        <TD valign="middle" class="ligne2" align="left">%$idcheque% :
          <input type="text" name="numchequemod" value="%$numcheque%" size="30">
        </TD>
        <TD valign="middle" class="ligne2" align="left" >%$bank% : 
          <input type="text" name="banquereglementmod" value="%$banquereglement%" size="30">
        </TD>
      </TR>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">      
      <TR> 
        <TD valign="middle" class="ligne1" align="left">%$regulationdate% - </TD>
        <TD valign="middle" class="ligne1" align="left">%$day%  : 
          <input type="text" name="jourr"  value="%$jourr%" size="2" maxlength="2">
        </TD>
        <TD valign="middle" class="ligne1" align="left">%$month% : 
          <input type="text" name="moisr"  value="%$moisr%" size="2" maxlength="2">
        </TD>
        <TD valign="middle" class="ligne1" align="left">%$year% :
          <input type="text" name="anr"  value="%$anr%" size="4" maxlength="4">
        </TD>
      </TR>
    </table>
    <table width="600">
      <tr> 
        <TD width="130" valign="middle"> 
          <input type="image" name="valider" src="%$HTMLADRUNGICONES%/%$valider%.gif" border="0">
        </TD>
        <TD width="456" valign="middle" class="texterouge" align="left" >%$messreglement%</TD>
      </tr>
    </table>
	<input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">
	<input type="hidden" name="valider" value="10">	
	%$champscache%	
</form>
<table width="600">
	<tr>
	  <td width="130">
	     <a href="%$CGIADR%/editfact.cgi?edit=%$numfact%" target="coucou"><img src="%$HTMLADRUNGICONES%/voir_facture.gif" border="0"></a>
	  </td>
	  <td class="texterouge" align="left" width="456">%$messedit%</td>
	</tr>
	<tr> 
	 <td>
		<a href="%$CGIADR%/entrees.cgi?username=%$login%&usertype=%$type%&idmod=%$numfact%&%$ch%"><img src="%$HTMLADRUNGICONES%/%$retour%.gif" border="0"></a>
	</td>
	<td class="texterouge" align="left">%$messretourentree%</td>
	</tr>
</table>
<!-- fin $affichRegler -->|;		   




sub majEntree{
    my ($numfact,$type,$login,$refpara,$refEntree, $refpaiement,$mess) = @_;
    my $title = $titlereglerfact;
    my ($clientidfact,$clientnom, $responsablecde, $refcde, $datefact, $statutfact,$fraisdeplt, 
    $totHT, $totTTC,$contact, $datereglement,$banquereglement, $numcheque,$paiement)=@$refEntree;
    #recuperation des variables
    my $ch = '';	
	($refpara,$ch) = &getParam(%$refpara);	
	my %para = %$refpara;
	my $champscache = &getHidden(%para);
    my ($retour,$valider) = $mess ? ("retour", "valider"): ("abandonner", "regler");
    my ($jourf, $moisf, $anf)=&sec_calend($datefact);
    my ($jourr, $moisr, $anr)=&sec_calend(time);
    if($datereglement){
	  ($jourr, $moisr, $anr)=&sec_calend($datereglement);
    }

    foreach my $val($fraisdeplt,$totHT,$totTTC){  
        $val = &formatNombre($val);
    }
    

    my $popupmodepai = &getPopup($refpaiement,$paiement,"paiementmod");
	my $onload = '';
    #construction de la page a afficher
    my $page=$body.&AffichLig(&affiche_barre($type,\%navigation,'entrees'),$type,$login).$titrePage;
	if($mess){$page .= $messPage;}	
	$page .= $affichRegler;		
		
	$page =~ s/%(\$\w+)%/$1/gee;
	&AffichPageWeb($title,$page);
    
    return;
}


1;
END{}


