####
# Modified by Nicolas SCHMELTZ for Abtey Prod.
#
# 03/10/2003 : gestion des remises
#
####

=pod

package de variables pour les factures
propres au theme UNGI

=cut

package UNGI::Facture;

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../../lib','../';	
} 

use strict;
use CGI  qw(:standard);
use Conf;
use Util;
use lang::Fr;
use UNGI::General; 


BEGIN{
	use Exporter;
	use vars qw($VERSION @ISA @EXPORT);
	$VERSION = 1.00;
	@ISA = qw(Exporter);
	@EXPORT= qw(&ListeFacture &majFacture &affichCommentFacture);	
		
}

use vars  @EXPORT;

###########################
#liste des factures
###########################

my $ListeFacture = q|
<!-- debut  $ListeFacture -->
    <table width="760" cellspacing="1" cellpadding="0" align="center">
      <tr align="center">
          <TD class="tetiere" align="center">%$id%</TD>
          <TD class="tetiere" height="35">%$name%</TD>
          <TD class="tetiere" height="35">%$date%</TD>
          <TD class="tetiere" height="35"> %$totalwithouttax% &euro;</TD>
          <TD class="tetiere" height="35"> %$remise%</TD>
          <TD class="tetiere" height="35"> %$totalwithtax% &euro;</TD>
          <TD class="tetiere" height="35">%$billstatus%</TD>
          <TD class="tetiere" height="35">%$billsend%</TD>
          <TD class="tetiere" height="35">%$datepayment%</TD>            
          <TD class="tetiere" height="35">%$action%</TD>
      </TR>
     %$liste%
     <tr align="center"> 
        <td class="tetiere" colspan="3" height="20">%$sum% &euro;</td>
        <td class="tetiere" height="20">%$sumHT%</td>
        <td class="tetiere" height="20">__</td>
        <td class="tetiere" height="20">%$sumTTC%</td>
        <td class="tetiere" colspan="4" height="20">&nbsp;</td>
      </tr>
    </table>
    <br>   
<form method="post" action="%$CGIADR%/facture.cgi" name="formulaire">
<table width="760" align="center">
    <tr align="center"> 
      <td class="tetiere2">%$searchby%&nbsp;:</td>
    </tr>
  </table>
  <table width="760" dwcopytype="CopyTableRow" align="center" cellpadding="3" cellspacing="1">
    <tr> 
      <td class="ligne1"> %$id%&nbsp;: 
        <input type="text" name="numfacttri"  size="20" value="%$para{numfacttri}%">
      </td>
      <td class="ligne1">%$namecli%  :
        <input type="text" name="nomclitri"  size="30" value="%$para{nomclitri}%">
      </td>
     </tr>
   </table>
   <table width="760" dwcopytype="CopyTableRow" align="center" cellpadding="3" cellspacing="1">   
     <tr>      
      <td class="ligne2">%$customername%  :
        %$popupcli%                 
      </td>      
    </tr>
  </table>
  <table width="760" align="center" cellpadding="3" cellspacing="1">
    <tr> 
      <td class="ligne1" width="320"> %$billdate% (JJ/MM/AAAA) : 
        <input type="text" name="jourtri"  size="2" maxlength="2" value="%$para{jourtri}%">
        <input type="text" name="moistri"  size="2" maxlength="2" value="%$para{moistri}%">
        <input type="text" name="antri"  size="4" maxlength="4" value="%$para{antri}%">
      </td>
      <td class="ligne1">%$datepayment% :
        %$popupecheance%
      </td>
      <td class="ligne1">%$billstatus% :
        %$popupstatut%
      </td>
    </tr>
  </table>     
  <table width="760" align="center" cellpadding="3" cellspacing="1">
    <tr>
      <td class="ligne2"> %$regulationdate% (JJ/MM/AAAA) :
        <input type="text" name="jourrtri"  size="2" maxlength="2" value="%$para{jourrtri}%">
        <input type="text" name="moisrtri"  size="2" maxlength="2" value="%$para{moisrtri}%">
        <input type="text" name="anrtri"  size="4" maxlength="4" value="%$para{anrtri}%">
      </td>
      <td class="ligne2"> %$idcheque%
        <input type="text" name="numchequetri"  size="15" value="%$para{numchequetri}%">
      </td>
	  <td class="ligne2"> %$billSent% :
		%$popupsent%
      </td>
    </tr>  
  </table>
  <table width="760" align="center" cellpadding="3" cellspacing="1">
    <tr> 
      <td class="ligne1">%$totalwithouttax% &euro;
        <input type="text" name="totHTtri"  size="20" value="%$para{totHTtri}%">
      </td>
      <td class="ligne1">%$totalwithtax% &euro;
        <input type="text" name="totTTCtri"  size="20" value="%$para{totTTCtri}%">
      </td>      
    </tr>
    <tr> 
      <td class="tetiere2" colspan="2" height="10"></td>
    </tr>
  </table>
  <br>
  <table width="500" border="0" cellspacing="0" cellpadding="5" align="center" class="ligne3">
    <tr>
      <td align="center">
        <table width="350" align="center">
          <tr> 
            <td><span class="texte4">%$sortby%</span> 
              %$popuptri%
            </td>
          </tr>
        </table>
        <table width="350" align="center">
          <tr> 
            <td class="texte4" align="left" valign="middle">%$linenumber%</td>
            <td> 
              <input type="text" name="nbligtri" value="%$nb%" size="4" maxlength="3">
            </td>
            <td class="texte4" align="center" valign="middle">%$ontotal% %$taille%</td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGICONES%/reload.gif" width="31" height="36">
            </td>
          </tr>
        </table>
        <table width="500" border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGICONES%/premier.gif" width="31" height="22" align="middle">
            </td>
            <td align="center"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="precedent" src="%$HTMLADRUNGICONES%/gauche.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="suivant" src="%$HTMLADRUNGICONES%/droite.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="dernier" src="%$HTMLADRUNGICONES%/dernier.gif" width="30" height="22" align="middle">
            </td>
          </tr>
        </table>        
      </td>
    </tr>
  </table> 
	<input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">
	<input type="hidden" name="pcdt" value="%$orderpcd%">
	<input type="hidden" name="suiv" value="%$ordersuiv%">
	<input type="hidden" name="chaine" value="%$ch%">
	</form>
	%$boutonBasFact%
<!-- fin  $ListeFacture -->|;

#hachage regroupant les differentes parties d'une ligne de facture
my %ligFacture = ();
tie %ligFacture,"Tie::IxHash";;
#une ligne de la liste
$ligFacture{'begin'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand -->
<!-- une ligne = 1  ligne de facture -->
  <tr align="center"> 
        <td class="numero">%$rangee[0]%</td>
        <td class="texte2">
			<a href="%$CGIADR%/clientmodif.cgi?clientid=%$rangee[9]%&username=%$login%&usertype=%$type%">%$rangee[1]%</a>
		</td>
        <td class="texte3">%$rangee[2]%</td>
        <td class="texte2">%$rangee[3]%</td>
        <td class="texte3">%$rangee[8]%</td>
        <td class="texte2">%$rangee[4]%</td>
        <td class="texte3">%$rangee[5]%</td>
        <td class="texte2">%$rangee[6]%</td>
        <td class="texte3">%$rangee[7]%</td>
        <td class="texte2"> 
          <table cellspacing="3" cellpadding="0" align="left">
            <tr> 
|;

$ligFacture{'modif'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: mod -->
<!-- une ligne = 1  ligne de facture en modif --> 
<tr align="center"> 
        <td class="couleur">%$rangee[0]%</td>
        <td class="couleur">
			<a href="%$CGIADR%/clientmodif.cgi?clientid=%$rangee[9]%&username=%$login%&usertype=%$type%">%$rangee[1]%</a>
		</td>
        <td class="couleur">%$rangee[2]%</td>
        <td class="couleur">%$rangee[3]%</td>
        <td class="couleur">%$rangee[4]%</td>
        <td class="couleur">%$rangee[5]%</td>
        <td class="couleur">%$rangee[6]%</td>
        <td class="couleur">%$rangee[7]%</td>
        <td class="texte2"> 
          <table cellspacing="3" cellpadding="0" align="left">
            <tr> 
|;

$ligFacture{'1'} = q|
<!-- Restricted-to: anybody -->
<!-- editer une facture -->
                  <td>                  	
                     <a href="%$CGIADR%/editfact.cgi?edit=%$rangee[0]%&username=%$login%&usertype=%$type%&script=facture&%$ch%" target="coucou"><img src="%$HTMLADRUNGICONES%/voir.gif" border="0"></a>
                  </td>
|;


$ligFacture{'2'} = q|
<!-- Forbidden-to: comptable commercial chefprojet chargeprojet supercommercial client -->
<!-- supprimer une facture -->
                  <td> 
				  	<a href="javascript:suppfact(%$rangee[0]%,'%$login%', '%$type%','%$ch%');">
                    	<img src="%$HTMLADRUNGICONES%/delete.gif" border="0"></a>					
				  </td> 
|;


$ligFacture{'3'} = q|
<!-- Forbidden-to: comptable supercommercial client -->
<!-- modifier une facture -->
				  <td> 
				  		<a href="%$CGIADR%/factmodif.cgi?numfact=%$rangee[0]%&username=%$login%&usertype=%$type%&%$ch%">
                    		<img src="%$HTMLADRUNGICONES%/modifier.gif" border="0"></a>
				  </td>
|;

$ligFacture{'4'} = q|
<!-- Forbidden-to: comptable commercial chefprojet chargeprojet assistantechefprojet   client -->
<!-- affich_on: env -->
<!-- envoyer une facture -->                  
                  <td> 
				  		<a href="javascript:envoyer(%$rangee[0]%,'%$login%', '%$type%','%$ch%');"> 
                    		<img src="%$HTMLADRUNGICONES%/envoyer.gif" border="0"></a>						
				  </td> 
|;



$ligFacture{'6'} = q|
<!-- Forbidden-to: comptable client-->
<!-- dupliquer une facture -->
                  <td align="center" valign="middle">
				  	 <a href="%$CGIADR%/editfact.cgi?duplicata=%$rangee[0]%&username=%$login%&usertype=%$type%&script=facture&%$ch%" target="coucou">
                    	 <img src="%$HTMLADRUNGICONES%/duplibouton.gif" border="0"></a>
				 </td>
|;

$ligFacture{'7'} = q|
<!-- Forbidden-to: comptable client -->
<!-- commenter une facture -->
                  <td align="center" valign="middle">
				  	 <a href="javascript:commentrelance(%$rangee[0]%,'%$login%', '%$type%','facture');">
                    	 <img src="%$HTMLADRUNGICONES%/comment.gif" border="0"></a>
				 </td>				   
|;

$ligFacture{'8'} = q|
<!-- Forbidden-to: comptable client-->
<!-- periodicite facture -->
                  <td align="center" valign="middle">
				  	 <a href="%$CGIADR%/factmodif.cgi?copier=%$rangee[0]%&username=%$login%&usertype=%$type%&%$ch%">
                    	 <img src="%$HTMLADRUNGICONES%/mensuel.gif" border="0"></a>
				 </td>
|;

$ligFacture{'end'} = q|
<!-- Restricted-to: anybody -->
<!-- fin lignefacture -->      
                </tr>
              </table>
              <!-- fin barre action -->
            </td>
          </tr>
|; 




my %boutonBasFact =();
tie %boutonBasFact,"Tie::IxHash";
#une ligne de la liste    
     
$boutonBasFact{'begin'} = q|      
      <table width="500" cellpadding="0" cellspacing="0" border="0" align="center">
        <tr>|;
      
$boutonBasFact{'1'} = q| 
<!-- Forbidden-to: client comptable --> 
        <td align="center" valign="bottom" colspan="3" height="30">
           <a href="%$CGIADR%/factmodif.cgi?username=%$login%&usertype=%$type%&%$ch%"> 
                 <img src="%$HTMLADRUNGICONES%/creer.gif" border="0"> 
		   </a>
        </td>|;
        
$boutonBasFact{'2'} = q|        
        <td align="center" valign="bottom" height="30">&nbsp;</td>
        <td align="center" valign="bottom" colspan="3" height="30">
            <a href="%$CGIADR%/login.cgi"> 
                 <img src="%$HTMLADRUNGICONES%/quitter2.gif" border="0"> 
			</a> 
        </td>|;

$boutonBasFact{'end'} = q|
      </tr>
    </table>
|;


sub ListeFacture{	
	my ($type,$login,$orderpcd,$ordersuiv,$nb,$taille,$title,$sumHT,$sumTTC,$mess,$reftabAffich,
	$refpara,$reftabcli,$refstatfact,$refecheance,$reftab,$refstatutenvoi) = @_;
	#on recupere les variables avec les valeurs necc pour l'affichage
    #et on formate les valeurs pour l'affichage    
	my $ch = '';	
	($refpara,$ch) = &getParam(%$refpara);
	my %para = %$refpara;
	#faire les listes droulantes	
    my $popupcli = &getPopup($reftabcli,$para{"clientidtri"},"clientidtri");
    my $popuptri = &getPopup($reftab, $para{"tri"},"tri");
    my $popupecheance =&getPopup($refecheance, $para{"echeancedatetri"},"echeancedatetri");
    my $popupstatut = &getPopup($refstatfact, $para{"statuttri"},"statuttri");
    my $popupsent = &getPopup($refstatutenvoi, $para{"statutenvoitri"},"statutenvoitri");
	#my $onload = '';
    my $onload = exists ($para{'notexiste'}) ? $onloadEcran:'';
   #faire la liste des factures a afficher avec seulement les boutons
    #que l'utilisateur a le droit de voir
	my %ligFactureDroit=();
    tie %ligFactureDroit,"Tie::IxHash";
    
    %ligFactureDroit = &getHashAffich(\%ligFacture,$type);
    #formater la liste des factures a afficher    
    my $liste = &makeListe($reftabAffich,\%ligFactureDroit);
    #afficher creer facture sssi l'utilisateur a le droit de creer une facture
	my %boutonBasFactDroit = ();
	tie %boutonBasFactDroit,"Tie::IxHash";
	%boutonBasFactDroit = &getHashAffich(\%boutonBasFact,$type);
	my $boutonBasFact = join("\n",(values %boutonBasFactDroit));
    #remplir avec les valeurs la ligne des sommes, formatees 
    foreach my $val ($sumHT,$sumTTC){
    	$val = &formatNombre($val);
    } 
     
    #construire la page
	my $page = $body.&AffichLig(&affiche_barre($type,\%navigation,'factures'),$type,$login).$titrePage;
	if($mess){$page .= $messPage;} 
	$page .= $ListeFacture;
	$page =~ s/%(\$\w+(\{\w*\})?)%/$1/gee;
=pod
	while($page =~ /%(\$\w+(\{\w*\})?)%/){
        $page =~ s/%(\$\w+(\{\w*\})?)%/$1/ee;
		my $val = $1;
        print p "dol1 = $val";
	}
=cut
	####################
	$page =~ s/%(\$\w+)%/$1/gee;	 
	&AffichPageWeb($title,$page);
	return;
}


##########################
#modifier/creer un facture
##########################

my $enteteFactureCreat = q|     
<!-- debut  $enteteFactureCreat -->
<form method="get" action="%$CGIADR%/factmodif.cgi" name="formulaire">    
     <table width="650" cellpadding="3" cellspacing="1">
      <tr> 
        <td class="ligne2" align="left" valign="middle" >%$name% : 
          %$popupclient%
        </td>
        <td valign="middle" colspan="2" align="right" class="ligne2"><a href="%$CGIADR%/clientmodif.cgi?usertype=%$type%&username=%$login%&script=factmodif&boutonnavig=factures&%$ch%"><img src="%$HTMLADRUNGICONES%/creercli.gif" border="0" align="middle" width="128" height="25"></a>
        </td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr> 
        <td height="30" valign="middle" class="ligne1" align="left"> 
          *&nbsp;%$responsable% :
          <input type="text" name="responsablecdefct" value="%$para{responsablecdefct}%">
        </td>
        <td valign="middle" class="ligne1" align="left"> %$contactfact% : 
          <input type="text" name="contactfct" value="%$para{contactfct}%">
        </td>
      </tr>
      <tr > 
        <td class="ligne2" height="30" > %$idorder% : 
          <input type="text" name="refcdefct" value="%$para{refcdefct}%">
        </td>
        <td valign="middle" class="ligne2" align="left"> %$billstatus% : 
          %$popupstatut%
        </td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr> 
        <td class="ligne1" align="left">%$remise% : 
          <input type="text" name="remisefct"  value="%$para{remisefct}%" size="4">%
        </td>
        <td class="ligne1" align="left">%$pricemovement% &euro;: 
          <input type="text" name="fraisdepltfct"  value="%$para{fraisdepltfct}%">
        </td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr> 
        <td class="ligne2"> %$modepaiement% :
          %$popupmodepai%
        </td>
        <td class="ligne2"> %$idcheque% :
          <input type="text" name="numchequefct"  value="%$para{numchequefct}%">
        </td>
        <td class="ligne2"> %$bank% : 
          <input type="text" name="banquereglementfct"  value="%$para{banquereglementfct}%">
        </td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr> 
        <td width="150" valign="middle"  class="ligne1" align="left">  
         %$billdate% : </td>
        <td valign="middle" class="ligne1" align="left">%$day%* :
          <input type="text" name="jourf" value="%$para{jourf}%" size="2" maxlength="2">
        </td>
        <td valign="middle" class="ligne1" align="left">%$month%* : 
          <input type="text" name="moisf" value="%$para{moisf}%" size="2" maxlength="2">
        </td>
        <td valign="middle" class="ligne1" align="left" >%$year%* : 
          <input type="text" name="anf" value="%$para{anf}%" size="4" maxlength="4">
        </td>
      </tr>
      <tr> 
        <td class="ligne2" width="150">%$regulationdate% :</td>
        <td class="ligne2" valign="middle" align="left">%$day% : 
          <input type="text" name="jourr" value="%$para{jourr}%" size="2" maxlength="2">
        </td>
        <td class="ligne2" valign="middle" align="left">%$month%* : 
          <input type="text" name="moisr" value="%$para{moisr}%" size="2" maxlength="2">
        </td>
        <td class="ligne2" valign="middle" align="left">%$year% : 
          <input type="text" name="anr" value="%$para{anr}%" size="4" maxlength="4">
        </td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr> 
        <td class="ligne1" width="150"> %$datepayment% :</td>
        <td class="ligne1"> 
          %$popupecheance%
        </td>
      </tr>
	  <tr>
        <td class="ligne1" width="150"> %$periodique% :</td>
        <td class="ligne1">
          %$popupperiode%
        </td>
      </tr>
    </table>
    <input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">
	<input type="hidden" name="validercreat" value="10">
	  %$champscache%
    <table width="650" cellpadding="0" cellspacing="0">
      <tr> 
        <td valign="bottom" align="left" height="35" class="texterouge"> 
          <input type="image" border="0" name="validercreat" src="%$HTMLADRUNGICONES%/validercreat.gif" width="71" height="25">
          %$messcreatfact%
        </td>        
      </tr>
    </table> 	
   </form>
   <table width="650" cellpadding="0" cellspacing="0">
       <tr>
          <td valign="bottom" align="left" height="35">
	  	<a href="%$CGIADR%/facture.cgi?usertype=%$type%&username=%$login%&%$ch%"><img src="%$HTMLADRUNGICONES%/abandonner.gif" border="0"></a>                
	  </td>
      </tr>
  </table> 
<!-- fin $enteteFactureCreat -->|; 

my $enteteFacture = q|     
<!-- debut  $enteteFacture -->
<table width="650" class="ligne3" cellpadding="3" cellspacing="0">
    <tr> 
      <td  class="texte4" align="left" width="20%">%$idbill% :</td>
      <td class="textegras">%$numfact%</td>
    </tr>
</table> 
<form method="post" action="%$CGIADR%/factmodif.cgi" name="formulaire">     
     <table width="650" cellpadding="3" cellspacing="1">
      <tr > 
        <td class="ligne2" align="left" valign="middle" >%$name% : 
          %$popupclient%
        </td>
        <td valign="middle" colspan="2" align="right" class="ligne2"><a href="%$CGIADR%/clientmodif.cgi?usertype=%$type%&username=%$login%&script=factmodif&boutonnavig=factures&%$ch%"><img src="%$HTMLADRUNGICONES%/creercli.gif" border="0" align="middle" width="128" height="25"></a>
        </td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr> 
        <td height="30" valign="middle" class="ligne1" align="left"> 
          *&nbsp;%$responsable% :
          <input type="text" name="responsablecdefct" value="%%$responsablecde%%">
        </td>
        <td valign="middle" class="ligne1" align="left"> %$contactfact% : 
          <input type="text" name="contactfct" value="%%$contact%%">
        </td>
      </tr>
      <tr > 
        <td class="ligne2" height="30" > %$idorder% : 
          <input type="text" name="refcdefct" value="%%$refcde%%">
        </td>
        <td valign="middle" class="ligne2" align="left"> %$billstatus% : 
          %$popupstatut%
        </td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr> 
        <td height="30" valign="middle" class="ligne1"> %$totalwithouttax% &euro;: %%$totHT%% </td>
        <td valign="middle" class="ligne1" align="center"> %$totalwithtax% &euro;: %%$totTTC%% </td>
		<td class="ligne1" align="left">%$remise% : 
          <input type="text" name="remisefct"  value="%%$remise%%" size="4"> %
        </td>

        <td class="ligne1" align="left">%$pricemovement% &euro;: 
          <input type="text" name="fraisdepltfct"  value="%%$fraisdeplt%%">
        </td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
        <td class="ligne2"> %$modepaiement% :
          %$popupmodepai%
        </td> 
        <td class="ligne2"> %$idcheque% : 
          <input type="text" name="numchequefct"  value="%%$numcheque%%">
        </td>
        <td class="ligne2"> %$bank% : 
          <input type="text" name="banquereglementfct"  value="%%$banquereglement%%">
        </td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr> 
        <td width="150" valign="middle"  class="ligne1" align="left">  
         %$billdate% : </td>
        <td valign="middle" class="ligne1" align="left">%$day%* : 
          <input type="text" name="jourf" value="%%$jourf%%" size="2" maxlength="2">
        </td>
        <td valign="middle" class="ligne1" align="left">%$month%* : 
          <input type="text" name="moisf" value="%%$moisf%%" size="2" maxlength="2">
        </td>
        <td valign="middle" class="ligne1" align="left" >%$year%* : 
          <input type="text" name="anf" value="%%$anf%%" size="4" maxlength="4">
        </td>
      </tr>
      <tr> 
        <td class="ligne2" width="150">%$regulationdate% :</td>
        <td class="ligne2" valign="middle" align="left">%$day% : 
          <input type="text" name="jourr" value="%%$jourr%%" size="2" maxlength="2">
        </td>
        <td class="ligne2" valign="middle" align="left">%$month%* : 
          <input type="text" name="moisr" value="%%$moisr%%" size="2" maxlength="2">
        </td>
        <td class="ligne2" valign="middle" align="left">%$year% : 
          <input type="text" name="anr" value="%%$anr%%" size="4" maxlength="4">
        </td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
        <td class="ligne1" width="150"> %$datepayment% :</td>
        <td class="ligne1" valign="middle" align="left">%$day%  : %%$jourech%%</td>
        <td class="ligne1" valign="middle" align="left">%$month% : %%$moisech%%</td>
        <td class="ligne1" valign="middle" align="left">%$year% : %%$anech%%</td>
        <td class="ligne1">
          %$popupecheance%
        </td>
      </tr>
    </table>
	<table width="650" cellpadding="3" cellspacing="1">
      <tr>
        <td class="ligne1" width="150"> %$periodique% :</td>
        <td class="ligne1">
          %$popupperiode%
        </td>
      </tr>
    </table>
    <input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">
	<input type="hidden" name="validermodif" value="10">
	%$champscache%			
    <br>     
    <table width="650" cellpadding="0" cellspacing="0">
      <tr> 
        <td valign="bottom" align="left" height="35" class="texterouge"> 
          <input type="image" border="0" name="validermodif" src="%$HTMLADRUNGICONES%/validermodif.gif" width="71" height="25">
          %$messmodentetefact%
        </td>        
      </tr>
    </table>
    </form> 	
    %%$listeLigFact%% 
    <form method="post" action="%$CGIADR%/factmodif.cgi" name="form">     
	<table width="650" border="0" cellspacing="0" cellpadding="0" class="ligne3">
      <tr>
        <td align="center">
          <table width="651" cellpadding="0" cellspacing="2">
            <tr> 
              <td colspan="8" class="texte4" align="left" height="17">%$addligfact%</td>
            </tr>
            <tr>
              <td colspan="8" class="tetiere" align="left" height="3"></td>
            </tr>
          </table>
          <table width="650" cellpadding="0" cellspacing="0">
            <tr> 
              <td>
                <table width="100%" cellspacing="2" cellpadding="0">
					<tr><td></td>
		              <td valign="middle" class="texte4" align="left">
						Famille : %$popupfamart% 
						Article %$popuparticle%
						Code %$codart%
					  </td>
				  </tr>
                  <tr>
                    <td height="69"  valign="middle" class="texte4" align="left">
                     *&nbsp;%$wording%: 
		     </td>
                    <td height="69"  class="texte4" align="left" colpsan="2">
                      <textarea name="libarticajout" cols="53" wrap="virtual">%$para{libarticajout}%</textarea>
                    </td>
                   </tr>
	         </table>
                 <table width="100%" cellspacing="2" cellpadding="0">
                  <tr> 
                    <td valign="middle" height="34" class="texte4" align="left" width="32%">
                       *&nbsp;%$quantity% :
                      <input type="text" name="qtefactureajout"  value="%$para{qtefactureajout}%" size="10">
                    </td>
                    <td valign="middle" class="texte4" width="48%" align="left">
                      %$unitprice% &euro;: 
                      <input type="text" name="prixHTajout" value="%$para{prixHTajout}%" size="16">
                    </td>
                    <td valign="middle" class="texte4" align="left">%$tva% : 
                      <input type="text" name="tauxTVAajout" value="%$para{tauxTVAajout}%" size="6" maxlength="5">
                    </td>
                  </tr>
                </table>
              </td>
              <td valign="middle" width="80" align="center" class="message"> 
                <input type="image" name="ajouter" src="%$HTMLADRUNGICONES%/ajouter.gif" border="0" width="39" height="30">
                <span class="texterouge">%$messajout%</span> </td>
          </table>
        </td>
      </tr>
    </table>
    <input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">
	<input type="hidden" name="ajouter" value="10">
	%$champscache%
  <br>
  <table width="650" cellpadding="0" cellspacing="0">
    <tr> 
	  <td valign="bottom" align="left">
	  	<a href="%$CGIADR%/editfact.cgi?generer=%$numfact%&username=%$login%&usertype=%$type%&script=facture&%$ch%" target="coucou"><img src="%$HTMLADRUNGICONES%/generer.gif" border="0" align="middle"></a>
      </td>
      <td valign="bottom" align="left">
      	<a href="%$CGIADR%/editfact.cgi?edit=%$numfact%&username=%$login%&usertype=%$type%&script=facture&%$ch%" target="coucou"><img src="%$HTMLADRUNGICONES%/voir_facture.gif" border="0" align="middle"></a>
      </td>
    <tr>
    <tr><td>&nbsp;</td></tr>
    </tr>
      <td valign="bottom" align="left">
      	<a href="%$CGIADR%/facture.cgi?idmod=%$numfact%&usertype=%$type%&username=%$login%&%$ch%"><img src="%$HTMLADRUNGICONES%/retour.gif" border="0"></a>
        <span class="texterouge">%$messretourlistefact%</span>
      </td>
    </tr>
  </table>	
  </form>
<!-- fin  $enteteFact -->|;

my $enteteligfact = q|
<!-- debut $enteteligfact -->
<br><br>
    <form method="post" action="%$CGIADR%/factmodif.cgi">               
      <table width="650" cellpadding="3" cellspacing="1">
      <tr> 
        <td class="tetiere" width="10%" align="center" valign="middle">%$quantity%</td>
        <td class="tetiere" width="30%" align="center" valign="middle">%$wording%</td>
        <td class="tetiere" align="center" valign="middle" >%$unitprice% &euro;</td>
        <td class="tetiere" align="center" valign="middle" >%$tva%</td>
        <td class="tetiere" width="20%" align="center" valign="middle">%$action%</td>
      </tr>        	
<!-- fin  $enteteligfact -->|;

my %ligneFact =();
tie %ligneFact,"Tie::IxHash";
$ligneFact{'1'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand -->
<!-- debut $modlig -->         
     <TR> 
        <TD align="center" valign="middle" class="texte2">%$rangee[1]%</TD>
        <TD align="center" valign="middle" class="texte3">%$rangee[0]% </TD>
        <TD align="center" valign="middle" class="texte2">%$rangee[2]%</TD>
        <TD align="center" valign="middle" class="texte3">%$rangee[3]%</TD>
        <!-- barre action -->
        <TD align="center" class="texte2"> 
          <table>
            <tr> 
              <td align="left" valign="top">
                 <a href="javascript:supplig(%$rangee[4]%,'%$login%','%$type%','%$ch%');"><img src="%$HTMLADRUNGICONES%/delete.gif" border="0" align="middle"></a>                 
              </TD>
              <TD align="left" valign="top"> 
                 <a href="%$CGIADR%/factmodif.cgi?mod=%$rangee[4]%&username=%$login%&usertype=%$type%&%$ch%"><img src="%$HTMLADRUNGICONES%/modifier.gif" border="0"></a>
              </TD>
            </TR>
          </table>
        </td>
     </tr>   
     <!-- fin barre action -->        
<!-- fin  $modlig -->|;

$ligneFact{'2'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: mod -->  
<!-- debut $modligmod -->         
<TR> 
	<td colspan="5">		
	<table width="100%">	
	<tr>	
        <TD align="center" valign="middle">
        	<input type="text" name="qtefacturemod" value="%$rangee[1]%" size="4">
        </TD>
        <TD align="center"  width="30%">
        	<TEXTAREA NAME="libarticmod" ROWS="3" COLS="40" WRAP="virtual">%$rangee[0]%
        	</TEXTAREA>        	
        </TD>
        <TD align="center" valign="middle">
        	<input type="text" name="prixHTmod" value="%$rangee[2]%" size="10">
        </TD>
        <TD align="center" valign="middle">
        	<input type="text" name="tauxTVAmod" value="%$rangee[3]%" size="5">
        </TD>
        <!-- barre action -->
        <TD align="center"> 
          <table>
            <tr>               
              <TD>
                 <input type="image" name="valide%" src="%$HTMLADRUNGICONES%/valider.gif" border="0">
                 <br><span class="texterouge">%$messmod%</span>
                 <input type="hidden" name="valide" value="%$rangee[4]%">
              </TD>
            </TR>
          </table>
        </td>
       </tr>
       </table>       
      </td> 
        <!-- fin barre action -->
</tr>        
<!-- fin $modligmod -->|;


my $finlistelig = q|
<input type="hidden" name="usertype" value="%$type%">
<input type="hidden" name="username" value="%$login%">
%$champscache%
</table>
</form>|;




sub majFacture{
	my ($numfact,$type,$login,$title,$refpara,$refentetefacture,$reflisteligfact,
	$reflistestatut,$reflistecli,$refecheance,$refpaiement,$refperiodicite,
	$reffamart, $mess)=@_;
	#on recupere les variables avec les valeurs necc pour l'affichage
    #et on formate les valeurs pour l'affichage
	my $ch = '';	
	($refpara,$ch) = &getParam(%$refpara);
	my %para = %$refpara;	
	my $champscache = &getHidden(%para);
	#faire les listes deroulantes				
    my @num=(0,5,14,15,16);

    #pour une facture qu'on cre, on force la valeur selectionne
    #de la liste deroulante sur la valeur selectionnee lors de la creation ratee
    my ($statutfact,$clientidfact,$echeance,$paiement,$periodicite) =
     ($para{"statutfactfct"}, $para{"clientidfactfct"}, $para{"echeancefct"},
     $para{"paiementfct"},$para{"periodicitefct"});

	 #si pas de statut, forcer  nr
	$statutfact = $statutfact || 2;
    #si la facture existe, on force les listes deroulantes sur les valeurs
    #de la facture 
    if($numfact){	
		($clientidfact,$statutfact,$echeance,$paiement,$periodicite)=@$refentetefacture[@num];
		&debug("periodicite = $periodicite");
	} 
	my $popupstatut = &getPopup($reflistestatut,$statutfact,"statutfactfct");
	my $popupecheance = &getPopup($refecheance,$echeance,"echeancefct");
	my $js = "OnChange = { popupWindow = open (
		'$CGIADR/rens_clifact.cgi?clientid=' + 
		clientidfactfct.options[clientidfactfct.selectedIndex].value,
		'windowName','width=1,height=1' ) ; } ";
	my $popupclient  = &getPopup($reflistecli,$clientidfact,"clientidfactfct", $js);
	my $popupmodepai = &getPopup($refpaiement,$paiement,"paiementfct");
    my $popupperiode = &getPopup($refperiodicite,$periodicite,"periodicitefct");
	$js = "OnChange = { popupWindow = open (
		'$CGIADR/rens_article.cgi?codfam=' + 
		famart.options[famart.selectedIndex].value,
		'windowName','width=1,height=1' ) ; } ";
    my $popupfamart  = &getPopup($reffamart,"-1","famart", $js);
	$js = "OnChange = { popupWindow = open (
		'$CGIADR/rens_article.cgi?idartic=' + 
		poparticle.options[poparticle.selectedIndex].value,
		'windowName','width=1,height=1' ) ; } ";
    my $popuparticle  = &getPopup({'',''},"","poparticle", $js);
	$js = "{ popupWindow = open (
		'$CGIADR/rens_article.cgi?codart=' + codartajout.value,
		'windowName','width=1, height=1' ) ; } ";
	my $codart = "<INPUT TYPE=\"TEXT\" NAME=\"codartajout\" SIZE=\"8\" ONBLUR=\"$js\" VALUE=\"-\">";
	#my $onload = '';
	 my $onload = exists ($para{'notexiste'}) ? $onloadEcran:'';
	#construction de la page
	my $page=$body.&AffichLig(&affiche_barre($type,\%navigation,'factures'),$type,$login).$titrePage;
	if($mess){$page .= $messPage;}	
	if($numfact){		
		$page .= &ModifierFacture($numfact,$refentetefacture,$reflisteligfact,\%para,$type);		
	}
	else{ $page .= &CreerFacture(\%para);		
	}		
	$page =~ s/%(\$\w+)%/$1/gee;
	&AffichPageWeb($title,$page);
	return;
} 


#pour modifier une facture
sub ModifierFacture{	 
	my ($numfact,$refentetefacture,$reflisteligfact,$refpara,$type)=@_;
	my %para = %$refpara;	
	#recup valeurs entete
	my ($clientidfact,$clientnom, $responsablecde, $refcde, $datefact, $statutfact,$fraisdeplt, $totHT,
    $totTTC,$contact, $datereglement,$banquereglement, $numcheque,$dateecheance,$echeance,$tmp,$tmp2, $remise)=@$refentetefacture;
    $fraisdeplt=sprintf("%.2f",$fraisdeplt);
    $totHT = sprintf("%.2f",$totHT);
    $totTTC = sprintf("%.2f",$totTTC);
    foreach my $val($fraisdeplt,$totHT,$totTTC){ 
      $val = &formatNombre($val);
      #$val =~ s/\./,/;    
      #1 while $val =~ s/(\d)(\d\d\d)(?!\d)/$1 $2/;
    }
    my ($jourf, $moisf, $anf) = &sec_calend($datefact);
    if($para{"jourf"} ||$para{"moisf"} || $para{"anf"}){
        ($jourf, $moisf, $anf) = @para{"jourf","moisf","anf"};
    }	 
   
    my ($jourr, $moisr, $anr) = ();
    if($para{"jourr"} ||$para{"moisr"} || $para{"anr"}){
    	($jourr, $moisr, $anr) = @para{"jourr","moisr","anr"};
    }
    elsif($datereglement){
   	($jourr, $moisr, $anr)=&sec_calend($datereglement);
    }
	foreach my $val ($jourf, $moisf, $anf,$jourr, $moisr, $anr){
		$val = $val || '';
	}
    my ($jourech, $moisech, $anech) =&sec_calend($dateecheance);  	
	my $page .=$enteteFacture;	
	#liste des lignes de factures		
	if(my @lignes = @$reflisteligfact){		
		my %ligLigneDroit=();
        tie %ligLigneDroit,"Tie::IxHash";
        %ligLigneDroit = &getHashAffich(\%ligneFact,$type);
        #formater la liste des factures a afficher    
        my $listeLigFact = &makeListe($reflisteligfact,\%ligLigneDroit);
        $listeLigFact = $enteteligfact.$listeLigFact.$finlistelig;
        $page =~ s/%%\$listeLigFact%%/$listeLigFact/;
    }
	#pour ajouter une ligne de facture
	$page =~ s/%%(\$\w+)%%/$1/gee;
	$page =~ s/%(\$\w+\{\w+\})%/$1/gee;


	#sub sur %% pour substituer seulement les valeurs passees,
	#sinon substitue les valeurs non passees par ''!	          
    return $page;
}


#pour creer une facture
sub CreerFacture{	
	my ($refpara) = @_;
	my %para = %$refpara;	
	if(!($para{"jourf"} || $para{"moisf"} || $para{"anf"})){
		  ($para{"jourf"}, $para{"moisf"},$para{"anf"})=&sec_calend(time);	
	}		
    my $page .=$enteteFactureCreat;
    $page =~ s/%(\$\w+\{\w+\})%/$1/gee;
    $page  =~ s/%%(\$\w+)%%/$1/gee;  
    return $page;
}

###################################
#afficher un commentaire facture
###################################

my $affichecommentaire = q|
<!-- debut  $affichecommentaire -->
<HTML>
    <HEAD>
      <TITLE>commentaires</TITLE>
    </HEAD>
<BODY BGCOLOR="#ffffff">
<form method=post action="%$CGIADR%/facture.cgi">
	<table width="600">
	<tr><td>Commentaires Factures num&eacute;ro %$numfact%</td></tr>
	 <tr>
	  <td><textarea name="commentaires" cols="70" rows="10" wrap="virtual">%$commentaire%</textarea></td>	  
	</tr>
	<tr><td>Commentaires Client</td></tr>
	<tr>
	  <td><textarea name="commentairescli" cols="70" rows="10" wrap="virtual">%$commentairecli%</textarea></td>	  
	</tr>
	<tr>
	 <td colspan="2"><input type="image" name="save" src="%$HTMLADRUNGICONES%/valider.gif" border="0"></td>
	</tr>	
	</table>		
    <input type="hidden" name="commentrelance" value="%$numfact%"> 
    <input type="hidden" name="save" value="10">   
 </form>
 <form>
    <input type="button" value="cliquez ici pour fermer" onClick="self.close();">
 </form>
 </BODY>
</HTML>
<!-- fin  $affichecommentaire -->|; 


sub affichCommentFacture{
	my ($commentaire,$commentairecli,$numfact,$idmod,$type,$login,$script) = @_;
	if($numfact){
		(my $page  = $affichecommentaire) =~ s/%(\$\w+)%/$1/gee;
		print header;
		print $page;
	}
	else{
		#my $script = "facture";
		$rafraichirEcran =~ s/%(\$\w+)%/$1/gee;
		print header();
		print $rafraichirEcran;
	}
    return;
}
	

1;
END{}
