=pod

package de variables pour les propal
propres au theme UNGI

=cut

package UNGI::Propal;

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../../lib','../';	
} 

use strict;
use CGI  qw(:standard);
use Conf;
use Util;
use lang::Fr;
use UNGI::General; 


BEGIN{
	use Exporter;
	use vars qw($VERSION @ISA @EXPORT);
	$VERSION = 1.00;
	@ISA = qw(Exporter);
	@EXPORT= qw(&AffichPropal &affichCommentPropal &AffichPropalCde);	
		
}

use vars  @EXPORT;



###########################
#liste des propals
###########################

my $ListePropal = q|
<!-- debut $ListePropal -->
<!-- ligne titre liste -->
    <table width="760" cellspacing="1" cellpadding="0" align="center">
      <tr align="center">
          <TD class="tetiere" align="center">%$id%</TD>          
		  <TD class="tetiere" align="center">%$wording%</TD>
		  <TD class="tetiere" align="center">%$namecommercial%</TD>
		  <TD class="tetiere" align="center">%$nameleadproject%</TD>
		  <TD class="tetiere" align="center">%$namecli%</TD>
		  <TD class="tetiere" align="center">%$date%</TD>
		  <TD class="tetiere" align="center">%$propalestim%</TD>
		  <TD class="tetiere" align="center">%$total%</TD>				
		  <TD class="tetiere" align="center">%$action%</TD>			  
      </TR>
      <!-- liste des propal -->
      %$liste%
      <!-- ligne finale avec les sommes -->
      <tr align="center"> 
        <td class="tetiere" colspan="6" height="20">%$sum% &euro;</td>        
		<TD class="tetiere" align="center">%$somestim%</TD>
		<TD class="tetiere">%$som%</TD>			
		<TD class="tetiere">&nbsp;</TD>           
      </tr>
    </table>
    <br>
    <!-- recherche par criteres -->
    <form method="post" action="%$CGIADR%/propal.cgi" name="formulaire" enctype="application/x-www-form-urlencoded" >	
    <table width="760" align="center">
    <tr align="center"> 
      <td class="tetiere2">%$searchby%&nbsp;:</td>
    </tr>
  </table>
  <table width="760" dwcopytype="CopyTableRow" align="center" cellpadding="3" cellspacing="1">
    <tr> 
      <td class="ligne1"> %$id%&nbsp;: 
        <input type="text" name="idpropaltri"  size="10" value="%$para{idpropaltri}%">
      </td>      
      <td class="ligne1"> %$total%&nbsp;: 
        <input type="text" name="totaltri"  size="10" value="%$para{totaltri}%">
      </td>
    </tr>
    </table>
    <table width="760" dwcopytype="CopyTableRow" align="center" cellpadding="3" cellspacing="1">    
    <tr>
      <td class="ligne2"> %$wording%&nbsp;:
        <input type="text" name="libpropaltri"  size="60" value="%$para{libpropaltri}%">
      </td>     
      <td class="ligne2"> %$date% (JJ/MM/AAAA) : 
        <input type="text" name="jourtri"  size="2" maxlength="2" value="%$para{jourtri}%">
        <input type="text" name="moistri"  size="2" maxlength="2" value="%$para{moistri}%">
        <input type="text" name="antri"  size="4" maxlength="4" value="%$para{antri}%">
      </td>
    </tr>
  </table>
  <table width="760" align="center" cellpadding="3" cellspacing="1">
    <tr>
      <td class="ligne1">%$propalestim%  :
        %$popupestim%
      </td>
      <td class="ligne1">%$namecli%  :
        <input type="text" name="nomclitri"  size="30" value="%$para{nomclitri}%">
      </td>
    </tr>
  </table>
  <table width="760" align="center" cellpadding="3" cellspacing="1">
    <tr>
      <td class="ligne1">%$customername%  :
        %$popupclient%
      </td>
    </tr>
  </table>
  <table width="760" align="center" cellpadding="3" cellspacing="1">
    <tr> 
     <td class="ligne2">%$namecommercial%  :
        %$popupcommercial%
      </td>
      <td class="ligne2">%$nameleadproject%  :
        %$popupchef%         
      </td> 
    <tr> 
      <td class="tetiere2"  height="10" colspan="2"></td>
    </tr>
  </table>
  <br>
  <table width="500" border="0" cellspacing="0" cellpadding="5" align="center" class="ligne3">
    <tr>
      <td align="center">
        <table width="350" align="center">
          <tr> 
            <td><span class="texte4">%$sortby%</span> 
              %$popuptri%
            </td>
          </tr>
        </table>
        <table width="350" align="center">
          <tr> 
            <td class="texte4" align="left" valign="middle">%$linenumber%</td>
            <td> 
              <input type="text" name="nbligtri" value="%$nb%" size="4" maxlength="3">
            </td>
            <td class="texte4" align="center" valign="middle">%$ontotal% %$taille%</td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGICONES%/reload.gif" width="31" height="36">
            </td>
          </tr>
        </table>
        <table width="500" border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGICONES%/premier.gif" width="31" height="22" align="middle">
            </td>
            <td align="center"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="precedent" src="%$HTMLADRUNGICONES%/gauche.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="suivant" src="%$HTMLADRUNGICONES%/droite.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="dernier" src="%$HTMLADRUNGICONES%/dernier.gif" width="30" height="22" align="middle">
            </td>
          </tr>
        </table>        
      </td>
    </tr>
  </table>
  <input type="hidden" name="usertype" value="%$type%">
  <input type="hidden" name="username" value="%$login%">
  <input type="hidden" name="pcdt" value="%$orderpcd%">
  <input type="hidden" name="suiv" value="%$ordersuiv%">
  <input type="hidden" name="chaine" value="%$ch%">
  </form>  
  <br> 
<table>     
    <tr>
      <td valign="middle" align="center">
      	<a href="%$CGIADR%/propal.cgi?username=%$login%&usertype=%$type%&toupdate=-1&%$ch%"><img src="%$HTMLADRUNGICONES%/nouveau.gif" border="0" align="middle"></a>
      </td>
      <td valign="middle" align="center"> 
      	<a href="%$CGIADR%/login.cgi"><img src="%$HTMLADRUNGICONES%/quitter2.gif" border="0" align="middle"></a> 
      </td>      
    </tr>
  </table>		
<!-- fin listepropal -->|; 


#hachage regroupant les differentes parties d'une ligne de facture
my %ligPropal = ();
tie %ligPropal,"Tie::IxHash";;
#une ligne de la liste
$ligPropal{'begin'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand,habit -->
<!-- une ligne = 1  ligne de propal -->
  <tr align="center"> 
        <td class="numero">%$rangee[0]%</td>
        <td class="texte2">%$rangee[1]%</td>
        <td class="texte3">%$rangee[2]%</td>
        <td class="texte2">%$rangee[3]%</td>
        <td class="texte3">
			<a href="%$CGIADR%/clientmodif.cgi?clientid=%$rangee[4]%&username=%$login%&usertype=%$type%">%$rangee[12]%</a>
        </td>
        <td class="texte2">%$rangee[5]%</td>
        <td class="texte3">%$rangee[6]%</td>
		<TD class="texte2">%$rangee[7]%</TD>
        <td class="texte3">
          <table cellspacing="3" cellpadding="0" align="left">
            <tr>
|;

$ligPropal{'modif'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: modif,habit -->
<!-- une ligne = 1  ligne de propal surligne --> 
<tr align="center"> 
        <td class="couleur">%$rangee[0]%</td>
        <td class="couleur">%$rangee[1]%</td>
        <td class="couleur">%$rangee[2]%</td>
        <td class="couleur">%$rangee[3]%</td>
        <td class="couleur">
			<a href="%$CGIADR%/clientmodif.cgi?clientid=%$rangee[4]%&username=%$login%&usertype=%$type%">%$rangee[12]%</a>
		</td>
        <td class="couleur">%$rangee[5]%</td>
        <td class="couleur">%$rangee[6]%</td>        
        <td class="couleur">%$rangee[7]%</td>       
        <td class="texte2"> 
          <table cellspacing="3" cellpadding="0" align="left">
            <tr> 
|;

$ligPropal{'1'} = q|
<!-- Forbidden-to: comptable  -->
<!-- affich_on: habit -->
<!-- pour modifier une propal -->
                     <td>
                        <a href="%$CGIADR%/propal.cgi?toupdate=%$rangee[0]%&username=%$login%&usertype=%$type%&%$ch%"><img src="%$HTMLADRUNGICONES%/modifier.gif" border="0"></a>        		
                     </td>
|;

$ligPropal{'2'} = q|
<!-- Forbidden-to: comptable  -->
<!-- affich_on: habit -->
<!-- editer un commentaire -->
                    <td>	
                       <a href="javascript:editpropal(%$rangee[0]%,'%$type%','%$login%');"><img src="%$HTMLADRUNGICONES%/comment.gif" border="0"></a>
                    </td>
|;



$ligPropal{'end'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: habit -->
<!-- fin lignepropal -->      
                </tr>
              </table>
              <!-- fin barre action -->
            </td>
          </tr>
|; 

my $ligPropalMaj = q|
<!-- une ligne de propal en modification = ligPropalMaj -->
  <table width="650" class="ligne3" cellpadding="3" cellspacing="0">
    <tr> 
      <td  class="texte4" align="left" width="20%">%$idproposition% :</td>
      <td class="textegras">%$para{toupdate}%</td>
    </tr>
   </table>
  <form method="post"  name="validmodpropal" enctype="application/x-www-form-urlencoded" >
  <table width="650" cellpadding="3" cellspacing="1">
	<tr>			
	  <TD class="ligne2" align="left" valign="middle" width="20%">
            %$namecli% :
	  </td>
	  <TD class="ligne2" align="left" valign="middle">
	     %$popupclientmod%
	  </td>
	  <td class="ligne2" valign="middle" align="right">
				   <a href="%$CGIADR%/clientmodif.cgi?toupdate=%$para{toupdate}%&usertype=%$type%&username=%$login%&script=propal&boutonnavig=commandes&%$ch%"><img src="%$HTMLADRUNGICONES%/creercli.gif" border="0" align="middle" width="128" height="25"></a>
       </td>
	</tr>
	<tr>  
	  <td class="ligne1" align="left" valign="middle" width="20%">
		   %$wording% :
	  </td>
	  <td class="ligne1" align="left" valign="middle" >
		   <textarea name="libpropalmod" cols="40" wrap="virtual">%$para{libpropalmod}%</textarea>
	  </TD>
	</tr>
	<tr>
	  <td class="ligne2" align="left" valign="middle" width="20%">
	     %$propalestim%
	  </td>
	  <td class="ligne2" align="left" valign="middle">
	     %$popupestimmod%
	  </td>
    </tr>
    <tr>
	 <td class="ligne1" align="left" valign="middle" width="20%">
	   %$commentaires% :
	 </td>
	 <td class="ligne1" align="left" valign="middle">
	   <textarea name="commentairesmod" cols="40" rows="2" wrap="virtual">%$para{commentairesmod}%</textarea>
	</TD>			
  </tr>
  <tr>
	<TD  class="ligne2" align="left" valign="middle" width="20%">
	   %$namecommercial% :
	</td>
	<TD  class="ligne2" align="left" valign="middle">
	   %$popupcommercialmod%
	</td>
  </tr>	
	<TD class="ligne1" align="left" valign="middle" width="20%">
	    %$nameleadproject% :
        </td>
	<TD class="ligne1" align="left" valign="middle">
		%$popupchefmod%
	</td>
  </tr>
  <tr>   
	 <TD class="ligne2" align="left" valign="middle" width="20%">
	 	%$total% &euro;
	 </td>
	 <TD class="ligne2" align="left" valign="middle">
		 <input type="text" name="totalmod" value="%$para{totalmod}%" size="30">
	 </TD>
  </tr>
 </table>
 <table width="650" cellpadding="3" cellspacing="1">
   <tr>									
	 <TD class="ligne1" align="left" valign="middle">%$date% - </td>
	 <td class="ligne1" align="left" valign="middle">
	       %$day% :
			<input type="text" name="jourm" value="%$para{jourm}%" size="2" maxlength="2">
	 </td>
	 <td class="ligne1" align="left" valign="middle">
	     %$month% :
		  <input type="text" name="moism" value="%$para{moism}%" size="2" maxlength="2">
	 </td>
	 <td  class="ligne1" align="left" valign="middle" >
	    %$year% :
		<input type="text" name="anm" value="%$para{anm}%" size="4" maxlength="4">
	 </td>
	</tr>
  </table>		    					
  <table width="650" cellpadding="0" cellspacing="0">
     <tr> 
        <td valign="bottom" align="left" height="35">
        	<a href="javascript:validmodpropal(%$para{toupdate}%,'%$type%','%$login%','%$ch%');"><img src="%$HTMLADRUNGICONES%/valider.gif" border="0"></a>           
            <span class="texterouge">%$messmod%</span>
        </td>
     </tr>
     <tr><td>&nbsp;</td></tr>
     <tr>
		<td valign="bottom" align="left">
      	  <a href="%$CGIADR%/propal.cgi?username=%$login%&usertype=%$type%&toupdate=-1&%$ch%"><img src="%$HTMLADRUNGICONES%/nouveau.gif" border="0" align="middle"></a>
        </td>
     </tr> 
	 <tr><td>&nbsp;</td></tr>
     <tr>
        <td valign="bottom" align="left">	       	 
	  	   <a href="%$CGIADR%/propal.cgi?usertype=%$type%&username=%$login%&%$ch%&idmod=%$para{toupdate}%"><img src="%$HTMLADRUNGICONES%/retour.gif" border="0"></a>                
	           <span class="texterouge">%$messretpropal%</span>
	    </td>
	 </tr>
   </table>   
   %$champscache%
   </form>              
<!-- fin une ligne de propal en modification-->|;

my $ligPropalAjout = q|
<!-- une ligne de propal en ajout  = ligPropalAjout -->
  <form method="post"  name="validmodpropal" enctype="application/x-www-form-urlencoded" >
  <table width="650" cellpadding="3" cellspacing="1">
	<tr>			
	  <TD class="ligne2" align="left" valign="middle" width="20%">
            %$namecli% :
	  </td>
	  <TD class="ligne2" align="left" valign="middle">
	    %$popupclientmod%
	  </td>
      <td class="ligne2" valign="middle" align="right">
				   <a href="%$CGIADR%/clientmodif.cgi?toupdate=%$para{toupdate}%&usertype=%$type%&username=%$login%&script=propal&boutonnavig=commandes&%$ch%"><img src="%$HTMLADRUNGICONES%/creercli.gif" border="0" align="middle" width="128" height="25"></a>
       </td>
	</tr>
	<tr>
		<td class="ligne1" align="left" valign="middle" width="20%">
		   %$wording% :
		</td>
		<td class="ligne1" align="left" valign="middle">
		   <textarea name="libpropalajout" cols="40" wrap="virtual">%$para{libpropalajout}%</textarea>
		</TD>
	</tr>
	<tr>
	  <td class="ligne2" align="left" valign="middle" width="20%">
	     %$propalestim% :
	  </td>
          <td class="ligne2" align="left" valign="middle" >
	     %$popupestimmod%
	  </td>
    </tr>
    <tr>
	 <td class="ligne1" align="left" valign="middle" width="20%">
	   %$commentaires% :
	 </td>
	 <td class="ligne1" align="left" valign="middle">
	   <textarea name="commentairesajout" cols="40" rows="2" wrap="virtual">%$para{commentairesajout}%</textarea>
	</TD>			
  </tr>
  <tr>
	<TD  class="ligne2" align="left" valign="middle" width="20%">
	   %$namecommercial% :
	</td>
	<TD  class="ligne2" align="left" valign="middle">
	   %$popupcommercialmod%
	</td>
  </tr>	
	<TD class="ligne1" align="left" valign="middle" width="20%">
	    %$nameleadproject% :
	</td>
	<TD class="ligne1" align="left" valign="middle">
		%$popupchefmod%
	</td>
  </tr>
  <tr>
	 <TD class="ligne2" align="left" valign="middle" width="20%">
	 	%$total% &euro;
	 </TD>
         <TD class="ligne2" align="left" valign="middle" >
		 <input type="text" name="totalajout" value="%$para{totalajout}%">
	 </TD>
  </tr>
 </table>
 <table width="650" cellpadding="3" cellspacing="1">
   <tr>									
	 <TD class="ligne1" align="left" valign="middle">%$date% - </td>
	 <td class="ligne1" align="left" valign="middle">
	       %$day% :
			<input type="text" name="jourf" value="%$para{jourf}%" size="2" maxlength="2">
	 </td>
	 <td class="ligne1" align="left" valign="middle">
	     %$month% :
		  <input type="text" name="moisf" value="%$para{moisf}%" size="2" maxlength="2">
	 </td>
	 <td  class="ligne1" align="left" valign="middle" >
	    %$year% :
		<input type="text" name="anf" value="%$para{anf}%" size="4" maxlength="4">
	 </td>
	</tr>
  </table>		    					
  <table width="650" cellpadding="0" cellspacing="0">
     <tr> 
        <td valign="bottom" align="left" height="35">
        	<input type="image" src="%$HTMLADRUNGICONES%/valider.gif" border="0">           
            <span class="texterouge">%$messmod%</span>
        </td>
     </tr> 
     <tr><td>&nbsp;</td></tr>
     <tr>            
        <td valign="bottom" align="left">	       	 
	  	   <a href="%$CGIADR%/propal.cgi?usertype=%$type%&username=%$login%&%$ch%"><img src="%$HTMLADRUNGICONES%/abandonner.gif" border="0"></a>                
	    </td>
	 </tr>
   </table>   
   <input type="hidden" name="usertype" value="%$type%">
   <input type="hidden" name="username" value="%$login%">	      
   <input type="hidden" name="ajouter" value="10">
   <input type="hidden" name="toupdate" value="-1">
   %$champscache%
   </form>              
<!-- fin une ligne de propal en ajout -->|;
				    
sub AffichPropal{
	my ($type,$login,$orderpcd,$ordersuiv,$nb,$taille,$som,$somestim,
    $reftabAffich,$refpara,$reftab,$reftabcommercial,$reftabcommercialajout,$reftabchef,
    $reftabchefajout, $refestim,$refestimajout,$reftabcli, $reftabcliajout ,$mess) = @_;
    my $ch = '';
	($refpara,$ch) = &getParam(%$refpara);
	my %para = %$refpara;
	if(exists ($para{"toupdate"}) && $para{"toupdate"}){
  	&PropalModif($type,$login,$refpara,$ch,$mess,$reftabcommercialajout,
  	$reftabchefajout, $refestimajout,$reftabcliajout);
    }
    else{
      &ListePropal($type,$login,$orderpcd,$ordersuiv,$nb,$taille,$som,$somestim,
      $reftabAffich,$refpara,$reftab,$reftabcommercial,$reftabchef,
      $refestim, $reftabcli,$mess,$ch);
    }   
    return;
}


sub PropalModif{
    my ($type,$login,$refpara,$ch,$mess,$reftabcommercialajout,
  	$reftabchefajout, $refestimajout, $reftabcliajout) = @_;
    my %para = %$refpara;

    my $champscache = &getHidden(%para);
    my $title = $titleModPropal;
    my $app = "mod";
    if($para{"toupdate"} == -1){
    	$app = "ajout";
    	if(!($para{"jourf"} || $para{"moisf"} || $para{"anf"})){
		  ($para{"jourf"}, $para{"moisf"},$para{"anf"})=&sec_calend(time);	
	    }
	    $title = $titleCreatPropal;
	}	
    foreach my $val (keys %para){
      if ($val =~ /(mod|ajout)$/ && $para{$val} =~ /^[+\-]{0,1}[0-9]+\.[0-9]{2}$/){
         $para{$val} = &formatNombre($para{$val});
      }
    }
    #print p "client = $para{'clientmod'}";
    my $popupestimmod =&getPopup($refestimajout, $para{"pourcestim$app"},"pourcestim$app");
	my $popupcommercialmod =&getPopup($reftabcommercialajout, $para{"commercial$app"},"commercial$app");
	my $popupchefmod = &getPopup($reftabchefajout, $para{"chefprojet$app"},"chefprojet$app");
    my $popupclientmod =&getPopup($reftabcliajout, $para{"client$app"},"nomcli$app");
    my $onload = '';
	my $page = $body.&AffichLig(&affiche_barre($type,\%navigation,'propal'),$type,$login).$titrePage;
	if($mess){$page .= $messPage;}
	if($para{'toupdate'} == -1){	     
	     $page .= $ligPropalAjout;
	}
	else{$page .= $ligPropalMaj;}
	$page =~ s/%(\$\w+\{\w+\})%/$1/gee;
    $page =~ s/%(\$\w+)%/$1/gee;
    #double substitution pour substituer les valeurs de liste
    $page =~ s/%(\$\w+)%/$1/gee;	 
    &AffichPageWeb($title,$page); 
    return;
}
	
	

sub ListePropal{
	my ($type,$login,$orderpcd,$ordersuiv,$nb,$taille,$som,$somestim,
    $reftabAffich,$refpara,$reftab,$reftabcommercial,$reftabchef,
     $refestim, $reftabcli,$mess,$ch) = @_;
    #on recupere les variables avec les valeurs necc pour l'affichage
    #et on formate les valeurs pour l'affichage    
     my %para = %$refpara;
	my $champscache = &getHidden(%para);
	$som = &formatNombre($som); $somestim = &formatNombre($somestim);	
	#on construit la liste des commandes formatees
	my %ligPropalDroit=();
    tie %ligPropalDroit,"Tie::IxHash";
    %ligPropalDroit = &getHashAffich(\%ligPropal,$type);
    my $liste = &makeListe($reftabAffich,\%ligPropalDroit);
    my $title =  $titleconspropal;
	#on fait les menus deroulants	  
    my $popuptri = &getPopup($reftab, $para{"tri"},"tri");
	my $popupestim =&getPopup($refestim, $para{"pourcestimtri"},"pourcestimtri");
	my $popupcommercial =&getPopup($reftabcommercial, $para{"commercialtri"},"commercialtri");
	my $popupchef = &getPopup($reftabchef, $para{"chefprojettri"},"chefprojettri"); 
	my $popupclient =&getPopup($reftabcli, $para{"clienttri"},"clienttri");
    #my $onload = '';
	my $onload = exists ($para{toupdate}) ? $onloadEcran:'';
    #on construit la page a afficher
    my $page = $body.&AffichLig(&affiche_barre($type,\%navigation,'propal'),$type,$login).$titrePage;
	if($mess){$page .= $messPage;}	
	$page .= $ListePropal;	
	$page =~ s/%(\$\w+\{\w+\})%/$1/gee;
	$page =~ s/%(\$\w+)%/$1/gee;
	#double substitution pour substituer les valeurs de liste
	$page =~ s/%(\$\w+)%/$1/gee;		 
	&AffichPageWeb($title,$page);
    return;
}

my $editCommentaire = q|
<!-- debut  $editCommentaire -->  
   <HTML>
    <HEAD>
      <script language="JAVASCRIPT" src="%$HTMLADRESSE%/javascript.js" type="text/javascript"></script>	
      <TITLE>commentaires</TITLE>
    </HEAD>
    <BODY BGCOLOR="#ffffff">
    <form method="post" action="%$CGIADR%/propal.cgi">
       <textarea name="commentaires" cols="70" rows="10" wrap="virtual">%$commentaire%</textarea></td>	  
	   <br>
	   <input type="image" name="save" src="%$HTMLADRUNGICONES%/valider.gif" border="0">			
       <input type="hidden" name="editpropal" value="%$idpropal%"> 
       <input type="hidden" name="save" value="10">
       <input type="hidden" name="usertype" value="%$type%">
 	  <input type="hidden" name="username" value="%$login%">   
	</form>
	  
      <form>
        <input type="button" value="cliquez ici pour fermer" onClick="retourclose(%$idpropal%,'%$login%','%$type%','propal');">
      </form>
   </BODY>
  </HTML>
<!-- fin  $editCommentaire -->|;


#afficher le commentaire d'un commande
sub affichCommentPropal{
	my ($commentaire,$idpropal,$idmod,$type,$login) = @_;
	if($idpropal){
		(my $page  = $editCommentaire) =~ s/%(\$\w+)%/$1/gee;
		print header;
		print $page;
	}
	else{#la propal selectionne existe plus
		my $script = "propal";
		$rafraichirEcran =~ s/%(\$\w+)%/$1/gee;
		print header();
		print $rafraichirEcran;
	}
    return;     
}


#######################################
#passer d'une propal vers une commande
#######################################

my $propalVersCommande = q|
<!-- debut  $propalVersCommande -->
   <table width="650" cellpadding="3" cellspacing="1">
    <tr>
      <td class="message" align="left">%$messpropalverscde%</td>
    </tr>
   </table>
   <br>
   <form method="post" action="%$CGIADR%/propalcde.cgi">
   <table width="650" cellpadding="3" cellspacing="1">   	  
	  <tr>	  
	  	<td class="ligne1" align="left" valign="middle"> %$orderreference% :&nbsp;&nbsp	  	
	  		<input name="refcommande" type="text"  size="50" value="%$para{refcommande}%">
	  	</td>
	  </tr>	  
	</table>	 
	 <input type="hidden" name="usertype" value="%$type%">
 	<input type="hidden" name="username" value="%$login%"> 	
 	<input type="hidden" name="idpropal" value="%$idpropal%">
 	
    <table width="650" cellpadding="0" cellspacing="0">	 	
 		<tr> 
 		  <td valign="bottom" align="left" height="35" class="texterouge">
 			<input name="valider" type="image" border="0" src="%$HTMLADRUNGICONES%/valider.gif">
 		    %$messfact%
 		  </td>	 	
 		</tr>
 	</table>
	</form>
<!-- fin  $propalVersCommande -->|;


sub AffichPropalCde{
 my ($type,$login,$idpropal,$mess,$refpara) = @_;
 my $title = $titlepropverscde;
 my $ch = '';
 ($refpara,$ch) = &getParam(%$refpara);
 my %para = %$refpara;
 my $onload = '';
 my $page = $body.&AffichLig(&affiche_barre($type,\%navigation,'propal'),$type,$login).$titrePage;
 if($mess){$page .= $messPage;}
 $page .= $propalVersCommande;
 $page =~ s/%(\$\w+\{\w+\})%/$1/gee;
 $page =~ s/%(\$\w+)%/$1/gee;	
 $page =~ s/%(\$\w+)%/$1/gee;			 
 &AffichPageWeb($title,$page);
 return;
}
 


1;

END{}
