=pod

package de variables pour les statistiques
propres au theme UNGI

=cut

package UNGI::Statistique;

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../../lib','../';	
} 

use strict;
use CGI  qw(:standard);
use Conf;
use Util;
use lang::Fr;
use UNGI::General; 


BEGIN{
	use Exporter;
	use vars qw($VERSION @ISA @EXPORT);
	$VERSION = 1.00;
	@ISA = qw(Exporter);
	@EXPORT= qw(&ListeStatistiques);	
		
}

use vars  @EXPORT;

###########################
#liste des factures
###########################

my $ListeStatistique = q|
<!-- debut  $ListeStatistique -->
    <table width="760" cellspacing="1" cellpadding="0" align="center">
      <tr align="center">    
          <TD class="tetiere" align="center">%$month%</TD>
		  <TD class="tetiere" align="center">%$year%</TD>
		  <TD class="tetiere" align="center">%$turnover% &euro;</TD>
		  <TD class="tetiere" align="center">%$expense% &euro;</TD>
		  <TD class="tetiere" align="center">%$profit% &euro;</TD>
		  <TD class="tetiere" align="center">%$regulation% &euro;</TD>				
		  <TD class="tetiere" align="center">%$bank% &euro;</TD>
      </TR>
     %$liste%
     <tr align="center"> 
        <TD colspan="2" class="textegras">%$average%</TD>						
		<TD class="tetiere" align="right">%$moyca%</TD>
		<TD class="tetiere" align="right">%$moydep%</TD>
		<TD class="tetiere" align="right">%$moybenef%</TD>
		<TD class="tetiere" align="right">%$moyentrees%</TD>		
		<TD class="tetiere" align="right">&nbsp;</TD>        
      </tr>
      <tr align="center">
        <TD colspan="2" class="textegras">%$sum%</TD>						
		<TD class="tetiere" align="right">%$somca%</TD>
		<TD class="tetiere" align="right">%$somdep%</TD>
		<TD class="tetiere" align="right">%$sombenef%</TD>
		<TD class="tetiere" align="right">%$somentrees%</TD>		
		<TD class="tetiere" align="right">&nbsp;</TD>        
      </tr> 
    </table>
    <br>   
<form method="post" action="%$CGIADR%/statistiques.cgi" name="formulaire">
<table width="760" align="center">
    <tr align="center"> 
      <td class="tetiere2">%$searchby%&nbsp;:</td>
    </tr>
  </table>   
  <table width="760" align="center" cellpadding="3" cellspacing="1">    
    <tr>            
      <td class="ligne2" width="25%"><span class="ligne2">%$month%</span> 
        %$popupmoistri%
      </td>
      <td class="ligne2" width="25%"><span class="ligne2">%$year%</span> 
        %$popupantri%
      </td>
      <td class="ligne2">  
        <table>
        	<tr><td>anne calendaire</td></tr>
        	<tr><td><input type="radio" name="typeantri" value="calendaire" %$checkcal%></td><tr>
        </table>
      </td>
      <td class="ligne2">
        <table>
        	<tr><td>anne comptable</td></tr>
        	<tr><td><input type="radio" name="typeantri" value="comptable" %$checkcompt%></td><tr>
        </table>
      </td>
    </tr>
    <tr> 
      <td class="tetiere2" colspan="4" height="10"></td>
    </tr>    
  </table>
  <br>    
  <table width="500" border="0" cellspacing="0" cellpadding="5" align="center" class="ligne3">
    <tr>
      <td align="center">        
        <table width="350" align="center">
          <tr> 
            <td class="texte4" align="left" valign="middle">%$linenumber%</td>
            <td> 
              <input type="text" name="nbligtri" value="%$nb%" size="4" maxlength="3">
            </td>
            <td class="texte4" align="center" valign="middle">%$ontotal% %$taille%</td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGI%/icones/reload.gif" width="31" height="36">
            </td>
          </tr>
        </table>
        <table width="500" border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGI%/icones/premier.gif" width="31" height="22" align="middle">
            </td>
            <td align="center"><img src="%$HTMLADRUNGI%/icones/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="precedent" src="%$HTMLADRUNGI%/icones/gauche.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGI%/icones/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="suivant" src="%$HTMLADRUNGI%/icones/droite.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGI%/icones/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="dernier" src="%$HTMLADRUNGI%/icones/dernier.gif" width="30" height="22" align="middle">
            </td>
          </tr>
        </table>        
      </td>
    </tr>
  </table> 
  <input type="hidden" name="usertype" value="%$type%">
  <input type="hidden" name="username" value="%$login%">
  <input type="hidden" name="pcdt" value="%$orderpcd%">
  <input type="hidden" name="suiv" value="%$ordersuiv%">
  <input type="hidden" name="chaine" value="%$ch%">
  </form>
  <table width="500" cellpadding="0" cellspacing="0" border="0" align="center">
     <tr>
       <td align="center" valign="bottom" colspan="3" height="30">
            <a href="%$CGIADR%/login.cgi"><img src="%$HTMLADRUNGI%/icones/quitter2.gif" border="0"></a> 
       </td>
     </tr>
  </table>
<!-- fin  $ListeStaistiques -->|;

#hachage regroupant les differentes parties d'une ligne de facture
my %ligStat = ();
tie %ligStat,"Tie::IxHash";;
#une ligne de la liste
$ligStat{'begin'} = q|
<!-- Restricted-to: anybody -->
<!-- une ligne = 1  ligne de statistiques -->
  <tr align="center" height="20"> 
        <td class="numero" align="right">%$rangee[0]%</td>
        <td class="texte2" align="right">%$rangee[1]%</td>
        <td class="texte3" align="right">%$rangee[2]%</td>
        <td class="texte2" align="right">%$rangee[3]%</td>
        <td class="texte3" align="right">%$rangee[4]%</td>
        <td class="texte2" align="right">%$rangee[5]%</td>
        <td class="texte3" align="right">%$rangee[6]%</td>
  </tr>      
|;



sub ListeStatistiques{	
	my ($type,$login,$orderpcd,$ordersuiv,$nb,$taille,$reftabAffich,$somca,
      $somdep,$sombenef,$somentrees,$moistri,$antri,$typeantri,$refhashmonthtri,
      $refhashantri,$refpara) = @_;   
	my $title = $titleConsStat;
	my $ch = '';	
	($refpara,$ch) = &getParam(%$refpara);
	#faire les listes droulantes	
    my $popupmoistri = &getPopup($refhashmonthtri,$moistri,"moistri");
    my $popupantri = &getPopup($refhashantri,$antri ,"antri");
	my $onload = '';
    #faire cocher la bonne case de typeann selon $typeantri
    my $checkcal = my $checkcompt = '';    
    $typeantri eq "comptable" ? $checkcompt = "checked" : $checkcal = "checked";
    #faire la liste des stat a afficher    
    #formater la liste des factures a afficher    
    my $liste = &makeListe($reftabAffich ,\%ligStat);
    my $moy = @$reftabAffich; 
    my $moyca = my $moydep = my $moybenef = my $moyentrees = 0;
    if($moy){
	   $moyca = $somca/$moy;	
	   $moydep =  $somdep/$moy;
	   $moybenef = $sombenef/$moy;
	   $moyentrees = $somentrees/$moy;
	}	
	
    foreach my $val ($somdep,$sombenef,$somentrees,$somca,$moyca,$moydep,$moybenef,$moyentrees){
    	$val = &formatNombre($val);
    } 
        
    #construire la page
	my $page = $body.&AffichLig(&affiche_barre($type,\%navigation,'statistiques'),$type,$login).$titrePage;
	
	$page .= $ListeStatistique;     
	$page =~ s/%(\$\w+(\{\w*\})?)%/$1/gee;
	$page =~ s/%(\$\w+)%/$1/gee;	 
	&AffichPageWeb($title,$page);
	return;
}	

1;
END{}
