#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####
#
# Gestion des Articles 
# Par Nicolas Schmeltz pour Abtey Production
#
#####


#article.cgi affiche la liste des articles

=pod
	affiche la liste des articles 	
=cut	
	
#mettre les librairies ds le chemin de perl

BEGIN {
  unshift @INC, '../lib', '../html';	
} 

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Articles;
 
#print header,start_html(-BGCOLOR => "#ffffff");

#traitement para
my @param=param();

#si pas de para, on quitte
if(!@param){
	print redirect("$CGIADR/login.cgi");
	exit(0);
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"

my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;
		


#declaration variables
	
#recup parametres
my $login=param("username");
my $type=param("usertype");
my $idmod=param('idmod')?param('idmod'):0;
my $supp=0;
my $mess='';



#trt des donnees
#suppression d'un client
if(param('supp')){
	$idmod=param('supp');
	#le client a supprimer existe t'il
	if (&compte("idartic","article","idartic = $idmod")){
		if (!(&compte("numfact","lig_facture","idartic = $idmod "))) # ||
#				&compte("idpropal","propal","nomcli = $idmod ") ||
#				&compte("numcde","commande","nomcli = $idmod ")))
		{
			$mess = $messarticlesupp;
			$supp=param('supp');
		}
		else{$mess = $messclientsuppnook;}
	}
	else{
	    $para{'notexiste'} = $supp;
		$supp = 0;
	}
}





#pour la mise en valeur des maj
if($idmod){
	param("suivant.x" => 10);	
}	

########################
#preparation des listes
#########################

#liste de tri par champs
my %tab=();
tie %tab,"Tie::IxHash";
%tab =  ("idartic", $articid, "codart", $codarticle,
"codfam", $famarticle,"desart",$desarticle,"qtestk",$quantity,
#"ca",$casociete,
"pxht",$unitprice . $totalwithouttaxsort #,"ca_fact",$cafact
 );

#liste des codfams
my %codfamart = ();
tie %codfamart,"Tie::IxHash";
%codfamart =("0" => $messchoice, &liste("famart", "codfam", "desfam", "1", "desfam"));


#liste des commerciaux
my $cond = "1"; # = "userrole = 'commercial' or userrole = 'admin'";
my %tabunite;
tie %tabunite,"Tie::IxHash";
$tabunite{$nobody}= $nobody;
%tabunite=(%tabunite,&liste("unite","codunit","desunit", $cond,"desunit"));

###############################
#construction liste des factures
##############################		

#declaration de variables	

#recuperation des para necc au tri
my $order=param("tri")?param("tri"):"idartic";
$para{"tri"} = $order;
my $orderpcd= param("pcdt");
my $ordersuiv=param("suiv");	
my $codarttri = param("codarttri");
my $codfamtri = param("codfamtri")?param("codfamtri"):$all;
my $desarttri = param("desarttri");
my $qtetri = param("qtetri");
my $pxtri = param("pxtri");
#my $catri = param("catri");
#my $cafacttri = param("cafacttri");
my $unittri=param("unittri") ? param("unittri"):$all;

my $nb=param("nbligtri")?param("nbligtri"):$nblig;
my $chaine = param('chaine');
my $inddeb = 0;
#on force les $para sur une liste deroulante a une valeur
$para{"tri"} = $order;

$para{"codfamtri"} = $codfamtri;
$para{"unittri"} = $unittri;

		
#preparation  liste clients  afficher
my $listechamps  = "idartic,codart, codfam, desart,qtestk, codunit, pxht";
my $table = "article ";
#construction de la condition
$cond = "idartic > 0 " ;


#traitement des para passes pour les tri
if($codarttri){
   my $codarttribis = "%".$codarttri."%";
   $cond .= "and codart like  '$codarttribis' ";
}

if($codfamtri ne $all){#dateecheance
  $cond.= " and codfam ='$codfamtri'";
}

if($qtetri){
   my $qtetribis = "%".$qtetri."%";
   $cond .= "and qtestk like  '$qtetribis' ";
}

if($pxtri){
   my $pxtribis = "%".$pxtri."%";
   $cond .= "and pxht like  '$pxtribis' ";
}

#if (defined($catri) && $catri =~ /\d+/){#rechercher ent et ent.*
#	$catri =~ s/,/\./;
#	$catri =~ s/\..*//;
#	my $catribis=$catri.".%";
#	my $catrimoins1 = $catri - 1;
#    my $catriplus1 = $catri + 1;
#	$cond .= " and (ca  between $catrimoins1 and $catriplus1) ";
#}


#if($cafacttri){
#    $cafacttri =~ s/,/\./;
#	$cafacttri =~ s/\..*//;
#	my $cafacttribis=$cafacttri.".%";
#	my $cafacttrimoins1 = $cafacttri - 1;
#    my $cafacttriplus1 = $cafacttri + 1;
#	my $condbis = "client.idartic = facture.idarticfact and ";
#	$condbis .= " client.idartic = facture.idarticfact  group by idartic ";
#    $condbis .= " having sum(totHT) between  $cafacttrimoins1 and $cafacttriplus1";
#
#	my $tablebis = "facture, client";
#    my @liste = &listenum("idartic",$tablebis,$condbis,"idartic");
#	@liste = (@liste) ? @liste : (0);
#    $condbis = "(";
#    foreach my $val (@liste){
#      $condbis .= "idartic = $val or ";
#   }
#   $condbis =~ s/or\s*$/ /;
#   $condbis .= ")";
#   $cond .= "and $condbis ";
# }

if($unittri ne $all){
    if($unittri =~ /$nobody/){$cond.= " and codunit = '$nobody'";}
    else{$cond.= " and codunit like '$unittri'";}
}

#verifier que idmod question possedent les para de tri, sinon on enleve les criteres de tri
#$listechamps,$table,$cond
if($idmod){
    #verifier qu'idmod existe pour le trt des selcetions
    #d'objet qui n'existe plus
	if(!(&compte("idartic","article","idartic = $idmod"))){
	    $para{'notexiste'} = $idmod;
	    $idmod = &select_pcdtbis($listechamps,$table,$cond, "idartic",$idmod);
		$order =  $para{"tri"} = "idartic";
	}
	my $lig;
	my $condbis=$cond. " and idartic=$idmod";
	if(!(($lig)=&select_une_lig("idartic",$table,$condbis))){
		$cond= " idartic > 0" ;
		foreach my $clef (keys %para){;
			if($clef =~ /tri$/ ){$para{$clef}='';}
		}
	}		
}



#pour positionner sur la fact pcdt la fact supp, en se basant sur l'id	
if($supp){
		$idmod=&select_pcdt($listechamps,$table,$cond,$order,$supp);
		#print p "idmod= $idmod";
		#supprimer les lignes de factures
		&supp("idartic = $supp",'article');
}
		
my ($reftabquestion,$ordersuivbis);
#l'ordre n'est pas le ca_fact
if($order !~ /ca_fact/){
	($reftabquestion,$ordersuivbis)=&select_lig($listechamps,$table,$cond,$order,$idmod);
}
else{#$order = ca_fact, on fait un ordre sur idartic puis on tri
	($reftabquestion,undef)=&select_lig($listechamps,$table,$cond,"idartic",$idmod);
#     my @table=@$reftabquestion;
#	 my %hash = ();
#	 for(my $i=0; $i < @table; $i++){
#	 	my @rangee=@{$table[$i]};
#		my $rangee = join(";",@rangee);
#        my $cond = " idarticfact = $rangee[0] ";
#		my $val = &sum("facture","totHT",$cond) || 0 ;
#		$hash{$rangee} = $val;
#	}
#    my @tablecons = sort {$hash{$a} <=> $hash{$b}} keys %hash;
#	my @tablebis = ();
#	for(my $i=0; $i <@tablecons; $i++){
#        #print p "tab = $tablecons[$i]";
#		#print p "val = $hash{$tablecons[$i]}";
#		my @rangee = split(/;/,$tablecons[$i]);
#		if(($rangee[0] == $idmod)){$ordersuivbis=$i;}
#		push(@tablebis,\@rangee);
#	}
#    $reftabquestion =\@tablebis;
#
}

my @table=@$reftabquestion;
my $taille = @table;
#pour afficher  partir de la question modifier, ajouter ou pour suivant
$ordersuiv=defined($ordersuivbis)?$ordersuivbis:$ordersuiv;

#recuperer numero dans la liste du 1e elem a afficher, du nb de ligne par ecran
#et du 1er elme et du dernier + 1 dans la liste selon ce qui a ete demande et
#deje vu par l'utilisateur

($inddeb,$orderpcd,$ordersuiv,$nb)= &getIndDeb($nb,$idmod,$ordersuiv,$orderpcd,$taille,$chaine,$ch);
#print p " ***nb = $nb";
#print p "***ordersuiv = $ordersuiv";
$para{"nbligtri"} = $nb;




			
#construction d'un tableau contenant juste les enreg a afficher, formater
my @tabAffich=();
for (my $i=$inddeb;$i < ($inddeb + $nb) &&$i<@table;$i++){			
	my @rangee=@{$table[$i]};
#	my $cond = " idarticfact = $rangee[0] ";
#	$rangee[8] = &sum("facture","totHT",$cond) || 0 ;
#	$rangee[8]=sprintf("%.2f",$rangee[8]);
    $rangee[4]=$rangee[4] || $norenseigne;
    $rangee[5]=$rangee[5] || $norenseigne;
    $rangee[6]=$rangee[6] ?sprintf("%.2f",$rangee[6]): $norenseigne;
	#my ($table,$champs,$cond)=@_;
	my $mod = ($idmod==$rangee[0])?$idmod:0;
	my $stand = !$mod;
	#$count,$table,$cond
	my $supp = !(&compte("numfact","lig_facture","idartic = $rangee[0]") ); #||
 #              &compte("idpropal","propal","nomcli = $rangee[0]") ||
#			   &compte("numcde","commande","nomcli = $rangee[0]")) || 0 ;
	$rangee[9] = { "stand" => $stand, "mod" => $mod, "supp" => $supp };
    push(@tabAffich,\@rangee);
}

#on va definir les $para inexistants pour eviter les erreurs dans le fichier de log
foreach my $val ('codarttri','desarttri','qtetri','pxtri','catri','cafacttri'){
	if(!exists $para{$val}){$para{$val} = '';}
}


########################
#affichage liste facture
########################

&ListeArticles($type,$login,$orderpcd,$ordersuiv,$nb,$taille, $titleconsarticle,
               $mess, \@tabAffich, \%para,\%tab,\%codfamart, \%tabunite);


		
	

	
		
	



