#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####


#editfact.cgi pour editer une facture
=pod
	pour diter une facture et son duplicata,  imprimer eventuellement	
=cut


BEGIN {
  unshift @INC, '../lib', '../html';	
}

use strict ;
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Editfacture;

#print header,start_html(-BGCOLOR => "#ffffff");
#traitement para

my @param=param();
#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"
my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;

#############################
#recuperation entete facture
#############################


#declaration variables
my $numfact=param('edit') || param('duplicata') || param('generer');
my $login=param("username");
my $type=param("usertype");
my $idmod = 0;
my @enteteFacture = ();
my $reftab = ''; my $tauxtva = 0;
#si param(generer) on fabrique la facture et son duplicata
my $generer = param("generer") ||  (! -f "$FACTUREAD/$numfact.pdf");
my $script = param("script");
if(&select_une_lig("numfact","facture","numfact = $numfact")){

######################################################
#recuperation et formatage de l'entete de la facture
######################################################
 if($generer){
	#recup entete
	my $cond="facture.clientidfact = client.clientid  and numfact = $numfact ";
	my $table="facture, client ";
	my $listechamps =  "clientnom, responsablecde, datefact, refcde, clientrue1, clientville, ";
	$listechamps .= " clientcp, datereglement, totHT, totTTC, fraisdeplt, banquereglement, ";
	$listechamps .= " numcheque,contact, clientnom2, clientrue2, clienttitre, clientpays,echeance";
	$listechamps .= ", remise, totHTremise ";
	@enteteFacture=&select_une_lig($listechamps,$table,$cond);


	#slection des lignes de facture
	$listechamps = "qtefacture, libartic, prixHT, tauxTVA";
	$table = " lig_facture ";
	$cond= "numfact= $numfact";
	my $order= "ligfact";
	($reftab) = &select_lig($listechamps,$table,$cond, $order,0);
	my @tab = @$reftab;
	#fin selection lignes facture


	#calcul total taux tva
	my $moytva=0;
	my $qtetot=0;
	for (my $z=0;$z<@tab;$z++){
		my($qtefacture, $libartic, $prixHT, $tauxTVA, $remise)=@{$tab[$z]};
		$moytva+=$qtefacture*$tauxTVA;
		$qtetot+=$qtefacture;
	}
	
	if($qtetot){
		$tauxtva=sprintf("%.2f",$moytva/$qtetot*100);
	}
   }
 }
 else{
    $idmod = $numfact;
    $numfact = 0;
 }



#################
#edition facture
#################
&editfact($numfact,\@enteteFacture,$reftab,$tauxtva,$login,$type,$idmod,$generer,$script,\%para);

	
