#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####
#
# Modified by Nicolas SCHMELTZ for Abtey Productions
#
# 03/10/2003 : ajout de la remise, rcupration auto d'infos client
# 06/10/2003 : Ajout de la recherche d'articles/familles
#
####

#appeller de l'ecran facture qd on cliq sur l'un
#des 3 boutons de la liste des factures fait par login.cgi
#gere edition, supp et 1er ecran de modif des factures

=pod
	pour modifier ou creer une facture	
=cut

BEGIN {
  unshift @INC, '../lib', '../html';	
}

use strict ;
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Facture;

#print header,start_html(-BGCOLOR => "#ffffff");

#traitement para
my @param=param();

#si pas de para, on quitte
if(!@param){
	print redirect("$CGIADR/login.cgi");
	exit(0);
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"

my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;


$para{"tauxTVAajout"} = $tvaconst;
$para{"prixHTajout"} = 0; 
#$para{"statutfactfct"} = 2;

#declaration variables
my $mess='';
my $idmodrep=0;
my $ligfact=0;   
 

#declaration variables
#recup para
my $numfact=param("numfact");
my $login=param("username");
my $type=param("usertype");
my $copier=param("copier") || 0;

#si $numfact et la facture numfact existe pas, il faut traiter
if($numfact && !&compte("numfact","facture","numfact = $numfact")){
	print redirect("$CGIADR/facture.cgi?idmod=$numfact&username=$login&usertype=$type&$ch");
	exit(0);
}

#si $copier et la facture $copier existe pas, il faut traiter
if($copier && !&compte("numfact","facture","numfact = $copier")){
    #print p "coucou";
	print redirect("$CGIADR/facture.cgi?idmod=$copier&username=$login&usertype=$type&$ch");
	exit(0);
}


#maj bdd

=pod
#modifier une facture
if(param('modif')){	
	$numfact=param('modif');			
}
=cut

#suppression d'une ligne de facture
if(param('supp')){
	my $supp=param('supp');
	#verifier existence de la ligne
	if(my ($idartic, $qtefact) = &select_une_lig("idartic, qtefacture","lig_facture","ligfact = $supp")){
		&supp("ligfact = $supp",'lig_facture');
		&maj_tot($numfact);
	 	&maj("idartic = $idartic", {qtestk => "$qtefact\' + qtestk + \'0"}, 'article') if ($idartic);
		$mess = $messligsuppok;	
	}
	else{
	    $para{'notexiste'} = $supp;
		$supp = 0;
	}

}	
	
#affichage permission modif ligne facture
if(param('mod')){
	$idmodrep =param('mod');
    #verifier existence de la ligne
	if(!&compte("ligfact","lig_facture","ligfact = $idmodrep")){
         $para{'notexiste'} = $idmodrep;
         $idmodrep = 0;
	}

}

# pour modifier une ligne de facture
if(param('valide')){
   $ligfact = param('valide');
   #verifier existence de la ligne
	if(!&compte("ligfact","lig_facture","ligfact = $ligfact")){
         $para{'notexiste'} = $ligfact;
         $ligfact = 0;
	}
}

#pour reproduire une facture identique  la date du jour
if($copier){
	#creation de l'entete de facture
	#selectionnez tous les champs de la facture
	my $listechamps ="clientidfact,responsablecde, refcde ,echeance, contact,fraisdeplt,";
	$listechamps .= "periodicite, remise";
	my ($clientidfact, $responsablecde, $refcde , $echeance, $contact, $fraisdeplt,
		$periodicite, $remise) = &select_une_lig($listechamps,"facture", "numfact = $copier");
	#numero de la nouvelle facture
	$numfact = &max("facture","numfact", "numfact > 0") + 1 ;
	#calcul de la date de la nouvelle facture
	#recuperez la date sous formar jj/mm/aaaa
    my ($jour, $mois, $an) = &sec_calend(time());
	my $datefact = &calend_sec($jour,$mois, $an);

	#calcul date echeance
	my $dateecheance = $datefact;
	if ($echeance eq "-1"){$dateecheance = $datefact;}
	elsif($echeance =~ /^\d+$/){
		$dateecheance=&calend_sec(&sec_calend($datefact + $echeance * 24 *3600));
	}
	else{#echeance fin de mois
	#recup date sec du 1er du mois suivant
		  if($mois == 12){$dateecheance = &calend_sec(1,1,$an + 1);}
		  else{$dateecheance = &calend_sec(1,$mois + 1,$an);}
		  #calcul dateecheance
		  $dateecheance = &calend_sec(&sec_calend($dateecheance + 30 * 24 *3600));
	}
	$listechamps ="(numfact, clientidfact,responsablecde, refcde ,datefact,echeance, dateecheance ,contact, ";
	$listechamps .= "fraisdeplt,  periodicite, remise)";
	my @listeval =($numfact, $clientidfact,$responsablecde, $refcde ,$datefact,$echeance,$dateecheance,
	$contact, $fraisdeplt,  $periodicite, $remise);
	foreach my $val (@listeval){
		$val =~ s/(?<!\\)('|")/\\$1/g;
		$val="'".$val."'";
	}
    my $listeval = "(".join(",",@listeval).")";
	&insert( $listeval,$listechamps,"facture");
	$listechamps="libartic, qtefacture, prixHT, tauxTVA";
	#creation des lignes de facture
    my $cond = "numfact = $copier";
    my $order="ligfact";
    my ($reflisteligfact)=&select_lig($listechamps,"lig_facture",$cond, $order);
    my @liste = @$reflisteligfact;
    $listechamps = "(ligfact, numfact,$listechamps)";
    for(my $i=0; $i <@liste; $i++){
  	   my ($libartic, $qtefacture, $prixHT, $tauxTVA) = @{$liste[$i]};
	   my $ligfact = &max ("lig_facture","ligfact", "ligfact > 0") + 1 ;
	   my @listeval = ($ligfact, $numfact ,$libartic, $qtefacture, $prixHT, $tauxTVA);
       foreach my $val (@listeval){
		  $val =~ s/(?<!\\)('|")/\\$1/g;
		  $val="'".$val."'";
	   }

       my $listeval = "(".join(",",@listeval).")";
       &insert( $listeval,$listechamps,"lig_facture");
    }
	&maj_tot($numfact);

}


#modif ou cration de l'entete de facture
if(param('validercreat') || param('validermodif')){
	#print header,start_html;
	$mess='';
	my $datereglement=0;	
	my $responsablecde=param("responsablecdefct");	
	my $fraisdeplt=param("fraisdepltfct");
	my $statut = param('statutfactfct');
	my $periodicite = param('periodicitefct');
	$fraisdeplt=~ s/\s+//g;
	param("fraisdepltfct => $fraisdeplt");
	#si resp et/ou datefact non renseign on entre pas
	#si un para est mal renseign on entre pas 
	if(!$responsablecde){$mess="$messresp, ";}
	if ($fraisdeplt && !($fraisdeplt =~ /^[+\-]{0,1}[0-9]+[,.]{0,1}[0-9]*$/)){
		$mess .="$messfraisdeplt, ";		
		}
	else{
		$fraisdeplt =~ s/,/\./;
		param("fraisdepltfct" => $fraisdeplt);
		}	
	my $remise = param('remisefct');
	# vrif syntaxe de la remise optionnelle 
	if ( $remise && !($remise =~ /^[0-9][0-9]?([,.][0-9][0-9]?)?$/) )
		{ $mess .= "$messremisenotok, " }
	else {
		$remise =~ s/,/./;
		param("remisefct" => $remise);
	}
	my ($jour,$mois,$an)=(param("jourf"),param("moisf"),param("anf"));
	my $datefact='';	
	if(!(($an && $mois && $jour) && (my $ok=&verif_date($jour, $mois, $an)))){		
		$mess .="$messdatefact, ";
		}
	else{$datefact=&calend_sec($jour, $mois, $an);}
	#########
	my ($jourr,$moisr,$anr)=(param("jourr"),param("moisr"),param("anr"));
	if($jourr || $moisr|| $anr){
		if(!(($jourr && $moisr && $anr) && (my $ok=&verif_date($jourr, $moisr, $anr)))){
			$mess .="$messdatereglement, ";
		}
		else{$datereglement=&calend_sec($jourr, $moisr, $anr);}	
	}
	#else{$datereglement=0;}

    #datereg sssi stautfact = regle (1) et si statut =1, datereg = oblig
	if($datereglement && param('statutfactfct') > 1){
		$mess .= "$messdateregandnotset, ";
	}
	if(!$datereglement && param('statutfactfct') == 1){
		$mess .= "$messsetandnotdatereg, ";
	}


	#calcul echance
	my $echeance = param('echeancefct');
	my $dateecheance=0;	
	if ($datefact && $echeance){
		if ($echeance eq "-1"){$dateecheance = $datefact;}
		elsif($echeance =~ /^\d+$/){
			$dateecheance=&calend_sec(&sec_calend($datefact + $echeance * 24 *3600));
		}
		else{#echeance fin de mois
		#recup date sec du 1er du mois suivant
		  if($mois == 12){$dateecheance = &calend_sec(1,1,$an + 1);}
		  else{$dateecheance = &calend_sec(1,$mois + 1,$an);}
		  #calcul dateecheance
		  $dateecheance = &calend_sec(&sec_calend($dateecheance + 30 * 24 *3600));
		}
	} 
	elsif(!$echeance){$mess .= "$messnoecheance, ";}	
	if (!param('clientidfactfct')){$mess .= "$messnocustomerselect, ";}
	#statut obligatoire	
	if (!$statut){$mess .= "$messnostatutselect,";}	
	#si maj, le statut doit tre soit regle, soit la derniere relance effectue si facture
	#deja relance, ou non regle si facture jamais relance
	#surtout pas inrementer ou decrementer les relances par la modif de facture
	if($numfact){
		my ($ancstatut) = &select_une_lig("statutfact","facture","numfact = $numfact");
		my $compte = &compte("idrelance","relance","numfact = $numfact");
		if(!($statut == 1 || $statut == $compte + 2)){#statut diff de reg ou derniere relance
			$mess .= "$messinvalidstatut, ";
		}
	}
	
	#forcer  choisir une priodicite
	if ($periodicite == -1){ $mess .= "$messnoperiodicite";}
	if($mess){
		foreach my $para (@param){
			if($para =~ /(fct$|^(jour|mois|an))/){
				$para{$para}=param($para);
			}
		}
		if($numfact){$para{"numfact"} = $numfact;}
	}	 				
	if(!$mess){#$mess = $messfct
		$numfact=$numfact?$numfact:&max('facture', 'numfact') + 1;		
		my %hash;
		$hash{'datefact'} = $datefact;
		$hash{'datereglement'} = $datereglement;
		$hash{'dateecheance'} = $dateecheance;
		my @listechamps=('numfact','datefact','datereglement','dateecheance');
		my @listeval =($numfact,$datefact,$datereglement,$dateecheance);
		foreach my $champs(@param){
			if($champs =~ /(fct)$/){
				my $val=param($champs);
				push(@listeval,$val);
				$champs =~ s/$1//;
				push(@listechamps,$champs);
				$hash{$champs}= $val;
				}
			}		
		foreach my $val (@listeval){
				$val="'".$val."'";
			}
		my $listeval = "(".join(",",@listeval).")";
		my $listechamps = "(".join(",",@listechamps).")";
		if(param('validercreat.x')){
			$mess="$messcreatok";
			&insert( $listeval,$listechamps,"facture");
            #&maj_tot($numfact);
		}
		
		else{#param('validermodif.x') cad update
			$mess="$messmodifok";			
		    &maj("numfact = $numfact",\%hash,"facture");

		}
		&maj_tot($numfact);
	}			 
}			
		
#ajouter ou modifer une ligne de facture
if(param('ajouter') || $ligfact){		
	my $app=$ligfact?"mod":"ajout";
	my $libartic=param("libartic$app");	
	my $qtefacture=param("qtefacture$app");
	$qtefacture =~ s/\s+//g;  
	my $prixHT=param("prixHT$app");
	$prixHT =~ s/\s+//g;
	my $tauxTVA=param("tauxTVA$app");
	$tauxTVA =~ s/\s+//g; 
	my $codart = param("codart$app");
	my $idartic = param("poparticle");
	#les champs sont ils bien renseigns
	if(!$libartic){$mess.="$messlib, ";}		
	if (!$qtefacture || !($qtefacture =~ /^[+\-]{0,1}[0-9]+[,.]{0,1}[0-9]*$/)){
		$mess.="$messqtelig, ";
		}
	else{
		$qtefacture =~ s/,/\./;
		param("qtefacture$app" =>$qtefacture);		
	} 		
	if ($prixHT && !($prixHT =~ /^[+\-]{0,1}[0-9]+[,.]{0,1}[0-9]*$/)){
			$mess.="$messprixlig, ";
		}
	else{
		$prixHT =~ s/,/\./;			
		param("prixHT$app" =>$prixHT);
		}	
	if ($tauxTVA && !($tauxTVA =~ /^[+\-]{0,1}[0-9]+[,.]{0,1}[0-9]*$/)){
			$mess.="$messtva, ";
		}
	else{
		$tauxTVA =~ s/,/\./;			
		param("tauxTVA$app" =>$tauxTVA);
		}	
	#il existe pas dj pour la facture une ligne avce le meme libelle et meme codart	
	my $cond="numfact=$numfact and libartic='$libartic' AND codart = '$codart'";
	if ($idartic) {
		$cond .= " AND idartic = $idartic";
	}
	else {
		$cond .= " AND idartic IS NULL ";
	}
	
	if($ligfact){$cond.=" and ligfact<>$ligfact";}	
	if (my ($lig)=&select_une_lig("libartic","lig_facture",$cond)){
		$mess.="$messlibexiste, ";
		}
	if($ligfact && $mess){$idmodrep=$ligfact;}
	#ajouter dans le hachade de parametres %para les valeurs d'ajout
	#pour les reafficher
	if($mess){
		foreach my $para (@param){
			if ($para =~ /$app$/){$para{$para} = param($para);}
		}
		$para{"tauxTVA$app"} = ($para{"tauxTVA$app"} || $tvaconst);
		$para{"prixHT$app"} = ($para{"prixHT$app"} || 0); 		
	}			
	if(!$mess){	
	#trt para a ajouter
		$ligfact=$ligfact?$ligfact:&max('lig_facture', 'ligfact') + 1;
		my ($complement)=&select_une_lig('complement','lig_facture',"ligfact=$ligfact");		
		$complement=$complement?$complement:0;
		#gestion du complement de ligne
		if($qtefacture < 1  && $app eq "ajout"){		
			$complement=&max("lig_facture","complement") + 1;				
		}
		if($qtefacture < 1  && $app eq "mod"){
			$complement=$complement?$complement:&max("lig_facture","complement") + 1;
		}									
		my %hash;
		$hash{'complement'}=$complement;		
		my @listechamps=('ligfact','numfact','complement', 'idartic');
		my @listeval=($ligfact,$numfact,$complement, $idartic) ;
		foreach my $champs(@param){
			if($champs =~ /($app)$/){
				my $val=param($champs);
				if($champs =~ /TVA/){ $val=$val/100;}
				push(@listeval,$val);
				$champs =~ s/$app//;
				push(@listechamps,$champs);
				$hash{$champs}= $val;
			}
		}		
		foreach my $val (@listeval){
				$val="'".$val."'";
		}
		my $listeval = "(".join(",",@listeval).")";		
		my $listechamps = "(".join(",",@listechamps).")";
		my $qtemvtstk = 0;
		if(param('ajouter.x')){				
			&insert($listeval,$listechamps,"lig_facture");
			&maj_tot($numfact);
			$mess="$messajoutok";
			$qtemvtstk = - $hash{'qtefacture'}
			}
		else{#$libfact<>0, on modifie			
			($qtemvtstk, $idartic)=&select_une_lig('qtefacture, idartic','lig_facture',"ligfact=$ligfact");
			$qtemvtstk -= $hash{'qtefacture'};
			&maj("ligfact = $ligfact",\%hash,"lig_facture");
		    &maj_tot($numfact);
		    $mess="$messmodok";					  		 				
		}
	 &majcomplement($ligfact);
	 &maj("idartic = $idartic", {qtestk => "$qtemvtstk \' + qtestk + \'0"}, 'article') if ($idartic);
	# foreach my $k (param())
	 #{
	 #	print STDERR "$k = ".param("$k") ."\n";
	#	}
	}	
}	

if($numfact){$para{'numfact'} = $numfact;}

##############################	
#preparation liste deroulantes
##############################

#liste des statuts

=pod
  regles de gestion pour le choix/modif statut
  -si une facture n'a jamais t relanc, choix entre NR et R
  -si une facture a dj t relance, quelque soit son statut actuel
  choix entre R et derniere relance effectue
=cut

my %listestatut;
tie %listestatut,"Tie::IxHash";
$listestatut{"0"}=$messchoicestatut;
my %listestatutrecup =(&init_statfact("$LIBAD/statfact.conf"));
#si nouvelle facture, on ne peut choisir que le statut regle ou non regle
$listestatut{1} = $listestatutrecup{1};#regle
$listestatut{2} = $listestatutrecup{2};#non regle
my $compte = 0;
if($numfact && ($compte = &compte("idrelance","relance","numfact = $numfact"))){
	delete $listestatut{2};#on supprime non regle de la liste de choix
	$listestatut{2 + $compte} = $listestatutrecup{2 + $compte};
} 

#liste des clients repertories
my $liste_champs= "clientnom, clientville, clientcp";
my %listecli;
tie %listecli,"Tie::IxHash";
$listecli{"0"}= $messchoicecustomer;
%listecli= (%listecli,&liste("client", "clientid",$liste_champs," statut = '$libclient' ","clientnom"));

#pour les echeances de paiement
my %echeance;	
tie %echeance,"Tie::IxHash";
$echeance{'0'} = $messchoiceecheance;
foreach my $clef (sort keys %dateech){$echeance{$clef} = $dateech{$clef};}

#pour le mode de paiment
my %paiement =();
tie %paiement,"Tie::IxHash";
$paiement{'0'} = $messchoicepaiment;
foreach my $clef (sort  keys %modepaiement){$paiement{$clef} = $modepaiement{$clef};}

#pour la priodicit
my %periodicite = ();
tie %periodicite,"Tie::IxHash";
$periodicite{"-1"} = $messchoiceperiode;
foreach my $clef (sort {$a <=> $b} keys  %period){$periodicite{$clef} = $period{$clef};}
foreach my $clef (keys %periodicite){&debug("clef = $clef, val = $periodicite{$clef}");}

#pour les articles
my %famart;
tie %famart, "Tie::IxHash";
$famart{"-1"} = $messchoicefamart;
$famart{"-"} = $all;
$liste_champs = "codfam, desfam";
%famart = (%famart, &liste("famart", "codfam", $liste_champs, undef, "codfam"));

####################################
#prparation des donnees a afficher
####################################
my @listeligaffich =();
my @ramenechamps=();
#rcupration donnes facture
if($numfact){
	#recup entete	
  my $listechamps = "clientidfact,clientnom, responsablecde, refcde, datefact, statutfact, ";
  $listechamps .= " fraisdeplt, totHT, totTTC, contact, datereglement, ";
  $listechamps .= " banquereglement, numcheque,dateecheance,echeance,paiement,periodicite,remise";
  my $table = " client, facture ";
  my $cond = " client.clientid = facture.clientidfact and numfact = $numfact";   
  @ramenechamps=&select_une_lig($listechamps,$table,$cond);
   foreach my $clef (@ramenechamps){	
        if($clef){$clef =~ s/"/\&quot;/g;}
	}
   my ($datefact,$datereglement,$dateech) = @ramenechamps[4,10,13];
   if(exists $para{"statutfactfct"}){
   	 @ramenechamps = @para{"clientidfactfct","clientnomfactfct", "responsablecdefct",
   	 "refcdefct", "datefactfct", "statutfactfct","fraisdepltfact", "totHTfct", "totTTCfct",
   	 "contactfct", "datereglementfct", "banquereglementfct", "numchequefct","dateecheancefct",
   	 "echeancefct","paiementfct","periodicitefct", "remisefct"};
   	 @ramenechamps[4,10,13] = ($datefact,$datereglement,$dateech);
   }
   #recup ligne facture
   $listechamps="libartic, qtefacture, prixHT, tauxTVA, ligfact";
   $table="lig_facture";
   $cond = "numfact = $numfact";
   my $order="ligfact";
  my ($reflisteligfact)=&select_lig($listechamps,$table,$cond, $order);
  my @liste = @$reflisteligfact;
  for(my $i=0; $i <@liste; $i++){
  	my @rangee=@{$liste[$i]};
	  foreach my $clef(@rangee){
		 $clef =~ s/"/\&quot;/g;
	  }
	  $rangee[1]=sprintf("%.2f",$rangee[1]);
	  $rangee[1] =~ /\.(.{2})/;
	  if($1 =~ /^00$/){$rangee[1] = int($rangee[1]);}
	  $rangee[2]=sprintf("%.2f",$rangee[2]);
	  $rangee[3]=sprintf("%.2f",$rangee[3]*100);
	  my $mod = 0;
	  if ($rangee[4]==$idmodrep){
	  	$mod = 1;
	  	if(exists $para{"prixHTmod"}){	  		
	  		@rangee = (@para{"libarticmod", "qtefacturemod", "prixHTmod", "tauxTVA"},$rangee[4]);
	  	}
	  	
	  		  	
	  }
	  #pas afficher plus de $maxcar en lecture
	  if(!$mod && length($rangee[0])>$maxcar){
	  	          $rangee[0]=substr($rangee[0],0,$maxcar - 4);
					$rangee[0] =~ s/\s+\w+$//;
					$rangee[0] .= " ...";
	  }
	  my $stand = !$mod;
	  $rangee[5] = {"mod" => $mod, "stand" => $stand};
	  push(@listeligaffich,\@rangee);
   }	 	  
}

#on va definir les $para inexistants pour eviter les erreurs dans le fichier de log
foreach my $val ('libarticajout','qtefactureajout','responsablecdefct','contactfct','refcdefct',
'fraisdepltfct','numchequefct','banquereglementfct','jourr','moisr','anr', 'remisefct'){
	if(!exists $para{$val}){$para{$val} = '';}
}


#############################
#affichage facture
#############################
&majFacture($numfact,$type,$login,$titlemodfact,\%para,\@ramenechamps,\@listeligaffich,
    \%listestatut,\%listecli,\%echeance,\%paiement,\%periodicite, \%famart, $mess);

