#!/usr/local/bin/perl -w

#maj propal pour le nom client qui devient l'identifiant clientid


BEGIN {
  unshift @INC, '../lib', '../html';
}

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion

use DBI;
use Conf;
use Util;
use lang::Fr;


my $listechamps = "idpropal,nomcli,commercial";
my ($reftab) =  &select_lig($listechamps,'propal','idpropal > 0','idpropal');
my @tab = @$reftab;
for(my $i=0; $i < @tab ; $i++){
    #print "i = $i\n";
    my ($idpropal,$nomcli,$commercial) = @{$tab[$i]};
	#print "val = $idpropal,$nomcli,$commercial\n";
	#pour limiter les doublons de clients car plusiieurs propals peuvent
	#etre emises pour le meme client
    $nomcli =~ s/(?<!\\)('|")/\\$1/g;
    $commercial =~ s/(?<!\\)('|")/\\$1/g;
    (my $clientid) = &select_une_lig("clientid","client","statut = '$libprospect' and clientnom = '$nomcli'");
	if(!$clientid){
	#on cree le client dans la base (table client)
		$clientid = &max("client","clientid") + 1;

		my @listeval = ($clientid,$nomcli,$commercial,$libprospect,$norenseigne,
    	$norenseigne,$norenseigne);

		foreach my $val(@listeval){
					$val =~ s/(?<!\\)('|")/\\$1/g;
					$val="'".$val."'";
				}

		my $listeval="(".join(",",@listeval).")";
		my $listechamps = "clientid,clientnom,clientcommercial,statut,clientcp,clientrue1,clientville";
		$listechamps = "(".$listechamps.")";
		&insert($listeval,$listechamps,"client");
	}
    &maj("idpropal = $idpropal",{'nomcli' => $clientid},"propal");
}



