#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####


#appeller de l'ecran utilisateur qd on cliq sur le bouton modifier
#de la liste des utilisateurs fait par utilisateur.cgi
 
=pod
	pour creer un utlisateur		
=cut

BEGIN {
  unshift @INC, '../lib', '../html';
}

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Utilisateur;

#print header,start_html(-BGCOLOR => "#ffffff");

#traitement para
my @param=param();

#si pas de para, on quitte
if(!@param){
	print redirect("$CGIADR/login.cgi");
	exit(0);
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"

my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;


#declaration variables
#recup para	
my $login=param("username");
my $type=param("usertype");
my $mess = '';
my $idmodrep = 0;
my $ligdroit = 0;
my $userid = (param('userid') || 0);

#si $userid et le user $userid existe pas, il faut traiter
if($userid && !&compte("userid","utilisateur","userid = $userid")){
	print redirect("$CGIADR/utilisateur.cgi?idmod=$userid&username=$login&usertype=$type&$ch");
	exit(0);
}

#supprimer un droit
if(param('supp')){
	my $supp=param('supp');
	#la ligne a supprime existe t'elle
	if(&compte("tacheuserid","tacheuserdroit","tacheuserid  = $supp")){
		&supp("tacheuserid = $supp",'tacheuserdroit');
		$mess = $messligsuppok;
	}
	else{
	    $para{'notexiste'} = $supp;
		$supp = 0;
	}
}

#affichage permission modif droit
if(param('mod')){
	$idmodrep =param('mod');
	if(!&compte("tacheuserid","tacheuserdroit","tacheuserid = $idmodrep")){
         $para{'notexiste'} = $idmodrep;
         $idmodrep = 0;
	}
}

# pour modifier un droit
if(param('valide')){
   $ligdroit = param('valide');
   #verifier existence de la ligne
	if(!&compte("tacheuserid","tacheuserdroit","tacheuserid = $ligdroit")){
         $para{'notexiste'} = $ligdroit;
         $ligdroit = 0;
	}
}


#maj table user
#modif ou creation d'un utilisateur
if(param('validercreat') || param('validermodif')){			
	my $username=param("usernamemod");	
	my $userrole=param("userrolemod");	
	my $userlogin=param("userloginmod");
	my $userpasswd=param("userpasswdmod");
	my $userpassconfirm=param("userpasswdconfirmmod");
    my $clientiduser = param('clientidusermod');
    my $nomcomplet = param('nomcompletmod');
	#si resp et/ou datefact non renseign on entre pas
	#si un para est mal renseign on entre pas
	if(!$username){$mess.="$messname, ";}
	if(!$userlogin){$mess.="$messlogin, ";}

	if (!$nomcomplet){$mess .= "$messnotwholename, ";}	
	#gestion mot de passe
	#on est oblige de donner un mdp seumelemnt en creation
	#sinon on peut changer et dans ce cas, mdp et confirmmdp doivent etre =
	#si pas de mot de passe et user inexistant => pas ok
	if(!$userid && !$userpasswd){$mess.="$messmdp, ";}
	#si mdp ne cofirm mmdp, => pas ok
	if($userpasswd ne $userpassconfirm){$mess.="$messmdp, ";}
    #si type = client, alors le client doit exister
	if($userrole eq $customer && $clientiduser == -1){$mess .= "$messnocliandtypecli, ";}
	#pas deux fois le mme login
	my $cond=" userlogin = '$userlogin' ";
	if($userid){$cond.=" and userid <> $userid";}	
	if (my ($lig)=&select_une_lig("userlogin","utilisateur",$cond)){
		$mess.="$messlogexiste, ";
	}
	#un role ne peut tre associ qu' un seul nom et un seul nom complet
	#pas 2 fois mme nom et role
    $cond=" username = '$username' and userrole = '$userrole'";
	if($userid){$cond.=" and userid <> $userid";}
	if (my ($lig)=&select_une_lig("userlogin","utilisateur",$cond)){
		$mess.="$messnameroleexist, ";
	}
	#pas 2 fois mme nomcomplet et role
	$cond=" nomcomplet = '$nomcomplet' and userrole = '$userrole'";
	if($userid){$cond.=" and userid <> $userid";}
	if (my ($lig)=&select_une_lig("userlogin","utilisateur",$cond)){
		$mess.="$messnomcomproleexist, ";
	}
	if($mess){
		foreach my $para (@param){
			if($para =~ /mod$/){
				$para{$para}=param($para);
			}
		}
		#if($userid){$para{"userid"} = $userid;}
	}
						
	if(!$mess){#$mess = $messfct
        if(!$userid || $userpassconfirm){
		    #on cree un user ou on veut changer le mdp d'un user existant
			my $salt = substr($userpasswd,0,2);
        	$userpasswd = crypt($userpasswd, $salt);
	    }
		else{($userpasswd) =&select_une_lig("userpasswd","utilisateur","userid = $userid");}
		##############
        #calcul de l'indice de hierarchie
        ##############
		

		$userid=$userid?$userid:&max('utilisateur', 'userid') + 1;
		my %hash;
		#forcer le clientiduser  -1 si role <> client
		$clientiduser = $userrole eq $customer ? $clientiduser : "-1";

		my @listechamps=('userid','username','userlogin','userpasswd','userrole','nomcomplet',
		'clientiduser');


		my @listeval =($userid,$username,$userlogin,$userpasswd,$userrole,$nomcomplet,
		$clientiduser);
		for (my $i=0;$i < @listechamps; $i++){			
				$hash{$listechamps[$i]}= $listeval[$i];			
		}		
		foreach my $val (@listeval){
				$val="'".$val."'";
		}
		my $listeval = "(".join(",",@listeval).")";		
		my $listechamps = "(".join(",",@listechamps).")";	
		if (param('validercreat')){
			$mess="$messcreatuserok";			
			&insert( $listeval,$listechamps,"utilisateur");			
		}
		
		else{#param('validermodif.x') cad update
			$mess="$messmodifuserok";			
		    &maj("userid = $userid",\%hash,"utilisateur");
		}		
	}			 
}



#ajouter ou modifier un droit
if(param('ajouter') || $ligdroit){
	my $app=$ligdroit?"mod":"ajout";
	my $useridli = param("useridli$app");
    my $droitsupp = param("droitsupp$app");
	my $droitmaj = param("droitmaj$app");

	#les champs sont ils bien renseigns
	if(!$useridli){$mess.="$messnouserdroit, ";}
	if(!$droitsupp){$mess.="$messnodroitsupp, ";}
	if(!$droitmaj){$mess.="$messnodroitmaj, ";}
	#verifier que le mme userli n'est pas entre 2 fois
	#pour le mme userlu
	my $cond = "useridlu = $userid and useridli = $useridli ";
	if($ligdroit){$cond .= " and tacheuserid <> $ligdroit";}
	if(&select_une_lig("useridli","tacheuserdroit",$cond)){
		$mess .= "$messuserdroitexiste, ";
	}

	if($ligdroit && $mess){$idmodrep = $ligdroit;}
	#ajouter dans le hachade de parametres %para les valeurs d'ajout
	#pour les reafficher
	if($mess){
		foreach my $para (@param){
			if ($para =~ /$app$/){$para{$para} = param($para);}
		}
	}
	if(!$mess){
	#trt para a ajouter
		$ligdroit=$ligdroit?$ligdroit:&max('tacheuserdroit', 'tacheuserid') + 1;
		my %hash;
        $hash{'tacheuserid'} = $ligdroit;
		$hash{'useridlu'} = $userid ;
		my @listechamps=('tacheuserid','useridlu');
		my @listeval=($ligdroit,$userid) ;
		foreach my $champs(@param){
			if($champs =~ /($app)$/){
				my $val=param($champs);
				push(@listeval,$val);
				$champs =~ s/$app//;
				push(@listechamps,$champs);
				$hash{$champs}= $val;
			}
		}
		foreach my $val (@listeval){
				$val="'".$val."'";
		}
		my $listeval = "(".join(",",@listeval).")";
		my $listechamps = "(".join(",",@listechamps).")";
		if(param('ajouter.x')){
			&insert($listeval,$listechamps,"tacheuserdroit");
			$mess="$messajoutok";
			}
		else{#$libfact<>0, on modifie
			&maj("tacheuserid = $ligdroit",\%hash,"tacheuserdroit");
		    $mess="$messmodok";
		}
	}
}



if($userid){$para{'userid'} = $userid;}			



##############################		
#preparation liste deroulante
##############################

#liste des roles
my %tabuserrole;
tie %tabuserrole,"Tie::IxHash";
%tabuserrole=&init_statfact("$LIBAD/usertype.conf");

#liste des clients
#pour la liste des noms
my $liste_champs= "clientnom, clientville, clientcp";
my %tabcli;
tie %tabcli,"Tie::IxHash";
$tabcli{"-1"}= $messchoicecustomer;
%tabcli= (%tabcli,&liste("client", "clientid",$liste_champs,"clientid >= 1","clientnom"));
	
#liste des utilisatuers sauf celui qui est maj
#liste des utilisateurs
my $cond = "userrole <>  'client' and userid <> $userid";
my %tabuser = ();
tie %tabuser,"Tie::IxHash";
$tabuser{'0'} = $messchoiceuser;
%tabuser=(%tabuser,&liste("utilisateur","userid","nomcomplet, userrole", $cond,"nomcomplet"));

#liste des droits
my %tabmaj = my %tabsupp = ();
tie %tabmaj,"Tie::IxHash";
tie %tabsupp,"Tie::IxHash";
%tabmaj = (0 => $messchoice, 1 => $no, 2 => $yes);
%tabsupp = (0 => $messchoice, 1 => $no, 2 => $yes);


#prparation des donnees
my @ramenechamps =my @listedroit = ();
#rcupration donnes facture
if($userid){	#recup entete	
  my $listechamps = "username, userrole, userlogin, ";
  $listechamps .= "clientiduser,nomcomplet";
  my $table = " utilisateur ";
  my $cond = "  userid = $userid";   
  @ramenechamps=&select_une_lig($listechamps,$table,$cond);
  foreach my $clef (@ramenechamps){	
		$clef =~ s/"/\&quot;/g;		
  }

  if(exists $para{"usernamemod"}){
  	(@ramenechamps)= @para{"usernamemod","userrolemod","userloginmod","clientidusermod",
  	"nomcompletmod"};
  	
  }

  #si user not client, on selectionne les droits de lecture, maj, ... sur les taches
  #recup liste des uers ayant le droit de lire, maj,... les taches du user maj
   $listechamps="tacheuserid, useridli,  droitmaj, droitsupp ";
   $table="tacheuserdroit";
   $cond = "useridlu = $userid";
   my $order="useridli";


  my ($reflisteligDroitTache)=&select_lig($listechamps,$table,$cond, $order,0);

  my @liste = @$reflisteligDroitTache;

  for(my $i=0; $i <@liste; $i++){
     my @rangee=@{$liste[$i]};
	 foreach my $clef(@rangee){
		 $clef =~ s/"/\&quot;/g;
	 }
	 my $mod = 0;
	 if($rangee[0] == $idmodrep){
	    #print p "rangee = idmod";
	    $mod = 1;
	 	$rangee[1] = [\%tabuser,$rangee[1],"useridlimod"];
        $rangee[2] = [\%tabmaj,$rangee[2],"droitmajmod"];
		$rangee[3] = [\%tabsupp,$rangee[3],"droitsuppmod"];
	 }
     else{
	     $rangee[1] = join("-",&select_une_lig("nomcomplet, userrole","utilisateur","userid = $rangee[1]"));
	     my %val = (1 => $no, 2 => $yes);
		 for(my $i = 2; $i  <= 3; $i++){
		      $rangee[$i] = $val{$rangee[$i]};
		}
     }
      my $stand = !$mod;
	  $rangee[5] = {"mod" => $mod, "stand" => $stand};
	  push(@listedroit,\@rangee);

  }

}

#on va definir les $para inexistants pour eviter les erreurs dans le fichier de log
foreach my $val ('usernamemod','userloginmod','nomcompletmod'){
	if(!exists $para{$val}){$para{$val} = '';}
}


############################
#affichage
###########################
&AffichCreatUser($userid,$type,$login,\%para,\@ramenechamps,
    \%tabcli,\%tabuserrole,\%tabuser, \%tabmaj, \%tabsupp, \@listedroit,$mess);



