#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####


#propalcde.cgi 
=pod
	pour transformer une propal en commande, sert  faire renseigner la refrence de
	la commande et le client	
=cut

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../lib', '../html';	
}

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
use CGI  qw(:standard);
use Conf;
use lang::Fr;
use Util;
use UNGI::Propal;

#declaration modules utiles


#print header,start_html(-BGCOLOR => "#ffffff");
#print p "dans propal vercs cde";

#traitement para
my @param=param();

#si pas de para, on quitte
if(!@param){
	print redirect("$CGIADR/login.cgi");
	exit(0);
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"
my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;


#recuperation des para d'utilisateurs indisepensables
my $login=param("username");
my $type=param("usertype");

#declaration variables
my $idpropal = param('idpropal');
#si la propal a modifier n'existe plus, on redirige vers la liste des propals
if(!&select_une_lig("idpropal","propal","idpropal = $idpropal")){
       #on passe valider pour que la fenetre indiquant
	   #que la propal existe plus apparaissent
       print redirect("$CGIADR/propal.cgi?username=$login&usertype=$type&valider=$idpropal");
	   exit(0);
}

my $refcommande = param('refcommande');
my $mess='';


##########################
#transformation propal en commande
##########################
if (!param('creat')){
   if(!$refcommande){$mess .= "$messorderref, ";}
   $para{"refcommande"} = $refcommande;
}

if($refcommande){
	my ($clientid) = &select_une_lig("nomcli","propal","idpropal = $idpropal");
	#listedes champs  insere dans nouvelle commande
	my $listechamps = '(refcommande,libcde,chefprojet,commercial,montcde,numcde,datecde,datefact,nomcli)';
	#on recupere les valeurs a insere dans la commande
	my @listeval=&select_une_lig('libpropal,chefprojet,commercial,total',
	        'propal',"idpropal=$idpropal");		
	my $numcde = &max('commande','numcde','numcde >= 1') + 1;
	my $date=&calend_sec(&sec_calend(time()));	
	push(@listeval,$numcde,$date,$date,$clientid);
	my @date =&sec_calend(time()); 
	unshift(@listeval,$refcommande);
	foreach my $val (@listeval){
	  	$val =~  s/(?<!\\)('|")/\\$1/g;
	  	$val="'".$val."'";
	}
	my $listeval = "(".join(",",@listeval).")";
	#on insere l'entete de la commande
	&insert( $listeval,$listechamps,"commande");
	#maj statut du client en client
	&maj("clientid = $clientid", {'statut' => $libclient},"client");
	&supp("idpropal = $idpropal","propal");
	#envoi mail pour signifier commande
	if($mail){	
	 (my $client) = &select_une_lig("clientnom","client","clientid = $clientid");
	 my $messmail = &MakeMail($listeval[3],$client,@date,@listeval[2,4,1]);
	 &envoiMail($mail,$messmail);
	}
	print redirect ("$CGIADR/commande.cgi?username=$login&usertype=$type&toupdate=$numcde");	
	exit(0);
} 
 

#on va definir les $para inexistants pour eviter les erreurs dans le fichier de log
foreach my $val ('refcommande'){
	if(!exists $para{$val}){$para{$val} = '';}
}



###############
#affichage
#################

&AffichPropalCde($type,$login,$idpropal,$mess,\%para);

