#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####


#facture.cgi affiche la liste des factures

=pod
	affiche la liste des factures 	
=cut	
	
#mettre les librairies ds le chemin de perl

BEGIN {
  unshift @INC, '../lib', '../html';	
} 

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use Tie::IxHash;
use CGI  qw(:standard);
#use DBI;
use Conf;
use lang::Fr;
use Util;
use UNGI::Taches;
 
#print header,start_html(-BGCOLOR => "#ffffff");

#traitement para
my @param=param();

#si pas de para, on quitte
if(!@param){
	print redirect("$CGIADR/login.cgi");
	exit(0);
}

#trt de tous les paras : supp espace devant, derriere
#substitute ' et " par \' ou \"

my ($refpara,$ch)=&getParamHash(@param);
my %para = %$refpara;
		


#declaration variables
	
#recup parametres
my $login=param("username");
my $type=param("usertype");
my $idmod=param('idmod')?param('idmod'):0;
my $supp = my $mod = 0;
my $mess='';
my $tacheid = 0;
#userid de user de la personne connectee
my ($persouserid) = &select_une_lig("userid","utilisateur","userlogin = '$login'");

#trt des donnees
#suppression d'une tache
if(param('supp')){
	#$cond,$table
	$idmod=param('supp');
	$supp = $idmod;
	if(!(&compte("tacheid","tacheclient","tacheid = $supp"))){
		param("toupdate" => $supp);
		$supp = 0;
	}
}

#mettre une tache a fait
if(param("faittache")){
	my $tacheid =param("faittache");
	$idmod = $tacheid;
	if(!(&compte("tacheid","tacheclient","tacheid = $supp"))){
	   &maj("tacheid = $tacheid",{'tachefait' => 2},"tacheclient");
	}
}

#defaire une tache
if(param("defaittache")){
	my $tacheid =param("defaittache");
	$idmod = $tacheid;
	if(!(&compte("tacheid","tacheclient","tacheid = $supp"))){
		&maj("tacheid = $tacheid",{'tachefait' => 1},"tacheclient");
	}
}

#modification d'une tache
if(param('valider')){
   $tacheid = param('valider');
}


#ajouter ou modifier une commande
if(param('ajouter') || $tacheid){
	my $app=$tacheid?"mod":"ajout";
	my $ind=$tacheid?"m":"f";
	my $datetache;
	#ctrl lib
	if(!param("tachelibelle$app")){$mess.="$messlib, ";}
    if(!param("clientid$app")){$mess.="$messclienttachenotok, ";}
    if(!param("tacheuserid$app")){$mess.="$messuserconcerned, ";}
    if(!param("tachefait$app")){$mess.="$messfaitnotok, ";}
	#ctrl datetache
    my($jourf,$moisf,$anf)= (param("jour$ind"),param("mois$ind"), param("an$ind"));
    #date previsionnelle de facturation
	if(!(($jourf && $moisf &&$anf) && (my $ok=&verif_date($jourf, $moisf, $anf,1)))){
		$mess.="$messdatetache, ";
	}
	else{$datetache=&calend_sec($jourf,$moisf,$anf);}
	#ctrl de l'heure
    my $heuref = param("heure$ind");
	#print p "*** heure = $heuref";
	#print p "*** app = $app";
	my $minf = param("min$ind");
	my $heuretache = '';
	if(($heuref ne '') && !($heuref =~ /^\d{1,2}$/ && $heuref >=0 && $heuref <=23)){
	    #print p "heure pas num";
		#print p "heuref = $heuref";
		$mess .= "$messhournotok, ";
	}
	#min entre 0 et 59
	elsif(($minf ne '') && !($minf =~ /^\d{1,2}$/ && $minf >=0 && $minf <=59)){
        print p "mn pas num";
		$mess .= "$messhournotok, ";
	}
	#l'heure doit etre renseigne si les minutes le sont
    elsif(($minf ne '') && ($heuref eq '')){
	    #print p "heure = $heuref";
        #print p "min sans h";
		$mess .= "$messhournotok, ";
	}
	else{#tout est ok
		$heuref = $heuref || "00";
		#print p "heure = $heuref";
		$minf = $minf || "00";
		#print p "min = $minf";
        $heuref = length($heuref)< 2 ? "0$heuref": $heuref;
        $minf = length($minf)< 2 ? "0$minf": $minf;
        $heuretache ="${heuref}:$minf";
		#print p "heure = $heuretache";
	}


	if($tacheid && $mess){$mod=1;$idmod=$tacheid;}
	if($mess){
		foreach my $para (@param){
			if ($para =~ /($app$|$ind$)/){$para{$para} = param($para);}
		}
		if($tacheid){
			$para{'tacheid'} = $tacheid;
		}
	}
	if(!$mess){		
		$tacheid=$tacheid?$tacheid:&max('tacheclient', 'tacheid') + 1;
		$idmod=$tacheid;
		my %hash;
		$hash{'tachedate'} = $datetache;
		$hash{'tacheheure'} = $heuretache;
		my @listechamps=('tacheid','tachedate','tacheheure');
		my @listeval =($tacheid,$datetache,$heuretache);
		foreach my $champs(@param){
			if($champs =~ /($app)$/){
				my $val=param($champs);
				push(@listeval,$val);
				$champs =~ s/$1//;
				push(@listechamps,$champs);
				$hash{$champs}= $val;
				}
			}
		foreach my $val (@listeval){
				$val="'".$val."'";
			}
		my $listeval = "(".join(",",@listeval).")";
		my $listechamps = "(".join(",",@listechamps).")";
		if($app eq "ajout"){	
			&insert($listeval,$listechamps,'tacheclient');
			$mess="$messajtacheok";
			param("toupdate" => $tacheid);

		}
		#verrifier que la commande existe avnat de la modifier
		elsif(&select_une_lig("tacheid","tacheclient","tacheid = $tacheid")){
			$mess = $messmodtacheok;
			&maj("tacheid = $tacheid",\%hash,"tacheclient");
		}
	}

}

if(param('toupdate')){
	#$mod=1;
	#print p "dans mod";
	$idmod = $mod = $para{"toupdate"} = param('toupdate');
	#print p "dans param(update) mod = $mod";
}

#pour la mise en valeur des maj
if($idmod){
	param("suivant.x" => 10);	
}	

########################
#preparation des listes
#########################

#liste des users
my $liste_champs= "clientnom, clientville, clientcp";
my (%tabcli,%tabcliajout) =();
tie %tabcli,"Tie::IxHash";
tie %tabcliajout,"Tie::IxHash";
$tabcli{$all}=$all;	
$tabcliajout{'0'} = $messchoicecustomer;
$tabcliajout{'-1'} = $nobody;
%tabcli= (%tabcli,&liste("client", "clientid",$liste_champs,"clientid > 0","clientnom"));
%tabcliajout= (%tabcliajout,&liste("client", "clientid",$liste_champs,"clientid > 0","clientnom"));

    
#liste de tri par champs
my %tab =  ("tacheid", $idjobliste, "clientnom", $namecli,
"tacheuserid",$nameuser,"tachedate",$date,"tacheheure",$hour);

#liste des utilisateurs que l'on a le droit de voir
my @listenum = &listenum("useridlu","tacheuserdroit","useridli = $persouserid", "useridlu");
push(@listenum,$persouserid);
my $liste = "(".join(",",@listenum).")";
my $cond = " userid in  $liste" ;
my %tabuser = ();
tie %tabuser,"Tie::IxHash";
$tabuser{$all} = $all;
%tabuser=(%tabuser,&liste("utilisateur","userid","nomcomplet, userrole", $cond,"nomcomplet"));
#liste des utilisateurs que l'on a le droit de modifier
@listenum = &listenum("useridlu","tacheuserdroit","useridli = $persouserid and droitmaj = 2", "useridlu");
push(@listenum,$persouserid);
$liste = "(".join(",",@listenum).")";
$cond = " userid in  $liste" ;
my %tabuserajout = ();
tie %tabuserajout,"Tie::IxHash";
$tabuserajout{'0'} = $messchoiceuser;
%tabuserajout=(%tabuserajout,&liste("utilisateur","userid","nomcomplet, userrole", $cond,"nomcomplet"));

#liste des faits/non faits
my (%tabfait,%tabfaitajout) = ();
tie %tabfait,"Tie::IxHash";
tie %tabfaitajout,"Tie::IxHash";
%tabfait = ($all => $all, 1 => $listelibnonfait, 2 => $listelibfait, );
%tabfaitajout = ("0" => $messchoice,  1 => $listelibnonfait, 2 => $listelibfait,);

#type action :commerciale/nom commerciale
my %tabtypeaction = ();
tie %tabtypeaction,"Tie::IxHash";
%tabtypeaction = ($all => $all, $libcommercial => $libcommercial, $libnoncommercial =>$libnoncommercial);


###############################
#construction liste des taches
##############################		

#declaration de variables	

#recuperation des para necc au tri
my $order=param("tri")?param("tri"):"tacheid";
$para{"tri"} = $order;
my $orderpcd= param("pcdt");
my $ordersuiv=param("suiv");	

my $tacheidtri = param("tacheidtri");
#recherche sur l'identifiant = recherche exacte
my $clientidtri=param("clientidtri")?param("clientidtri"):$all;
#recherche sur le nom du client (clientnom), de type comme
my $nomclitri = param("nomclitri") ;
my $useridtri = param("useridtri")|| $persouserid ;
my $libtachetri = param("libtachetri");

my $antri= param("antri"); my $moistri = param("moistri"); my $jourtri= param("jourtri");
my $heuretri = param("heuretri"); my $mintri = param("mintri");


my $tachefaittri = param("tachefaittri") || 1 ;#1 = non fait, 2 = fait, non fait par defaut
my $typeactiontri =param("typeactiontri") || $all;
my $nb=param("nbligtri")?param("nbligtri"):$nblig;
my $chaine = param('chaine');
my $inddeb = 0;

#on force les $para sur une liste deroulante a une valeur
$para{"tri"} = $order;
$para{"clientidtri"} = $clientidtri;
$para{"tachefaittri"} = $tachefaittri;
$para{"typeactiontri"} = $typeactiontri;
$para{"useridtri"} = $useridtri;
		
#preparation  liste facture  afficher
my $listechamps  = "tacheid, clientid,tacheuserid, tachedate, tacheheure,tachelibelle,tachefait";

my $table = "tacheclient";
#construction de la condition
#on ne voit que ces propres taches et celles de ces employes
#1)selection de l'userid de la personnes logg
#my ($persouserid) = &select_une_lig("userid","user","userlogin = '$login'");
#print p "userid = $persouserid";
#2)liste des personnes dont on peut lire les taches
@listenum = &listenum("useridlu","tacheuserdroit","useridli = $persouserid", "useridlu");
push(@listenum,$persouserid);
$liste = "(".join(",",@listenum).")";
$cond = " tacheuserid in  $liste" ;

#traitement des para passes pour les tri
if($tachefaittri ne $all){#clientid
	$cond.= " and tachefait ='$tachefaittri'";
}

#sur le clientid
if($clientidtri ne $all){#clientid
	$cond.= " and clientid='$clientidtri'";
}

#pour une recherche de type comme sur le nom
if($nomclitri){
   my $nomclitribis = "%".$nomclitri."%";
   my @liste = &listenum("clientid","client","clientnom like '$nomclitribis'","clientid");
   @liste = (@liste) ? @liste : (0);
   my $condbis = "(";
   foreach my $val (@liste){
      $condbis .= "clientid = $val or ";
   }
   $condbis =~ s/or\s*$/ /;
   $condbis .= ")";
   $cond .= "and $condbis ";
}

#recherche sur identifiant de la tache(tacheuserid)
if ($tacheidtri){
  my @tacheidtri = split (/\D+/,$tacheidtri);
  if(@tacheidtri){
    $cond .= " and (";
    foreach my $elem (@tacheidtri){$cond.= " tacheid like '$elem' or";}
    $cond =~ s/or$//;
    $cond .= ")";
  }
}

#recherche sur l'utilisateur
if($useridtri ne $all){#clientid
	$cond.= " and tacheuserid='$useridtri'";
}

#sur le type de tache (commercial ou pas)
if($typeactiontri ne $all){#clientid
    #si une tache n'est pas rattachee a un client
	#le clientidtache = 0
    if($typeactiontri eq $libcommercial){	$cond .= " and clientid <> 0";}
	else{$cond.= " and clientid = 0";}
}

#sur la date
if($antri || $moistri || $jourtri){
	my $ch=&date_tri($antri,$moistri,$jourtri, "tachedate","tacheclient",1);
	#on passe 1  date_tri pour ne pas faire de controle sur date demande > date jour
	$cond .=$ch;
	#print p "ch = $ch";
}


#sur l'heure
if($heuretri && $heuretri =~ /^\d{1,2}$/ && $heuretri < 24 && $heuretri >= 0){
    $heuretri = length($heuretri) == 2 ? $heuretri : "0$heuretri";
	#print p "mintri = $mintri";
	if($mintri && $mintri =~ /^\d{1,2}$/ && $mintri < 60 && $mintri>= 0){
		$mintri = length($mintri) == 2 ? $mintri : "0$mintri";
		$heuretri = "$heuretri:$mintri";
        $cond .= "and tacheheure = '$heuretri'";
	}
	else{$cond .= "and tacheheure like '$heuretri%'";}


}


#verifier que idmod question possedent les para de tri, sinon on enleve les criteres de tri
#$listechamps,$table,$cond
if($idmod){
    #verifier qu'idmod existe pour le trt des selcetions
    #d'objet qui n'existe plus
	if(!(&compte("tacheid","tacheclient","tacheid = $idmod"))){
        $para{'toupdate'} = $idmod ;
        param('toupdate' => $idmod);
	    $idmod = &select_pcdtbis($listechamps,$table,$cond,"tacheid",$idmod);
		$mod = 0;
		$order =  $para{"tri"} =  "tacheid";
	}
	my $lig;
	my $condbis=$cond. " and tacheid=$idmod";
	if(!(($lig)=&select_une_lig("tacheid",$table,$condbis))){
		$cond= " tacheid > 0 " ;
		foreach my $clef (keys %para){;
			if($clef =~ /tri$/ ){$para{$clef}='';}
		}
	}		
}



#pour positionner sur la tache pcdt la tache supp, en se basant sur l'id
if($supp){
		$idmod=&select_pcdt($listechamps,$table,$cond,$order,$supp);
		#print p "idmod= $idmod";
		#supprimer les lignes de factures
		&supp("tacheid = $supp",'tacheclient');
}


my ($reftabquestion,$ordersuivbis);
($reftabquestion,$ordersuivbis)=&select_lig($listechamps,$table,$cond,$order,$idmod);
my @table=@$reftabquestion;
my $taille = @table;
#pour afficher  partir de la question modifier, ajouter ou pour suivant
$ordersuiv=defined($ordersuivbis)?$ordersuivbis:$ordersuiv;

#recuperer numero dans la liste du 1e elem a afficher, du nb de ligne par ecran
#et du 1er elme et du dernier + 1 dans la liste selon ce qui a ete demande et
#deje vu par l'utilisateur

($inddeb,$orderpcd,$ordersuiv,$nb)= &getIndDeb($nb,$idmod,$ordersuiv,$orderpcd,$taille,$chaine,$ch);
$para{"nbligtri"} = $nb;

#print p "nb = $nb";
#print p "ordersuiv = $ordersuiv";



#construction d'un tableau contenant juste les enreg a afficher, formater
my @tabAffich=();
my $toupdate = 0;
for (my $i=$inddeb;$i < ($inddeb + $nb) &&$i<@table;$i++){			
	my @rangee=@{$table[$i]};
	my @date=&sec_calend($rangee[3]);
	$rangee[3]=join("/",@date);

    my @user =&select_une_lig("nomcomplet,userrole","utilisateur","userid = $rangee[2]");
	my $tacheuserid = $rangee[2];
    my $lienoui = my $liennon = 0;
    if ($mod==$rangee[0]){
	   $toupdate = 1;
	   #s'il n'y a pas eu de demande de modif non valide
	   #on remplit %para avec les valeurs existantes et enregistree dans la base
	   #donc cas d'une demande de modif(clic sur modifier)
	   if(!exists $para{"tacheid"}){
	        @para{"tacheidmod", "clientidmod","tacheuseridmod", "tachedatemod",
			"tacheheuremod","tachelibellemod","tachefaitmod"}
	        = @rangee;
	        @para{"jourm","moism","anm"}= @date;
			@para{"heurem","minm"} = split(/:/,$rangee[4]);
			#print p "userid = $para{tacheuseridmod}";
	     }
	}
	else{
		$rangee[2] = join("-", @user);
    	$rangee[6] = ($rangee[6]  == 2) ? $libX : $no;
        #une action peut ou pas concern un client

		if($rangee[1] ne -1){#concerne un client
			($rangee[7]) =&select_une_lig("clientnom","client","clientid = $rangee[1]");
			$lienoui = 1;
		}
		else{
			$rangee[7] = $libactionnocommercial;
			$liennon = 1;
		}
	}
	#ne concerne pas un client
	my $modif = ($idmod==$rangee[0] && !$mod)?$idmod:0;
	my $stand = !$modif;
	my ($defait) = &select_une_lig("tachefait","tacheclient","tacheid = $rangee[0]");
	$defait = ($defait == 2) ? 1 : 0;
	my $fait = !$defait;
	my $supp = $fait;
	my $maj = 1;
    #permission affichage selon les droits de l'utilisateur
	if($persouserid != $tacheuserid){
	    my $cond = "useridlu = $tacheuserid and useridli = $persouserid";
		my ($droitsupp,$droitmaj) = &select_une_lig('droitsupp, droitmaj',"tacheuserdroit",$cond);
		if ($droitsupp == 1){$supp = 0;}
		if($droitmaj == 1){$maj = 0;}
	}
	$rangee[8] = { "stand" => $stand, "modif" => $modif, "fait" => $fait,
	  				   "defait" => $defait, "supp" => $supp, "maj" => $maj,
					   "lienoui" => $lienoui, "liennon" => $liennon };
    push(@tabAffich,\@rangee);
}


#si la tachze a modifier n'existe pas et qu'il n'y a pas
#de tache a creer, $para{"toupdate"} est detruit
if(!$toupdate && exists($para{"toupdate"}) && $para{"toupdate"} > 0){$para{"toupdate"}= 0 ;}

#on va definir les $para inexistants pour eviter les erreurs dans le fichier de log
foreach my $val ('tacheidtri','nomclitri','jourtri','moistri','antri','heuretri','mintri','libtachetri',
'tachelibelleajout','heuref','minf'){
	if(!exists $para{$val}){$para{$val} = '';}
}


########################
#affichage liste facture
########################

&AffichTaches($type,$login,$orderpcd,$ordersuiv,$nb,$taille, $titleconstache,
               $mess, \@tabAffich,
              \%para,\%tabcli,\%tab,\%tabuser,\%tabfait,\%tabtypeaction,
			  \%tabcliajout,\%tabuserajout,\%tabfaitajout);


		
	

	

	



