#!/usr/local/bin/perl -w

#####
#
# Copyright (C) 2002 UNGI
#
# This file is part of UNGI facturier
#
# UNGI Facturier is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# UNGI Facturier is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#####
#
# Visit us!
#
# http://www.ungi.net
# http://ignu.ungi.org
#
#####

#testconnection.cgi pour tester la connection  la base de donnes



BEGIN {
  unshift @INC, '../lib';	
} 

#declaration modules utiles
use strict ;
#pour afficher les elem d'un hachage selon leur ordre d'insertion
use CGI  qw(:standard);
use DBI;
use Conf;
use Util;
#print header,start_html(-BGCOLOR => "#ffffff");
my $message="message de diagnostique de connection mysql: <br>";

my $dbh=DBI->connect(@connect) ;
#$dbh->disconnect();
if(!$dbh){$message="pas de connection car $DBI::errstr";}
else{
  my $sql="select nomcomplet, userrole from utilisateur";
  my $sth=$dbh->prepare($sql);
  if(!$sth){$message.="impossible de prparer car $DBI::errstr et $DBI::err";}
  else{
       my $recup = $sth->execute;
       if(!$recup){$message.="impossible d'xcuter car $DBI::errstr";}
       else{ 
          $message .= "tout semble ok, voici la liste des utilisateurs<br>";         
          $message .= "nom,  role utilisateur<br>";
          while(my @rangee=$sth->fetchrow_array()){            
            $message .= join(",",@rangee)."<br>";
          }
       $sth->finish();	
       }
  }
  $dbh->disconnect();	
}
print header;
print start_html();
print $message;
print "remote_host = $ENV{REMOTE_HOST}\n";
print "remote_ADDR = $ENV{REMOTE_ADDR}\n";
print end_html();
