#####
#
# File modified by Nicolas Schmeltz for Abtey Productions
#
# 02/10/2003 : add 'remise_defaut' and 'clientresponsable'
#
#####



=pod

package de variables pour les factures
propres au theme UNGI

=cut

package UNGI::Articles;

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../../lib','../';	
} 

use strict;
use CGI  qw(:standard);
use Conf;
use Util;
use lang::Fr;
use UNGI::General; 


BEGIN{
	use Exporter;
	use vars qw($VERSION @ISA @EXPORT);
	$VERSION = 1.00;
	@ISA = qw(Exporter);
	@EXPORT= qw(&ListeArticles &majArticle);
		
}

use vars  @EXPORT;

###########################
#liste des factures
###########################

my $ListeArticles = q|
<!-- debut  $ListeFacture -->
    <table width="760" cellspacing="1" cellpadding="0" align="center">
      <tr align="center">
          <TD class="tetiere" align="center">%$id%</TD>
          <TD class="tetiere" height="35">%$codarticle%</TD>
          <TD class="tetiere" height="35">%$famarticle%</TD>
		  <TD class="tetiere" height="35">%$desarticle%</TD>
		  <TD class="tetiere" height="35">%$quantity%</TD>
		  <TD class="tetiere" height="35">%$unit%</TD>
          <TD class="tetiere" height="35">%$unitprice%</TD>
          <TD class="tetiere" height="35">%$action%</TD>
      </TR>
     %$liste%
    </table>
	<br>
<form method="post" action="%$CGIADR%/articles.cgi" name="formulaire">
<table width="760" align="center">
    <tr align="center">
      <td class="tetiere2">%$searchby%&nbsp;:</td>
    </tr>
  </table>
  <table width="760" dwcopytype="CopyTableRow" align="center" cellpadding="3" cellspacing="1">
    <tr>
      <td class="ligne2">%$codarticle%  :
        <input type="text" name="codarttri"  size="60" value="%$para{codarttri}%">
      </td>
	  <td class="ligne2">%$famarticle%  :
		%$popupcodfamcli%
      </td>
     </tr>
   </table>
   <table width="760" dwcopytype="CopyTableRow" align="center" cellpadding="3" cellspacing="1">
    <tr>
      <td class="ligne1">%$desarticle%  :
        <input type="text" name="desarttri"  size="20" value="%$para{desarttri}%">
      </td>
	  <td class="ligne1">%$quantity%  :
		<input type="text" name="qtetri"  size="50" value="%$para{qtetri}%">
      </td>
     </tr>
   </table>
   <table width="760" dwcopytype="CopyTableRow" align="center" cellpadding="3" cellspacing="1">
    <tr>
      <td class="ligne2">%$unitprice%  :
        <input type="text" name="pxhttri"  size="8" value="%$para{pxhttri}%">
      </td>
	  <td class="ligne2">%$unit%  :
		%$popupunit%
      </td>
    </tr>
   </table>
  <br>
  <table width="500" border="0" cellspacing="0" cellpadding="5" align="center" class="ligne3">
    <tr>
      <td align="center">
        <table width="350" align="center">
          <tr> 
            <td><span class="texte4">%$sortby%</span> 
              %$popuptri%
            </td>
          </tr>
        </table>
        <table width="350" align="center">
          <tr> 
            <td class="texte4" align="left" valign="middle">%$linenumber%</td>
            <td> 
              <input type="text" name="nbligtri" value="%$nb%" size="4" maxlength="3">
            </td>
            <td class="texte4" align="center" valign="middle">%$ontotal% %$taille%</td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGICONES%/reload.gif" width="31" height="36">
            </td>
          </tr>
        </table>
        <table width="500" border="0" cellspacing="0" cellpadding="0">
          <tr>
            <td align="center" valign="middle">
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGICONES%/premier.gif" width="31" height="22" align="middle">
            </td>
            <td align="center"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle">
              <input type="image" border="0" name="precedent" src="%$HTMLADRUNGICONES%/gauche.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle">
              <input type="image" border="0" name="suivant" src="%$HTMLADRUNGICONES%/droite.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle">
              <input type="image" border="0" name="dernier" src="%$HTMLADRUNGICONES%/dernier.gif" width="30" height="22" align="middle">
            </td>
          </tr>
        </table>
      </td>
    </tr>
  </table> 
	<input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">
	<input type="hidden" name="pcdt" value="%$orderpcd%">
	<input type="hidden" name="suiv" value="%$ordersuiv%">
	<input type="hidden" name="chaine" value="%$ch%">
	</form>
	%$boutonBasArticle%
<!-- fin  $ListeArticles -->|;

#hachage regroupant les differentes parties d'une ligne de facture
my %ligArticle = ();
tie %ligArticle,"Tie::IxHash";;
#une ligne de la liste
$ligArticle{'begin'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand -->
<!-- une ligne = 1  ligne de article -->
  <tr align="center"> 
        <td class="numero">%$rangee[0]%</td>
        <td class="texte2">
			<a href="%$CGIADR%/articlemodif.cgi?idartic=%$rangee[0]%&username=%$login%&usertype=%$type%&%$ch%">%$rangee[1]%</a>
		</td>
        <td class="texte3">%$rangee[2]%</td>
        <td class="texte2">%$rangee[3]%</td>
        <td class="texte3">%$rangee[4]%</td>
        <td class="texte2">%$rangee[5]%</td>
        <td class="texte3">%$rangee[6]%</td>
        <td class="texte2">
          <table cellspacing="3" cellpadding="0" align="left">
            <tr> 
|;

$ligArticle{'modif'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: mod -->
<!-- une ligne = 1  ligne de article en modif -->
<tr align="center"> 
        <td class="couleur">%$rangee[0]%</td>
        <td class="couleur">
			<a href="%$CGIADR%/articlemodif.cgi?idartic=%$rangee[0]%&username=%$login%&usertype=%$type%&%$ch%">%$rangee[1]%</a>
		</td>
        <td class="couleur">%$rangee[2]%</td>
        <td class="couleur">%$rangee[3]%</td>
        <td class="couleur">%$rangee[4]%</td>
        <td class="couleur">%$rangee[5]%</td>
        <td class="couleur">%$rangee[6]%</td>
        <td class="texte2"> 
          <table cellspacing="3" cellpadding="0" align="left">
            <tr> 
|;


$ligArticle{'1'} = q|
<!-- Forbidden-to: comptable  client -->
<!-- modifier une article -->
				  <td>
				  		<a href="%$CGIADR%/articlemodif.cgi?idartic=%$rangee[0]%&username=%$login%&usertype=%$type%&%$ch%">
                    		<img src="%$HTMLADRUNGICONES%/modifier.gif" border="0"></a>
				  </td>
|;

$ligArticle{'2'} = q|
<!-- Forbidden-to: client -->
<!-- affich_on: supp -->
<!-- supprimer un article -->
                    <td>
						<a href="javascript:supparticle(%$rangee[0]%,'%$login%','%$type%','%$ch%');"><img src="%$HTMLADRUNGICONES%/delete.gif" border="0"></a>
				    </td>
|;

=pod
$ligArticle{'3'} = q|
<!-- Forbidden-to: comptable article -->
<!-- commenter un article -->
                  <td align="center" valign="middle">
				  	 <a href="javascript:commentrelance(%$rangee[0]%,'%$login%', '%$type%');">
                    	 <img src="%$HTMLADRUNGICONES%/comment.gif" border="0"></a>
				 </td>
|;
=cut


$ligArticle{'end'} = q|
<!-- Restricted-to: anybody -->
<!-- fin lignefacture -->      
                </tr>
              </table>
              <!-- fin barre action -->
            </td>
          </tr>
|; 




my %boutonBasArticle =();
tie %boutonBasArticle,"Tie::IxHash";
#une ligne de la liste    
     
$boutonBasArticle{'begin'} = q|
      <table width="500" cellpadding="0" cellspacing="0" border="0" align="center">
        <tr>|;
      
$boutonBasArticle{'1'} = q|
<!-- Forbidden-to: client comptable  --> 
        <td align="center" valign="bottom" colspan="3" height="30">
           <a href="%$CGIADR%/articlemodif.cgi?username=%$login%&usertype=%$type%&%$ch%">
                 <img src="%$HTMLADRUNGICONES%/creeart.gif" border="0">
		   </a>
        </td>|;
        
$boutonBasArticle{'2'} = q|
        <td align="center" valign="bottom" height="30">&nbsp;</td>
        <td align="center" valign="bottom" colspan="3" height="30">
            <a href="%$CGIADR%/login.cgi"> 
                 <img src="%$HTMLADRUNGICONES%/quitter2.gif" border="0"> 
			</a> 
        </td>|;

$boutonBasArticle{'end'} = q|
      </tr>
    </table>
|;



sub ListeArticles{
	my ($type,$login,$orderpcd,$ordersuiv,$nb,$taille,$title,$mess,$reftabAffich,
	$refpara,$reftab,$refcodfamcli,$reftabunite) = @_;
	#on recupere les variables avec les valeurs necc pour l'affichage
    #et on formate les valeurs pour l'affichage    
	my $ch = '';	
	($refpara,$ch) = &getParam(%$refpara);
	my %para = %$refpara;
	#faire les listes droulantes
    my $popupcodfamcli = &getPopup($refcodfamcli,$para{"codfamtri"},"codfamtri");
    my $popuptri = &getPopup($reftab, $para{"tri"},"tri");
	my $popupunit =&getPopup($reftabunite, $para{"commercialtri"},"commercialtri");
   # my $onload = '';
    my $onload = exists ($para{'notexiste'}) ? $onloadEcran:'';
   #faire la liste des factures a afficher avec seulement les boutons
    #que l'utilisateur a le droit de voir
	my %ligArticleDroit=();
    tie %ligArticleDroit,"Tie::IxHash";
    #print p "***type = $type";
    %ligArticleDroit = &getHashAffich(\%ligArticle,$type);
	
    #formater la liste des factures a afficher    
    my $liste = &makeListe($reftabAffich,\%ligArticleDroit);
    #afficher creer facture sssi l'utilisateur a le droit de creer une facture
	my %boutonBasCliDroit = ();
	tie %boutonBasCliDroit,"Tie::IxHash";
	%boutonBasCliDroit = &getHashAffich(\%boutonBasArticle,$type);
	my $boutonBasArticle = join("\n",(values %boutonBasCliDroit));

        
    #construire la page
	my $page = $body.&AffichLig(&affiche_barre($type,\%navigation,'articles'),$type,$login).$titrePage;
	if($mess){$page .= $messPage;} 
	$page .= $ListeArticles;
    #$page =~ s/%(\$\w+\{\w*\})%/$1/gee;

	$page =~ s/%(\$\w+(\{\w*\})?)%/$1/gee;

	$page =~ s/%(\$\w+)%/$1/gee;
	&AffichPageWeb($title,$page);
	return;
}


##########################
#modifier/creer un article
##########################

my $enteteArticleCreat = q|
<!-- debut  $enteteArticleCreat -->
<form method="get" action="%$CGIADR%/articlemodif.cgi" name="formulaire">
     <table width="650" cellpadding="3" cellspacing="1">
      <tr>
      <td class="ligne1"> * %$codarticle% :&nbsp;&nbsp;
	  		<input name="codartajout" type="text" value="%$para{codartajout}%" size="40">
      </td>
      <td valign="middle" class="ligne1" align="left"> %$famarticle% :
          %$popupcodfamcli%
      </td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne2">* %$desarticle% :
	  		<input name="desartajout" type="text" value="%$para{desartajout}%" size="60">
	  	</td>
      </tr>
    </table>
	 <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">%$unitprice% %$totalwhithouttaxsort% :&nbsp;&nbsp;
	  		<input name="pxhtajout" type="text" value="%$para{pxhtajoutajout}%" size="6">
	  	</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne2">%$quantity% :&nbsp;&nbsp;
	  		<input name="qtestkajout" type="text" value="%$para{atestkajout}%" size="4">
	  	</td>
	  	<td class="ligne2">%$unit% :&nbsp;&nbsp;
			%$popupunit%
	  	</td>
      </tr>
    </table>
    <input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">
	<input type="hidden" name="script" value="%$script%">
	<input type="hidden" name="validercreat" value="10">
	  %$champscache%
    <table width="650" cellpadding="0" cellspacing="0">
      <tr> 
        <td valign="bottom" align="left" height="35" class="texterouge">
          <input type="image" border="0" name="validercreat" src="%$HTMLADRUNGICONES%/validercreat.gif" width="71" height="25">
          %$messcreatarticle%
        </td>
      </tr>
    </table> 	
   </form>
   <table width="650" cellpadding="0" cellspacing="0">
       <tr>
          <td valign="bottom" align="left" height="35">
	  	<a href="%$CGIADR%/%$script%.cgi?usertype=%$type%&username=%$login%&%$ch%"><img src="%$HTMLADRUNGICONES%/abandonner.gif" border="0"></a>
	  </td>
      </tr>
  </table>
<!-- fin $enteteArticleCreat -->|;

my $enteteArticle = q|
<!-- debut  $enteteArticle -->
<table width="650" class="ligne3" cellpadding="3" cellspacing="0">
    <tr>
      <td  class="texte4" align="left" width="20%">%$articid% :</td>
      <td class="textegras">%$idartic%</td>
    </tr>
</table>
<form method="get" action="%$CGIADR%/articlemodif.cgi" name="formulaire">
    %%$ligCoordArticle%% 
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">%$unitprice% %$totalwithouttaxsort% :&nbsp;&nbsp;
	  		<input name="pxhtajout" type="text" value="%%$pxht%%" size="6">
	  	</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne2">%$quantity% :&nbsp;&nbsp;
	  		<input name="qtestkajout" type="text" value="%%$qtestk%%" size="4">
	  	</td>
	  	<td class="ligne2">%$unit% :&nbsp;&nbsp;
			%$popupunit%
	  	</td>
      </tr>
    </table>
	 <table width="650" cellpadding="3" cellspacing="1">
      <tr>
      </tr>
    </table>
    <input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">
	<input type="hidden" name="script" value="%$script%">
	<input type="hidden" name="validermodif" value="10">
	  %$champscache%
    <table width="650" cellpadding="0" cellspacing="0">
      <tr> 
        <td valign="bottom" align="left" height="35" class="texterouge">
          <input type="image" border="0" name="validermodif" src="%$HTMLADRUNGICONES%/validermodif.gif" width="71" height="25">
          %$messcreatarticle%
        </td>
      </tr>
    </table> 	
   </form>
    %%$listeLigFamart%%
    <form method="post" action="%$CGIADR%/articlemodif.cgi" name="form">
	<table width="650" border="0" cellspacing="0" cellpadding="0" class="ligne3">
      <tr>
        <td align="center">
          <table width="651" cellpadding="0" cellspacing="2">
            <tr>
              <td colspan="8" class="texte4" align="left" height="13">%$addfamart%</td>
            </tr>
            <tr>
              <td colspan="8" class="tetiere" align="left" height="3"></td>
            </tr>
          </table>
          <table width="650" cellpadding="0" cellspacing="0">
            <tr>
              <td>
                <table width="100%" cellspacing="2" cellpadding="0">
                  <tr>
                    <td height="69"  valign="middle" class="texte4" align="left">
                     *&nbsp;%$codfamart%:
					 <input type="text" name="codfamajout"  value="%$para{codfamajout}%" size="10">
		            </td>
                  </tr>
                  <tr>
                    <td valign="middle" height="34" class="texte4" align="left">
                       &nbsp;%$desfamart% :
                      <input type="text" name="desfamajout"  value="%$para{desfamajout}%" size="30">
                    </td>
                  </tr>
                </table>
              </td>
              <td valign="middle" width="80" align="center" class="message"> 
                <input type="image" name="ajouter" src="%$HTMLADRUNGICONES%/ajouter.gif" border="0" width="39" height="30">
                <span class="texterouge">%$messajout%</span> </td>            
          </table>
        </td>
      </tr>
    </table>
    <input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">
	<input type="hidden" name="script" value="%$script%">
	<input type="hidden" name="ajouter" value="10">
	%$champscache%
	</form>
 <!-- unit article -->
%%$listeLigUnite%%
    <form method="post" action="%$CGIADR%/articlemodif.cgi" name="form">
	<table width="650" border="0" cellspacing="0" cellpadding="0" class="ligne3">
      <tr>
        <td align="center">
          <table width="651" cellpadding="0" cellspacing="2">
            <tr>
              <td colspan="8" class="texte4" align="left" height="13">%$addunit%</td>
            </tr>
            <tr>
              <td colspan="8" class="tetiere" align="left" height="3"></td>
            </tr>
          </table>
          <table width="650" cellpadding="0" cellspacing="0">
            <tr>
              <td>
                 <table width="100%" cellspacing="2" cellpadding="0">
                  <tr>
                    <td valign="middle" height="34" class="texte4" align="left">
                       &nbsp;%$codeunite%* :
					   <input type="text" name="codunitajout" value="%$para{codunitajout}%" size="10" maxlength="8">
                    </td>
	                <td valign="middle" height="34" class="texte4" align="left">
                       &nbsp;%$desunite%* :
					   <input type="text" name="desunitajout" value="%$para{desunitajout}%" size="30" maxlength="60">
                    </td>
                  </tr>
                </table>
              </td>
              <td valign="middle" width="80" align="center" class="message"> 
                <input type="image" name="ajouterunit" src="%$HTMLADRUNGICONES%/ajouter.gif" border="0" width="39" height="30">
                <span class="texterouge">%$messajout%</span></td>
          </table>
        </td>
      </tr>
    </table>
    <input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">
	<input type="hidden" name="script" value="%$script%">
	<input type="hidden" name="ajouterunit" value="10">
	%$champscache%
	</form>
 <!-- fin unit article -->

  <table width="650" cellpadding="0" cellspacing="0">
    </tr>
      <td valign="bottom" align="left">
      	<a href="%$CGIADR%/%$script%.cgi?idmod=%$idartic%&usertype=%$type%&username=%$login%&%$ch%"><img src="%$HTMLADRUNGICONES%/retour.gif" border="0"></a>
        <span class="texterouge">%$messretour%</span>
      </td>
    </tr>
  </table>
<!-- fin  $enteteArticle -->|;


#####maj contact########

my $enteteligFamart = q|
<!-- debut $enteteligfact -->
<br><br>
    <form method="post" action="%$CGIADR%/articlemodif.cgi">
      <table width="650" cellpadding="3" cellspacing="1">
      <tr>
        <td class="tetiere"  align="center" valign="middle">%$codfamart%</td>
        <td class="tetiere"  align="center" valign="middle">%$desfamart%</td>
        <TD align="center" valign="middle" class="tetiere">%$action% </TD>
      </tr>
<!-- fin  $enteteligContact -->|;

my %ligneFamart =();
tie %ligneFamart,"Tie::IxHash";
$ligneFamart{'1'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand -->
<!-- debut $modlig -->
     <TR>
        <TD align="center" valign="middle" class="texte2">%$rangee[1]%</TD>
        <TD align="center" valign="middle" class="texte3">%$rangee[2]% </TD>
        <!-- barre action -->
        <TD align="center" class="texte2">
          <table>
            <tr>
              <td align="left" valign="top">
                 <a href="javascript:suppfamart(%$rangee[0]%,'%$login%','%$type%','%$script%','%$ch%');"><img src="%$HTMLADRUNGICONES%/delete.gif" border="0" align="middle"></a>
              </TD>
              <TD align="left" valign="top">
                 <a href="%$CGIADR%/articlemodif.cgi?mod=%$rangee[0]%&username=%$login%&usertype=%$type%&script=%$script%&%$ch%"><img src="%$HTMLADRUNGICONES%/modifier.gif" border="0"></a>
              </TD>
            </TR>
          </table>
        </td>
     </tr>
     <!-- fin barre action -->        
<!-- fin  $modlig -->|;

$ligneFamart{'2'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: mod -->
<!-- debut $modligmod -->         
<TR>
	<td colspan="5">		
	<table width="100%">
	<tr>	
        <TD align="center" valign="middle">
        	<input type="text" name="codfammod" value="%$rangee[1]%" size="10">
        </TD>
        <TD align="center"  valign="middle">
			<input type="text" name="desfammod" value="%$rangee[2]%" size="30">
        </TD>
        <!-- barre action -->
        <TD align="center">
          <table>
            <tr>
              <TD>
                 <input type="image" name="valide" src="%$HTMLADRUNGICONES%/valider.gif" border="0">
                 <br><span class="texterouge">%$messmod%</span>
                 <input type="hidden" name="valide" value="%$rangee[0]%">
              </TD>
            </TR>
          </table>
        </td>
       </tr>
       </table>       
      </td>
        <!-- fin barre action -->
</tr>
<!-- fin $modligmod -->|;


my $finlistelig = q|
<input type="hidden" name="usertype" value="%$type%">
<input type="hidden" name="username" value="%$login%">
<input type="hidden" name="script" value="%$script%">
%$champscache%
</table>
</form>|;

########fin maj contact #########

######maj unit#######
my $enteteligUnite = q|
<!-- debut $enteteligunit -->
<br><br>
    <form method="post" action="%$CGIADR%/articlemodif.cgi">
      <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	    <td class="tetiere"  align="center" valign="middle">%$codeunite%</td>
        <td class="tetiere"  align="center" valign="middle">%$desunite%</td>
        <td class="tetiere"  align="center" valign="middle">%$action%</td>
      </tr>
<!-- fin  $enteteligContact -->|;

my %ligneUnite =();
tie %ligneUnite,"Tie::IxHash";
$ligneUnite{'1'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand -->
<!-- debut $modlig -->
     <TR>
        <TD align="center" valign="middle" class="texte2">%$rangee[1]%</TD>
		<TD align="center" valign="middle" class="texte3">%$rangee[2]% </TD>
        <!-- barre action -->
        <TD align="center" class="texte2">
          <table>
            <tr>


<!-- fin $modlig -->|;

$ligneUnite{'2'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand, maj -->
<!-- debut mod -->
              <TD align="left" valign="top">
                 <a href="%$CGIADR%/articlemodif.cgi?modunit=%$rangee[0]%&username=%$login%&usertype=%$type%&script=%$script%&%$ch%"><img src="%$HTMLADRUNGICONES%/modifier.gif" border="0"></a>
              </TD>
<!-- fin mod -->|;


$ligneUnite{'3'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand, supp -->
<!-- debut supp -->
			  <td align="left" valign="top">
                 <a href="javascript:suppunit(%$rangee[0]%,'%$login%','%$type%','%$script%','%$ch%');"><img src="%$HTMLADRUNGICONES%/delete.gif" border="0" align="middle"></a>
              </TD>
<!-- fin  supp -->|;


$ligneUnite{'4'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand -->
<!-- debut fin barre action -->
            </TR>
          </table>
        </td>
     </tr>
<!-- fin fin barre action -->|;


$ligneUnite{'5'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: mod -->
<!-- debut $modligmod -->         
<TR>
	<td colspan="5">		
	<table width="100%">
	<tr>
	    <TD align="center" valign="middle">
        	<input type="text" name="codunitmod" value="%$rangee[1]%" size="10">
        </TD>
        <TD align="center" valign="middle">
        	<input type="text" name="desunitmod" value="%$rangee[2]%" size="30">
        </TD>
        <!-- barre action -->
        <TD align="center">
          <table>
            <tr>
              <TD>
                 <input type="image" name="valideunit" src="%$HTMLADRUNGICONES%/valider.gif" border="0">
                 <br><span class="texterouge">%$messmod%</span>
                 <input type="hidden" name="valideunit" value="%$rangee[0]%">
              </TD>
            </TR>
          </table>
        </td>
       </tr>
       </table>       
      </td>
        <!-- fin barre action -->
</tr>
<!-- fin $modligmod -->|;


my $finlisteligUnite = q|
<input type="hidden" name="usertype" value="%$type%">
<input type="hidden" name="username" value="%$login%">
<input type="hidden" name="script" value="%$script%">
%$champscache%
</table>
</form>|;
######fin maj unit#######

my $ligCoordArticleMod = q|
<table width="650" cellpadding="3" cellspacing="1">
      <tr>
      <td class="ligne1"> * %$codarticle% :&nbsp;&nbsp;
	  		<input name="codartajout" type="text" value="%%$codart%%"  size="40">
      </td>
      <td valign="middle" class="ligne2" align="left"> %$famarticle% :
 		   %$popupcodfamcli%
      </td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">* %$desarticle% :
	  		<input name="desartajout" type="text" value="%%$desart%%" size="60">
	  	</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  </tr>
    </table>
|;

my $ligCoordArticleNoMod = q|
<table width="650" cellpadding="3" cellspacing="1">
      <tr>
      <td class="ligne1"> %$codarticle% :&nbsp; %%$codart%%
	  <INPUT TYPE='HIDDEN' NAME='codartajout' VALUE='%%$codart%%'>
      </td>
      <td valign="middle" class="ligne2" align="left"> %$famarticle% :
 		   %$popupcodfamcli%
      </td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  	<td class="ligne1">* %$desarticle% :
	  		<input name="desartajout" type="text" value="%%$desart%%" size="60">
	  	</td>
      </tr>
    </table>
    <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	  </tr>
    </table>
|;


#hachage pour le message du bouton retour
my %messretour = ('articles' => $messretourlistearticle,
				  'factmodif' => $messretourmajfact
#				  'propal' => $messretourmajpropal,
#				  'commande' => $messretourmajcde,
#				  'units' => $messretourmajunit
				  );
				  
				  
sub majArticle{
	my ($idartic,$type,$login,$title,$refpara,$refenteteArticle,$reflisteligFamart,
	$reflisteunit,$reflistecodfam,$reftabunite ,$reftabuser,$mess,$readonly,$script)=@_;
	#on recupere les variables avec les valeurs necc pour l'affichage
    #et on formate les valeurs pour l'affichage
	my $ch = '';	
	($refpara,$ch) = &getParam(%$refpara);
	my %para = %$refpara;	
	my $champscache = &getHidden(%para);
	if(exists $para{"toupdate"}){
	   $champscache .= &AffichLig($hidden,"toupdate",$para{"toupdate"});
	   $ch .= "&toupdate=$para{toupdate}";
	}
	#faire les listes deroulantes				
    my @num=(3,6);

    #pour une facture qu'on cre, on force la valeur selectionne
    #de la liste deroulante sur la valeur selectionnee lors de la creation ratee

    my ($codfamcli,$codunit) =
     ($para{"codfamajout"}, $para{"codunitajout"});

    my $messretour = $messretour{$script};
    #si la facture existe, on force les listes deroulantes sur les valeurs
    #de la facture 
    if($idartic){
		($codfamcli,$codunit)=@$refenteteArticle[@num];
	}
	########
	my $user = 0;
    ########
	my $popupcodfamcli = &getPopup($reflistecodfam,$codfamcli,"codfamajout");
    my $popupunit = &getPopup($reftabunite,$codunit,"codunitajout");
	#my $onload = '';
	my $onload = exists ($para{'notexiste'}) ? $onloadEcran:'';
	#construction de la page
	my $page=$body.&AffichLig(&affiche_barre($type,\%navigation,'articles'),$type,$login).$titrePage;
	if($mess){$page .= $messPage;}
	if($idartic){
		$page .= &ModifierArticle($idartic,$refenteteArticle,$reflisteligFamart,$reflisteunit,\%para,$type,$readonly);
	}
	else{$page .= &CreerArticle(\%para);}
	$page =~ s/%(\$\w+)%/$1/gee;
	&AffichPageWeb($title,$page);
	return;
} 


#pour modifier une facture
sub ModifierArticle{
	my ($numfact,$refenteteArticle,$reflisteligFamart,$reflisteunit,$refpara,$type,$readonly)=@_;
	my %para = %$refpara;
	#recup valeurs entete
	my ($idartic,$codart,$desart , $codfam, $qtestk,
       $pxht, $codunit)=@$refenteteArticle;
	
    $pxht = &formatNombre($pxht);
    
	my $ligCoordArticle = $readonly?$ligCoordArticleNoMod:$ligCoordArticleMod;

	my $onload = '';
    #if($para{"readonly"}){
	my $page .=$enteteArticle;

	#liste des lignes familles
    my $listeLigFamart = '';
	if(my @lignes = @$reflisteligFamart){
		my %ligLigneDroit=();
        tie %ligLigneDroit,"Tie::IxHash";
        %ligLigneDroit = &getHashAffich(\%ligneFamart,$type);
        #formater la liste des factures a afficher
        $listeLigFamart = &makeListe($reflisteligFamart,\%ligLigneDroit);
        $listeLigFamart = $enteteligFamart.$listeLigFamart.$finlistelig;
        $page =~ s/%%\$listeLigFamart%%/$listeLigFamart/;
    }
    #liste des units
    my $listeLigUnite = '';
    if(my @lignes = @$reflisteunit){
		my %ligLigneDroit=();
        tie %ligLigneDroit,"Tie::IxHash";
        %ligLigneDroit = &getHashAffich(\%ligneUnite,$type);
        #formater la liste des factures a afficher
        $listeLigUnite = &makeListe($reflisteunit,\%ligLigneDroit);
        $listeLigUnite = $enteteligUnite.$listeLigUnite.$finlisteligUnite;
        $page =~ s/%%\$listeLigUnite%%/$listeLigUnite/;
    }
    $page =~ s/%%\$ligCoordArticle%%/$ligCoordArticle/;
	#pour ajouter une ligne de facture
	$page =~ s/%%(\$\w+)%%/$1/gee;
	$page =~ s/%(\$\w+\{\w+\})%/$1/gee;
	#sub sur %% pour substituer seulement les valeurs passees,
	#sinon substitue les valeurs non passees par ''!
    return $page;
}


#pour creer une facture
sub CreerArticle{
	my ($refpara) = @_;
	my %para = %$refpara;	

    my $page .=$enteteArticleCreat;
    $page =~ s/%(\$\w+\{\w+\})%/$1/gee;
    $page  =~ s/%%(\$\w+)%%/$1/gee;
    return $page;
}


1;
END{}
