=pod

package de variables pour les commandes
propres au theme UNGI

=cut

package UNGI::Commande;

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../../lib','../';	
} 

use strict;
use CGI  qw(:standard);
use Conf;
use Util;
use lang::Fr;
use UNGI::General; 


BEGIN{
	use Exporter;
	use vars qw($VERSION @ISA @EXPORT);
	$VERSION = 1.00;
	@ISA = qw(Exporter);
	@EXPORT= qw(&AffichCommande &affichCommentCommande);	
		
}

use vars  @EXPORT;



###########################
#liste des depenses
###########################

my $ListeCommande = q|
<!-- debut $ListeCommande -->
<!-- ligne titre liste -->
    <table width="760" cellspacing="1" cellpadding="0" align="center">
      <tr align="center">
          <TD class="tetiere" align="center">%$id%</TD>
          <TD class="tetiere" align="center">%$orderreference%</TD>
		  <TD class="tetiere" align="center">%$wording%</TD>
		  <TD class="tetiere" align="center">%$namecommercial%</TD>
		  <TD class="tetiere" align="center">%$nameleadproject%</TD>
		  <TD class="tetiere" align="center">%$namecli%</TD>
		  <TD class="tetiere" align="center">%$date%</TD>
		  <TD class="tetiere" align="center">%$dateprevision%</TD>
		  <TD class="tetiere" align="center">%$total% &euro;</TD>				
		  <TD class="tetiere" align="center">%$action%</TD>
      </TR>
      <!-- liste des commandes -->
      %$liste%
      <!-- ligne finale avec les sommes -->
      <tr align="center"> 
        <td class="tetiere" colspan="8" height="20">%$sum% &euro;</td>        
        <td class="tetiere" height="20">%$som%</td>        
        <td class="tetiere"  height="20">&nbsp;</td>
      </tr>
    </table>
    <br>
    <!-- recherche par criteres -->
    <form method="post" action="%$CGIADR%/commande.cgi" name="formulaire" enctype="application/x-www-form-urlencoded" >	
    <table width="760" align="center">
    <tr align="center"> 
      <td class="tetiere2">%$searchby%&nbsp;:</td>
    </tr>
  </table>
  <table width="760" dwcopytype="CopyTableRow" align="center" cellpadding="3" cellspacing="1">
    <tr> 
      <td class="ligne1"> %$id%&nbsp;: 
        <input type="text" name="numcdetri"  size="10" value="%$para{numcdetri}%">
      </td>
      <td class="ligne1"> %$orderreference%&nbsp;:
        <input type="text" name="refcommandetri"  size="10" value="%$para{refcommandetri}%">
      </td>
      <td class="ligne1"> %$total%&nbsp;: 
        <input type="text" name="montcdetri"  size="10" value="%$para{montcdetri}%">
      </td>
    </tr>
    </table>
    <table width="760" dwcopytype="CopyTableRow" align="center" cellpadding="3" cellspacing="1">    
    <tr>
      <td class="ligne2"> %$wording%&nbsp;:
        <input type="text" name="libcdetri"  size="60" value="%$para{libcdetri}%">
      </td>     
      <td class="ligne2"> %$date% (JJ/MM/AAAA) : 
        <input type="text" name="jourtri"  size="2" maxlength="2" value="%$para{jourtri}%">
        <input type="text" name="moistri"  size="2" maxlength="2" value="%$para{moistri}%">
        <input type="text" name="antri"  size="4" maxlength="4" value="%$para{antri}%">
      </td>
    </tr>
  </table>
  <table width="760" align="center" cellpadding="3" cellspacing="1">
    <tr>
      <td class="ligne1">%$name%  :
        %$popupcli%
      </td>
    </tr>
  </table>
  <table width="760" align="center" cellpadding="3" cellspacing="1">
    <tr>
      <td class="ligne2">%$namecli%  :
        <input type="text" name="nomclilettretri"  size="60" value="%$para{nomclilettretri}%">
      </td>
    </tr>
  </table>
  <table width="760" align="center" cellpadding="3" cellspacing="1">
    <tr> 
     <td class="ligne1">%$namecommercial%  :
        %$popupcommercial%
      </td>
      <td class="ligne1">%$nameleadproject%  :
        %$popupchef%         
      </td> 
    <tr> 
      <td class="tetiere2"  height="10" colspan="2"></td>
    </tr>
  </table>
  <br>
  <table width="500" border="0" cellspacing="0" cellpadding="5" align="center" class="ligne3">
    <tr>
      <td align="center">
        <table width="350" align="center">
          <tr> 
            <td><span class="texte4">%$sortby%</span> 
              %$popuptri%
            </td>
          </tr>
        </table>
        <table width="350" align="center">
          <tr> 
            <td class="texte4" align="left" valign="middle">%$linenumber%</td>
            <td> 
              <input type="text" name="nbligtri" value="%$nb%" size="4" maxlength="3">
            </td>
            <td class="texte4" align="center" valign="middle">%$ontotal% %$taille%</td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGICONES%/reload.gif" width="31" height="36">
            </td>
          </tr>
        </table>
        <table width="500" border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGICONES%/premier.gif" width="31" height="22" align="middle">
            </td>
            <td align="center"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="precedent" src="%$HTMLADRUNGICONES%/gauche.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="suivant" src="%$HTMLADRUNGICONES%/droite.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="dernier" src="%$HTMLADRUNGICONES%/dernier.gif" width="30" height="22" align="middle">
            </td>
          </tr>
        </table>        
      </td>
    </tr>
  </table>
  <input type="hidden" name="usertype" value="%$type%">
  <input type="hidden" name="username" value="%$login%">
  <input type="hidden" name="pcdt" value="%$orderpcd%">
  <input type="hidden" name="suiv" value="%$ordersuiv%">
  </form> 
<table>    
      <td valign="middle" align="center">
      	<a href="%$CGIADR%/commande.cgi?username=%$login%&usertype=%$type%&toupdate=-1"><img src="%$HTMLADRUNGICONES%/nouveau.gif" border="0" align="middle"></a>
      </td>
      <td valign="middle" align="center"> 
      	<a href="%$CGIADR%/login.cgi"><img src="%$HTMLADRUNGICONES%/quitter2.gif" border="0" align="middle"></a> 
      </td>      
    </tr>
  </table>	 
		
<!-- fin liste commandes -->|; 


#hachage regroupant les differentes parties d'une ligne de facture
my %ligCommande = ();
tie %ligCommande,"Tie::IxHash";;
#une ligne de la liste
$ligCommande{'begin'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand,habit -->
<!-- une ligne = 1  ligne de commande -->
  <tr align="center"> 
        <td class="numero">%$rangee[0]%</td>
        <td class="texte2">%$rangee[1]%</td>
        <td class="texte3">%$rangee[2]%</td>
        <td class="texte2">%$rangee[3]%</td>
        <td class="texte3">%$rangee[4]%</td>
        <td class="texte2">
			<a href="%$CGIADR%/clientmodif.cgi?clientid=%$rangee[8]%&username=%$login%&usertype=%$type%">%$rangee[5]%</a>
		</td>
        <td class="texte3">%$rangee[6]%</td>
        <TD class="texte2">%$rangee[10]%</TD>
		<TD class="texte3">%$rangee[7]%</TD>		        
        <td class="texte2"> 
          <table cellspacing="3" cellpadding="0" align="left">
            <tr> 
|;

$ligCommande{'modif'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: modif,habit -->
<!-- une ligne = 1  ligne de depenses surligne --> 
<tr align="center"> 
        <td class="couleur">%$rangee[0]%</td>
        <td class="couleur">%$rangee[1]%</td>
        <td class="couleur">%$rangee[2]%</td>
        <td class="couleur">%$rangee[3]%</td>
        <td class="couleur">%$rangee[4]%</td>
        <td class="couleur">
			<a href="%$CGIADR%/clientmodif.cgi?clientid=%$rangee[8]%&username=%$login%&usertype=%$type%">%$rangee[5]%</a>
		</td>
        <td class="couleur">%$rangee[6]%</td>
        <td class="couleur">%$rangee[10]%</td>
        <td class="couleur">%$rangee[7]%</td>       
        <td class="texte2"> 
          <table cellspacing="3" cellpadding="0" align="left">
            <tr> 
|;

$ligCommande{'1'} = q|
<!-- Forbidden-to: comptable supercommercial -->
<!-- affich_on: habit -->
<!-- pour modifier une commande -->
                     <td>
                        <a href="%$CGIADR%/commande.cgi?toupdate=%$rangee[0]%&username=%$login%&usertype=%$type%&%$ch%"><img src="%$HTMLADRUNGICONES%/modifier.gif" border="0"></a>
					 </td>										
|;

$ligCommande{'2'} = q|
<!-- Forbidden-to: comptable chargeprojet supercommercial -->
<!-- affich_on: habit -->
<!-- supprimer une commande -->
                    <td>	
						<a href="javascript:suppcde(%$rangee[0]%,'%$login%','%$type%','%$ch%');"><img src="%$HTMLADRUNGICONES%/delete.gif" border="0"></a>
				    </td>
|;

$ligCommande{'3'} = q|
<!-- Forbidden-to: comptable chargeprojet supercommercial -->
<!-- affich_on: habit -->
<!-- facturer une commande -->
                    <td>	
						<a href="javascript:facturercde(%$rangee[0]%,'%$login%','%$type%');"><img src="%$HTMLADRUNGICONES%/facturer.gif" border="0"></a>
				    </td>
|;

$ligCommande{'4'} = q|
<!-- Forbidden-to: comptable  -->
<!-- affich_on: habit -->
<!-- editer un commentaire de commande -->
                   <td>
                     <a href="javascript:editcde(%$rangee[0]%,'%$login%','%$type%');"><img src="%$HTMLADRUNGICONES%/comment.gif" border="0"></a>
				   </td>	
|;

$ligCommande{'end'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: habit -->
<!-- fin lignecommande -->      
                </tr>
              </table>
              <!-- fin barre action -->
            </td>
          </tr>
|; 

my $ligCommandeMaj = q|
<!-- une ligne de commande en modification = ligCommandeMaj -->
	<table width="650" class="ligne3" cellpadding="3" cellspacing="0">
    <tr> 
      <td  class="texte4" align="left" width="20%">%$idorder% :</td>
      <td class="textegras">%$para{toupdate}%</td>
    </tr>
   </table>
   <form method="post" action="%$CGIADR%/commande.cgi" name="validmodcde" enctype="application/x-www-form-urlencoded" >
		<table width="650" cellpadding="3" cellspacing="1">
		  <tr>
			<TD class="ligne2" align="left" valign="middle" width="20%">
			    %$namecli% :
			</td>
			<TD class="ligne2" align="left" valign="middle">
			    %$popupclimod%
			</td>				
			<td class="ligne2" valign="middle" align="right">
				   <a href="%$CGIADR%/clientmodif.cgi?toupdate=%$para{toupdate}%&usertype=%$type%&username=%$login%&script=commande&boutonnavig=commandes&%$ch%"><img src="%$HTMLADRUNGICONES%/creercli.gif" border="0" align="middle" width="128" height="25"></a> 
            		</td>
		  </tr>
		</table>
		<table width="650" cellpadding="3" cellspacing="1">
		   <tr>
		      <td class="ligne1" align="left" valign="middle" width="20%">
		           %$orderreference% :
		      </td>
		      <td class="ligne1" align="left" valign="middle">
		           <input type="text" name="refcommandemod" value="%$para{refcommandemod}%">
		      </td>
		   </tr>
		   <tr>
		      <td class="ligne2" align="left" valign="middle">
		         %$wording% :
		      </td>
		      <td class="ligne1" align="left" valign="middle">
				<textarea name="libcdemod" cols="30" wrap="virtual">%$para{libcdemod}%</textarea>
		      </TD>
		   </tr>
		   <tr>
		      <td class="ligne1" align="left" valign="middle">
		          %$commentaires% :
                      </td>
		      <td class="ligne1" align="left" valign="middle">
		          <textarea name="commentairesmod" cols="40" rows="2" wrap="virtual">%$para{commentairesmod}%</textarea>			
		       </td>
		   </tr>
		   <tr>
		      <TD  class="ligne2" align="left" valign="middle">
		         %$namecommercial% :
		      </td>
		      <TD  class="ligne2" align="left" valign="middle">
				 %$popupcommercialmod%
		      </td>
		   </tr>
		   <tr>
			  <TD class="ligne1" align="left" valign="middle">
			  	%$nameleadproject% :
		          </td>
		          <TD class="ligne1" align="left" valign="middle">
				  %$popupchefmod%
			  </td>
		   </tr>
		   <tr>
		        <TD class="ligne2" align="left" valign="middle">
		             %$total% &euro;
			</td>
			<TD class="ligne2" align="left" valign="middle">
		             <input type="text" name="montcdemod" value="%$para{montcdemod}%" size="30">
		        </TD>
		    </tr>
		  </table>  		   
		 <table width="650" cellpadding="3" cellspacing="1">
		   <tr>   									
			 <TD class="ligne1" align="left" valign="middle">%$date% - </td>
			 <td class="ligne1" align="left" valign="middle">
			   %$day% :
				<input type="text" name="jourm" value="%$para{jourm}%" size="2" maxlength="2">
			</td>
			<td class="ligne1" align="left" valign="middle">
			    %$month% :
				<input type="text" name="moism" value="%$para{moism}%" size="2" maxlength="2">
			</td>
			<td class="ligne1" align="left" valign="middle">
			    %$year% :
				<input type="text" name="anm" value="%$para{anm}%" size="4" maxlength="4">
			</td>
		  </tr>
		  <tr>
		     <TD class="ligne2" align="left" valign="middle">%$dateprevision% - </td>
			 <td class="ligne2" align="left" valign="middle">
			    %$day% :
				<input type="text" name="jourrm" value="%$para{jourrm}%" size="2" maxlength="2">
			 </td>
			 <td class="ligne2" align="left" valign="middle">
			    %$month% :
				<input type="text" name="moisrm" value="%$para{moisrm}%" size="2" maxlength="2">
			 </td>
			 <td class="ligne2" align="left" valign="middle">
			    %$year% :
				<input type="text" name="anrm" value="%$para{anrm}%" size="4" maxlength="4">
			</td>
		  </tr>
	  </table>
	  <table width="650" cellpadding="0" cellspacing="0">
        <tr> 
          <td valign="bottom" align="left" height="35">
		    <input type="image" name="valider" src="%$HTMLADRUNGICONES%/valider.gif" border="0"></a>           
            <span class="texterouge">%$messmod%</span>
          </td>
        </tr>
        <tr><td>&nbsp;</td></tr>
        <tr>
			<td valign="bottom" align="left">
      			<a href="%$CGIADR%/commande.cgi?username=%$login%&usertype=%$type%&toupdate=-1"><img src="%$HTMLADRUNGICONES%/nouveau.gif" border="0" align="middle"></a>
      		</td>
		</tr>
	    <tr><td>&nbsp;</td></tr>
        <tr>
           <td valign="bottom" align="left">	       	 
	  	   <a href="%$CGIADR%/commande.cgi?usertype=%$type%&username=%$login%&%$ch%&idmod=%$para{toupdate}%"><img src="%$HTMLADRUNGICONES%/retour.gif" border="0"></a>                
	           <span class="texterouge">%$messretcde%</span>
	       </td>
	    </tr>
	  </table>
      <input type="hidden" name="usertype" value="%$type%">
	  <input type="hidden" name="username" value="%$login%">	      
	  <input type="hidden" name="valider" value="%$para{toupdate}%">
	  <input type="hidden" name="toupdate" value="%$para{toupdate}%">
	      %$champscache%
    </form>             
<!-- fin une ligne de commande en modification-->|;

my $ligCommandeAjout  = q|
<!-- une ligne de commande en ajout =  ligCommandeAjout -->
   <form method="post" action="%$CGIADR%/commande.cgi" name="validmodcde" enctype="application/x-www-form-urlencoded" >
		<table width="650" cellpadding="3" cellspacing="1">
		  <tr>			
			<TD class="ligne2" align="left" valign="middle" width="20%">
			    %$namecli% :
			</td>
			<TD class="ligne2" align="left" valign="middle">
			    %$popupclimod%
			</td>				
			<td class="ligne2" valign="middle" align="right">
				   <a href="%$CGIADR%/clients.cgi?toupdate=%$para{toupdate}%&usertype=%$type%&username=%$login%&script=commande&boutonnavig=commandes&%$ch%"><img src="%$HTMLADRUNGICONES%/creercli.gif" border="0" align="middle" width="128" height="25"></a> 
                        </td>
		  </tr>
		</table>
		<table width="650" cellpadding="3" cellspacing="1">
		   <tr>
		      <td class="ligne1" align="left" valign="middle" width="20%">
		           %$orderreference% :
		      </td>
		      <td class="ligne1" align="left" valign="middle">
		           <input type="text" name="refcommandeajout" value="%$para{refcommandeajout}%" size="30">
		      </td>
		   </tr>
		</table>
		<table width="650" cellpadding="3" cellspacing="1">
		   <tr>
		      <td class="ligne2" align="left" valign="middle" width="20%">
		         %$wording% :
		      </td>
		      <td class="ligne2" align="left" valign="middle">
				<textarea name="libcdeajout" cols="40" wrap="virtual">%$para{libcdeajout}%</textarea>
		      </TD>
		   </tr>
		   <tr>
		       <td class="ligne1" align="left" valign="middle" width="20%">
		          %$commentaires% :
		       </TD>
		       <td class="ligne1" align="left" valign="middle">
		          <textarea name="commentairesajout" cols="40" rows="2" wrap="virtual">%$para{commentairesajout}%</textarea>			
		       </td>
		   </tr>
		   <tr>
		      <TD  class="ligne2" align="left" valign="middle" width="20%">
		         %$namecommercial% :
		      </td>
		      <TD  class="ligne2" align="left" valign="middle">
				 %$popupcommercialmod%
			  </td>
		   </tr>
		   <tr>
			  <TD class="ligne1" align="left" valign="middle" width="20%">
			  	%$nameleadproject% :
		          </td>
		          <TD class="ligne1" align="left" valign="middle">
				  %$popupchefmod%
			  </td>
		   </tr>
		   <tr>
		        <TD class="ligne2" align="left" valign="middle" width="20%">
		             %$total% &euro;
			</td>
		          <TD class="ligne2" align="left" valign="middle">
		             <input type="text" name="montcdeajout" value="%$para{montcdeajout}%" size="30">
		        </TD>
		    </tr>
		  </table>  		   
		 <table width="650" cellpadding="3" cellspacing="1">
		   <tr>   									
			 <TD class="ligne1" align="left" valign="middle">%$date% - </td>
			 <td class="ligne1" align="left" valign="middle">
			   %$day% :
				<input type="text" name="jourf" value="%$para{jourf}%" size="2" maxlength="2">
			</td>
			<td class="ligne1" align="left" valign="middle">
			    %$month% :
				<input type="text" name="moisf" value="%$para{moisf}%" size="2" maxlength="2">
			</td>
			<td class="ligne1" align="left" valign="middle">
			    %$year% :
				<input type="text" name="anf" value="%$para{anf}%" size="4" maxlength="4">
			</td>
		  </tr>
		  <tr>
		     <TD class="ligne2" align="left" valign="middle">%$dateprevision% - </td>
			 <td class="ligne2" align="left" valign="middle">
			    %$day% :
				<input type="text" name="jourrf" value="%$para{jourrf}%" size="2" maxlength="2">
			 </td>
			 <td class="ligne2" align="left" valign="middle">
			    %$month% :
				<input type="text" name="moisrf" value="%$para{moisrf}%" size="2" maxlength="2">
			 </td>
			 <td class="ligne2" align="left" valign="middle">
			    %$year% :
				<input type="text" name="anrf" value="%$para{anrf}%" size="4" maxlength="4">
			</td>
		  </tr>
	  </table>
	  <table width="650" cellpadding="0" cellspacing="0">
        <tr> 
          <td valign="bottom" align="left" height="35">					
		    <input type="image" name="valider" src="%$HTMLADRUNGICONES%/valider.gif" border="0"></a>           
            <span class="texterouge">%$messmod%</span>
          </td>
        </tr>
        <tr><td>&nbsp;</td></tr>
        <tr>            
           <td valign="bottom" align="left">	       	 
	  	   <a href="%$CGIADR%/commande.cgi?usertype=%$type%&username=%$login%&%$ch%"><img src="%$HTMLADRUNGICONES%/abandonner.gif" border="0"></a> 
		   <span class="texterouge">%$messretcde%</span>
	       </td>
	    </tr>
	  </table>
      <input type="hidden" name="usertype" value="%$type%">
	  <input type="hidden" name="username" value="%$login%">	      
	  <input type="hidden" name="ajouter" value="10">
	  <input type="hidden" name="toupdate" value="-1">
	      %$champscache%
    </form>             
<!-- fin une ligne de commande en ajout -->|;

				    
sub AffichCommande{
    my ($type,$login,$orderpcd,$ordersuiv,$nb,$taille,$som,
    $reftabAffich,$refpara,$reftab,$reftabcommercial,$reftabcommercialajout,$reftabchef,
    $reftabchefajout,$reftabcli,$reftabcliajout, $mess)= @_;
    my $ch = '';
	($refpara,$ch) = &getParam(%$refpara);
	my %para = %$refpara;
	if(exists ($para{"toupdate"}) && $para{"toupdate"}){
  	&CommandeModif($type,$login,$refpara,$ch,$mess,$reftabcommercialajout,$reftabchefajout,
  	$reftabcliajout);
  }
  else{
      &ListeCommande($type,$login,$orderpcd,$ordersuiv,$nb,$taille,$som,
      $reftabAffich,$refpara,$ch,$reftab,$reftabcommercial,$reftabchef,$reftabcli, $mess);          
  }   
  return;
} 


sub CommandeModif{
    my ($type,$login,$refpara,$ch,$mess,$reftabcommercialajout,$reftabchefajout,
  	$reftabcliajout) = @_;
    my %para = %$refpara;
    my $champscache = &getHidden(%para);
    my $title = $titleModOrder;
    my $app = "mod";
    if($para{"toupdate"} == -1){
          $app = "ajout"; 
          if(!($para{"jourf"} || $para{"moisf"} || $para{"anf"})){
		      ($para{"jourf"}, $para{"moisf"},$para{"anf"})=&sec_calend(time);	
	      }	      
	    $para{"Montcdeajout"} = ($para{"MontTTCajout"} || "0.00");	    
	    $title = $titleCreatOrder;   
    }      	 
    foreach my $val (keys %para){
      if ($val =~ /(mod|ajout)$/ && $para{$val} =~ /^[+\-]{0,1}[0-9]+\.[0-9]{2}$/){
         $para{$val} = &formatNombre($para{$val});
      }
    }
	my $popupclimod = &getPopup($reftabcliajout, $para{"nomcli$app"},"nomcli$app");
	my $popupcommercialmod =&getPopup($reftabcommercialajout,$para{"commercial$app"},"commercial$app"); 	
	my $popupchefmod =  &getPopup($reftabchefajout,$para{"chefprojet$app"} ,"chefprojet$app"); 
	my $onload = '';

	my $page = $body.&AffichLig(&affiche_barre($type,\%navigation,'commandes'),$type,$login).$titrePage;
	if($mess){$page .= $messPage;}	
	if($para{'toupdate'} == -1){	     
	     $page .= $ligCommandeAjout;
	}
	else{$page .= $ligCommandeMaj;}
	$page =~ s/%(\$\w+\{\w+\})%/$1/gee;
    $page =~ s/%(\$\w+)%/$1/gee;
    #double substitution pour substituer les valeurs de liste
    $page =~ s/%(\$\w+)%/$1/gee;	 
    &AffichPageWeb($title,$page);	
    return;	
}

	
sub ListeCommande{
    &debug("debut listecommande");
	my ($type,$login,$orderpcd,$ordersuiv,$nb,$taille,$som,
    $reftabAffich,$refpara,$ch,$reftab,$reftabcommercial,$reftabchef,
    $reftabcli,$mess)= @_; 
    #on recupere les variables avec les valeurs necc pour l'affichage
    #et on formate les valeurs pour l'affichage   
	my %para = %$refpara;	
	my $champscache = &getHidden(%para);
	$som = &formatNombre($som);	
	my $title = $titleconscde ;
	#on construit la liste des commandes formatees
	my %ligCommandeDroit=();
    tie %ligCommandeDroit,"Tie::IxHash";
    %ligCommandeDroit = &getHashAffich(\%ligCommande,$type);
	&debug("type = $type");
    my $liste = &makeListe($reftabAffich,\%ligCommandeDroit);     
	
	#on fait les menus deroulants	  	  
    my $popuptri = &getPopup($reftab, $para{"tri"},"tri");
	my $popupcli = &getPopup($reftabcli, $para{"nomclitri"},"nomclitri");
	my $popupcommercial =&getPopup($reftabcommercial, $para{"commercialtri"},"commercialtri");
	my $popupchef = &getPopup($reftabchef, $para{"chefprojettri"},"chefprojettri"); 
	#my $onload = '';
	my $onload = exists ($para{toupdate}) ? $onloadEcran:'';
    #on construit la page a afficher
    my $page = $body.&AffichLig(&affiche_barre($type,\%navigation,'commandes'),$type,$login).$titrePage;
	if($mess){$page .= $messPage;}	
	$page .= $ListeCommande;	
	$page =~ s/%(\$\w+\{\w+\})%/$1/gee;
	$page =~ s/%(\$\w+)%/$1/gee;
	#double substitution pour substituer les valeurs de liste
	$page =~ s/%(\$\w+)%/$1/gee;		 
	&AffichPageWeb($title,$page);
	&debug("fin listecommande");
    return;
}

my $editCommentaire = q|
<!-- debut  $editCommentaire -->  
   <HTML>
    <HEAD>
      <TITLE>commentaires</TITLE>
    </HEAD>
    <BODY BGCOLOR="#ffffff">
    <form method=post action="%$CGIADR%/commande.cgi">
       <textarea name="commentaires" cols="70" rows="10" wrap="virtual">%$commentaire%</textarea></td>	  
	   <input type="image" name="save" src="%$HTMLADRUNGICONES%/valider.gif" border="0">			
       <input type="hidden" name="editcde" value="%$numcde%"> 
       <input type="hidden" name="save" value="10">  
	</form>  
      <form>
        <input type="button" value="cliquez ici pour fermer" onClick="self.close();">
      </form>
   </BODY>
  </HTML>
<!-- fin  $editCommentaire -->|;


#afficher le commentaire d'un commande
sub affichCommentCommande{
	my ($commentaire,$numcde,$idmod,$type,$login) = @_;
	if($numcde){
		(my $page  = $editCommentaire) =~ s/%(\$\w+)%/$1/gee;
		print header;
		print $page;
	}
	else{
		my $script = "commande";
		$rafraichirEcran =~ s/%(\$\w+)%/$1/gee;
		print header();
		print $rafraichirEcran;
	}
    return;     
}


1;

END{}
