=pod

package de variables pour les depenses
propres au theme UNGI

=cut

package UNGI::Depense;

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../../lib','../';	
} 

use strict;
use CGI  qw(:standard);
use Conf;
use Util;
use lang::Fr;
use UNGI::General; 


BEGIN{
	use Exporter;
	use vars qw($VERSION @ISA @EXPORT);
	$VERSION = 1.00;
	@ISA = qw(Exporter);
	@EXPORT= qw(&AffichDepense);	
		
}

use vars  @EXPORT;



###########################
#liste des depenses
###########################

my $ListeDepense = q|
<!-- debut $ListeDepense -->
<!-- ligne titre liste -->
    <table width="760" cellspacing="1" cellpadding="0" align="center">
      <tr align="center">
          <TD class="tetiere" align="center">%$id%</TD>
          <TD class="tetiere" height="35">%$wording%</TD>
          <TD class="tetiere" height="35">%$date%</TD>
          <TD class="tetiere" height="35"> %$totalwithouttax% &euro;</TD>
          <TD class="tetiere" height="35"> %$totalwithtax% &euro;</TD>          
          <TD class="tetiere" height="35">%$idcheque%</TD>
          <TD class="tetiere" height="35">%$mansupply%</TD>            
          <TD class="tetiere" height="35">%$action%</TD>
      </TR>
      <!-- liste des depenses -->
      %$liste%
      <!-- ligne finale avec les sommes -->
      <tr align="center"> 
        <td class="tetiere" colspan="3" height="20">%$sum% &euro;</td>        
        <td class="tetiere" height="20">%$somHT%</td>
        <td class="tetiere" height="20">%$somTTC%</td>
        <td class="tetiere" colspan="3" height="20">&nbsp;</td>
      </tr>
    </table>
    <br>
    <!-- recherche par criteres -->
    <form method="post" action="%$CGIADR%/depenses.cgi" name="formulaire" enctype="application/x-www-form-urlencoded" >	
    <table width="760" align="center">
    <tr align="center"> 
      <td class="tetiere2">%$searchby%&nbsp;:</td>
    </tr>
  </table>
  <table width="760" dwcopytype="CopyTableRow" align="center" cellpadding="3" cellspacing="1">
    <tr> 
      <td class="ligne1"> %$id%&nbsp;: 
        <input type="text" name="numdeptri"  size="20" value="%$para{numdeptri}%">
      </td>
      <td class="ligne1"> %$date% (JJ/MM/AAAA) :
        <input type="text" name="jourtri"  size="2" maxlength="2" value="%$para{jourtri}%">
        <input type="text" name="moistri"  size="2" maxlength="2" value="%$para{moistri}%">
        <input type="text" name="antri"  size="4" maxlength="4" value="%$para{antri}%">
      </td>
    </tr>
  </table>
  <table width="760" align="center" cellpadding="3" cellspacing="1">
    <tr>      
      <td class="ligne2"> %$wording% :
        <input type="text" name="libdeptri"  size="30" value="%$para{libdeptri}%">
      </td>
      <td class="ligne2"> %$mansupply% :
        <input type="text" name="fournisseurtri"  size="15" value="%$para{fournisseurtri}%">
      </td>
    </tr>
  </table>
  <table width="760" align="center" cellpadding="3" cellspacing="1">
    <tr> 
      <td class="ligne1">%$totalwithouttax% &euro;
        <input type="text" name="MontHTtri"  size="12" value="%$para{MontHTtri}%">
      </td>
      <td class="ligne1">%$totalwithtax% &euro;
        <input type="text" name="MontTTCtri"  size="12" value="%$para{MontTTCtri}%">
      </td>      
    </tr>
    <tr> 
      <td class="tetiere2"  height="10" colspan="2"></td>
    </tr>
  </table>
  <br>
  <table width="500" border="0" cellspacing="0" cellpadding="5" align="center" class="ligne3">
    <tr>
      <td align="center">
        <table width="350" align="center">
          <tr> 
            <td><span class="texte4">%$sortby%</span> 
              %$popuptri%
            </td>
          </tr>
        </table>
        <table width="350" align="center">
          <tr> 
            <td class="texte4" align="left" valign="middle">%$linenumber%</td>
            <td> 
              <input type="text" name="nbligtri" value="%$nb%" size="4" maxlength="3">
            </td>
            <td class="texte4" align="center" valign="middle">%$ontotal% %$taille%</td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGICONES%/reload.gif" width="31" height="36">
            </td>
          </tr>
        </table>
        <table width="500" border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGICONES%/premier.gif" width="31" height="22" align="middle">
            </td>
            <td align="center"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="precedent" src="%$HTMLADRUNGICONES%/gauche.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle">
              <input type="image" border="0" name="suivant" src="%$HTMLADRUNGICONES%/droite.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="dernier" src="%$HTMLADRUNGICONES%/dernier.gif" width="30" height="22" align="middle">
            </td>
          </tr>
        </table>        
      </td>
    </tr>
  </table>
  <input type="hidden" name="usertype" value="%$type%">
  <input type="hidden" name="username" value="%$login%">
  <input type="hidden" name="pcdt" value="%$orderpcd%">
  <input type="hidden" name="suiv" value="%$ordersuiv%">
  <input type="hidden" name="chaine" value="%$ch%">
  </form>  
  <br><br>   
<table>
    <tr> 
      <td valign="middle" align="center">
      	<a href="%$CGIADR%/depenses.cgi?username=%$login%&usertype=%$type%&toupdate=-1"><img src="%$HTMLADRUNGICONES%/nouveau.gif" border="0" align="middle"></a>
      </td>
      <td valign="middle" align="center"> 
      	<a href="%$CGIADR%/login.cgi"><img src="%$HTMLADRUNGICONES%/quitter2.gif" border="0" align="middle"></a>
      </td>      
    </tr>
  </table>	 
		
<!-- fin listedepenses -->|; 


#hachage regroupant les differentes parties d'une ligne de facture
my %ligDepense = ();
tie %ligDepense,"Tie::IxHash";;
#une ligne de la liste
$ligDepense{'begin'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand,habit -->
<!-- une ligne = 1  ligne de facture -->
  <tr align="center"> 
        <td class="numero">%$rangee[0]%</td>
        <td class="texte2">%$rangee[1]%</td>
        <td class="texte3">%$rangee[2]%</td>
        <td class="texte2">%$rangee[3]%</td>
        <td class="texte3">%$rangee[4]%</td>
        <td class="texte2">%$rangee[5]%</td>
        <td class="texte3">%$rangee[6]%</td>        
        <td class="texte2"> 
          <table cellspacing="3" cellpadding="0" align="left">
            <tr> 
|;

$ligDepense{'modif'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: modif,habit -->
<!-- une ligne = 1  ligne de depenses surligne --> 
<tr align="center"> 
        <td class="couleur">%$rangee[0]%</td>
        <td class="couleur">%$rangee[1]%</td>
        <td class="couleur">%$rangee[2]%</td>
        <td class="couleur">%$rangee[3]%</td>
        <td class="couleur">%$rangee[4]%</td>
        <td class="couleur">%$rangee[5]%</td>
        <td class="couleur">%$rangee[6]%</td>        
        <td class="texte2"> 
          <table cellspacing="3" cellpadding="0" align="left">
            <tr> 
|;

$ligDepense{'1'} = q|
<!-- Forbidden-to: comptable supercommercial -->
<!-- affich_on: habit -->
<!-- pour modifier une depense -->
                     <td>
                        <a href="%$CGIADR%/depenses.cgi?toupdate=%$rangee[0]%&username=%$login%&usertype=%$type%&%$ch%"><img src="%$HTMLADRUNGICONES%/modifier.gif" border="0"></a>
					 </td>										
|;

$ligDepense{'2'} = q|
<!-- Forbidden-to: comptable supercommercial -->
<!-- affich_on: habit -->
                    <td>	
						<a href="javascript:suppdep(%$rangee[0]%,'%$login%','%$type%','%$ch%');"><img src="%$HTMLADRUNGICONES%/delete.gif" border="0"></a>						
				    </td>
|;

$ligDepense{'end'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: habit -->
<!-- fin lignefacture -->      
                </tr>
              </table>
              <!-- fin barre action -->
            </td>
          </tr>
|; 


#pour afficher une depense en modification
my $ligDepenseMaj = q|
<!-- une ligne de depense en modification =  ligDepenseMaj pour modifier une depense-->
   <table width="650" class="ligne3" cellpadding="3" cellspacing="0">
    <tr> 
      <td  class="texte4" align="left" width="20%">%$idexpense% :</td>
      <td class="textegras">%$para{toupdate}%</td>
    </tr>
   </table>
   <form method="get" action="%$CGIADR%/depenses.cgi" name="validmoddep" enctype="application/x-www-form-urlencoded" >
	<table width="650" cellpadding="3" cellspacing="1">
	  <tr>
		<td class="ligne2" align="left" valign="middle" >
		    %$wording% :
		</td>
		<td class="ligne2" align="left" valign="middle" >
			<textarea name="libdepmod" cols="60" wrap="virtual">%$para{libdepmod}%</textarea>
		</td>
	  </tr>	
	  <tr>
		<td class="ligne1" align="left" valign="middle" >	
			%$mansupply% :
		</td>
		<td class="ligne2" align="left" valign="middle" >
			<textarea name="fournisseurmod" cols="60" wrap="virtual">%$para{fournisseurmod}%</textarea>
		</td>
	  </tr>	
	</table>
	<table width="650" cellpadding="3" cellspacing="1">
	  <tr>											
		<td class="ligne2" align="left" valign="middle">%$date% - </td>
		<td class="ligne2" align="right" valign="middle">
		   %$day% :
	        </td>
		<td class="ligne2" align="left" valign="middle">
		   <input type="text" name="jourm" value="%$para{jourm}%" size="2" maxlength="2">
		</td>
		<td class="ligne2" align="right" valign="middle">
		   %$month% :
		</td>
		<td class="ligne2" align="left" valign="middle">
		   <input type="text" name="moism" value="%$para{moism}%" size="2" maxlength="2">
		</td>
		<td class="ligne2" align="right" valign="middle">
		   %$year% :
                </td>
		<td class="ligne2" align="left" valign="middle">
		   <input type="text" name="anm" value="%$para{anm}%" size="4" maxlength="4">
		</td>
	  </tr>
	</table>
	<table width="650" cellpadding="3" cellspacing="1">	  
	  <tr>											
		<td class="ligne1" align="middle" valign="middle">		
			%$totalwithouttax% &euro;
			<input type="text" name="MontHtmod" value="%$para{MontHtmod}%" size="30">
		</TD>
		<td class="ligne1" align="left" valign="middle">		  
			  <input type="checkbox" name="auto" value="1">		    
		</TD>
		<td class="ligne1" align="left" valign="middle">					
		    %$totalwithtax% &euro;
		    <input type="text" name="MontTTCmod" value="%$para{MontTTCmod}%" size="30">
		</TD>
	   </tr>
	  </table>
	  <table width="650" cellpadding="3" cellspacing="1">	
		<td class="ligne1" align="left" valign="middle">
			%$idcheque%
			<input type="text" name="numchequemod" value="%$para{numchequemod}%" size="30">
		</TD>
	  </tr>
	</table>	        
    <input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">	
	<input type="hidden" name="valider" value="%$para{toupdate}%">
	<input type="hidden" name="toupdate" value="%$para{toupdate}%">
    %$champscache%    			
	<table width="650" cellpadding="0" cellspacing="0">

      <tr> 
        <td valign="bottom" align="left" height="35">
          <input type="image" border="0" name="valider" src="%$HTMLADRUNGICONES%/valider.gif">
          <span class="texterouge">%$messmod%</span>          
        </td>                
      </tr>
      <tr><td>&nbsp;</td></tr>
	   <tr>
	     <td valign="bottom" align="left">
      	    <a href="%$CGIADR%/depenses.cgi?username=%$login%&usertype=%$type%&toupdate=-1"><img src="%$HTMLADRUNGICONES%/nouveau.gif" border="0" align="middle"></a>
         </td>
	  </tr>
      <tr><td>&nbsp;</td></tr>
      <tr>      
      <td valign="bottom" align="left">	       	 
	  	<a href="%$CGIADR%/depenses.cgi?usertype=%$type%&username=%$login%&%$ch%&idmod=%$para{toupdate}%"><img src="%$HTMLADRUNGICONES%/retour.gif" border="0"></a>
		<span class="texterouge">%$messretdep%</span>
	  </td>
    </tr>
    </table>  
    </form>       
	<!-- fin une ligne de depense en modification-->|;
				    

#pour afficher une depense en ajout
my $ligDepenseAjout = q|
<!-- une ligne de depense en ajout = ligDepenseAjout -->
   <form method="pot" action="%$CGIADR%/depenses.cgi" name="validmoddep" enctype="application/x-www-form-urlencoded" >
	<table width="650" cellpadding="3" cellspacing="1">
	  <tr>
		<td class="ligne2" align="left" valign="middle" >
		    %$wording% : 
		</td>
		<td class="ligne2" align="left" valign="middle" >
			<textarea name="libdepajout" cols="30" wrap="virtual">%$para{libdepajout}%</textarea>
		</td>
	  </tr>	
	  <tr>
		<td class="ligne1" align="left" valign="middle" >
			%$mansupply% :
		</td>
		<td class="ligne1" align="left" valign="middle" >
			<textarea name="fournisseurajout" cols="30" wrap="virtual">%$para{fournisseurajout}%</textarea>
		</td>
	  </tr>	
	</table>
	<table width="650" cellpadding="3" cellspacing="1">
	  <tr>											
		<td class="ligne2" align="left" valign="middle">%$date% - </td>
		<td class="ligne2" align="right" valign="middle">
		   %$day% :
		</td>
		<td class="ligne2" align="left" valign="middle">
		   <input type="text" name="jourf" value="%$para{jourf}%" size="2" maxlength="2">
		</td>
		<td class="ligne2" align="right" valign="middle">
		   %$month% :
		</td>
		<td class="ligne2" align="left" valign="middle">
		   <input type="text" name="moisf" value="%$para{moisf}%" size="2" maxlength="2">
		</td>
		<td class="ligne2" align="right" valign="middle">
		   %$year% :
		</td>
		<td class="ligne2" align="left" valign="middle">
		   <input type="text" name="anf" value="%$para{anf}%" size="4" maxlength="4">
		</td>
	  </tr>
	</table>
	<table width="650" cellpadding="3" cellspacing="1">
	  <tr>
	    <td class="message" align="middle" valign="middle" colspan="3">%$messcalculation%</td>
	  </tr>
	  <tr>											
		<td class="ligne1" align="left" valign="middle">		
			%$totalwithouttax% &euro;
			<input type="text" name="MontHtajout" value="%$para{MontHtajout}%" size="8">
		</TD>
		<td class="ligne1" align="left" valign="middle">		  
			  <input type="checkbox" name="auto" value="1">		    
		</TD>
		<td class="ligne1" align="left" valign="middle">					
		    %$totalwithtax% &euro;
		    <input type="text" name="MontTTCajout" value="%$para{MontTTCajout}%" size="8">
		</TD>
	   </tr>
	  </table>
	  <table width="650" cellpadding="3" cellspacing="1">	
		<td class="ligne1" align="left" valign="middle">
			%$idcheque%
			<input type="text" name="numchequeajout" value="%$para{numchequeajout}%" size="30">
		</TD>
	  </tr>
	</table>	        
    <input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">	
	<input type="hidden" name="ajouter" value="10">
	<input type="hidden" name="toupdate" value="-1">
    %$champscache%    			
	<table width="650" cellpadding="0" cellspacing="0">
      <tr> 
        <td valign="bottom" align="left" height="35" class="texterouge"> 
          <input type="image" border="0" name="valider" src="%$HTMLADRUNGICONES%/valider.gif">
          <span class="texterouge">%$messmod%</span>          
        </td>                
      </tr>
      <tr><td>&nbsp;</td></tr>
      <tr>      
      <td valign="bottom" align="left">	       	 
	  	<a href="%$CGIADR%/depenses.cgi?usertype=%$type%&username=%$login%&%$ch%"><img src="%$HTMLADRUNGICONES%/abandonner.gif" border="0"></a>
	        <span class="texterouge">%$messretdep%</span>
	  </td>
    </tr>
    </table>  
    </form>       
	<!-- fin une ligne de depense en modification-->|;
				  


sub AffichDepense{
  my ($type,$login,$orderpcd,$ordersuiv,$nb,$taille,$somHT,$somTTC,
    $reftabAffich,$refpara,$reftab,$mess) = @_;
  my $ch = '';
  ($refpara,$ch) = &getParam(%$refpara);
  my %para = %$refpara;   
  if(exists ($para{"toupdate"}) && $para{"toupdate"}){
  	&DepenseModif($type,$login,$refpara,$mess,$ch);
  }
  else{
      &ListeDepense($type,$login,$orderpcd,$ordersuiv,$nb,$taille,$somHT,$somTTC,
        $reftabAffich,$refpara,$reftab,$mess,$ch);          
  }   
  return;
} 

sub DepenseModif{
   my ($type,$login,$refpara,$mess,$ch) = @_;
   my $title = $titleModExpense;
   my %para = %$refpara;
   my $champscache = &getHidden(%para);      
   #formatage des nombres
   if($para{"toupdate"} == -1){
       if(!($para{"jourf"} || $para{"moisf"} || $para{"anf"})){
		  ($para{"jourf"}, $para{"moisf"},$para{"anf"})=&sec_calend(time);	
	    }
	    
	    $para{"MontTTCajout"} = ($para{"MontTTCajout"} || "0.00");
	    $para{"MontHtajout"} = ($para{"MontHtajout"} || "0.00");
	    $title = $titleCreatExpense; 
   }
   foreach my $val (keys %para){
     if ($val =~ /(mod|ajout)$/ && $para{$val} =~ /^[+\-]{0,1}[0-9]+\.[0-9]{2}$/){
        $para{$val} = &formatNombre($para{$val});
     }
   }   
   my $onload = ''; 
   my $page = $body.&AffichLig(&affiche_barre($type,\%navigation,'depenses'),$type,$login).$titrePage;
	if($mess){$page .= $messPage;}	
	if($para{'toupdate'} == -1){ 
	     
	     $page .= $ligDepenseAjout;
	}
	else{$page .= $ligDepenseMaj;}
	$page =~ s/%(\$\w+\{\w+\})%/$1/gee;
    $page =~ s/%(\$\w+)%/$1/gee;
    #double substitution pour substituer les valeurs de liste
    $page =~ s/%(\$\w+)%/$1/gee;	 
    &AffichPageWeb($title,$page);	
    return;
}

	
sub ListeDepense{
    my ($type,$login,$orderpcd,$ordersuiv,$nb,$taille,$somHT,$somTTC,
    $reftabAffich,$refpara,$reftab,$mess,$ch) = @_; 
    #on recupere les variables avec les valeurs necc pour l'affichage
    my $title = $titleconsdep;
    #et on formate les valeurs pour l'affichage  
    my %para = %$refpara;  
    #on construit les menus deroulants
    my $popuptri = &getPopup($reftab, $para{"tri"},"tri"); 
	my $champscache = &getHidden(%para);
	foreach my $val ($somHT,$somTTC){
		$val = &formatNombre($val);
	}	
	#on construit la liste des depenses formatees
	my %ligDepenseDroit=();
    tie %ligDepenseDroit,"Tie::IxHash";
    %ligDepenseDroit = &getHashAffich(\%ligDepense,$type);
    my $liste = &makeListe($reftabAffich,\%ligDepenseDroit);    
    #$liste =~ s/%(\$\w+)%/$1/gee;
    if(!($para{"jourf"} || $para{"moisf"} || $para{"anf"})){
		  ($para{"jourf"}, $para{"moisf"},$para{"anf"})=&sec_calend(time);	
	}	     
    #on construit la page a afficher
    my $onload = exists ($para{toupdate}) ? $onloadEcran:'';

    my $page = $body.&AffichLig(&affiche_barre($type,\%navigation,'depenses'),$type,$login).$titrePage;

    if($mess){$page .= $messPage;}
    $page .= $ListeDepense;
    $page =~ s/%(\$\w+\{\w+\})%/$1/gee;
    $page =~ s/%(\$\w+)%/$1/gee;
=pod	while($page =~ /%(\$\w+)%/){
        $page =~ s/%(\$\w+)%/$1/ee;
		my $val = $1;
        #print p "dol1 = $val";
	}
=cut
    #double substitution pour substituer les valeurs de liste
    $page =~ s/%(\$\w+)%/$1/gee;
    &AffichPageWeb($title,$page); 
    return;
}


1;

END{}
