=pod

package de fonction et variables general
propres au theme UNGI

=cut

###
#
# 06/10/2003 : Ajout javascript dans getPopup par Abtey Prod
#
###

package UNGI::General;

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../../lib','../';	
} 

use strict;
use CGI  qw(:standard);
use Tie::IxHash;
use Conf;
use Util;
use lang::Fr;

BEGIN{
	use Exporter;
	use vars qw($VERSION @ISA @EXPORT);
	$VERSION = 1.00;
	@ISA = qw(Exporter);
	@EXPORT= qw(&Connectionfacturier &getParam &getPopup &AffichLig &makeListe &AffichPageWeb
	&affiche_barre &getHidden &formatNombre &printRafraichirEcran
	 $enTete $body $piedPage $titrePage $messPage $hidden %navigation $hautForm 
	 $basForm $rafraichirEcran $onloadEcran);
		
}

use vars  @EXPORT;


#entete des pages html
$enTete = q|
<!-- debut entete -->
<html>
  <head>
	<title> %$title%</title>
	<link rel="stylesheet" type="text/css" href="%$HTMLADRUNGI%/style.css" />
	<script language="JAVASCRIPT" src="%$HTMLADRESSE%/javascript.js" type="text/javascript"></script>
  </head>
<!-- fin entete -->|;

$body = q|
  <!-- body bgcolor="#FFFFFF" %$onload% text="#000000" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0" style="background-image: url(%$HTMLADRUNGICONES%/fond_tetiere.gif); background-repeat: no-repeat" -->

  <body bgcolor="#FFFFFF" %$onload% text="#000000" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">

  <div align="center">|;

$piedPage = q|
<!-- debut piedPage -->
   </div>  
  </body>
</html>
<!-- fin piedPage -->|;

$titrePage = q|
<p align="center">  
  <span class="titre">%$title%</span>   
</p>|;

$messPage = q|
<p class="message">%$mess%</p>|;

$hidden =  q|
<input type="hidden" name="%$valeur[1]%" value="%$valeur[2]%">|;

####################
#barre de navigation
####################
%navigation =();
tie %navigation,"Tie::IxHash";
#debut barre
$navigation{'begin'} = q|
<!-- Restricted-to: anybody -->
<!-- debut barre navigation -->
<!-- debut debut barrehaut -->
<!-- table  border="0" style="background-image: url(%$HTMLADRUNGICONES%/fond_tetiere.gif); background-repeat: no-repeat"><tr><td -->
<table width="760" border="0" cellspacing="0" cellpadding="0" height="20" align="center" style="background-image: url(%$HTMLADRUNGICONES%/fond_tetiere.gif); background-repeat: no-repeat">
  <tr>
    <td valign="top">
      <table width="98%" border="0" cellspacing="0" cellpadding="0" align="center">
        <tr align="left"> 
          <td height="15" colspan="8" valign="top">&nbsp;</td>
        </tr>
<!-- fin debut barrehaut -->	  
|;

#boutons barre

=pod

$navigation{'1'} = liste des depenses

=cut 

$navigation{'1'} = q|
<!-- Forbidden-to: client -->
<!-- debut liste depenses -->
           <td>
				<form method="post" action="%$CGIADR%/depenses.cgi" enctype="application/x-www-form-urlencoded">
					<input type="image" name="listedepenses" src="%$HTMLADRUNGICONES%/depenses.gif"  border="0" width="80" height="19">
					<input type="hidden" name="usertype" value="%$valeur[1]%" >
					<input type="hidden" name="username" value="%$valeur[2]%">
					<input type="hidden" name="dernier.x" value="10">
				</form>
		   </td>
<!-- fin liste depenses -->			
|;


=pod

$navigation{'2'} = liste des factures

=cut 

$navigation{'2'} = q|
<!-- Restricted-to: anybody -->
<!-- debut liste factures -->
           <td>
				<form method="post" action="%$CGIADR%/facture.cgi" enctype="application/x-www-form-urlencoded">
					<input type="image" name="listefactures" src="%$HTMLADRUNGICONES%/factures.gif"  border="0" width="79" height="19">
					<input type="hidden" name="usertype" value="%$valeur[1]%" >
					<input type="hidden" name="username" value="%$valeur[2]%">
					<input type="hidden" name="dernier.x" value="10">
					
				</form>
		   </td>
<!-- fin liste factures -->			
|;

=pod

$navigation{'3'} = liste des utilisateurs

=cut

$navigation{'3'} = q|
<!-- Forbidden-to: client comptable chefprojet commercial supercommercial-->
<!-- pour voir les utilisateurs -->
            <td>	
				<form method="post" action="%$CGIADR%/utilisateur.cgi" enctype="application/x-www-form-urlencoded">
					<input type="image" name="utilisateur" src="%$HTMLADRUNGICONES%/utilisateurs.gif" border="0" width="103" height="19">
					<input type="hidden" name="usertype" value="%$valeur[1]%" >
					<input type="hidden" name="username" value="%$valeur[2]%" >
				</form>
			</td>
<!-- fin utilisateurs -->|;	

=pod

$navigation{'4'} = liste des entrees

=cut


$navigation{'4'} = q|
<!-- Forbidden-to: client commercial  comptable chargeprojet supercommercial-->
<!-- pour voir les factures non reglees -->
			<td>	
				<form method="post" action="%$CGIADR%/entrees.cgi" enctype="application/x-www-form-urlencoded">
					<input type="image" name="entree" src="%$HTMLADRUNGICONES%/entrees.gif" border="0" width="81" height="19">
					<input type="hidden" name="usertype" value="%$valeur[1]%" >
					<input type="hidden" name="username" value="%$valeur[2]%" >					
				</form>
			</td>
<!-- fin factures non reglees -->|;	

=pod

$navigation{'5'} = liste des commandes

=cut

$navigation{'5'} = q|
<!-- Forbidden-to: client -->
<!-- pour voir les commandes -->
			<td>	
				<form method="post" action="%$CGIADR%/commande.cgi" enctype="application/x-www-form-urlencoded">
					<input type="image" name="commande" src="%$HTMLADRUNGICONES%/commandes.gif" border="0" width="95" height="19">
					<input type="hidden" name="usertype" value="%$valeur[1]%">
					<input type="hidden" name="username" value="%$valeur[2]%">
					<input type="hidden" name="dernier.x" value="10">					
				</form>
			</td>
<!-- fin commandes -->|;

=pod

$navigation{'6'} = liste des statistiques

=cut				

$navigation{'6'} = q|
<!-- Forbidden-to: client -->
<!-- pour voir les statistiques -->
			<td>				
				<form method="post" action="%$CGIADR%/statistiques.cgi" enctype="application/x-www-form-urlencoded">
					<input type="image" name="stat" src="%$HTMLADRUNGICONES%/statistiques.gif" border="0" width="103" height="19">
					<input type="hidden" name="usertype" value="%$valeur[1]%" >
					<input type="hidden" name="username" value="%$valeur[2]%" >
				</form>
			</td>
<!-- fin statistiques -->|;


=pod

$navigation{'7'} = liste des relances

=cut

$navigation{'7'} =q|
<!-- Forbidden-to: client -->
<!-- pour voir les relances -->
			<td>	
				<form method="post" action="%$CGIADR%/relance.cgi" enctype="application/x-www-form-urlencoded">
					<input type="image" name="relance" src="%$HTMLADRUNGICONES%/relance.gif" border="0" width="84" height="19">					
					<input type="hidden" name="usertype" value="%$valeur[1]%" >
					<input type="hidden" name="username" value="%$valeur[2]%" >
				</form>
			</td>
<!-- fin relances -->|;	

=pod

$navigation{'8'} = liste des articles

=cut

$navigation{'8'} =q|
<!-- Forbidden-to: client -->
<!-- pour voir les articles -->
			<td>	
				<form method="post" action="%$CGIADR%/articles.cgi" enctype="application/x-www-form-urlencoded">
					<input type="image" name="relance" src="%$HTMLADRUNGICONES%/article.gif" border="0" width="84" height="19">					
					<input type="hidden" name="usertype" value="%$valeur[1]%" >
					<input type="hidden" name="username" value="%$valeur[2]%" >
				</form>
			</td>
<!-- fin relances -->|;	


=pod

$navigation{'9'} = liste propals

=cut

$navigation{'9'} =q|
<!-- Forbidden-to: client comptable -->
<!-- pour voir les propals -->
			<td>
				<form method="post" action="%$CGIADR%/propal.cgi" enctype="application/x-www-form-urlencoded">
					<input type="image" name="propals" src="%$HTMLADRUNGICONES%/propal.gif" border="0" width="81" height="19">
				    <input type="hidden" name="usertype" value="%$valeur[1]%" >
					<input type="hidden" name="username" value="%$valeur[2]%" >
					<input type="hidden" name="dernier.x" value="10">
				</form>
			</td>
<!-- fin propals -->|;




$navigation{'10'} =q|
<!-- Forbidden-to: client comptable -->
<!-- pour voir les clients/prospects -->
			<td>
				<form method="post" action="%$CGIADR%/clients.cgi" enctype="application/x-www-form-urlencoded">
					<input type="image" name="clients" src="%$HTMLADRUNGICONES%/clients.gif" border="0">
				    <input type="hidden" name="usertype" value="%$valeur[1]%" >
					<input type="hidden" name="username" value="%$valeur[2]%" >
				</form>
			</td>
<!-- fin clients/prospects -->|;

$navigation{'11'} =q|
<!-- Forbidden-to: client comptable -->
<!-- pour voir les taches -->
			<td>
				<form method="post" action="%$CGIADR%/taches.cgi" enctype="application/x-www-form-urlencoded">
					<input type="image" name="taches" src="%$HTMLADRUNGICONES%/tache.gif" border="0">
				    <input type="hidden" name="usertype" value="%$valeur[1]%" >
					<input type="hidden" name="username" value="%$valeur[2]%" >
				</form>
			</td>
<!-- fin clients/prospects -->|;


=pod

$navigation{'12'} = quitter

=cut

$navigation{'12'} = q|
<!-- Restricted-to: anybody -->
<!-- quitter le facturier -->
			<td>	
				<form method="post" action="%$CGIADR%/login.cgi" enctype="application/x-www-form-urlencoded">
					<input type="image" name="quitter" src="%$HTMLADRUNGICONES%/quit.gif" border="0" >
				</form>
			</td>
<!-- fin quitter -->|;

=pod

$navigation{'end'} = fin barre

=cut

$navigation{'end'} = q|
<!-- Restricted-to: anybody -->
<!-- debut fin barrehaut -->
	  </table>
    </td>
  </tr>
</table>
<!-- /td></tr></table -->
<!-- fin fin barrehaut -->
<!-- debut barre navigation -->
|;

########################
#fin barre de navigation
########################			
			

$hautForm = q|
<form method="post" action="%$CGIADR%/%$valeur[1]%" name="%$valeur[2]%">|;

$basForm = q|
</form>|;


my $connectionFacturier = q|
<!-- debut $connectionFacturier -->
<body background="%$HTMLADRUNGICONES%/fond.gif" topmargin="60" marginheight="60">
<div align="center">  
  <table width="475" border="0" cellspacing="0" cellpadding="0" align="center">
    <tr> 
      <td><img src="%$HTMLADRUNGICONES%/logo_ungi.gif" width="185" height="121"></td>
      <td><img src="%$HTMLADRUNGICONES%/facturier.gif" width="290" height="69"></td>
    </tr>
  </table>
  <br>
<form method="post" action="%$CGIADR%/login.cgi">
<table width="475" cellspacing="0" cellpadding="2" align="center">
    <tr>
      <td bgcolor="#737ABF"> 
        <table width="100%" cellspacing="0" cellpadding="0">
          <tr>
            <td bgcolor="#3F4895" align="center" valign="middle" height="100"> 
              <br>
              <table width="300" cellspacing="0" cellpadding="0" align="center">
                <tr> 
                  <td class="txteblanc" width="279">%$name% :</td>
                  <td width="194" height="30"> 
                    <input type="text" name="username">
                  </td>
                </tr>
                <tr> 
                  <td width="279" class="txteblanc">%$passwd% :</td>
                  <td width="194" height="30"> 
                    <input type="password" name="userpass">
                  </td>
                </tr>
              </table>
              <br>
              <input type="image" border="0" name="valider" src="%$HTMLADRUNGICONES%/valider_login.gif" width="93" height="31">
              <br>
            </td>
          </tr>
        </table>
      </td>
    </tr>
  </table>
  <p>&nbsp;</p>
  <input type="hidden" name="dernier.x" value="10">
  </form>
<!-- fin  $connectionFacturier -->|;

#pour rafraichir l'ecran

$rafraichirEcran = q|
<html>
  <head>
    <script language="JAVASCRIPT" src="%$HTMLADRESSE%/javascript.js" type="text/javascript"></script>
  </head>
 <BODY BGCOLOR="#ffffff" onload="window.resizeTo(300,300);">
   <p> cette entite n&#039;existe pas </p>
        <a href="javascript:rafraichir('%$script%',%$idmod%,'%$login%','%$type%','%$ch%');">rafraichir</a>
 </BODY>
</HTML>
|;

=head2 printRafraichirEcran

affiche un fenetre qui demande de rafraichir
l'ecran et qui appelle le script $script.cgi
avec les parametres de $ch en tq qu'utilisateur
$userlogin de type $username
arg =$ch : para,$login = user,
	$type = type user, $script = script  lancer

=cut

sub printRafraichirEcran{
	my ($ch,$type,$login,$script,$idmod) = @_;
    $rafraichirEcran =~ s/%(\$\w+)%/$1/gee;
	print header();
	print $rafraichirEcran;
	return;
}


$onloadEcran = q|
onload="javascript:alert('%$messrafecran%');"|;


=head2 AffichLig

afficher une ligne
1er argument = $valeur[0] = fichier html
arg suivants = variables a substituer
($valeur[1...n])

=cut

sub AffichLig{
 &debug("debut sub AffichLig");
 my @valeur=@_;
 $valeur[0] =~ s/%%(\$\w+)%%/$1/eeg; 
 $valeur[0] =~ s/%(\$\w+\[\w*])%/$1/gee; 
 &debug("fin sub AffichLig");
 return $valeur[0];
} 

=pod

sub AffichPageWeb = affiche une page web
arg = titre head et page a afficher

=cut

sub AffichPageWeb{
    &debug("debut sub AffichPageWeb");
	my ($title,$page)=@_;	
	my $pageaffiche=$enTete.$page.$piedPage;
	$pageaffiche =~ s/%%(\$\w+)%%/$1/eeg;
	$pageaffiche =~ s/%(\$\w+)%/$1/eeg;
	print header;  	 
    print $pageaffiche;
    &debug("fin sub AffichPageWeb");
    return;
} 


=pod

sub makeListe = cree la liste des lignes a afficher
arguement = 
	$reftable = liste des enreg existants	
	$idmod = clef primaire de l'enreg correspondant a la ligne a mettre
	en evidence (suite a modif, supp, ...)	
	$refligne = ref sur le hachage contenant les var html du format d'affichage		
	retourne la liste des contrats formatees

=cut

sub makeListe{
    &debug("debut sub makeListe");
	my ($reftable,$refligne)=@_;
	my @table =@$reftable; 
	my $listecontrat='';
	for ( my $i=0 ;$i < @table; $i++) {
		my @rangee=@{$table[$i]};

        #&debug("dernier elem = $rangee[$#rangee]");
		my $ligne = &getLigne($refligne,$rangee[$#rangee]);
		#formater les nombres :replacer . par , et separer milliers par espaces
		for (my $i=0; $i<$#rangee;$i++){
			if(defined($rangee[$i]) && $rangee[$i] =~ /^[+\-]{0,1}[0-9]+\.[0-9]{2}$/){
			   $rangee[$i] = &formatNombre($rangee[$i]);			   
			}
		}
		#faire le popup si existe
		while($ligne =~ /\$popup_(\d+)/){
		    my $ind = $1;
			my $popup=&getPopup($rangee[$ind]->[0],$rangee[$ind]->[1],$rangee[$ind]->[2]);
			$ligne =~ s/%\$popup_($1)%/$popup/;
		}

		($listecontrat .= $ligne)=~ s/%(\$rangee\[\d+])%/$1/gee;

	}
    &debug("fin sub makeListe");
	return $listecontrat;  	
}

=pod

sub getLigne = renvoie la ligne a afficher selon les valeurs de l'enreg $refhash
si la supp est interdite, renvoie pas supp .....
arg = $refligne = ligne complete que l'utilisateur a le droit d'afficher
      $refhash = ref a un hachage contenant une valeur a 0 ou !0 pour chaque clef
      si la valeur est !0, on affiche, sinon pas. Par exemple sup => 0,
      on affiche pas le bouton supprimer
      chaque ligne a controler contient "affich_on: clef1,clef2,...."
      pour que la ligne soit affiche il faut que les valeurs de hachage
      correspondant a chacune des clefs soit !0
      
=cut

sub getLigne{
	&debug("debut sub getLigne");
	my ($refligne,$refhash)=@_;
	my %hash = %$refhash;
	my $ligne = '';
	my %ligne;
	tie %ligne,"Tie::IxHash";
	%ligne = %$refligne;
	foreach my $value (values %ligne){
		my $ancre=1;
		my @tab = split(/\n/,$value);
		if ($tab[2] =~ /affich_on:/){
			$tab[2] =~ s/^.*affich_on\W+//;
			$tab[2] =~ s/\W+$//;
			#######
			my @liste = split(/,\s*/,$tab[2]);				
			foreach my $clef (@liste){		
			  if(exists($hash{$clef}) && !$hash{$clef}){
				$ancre = 0;
				last;
			  }
			}						
		}	
	   $ligne .= ($ancre)? $value :'';
	}
	&debug("fin sub getLigne");
	return $ligne;
}

=pod

sub getPopup pour faire un popup
  accepte du js ss la forme "onchange = js_sub()"

=cut

sub getPopup{
	my ($refliste,$val,$para, $js) =@_;
	my %liste = ();
	tie %liste,"Tie::IxHash";
	%liste = %$refliste;
	#pour forcer il faut faire a en cas de ' ou "	
	if($val){
		$val =~ s/\&#039;/'/g;
		$val =~ s/\&quot;/"/g;
	}
	param($para,$val);
	my $popup;
	$js = "" if (! defined ($js)); # viter "Use of uninitialized value ..."
	if ($js =~ s/^onChange\s*=\s*//i) {
			$popup =scrolling_list(-NAME => $para,-LABELS => $refliste,
					-default => $val, -VALUES => [keys %liste] , -MULTIPLE => "0",
					-size =>1,
					-onChange => $js);
	}
	else {
		$popup =scrolling_list(-NAME => $para,-LABELS => $refliste,
				-default => $val, -VALUES => [keys %liste] , -MULTIPLE => "0",
				-size =>1);
	}
    return $popup;
}


=pod

retourne les boutons d'une liste de bouton passer en argument ($refhach)
qui ont le droit d'etre vu par l'utilisateur de type $type
$img=bouton qui doit tre mis en evidence dans la barre de navigation

=cut

sub affiche_barre {
	my ($type,$refhach,$img) =@_;
	my %navigation;
	tie %navigation,"Tie::IxHash";
	%navigation=%$refhach;
    my $page='';
#=pod
	my @pages = ();
	# On traite les gabarits les uns apres les autres
    my %navigationbis = ();
    tie %navigationbis,"Tie::IxHash";
	@navigationbis{@barrehautdroit} = @navigation{@barrehautdroit};
	#foreach my $clef (keys %navigationbis){
	#	print p "clef = $clef";
	#}

	foreach my $model (values %navigationbis) {
		my @buff=split(/\n/,$model);
		if(&restriction($type,$buff[1])){
			push(@pages,$model);
		}
	}
	#s'il y a plus d'elem dans @pages que le nb max de bouton par ligne
	#on divise la barre en deux, le plus d'elem en haut
	#par ex si 11 elem, 6 en haut et 5 en bas
	if(@pages > $nbmaxnavig){
		   my $indmilieu = @pages / 2;
		   $indmilieu = int($indmilieu) < $indmilieu ? int($indmilieu) + 1 : int($indmilieu);
           $indmilieu--;
		   my $taille = @pages;
		   $taille--;
		   for(my $i = $taille; $i > $indmilieu  ; $i--){
		   	  $pages[$i + 2] = $pages[$i];
           }
		   $pages[$indmilieu + 1] = $navigation{'end'};
           $pages[$indmilieu + 2] = $navigation{'begin'};
	}
    push(@pages,$navigation{'end'});
	unshift(@pages,$navigation{'begin'});
	$page = join("",@pages);
#=cut
=pod
   foreach my $model (values %navigation) {
		my @buff=split(/\n/,$model);
        $page .= (&restriction($type,$buff[1]))?$model:'';
   }
   #$page =~ s/($img)\.gif/$img\_2\.gif/;

=cut
    $page =~ s/($img)\.gif/$img\_2\.gif/;
	return $page;
}

=head2 Connectionfacturier

page de connection

=cut

sub Connectionfacturier{
	my ($title) = @_;	   
    &AffichPageWeb($title,$connectionFacturier);
    return;
}

=head2 getParam

effecture des trt pour l'affichage sur les para
reoit en arg le hachage de parametres
retourne le hachage modifi et une ch rsultant de la concatenation
des diffrents elements du hachage du type :clef1=valeur1&clef2=valeur2

=cut

sub getParam{
    &debug("debut sub getParam");
	my (%para) = @_;
	my $ch='';
	foreach my $clef (keys %para){
	    if(defined$para{$clef}){
			$para{$clef} =~ s/"/&quot;/g;
			$para{$clef} =~ s/'/&#039;/g;
	    }
		if($clef !~ /((ajout|fct|mod|toupdate)$|(^(jour|mois|an).*(f|r|m)$))/ && $para{$clef}){
			my $val = $para{$clef};
			#$val =~ s/"/\&quot;/g;
			$ch.= "$clef=$val&";
		}
		if(defined($para{$clef})){ $para{$clef} =~ s/\\(&quot;|&#039;)/$1/g;}		
		#$para{$clef} =~ s/"/\&quot;/g;
		#$para{$clef} =~ s/'/\&#039;/g;
	}
	$ch =~ s/&$//;
	$ch =~ s/\s+/+/g;	
    &debug("fin sub getParam");
	return (\%para,$ch);
}

sub getHidden {
	my (%para) = @_;
	my $champscache = '';
	foreach my $clef (keys %para){
		if($clef !~ /((ajout|fct|mod|toupdate)$|(^(jour|mois|an).*(f|r|m)$))/ && $para{$clef}){		
	        $champscache .= &AffichLig($hidden,$clef,$para{$clef});
	    }
	}
	return $champscache;
}	


#formate une somme pour l'affichage
sub formatNombre{
	my ($val) = @_;
	#2 decimales
	if($val =~ /^[+\-]{0,1}[0-9]+[.]{0,1}[0-9]*$/){
		$val = sprintf("%.2f",$val);
		#remplacer . par ,
		$val =~ s/\./,/;
		#sepration des milliers
		1 while $val =~ s/(\d)(\d\d\d)(?!\d)/$1 $2/g;
	}
	return $val;
}





1;
 
 END{}
	


