=pod

package de variables pour les commandes
propres au theme UNGI

=cut

package UNGI::Utilisateur;

#mettre les librairies ds le chemin de perl
BEGIN {
  unshift @INC, '../../lib','../';	
} 

use strict;
use CGI  qw(:standard);
use Conf;
use Util;
use lang::Fr;
use UNGI::General; 


BEGIN{
	use Exporter;
	use vars qw($VERSION @ISA @EXPORT);
	$VERSION = 1.00;
	@ISA = qw(Exporter);
	@EXPORT= qw(&ListeUtilisateurs  &AffichCreatUser);
		
}

use vars  @EXPORT;



###########################
#liste des depenses
###########################

my $ListeUtilisteur = q|
<!-- debut $ListeUtilisteur -->
<!-- ligne titre liste -->
    <table width="760" cellspacing="1" cellpadding="0" align="center">
      <tr align="center">
          <TD class="tetiere" align="center">%$id%</TD>
          <TD class="tetiere" align="center">%$loginname%</TD>
          <TD class="tetiere" align="center">%$name%</TD>                        
          <TD class="tetiere" align="center">%$role%</TD>
          <TD class="tetiere" align="center">%$wholename%</TD> 		  	  				
		  <TD class="tetiere" align="center" width="15%">%$action%</TD>
      </TR>
      <!-- liste des commandes -->
      %$liste%      
    </table>
    <br>
    <!-- recherche par criteres -->
    <form method="post" action="%$CGIADR%/utilisateur.cgi" name="formulaire" enctype="application/x-www-form-urlencoded" >	
    <table width="760" align="center">
    <tr align="center"> 
      <td class="tetiere2">%$searchby%&nbsp;:</td>
    </tr>
  </table>
  <table width="760" dwcopytype="CopyTableRow" align="center" cellpadding="3" cellspacing="1">
    <tr> 
      <td class="ligne1"> %$id%&nbsp;: 
        <input type="text" name="useridtri"  size="15" value="%$para{useridtri}%">
      </td>
      <td class="ligne2"> %$role%&nbsp;: 
          %$popuproletri%  
      </td>
    </tr>
    <tr>
      <td class="ligne1"> %$name%&nbsp;: 
        <input type="text" name="usernametri"  size="30" value="%$para{usernametri}%">
      </td>
      <td class="ligne1"> %$loginname%&nbsp;: 
        <input type="text" name="userlogintri"  size="30" value="%$para{userlogintri}%">
      </td>
    <tr>
      <td class="ligne2" colspan="2"> %$wholename%&nbsp;: 
        <input type="text" name="nomcomplettri"  size="50" value="%$para{nomcomplettri}%">
      </td>
    </tr>  
    <tr> 
      <td class="tetiere2" colspan="2" height="10"></td>
    </tr>      
    </table>   
  <br>
  <table width="500" border="0" cellspacing="0" cellpadding="5" align="center" class="ligne3">
    <tr>
      <td align="center">
        <table width="350" align="center">
          <tr> 
            <td><span class="texte4">%$sortby%</span> 
              %$popuptri%
            </td>
          </tr>
        </table>
        <table width="350" align="center">
          <tr> 
            <td class="texte4" align="left" valign="middle">%$linenumber%</td>
            <td> 
              <input type="text" name="nbligtri" value="%$nb%" size="4" maxlength="3">
            </td>
            <td class="texte4" align="center" valign="middle">%$ontotal% %$taille%</td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGICONES%/reload.gif" width="31" height="36">
            </td>
          </tr>
        </table>
        <table width="500" border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="premier" src="%$HTMLADRUNGICONES%/premier.gif" width="31" height="22" align="middle">
            </td>
            <td align="center"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="precedent" src="%$HTMLADRUNGICONES%/gauche.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="suivant" src="%$HTMLADRUNGICONES%/droite.gif" width="30" height="22" align="middle">
            </td>
            <td align="center" valign="middle"><img src="%$HTMLADRUNGICONES%/fond2.gif" width="16" height="16"></td>
            <td align="center" valign="middle"> 
              <input type="image" border="0" name="dernier" src="%$HTMLADRUNGICONES%/dernier.gif" width="30" height="22" align="middle">
            </td>
          </tr>
        </table>        
      </td>
    </tr>
  </table>
  <input type="hidden" name="usertype" value="%$type%">
  <input type="hidden" name="username" value="%$login%">
  <input type="hidden" name="pcdt" value="%$orderpcd%">
  <input type="hidden" name="suiv" value="%$ordersuiv%">
  <input type="hidden" name="chaine" value="%$ch%">
  </form> 
<table>    
      <td>
		   <a href="%$CGIADR%/modifuti.cgi?creat=10&username=%$login%&usertype=%$type%&%$ch%"><img src="%$HTMLADRUNGICONES%/creez_uti.gif" border="0"></a> 
	  </td>
      <td valign="middle" align="center"> 
      	<a href="%$CGIADR%/login.cgi"><img src="%$HTMLADRUNGICONES%/quitter2.gif" border="0" align="middle"></a> 
      </td>      
    </tr>
  </table>	 
		
<!-- fin liste utilisateur -->|; 


#hachage regroupant les differentes parties d'une ligne de facture
my %ligUtilisateur = ();
tie %ligUtilisateur,"Tie::IxHash";;
#une ligne de la liste
$ligUtilisateur{'begin'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand,habit -->
<!-- une ligne utilisateur -->
  <tr align="center"> 
        <td class="numero">%$rangee[0]%</td>
        <td class="texte2">%$rangee[1]%</td>
        <td class="texte3">%$rangee[2]%</td>
        <td class="texte2">%$rangee[3]%</td>
        <td class="texte3">%$rangee[4]%</td>        		        
        <td class="texte2"> 
          <table cellspacing="3" cellpadding="0" align="left">
            <tr> 
|;

$ligUtilisateur{'modif'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: modif,habit -->
<!-- une ligne utilisateur  --> 
<tr align="center"> 
        <td class="couleur">%$rangee[0]%</td>
        <td class="couleur">%$rangee[1]%</td>
        <td class="couleur">%$rangee[2]%</td>
        <td class="couleur">%$rangee[3]%</td>
        <td class="couleur">%$rangee[4]%</td>               
        <td class="texte2"> 
          <table cellspacing="3" cellpadding="0" align="left">
            <tr> 
|;

$ligUtilisateur{'1'} = q|
<!-- Forbidden-to: comptable commercial chefprojet chargeprojet supercommercial -->
<!-- affich_on: habit,mod -->
<!-- pour modifier un utilisateur -->
                     <td>
                        <a href="%$CGIADR%/modifuti.cgi?userid=%$rangee[0]%&username=%$login%&usertype=%$type%&%$ch%">
                    		<img src="%$HTMLADRUNGICONES%/modifier.gif" border="0"></a>
					 </td>
|;

$ligUtilisateur{'2'} = q|
<!-- Forbidden-to: comptable commercial  chefprojet chargeprojet supercommercial -->
<!-- affich_on: habit,supp -->
<!-- supprimer une utilisateur -->
                    <td>	
						<a href="javascript:supputi(%$rangee[0]%,'%$login%','%$type%','%$rangee[5]%','%$ch%');"><img src="%$HTMLADRUNGICONES%/delete.gif" border="0"></a>
				    </td>
|;

$ligUtilisateur{'end'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: habit -->
<!-- fin lignecommande -->      
                </tr>
              </table>
              <!-- fin barre action -->
            </td>
          </tr>
|; 


sub ListeUtilisateurs{	
	my ($type,$login,$orderpcd,$ordersuiv,$nb,$taille, 
               $mess, $reftabAffich,$refpara,$reftab,$reftabuserrole)= @_;
	#on recupere les variables avec les valeurs necc pour l'affichage
    #et on formate les valeurs pour l'affichage 
    my $title =  $titleuser;  
	my $ch = '';	
	($refpara,$ch) = &getParam(%$refpara);
	my %para = %$refpara;
	#faire les listes deroulantes	
    my $popuproletri = &getPopup($reftabuserrole,$para{"userroletri"},"userroletri");
    my $popuptri = &getPopup($reftab, $para{"tri"},"tri");
	#my $onload = '';
	my $onload = exists ($para{'notexiste'}) ? $onloadEcran:'';
    #faire la liste des factures a afficher avec seulement les boutons 
    #que l'utilisateur a le droit de voir
	my %ligUtilisateurDroit=();
    tie %ligUtilisateurDroit,"Tie::IxHash";    
    %ligUtilisateurDroit = &getHashAffich(\%ligUtilisateur,$type);
    #formater la liste des factures a afficher    
    my $liste = &makeListe($reftabAffich,\%ligUtilisateurDroit);
    #construire la page
	my $page = $body.&AffichLig(&affiche_barre($type,\%navigation,'utilisateurs'),$type,$login).$titrePage;
	if($mess){$page .= $messPage;} 
	$page .= $ListeUtilisteur;     
	$page =~ s/%(\$\w+(\{\w*\})?)%/$1/gee;

	$page =~ s/%(\$\w+)%/$1/gee;	 
	&AffichPageWeb($title,$page);
	return;
}





##############################
#creer/modifer un utilisateur
##############################

my $creatUser = q|
<!-- debut  $creatUser -->
	<form method=post action="%$CGIADR%/modifuti.cgi">
	<table width="650" cellpadding="3" cellspacing="1">
	  <tr>
	  	<td class="ligne2" align="left" valign="middle">
	  	    * %$name% :&nbsp;&nbsp;
	  		<input name="usernamemod" type="text" value="%$para{usernamemod}%" size="50">
	  	</td>
	  </tr>
	  <tr>	  
	  	<td class="ligne1" align="left" valign="middle">
	  	  *%$loginname% :&nbsp;&nbsp;
	  		<input name="userloginmod" type="text" value="%$para{userloginmod}%" size="50">
	  	</td>
	  </tr>
	  <tr>	  
	  	<td class="ligne2" align="left" valign="middle">
	  	  * %$wholename% :&nbsp;&nbsp;
	  		<input name="nomcompletmod" type="text" value="%$para{nomcompletmod}%" size="50">
	  	</td>
	  </tr>
	  <tr>
	  	<td class="ligne1" align="left" valign="middle">
	  	   * %$passwd% :&nbsp;&nbsp;
	  		<input name="userpasswdmod" type="password"  value="" size="50">
	  	</td>	  	
	  </tr>
	  <tr>
	  	<td class="ligne2" align="left" valign="middle">
	  		* %$confirmpassword% :&nbsp;&nbsp;
	  		<input name="userpasswdconfirmmod" type="password"   value="" size="50">
	  	</td>
	   </tr>	  
	  <tr>
	  	<td class="ligne1" align="left" valign="middle">
	  	    * %$role% :&nbsp;&nbsp;
	  		%$popuproleuti%
	  	</td>
	  </tr>
	  </table>
	 <table width="650" cellpadding="3" cellspacing="1">
	  <tr>
	   <td class="message" colspan="2">Si le rle est client :</td>
	  <tr>
	  	<td class="ligne1" align="left" valign="middle">
	  	   %$namecli% :&nbsp;&nbsp;
	  	   %$popuplisteclient%
	  	</td>
	  	<td>
	       <a href="%$CGIADR%/clientmodif.cgi?script=modifuti&username=%$login%&usertype=%$type%&%$ch%"><img src="%$HTMLADRUNGICONES%/creercli.gif" border="0"></a>
		  </td>
	  </tr>
	 </table>	 
	 <input type="hidden" name="usertype" value="%$type%">
 	<input type="hidden" name="username" value="%$login%"> 
 	<input type="hidden" name="validercreat" value="10">
 	%$champscaches%
 	<table width="650" cellpadding="0" cellspacing="0">
 		<tr> 
 		  <td valign="bottom" align="left" height="35"> 
 			<input name="validercreat" type="image" border="0" src="%$HTMLADRUNGICONES%/valider.gif">
 		    <span class="texterouge">%$messmod%</span>
 		  </td>	 	
 		</tr>
 	</table>
	</form>   
    <table width="650" cellpadding="0" cellspacing="0">		
 	<tr>
 		<td valign="bottom" align="left" height="35">
 		   <a href="%$CGIADR%/utilisateur.cgi?usertype=%$type%&username=%$login%&%$ch%"><img src="%$HTMLADRUNGICONES%/abandonner.gif" border="0"></a> 	
 		</td>		
 	</tr>	
</table> 
<!-- fin   $creatUser -->|;
	 

my $modifUser = q|
<!-- debut  $modifUser -->
    <table width="650" class="ligne3" cellpadding="3" cellspacing="0">
    <tr> 
      <td  class="texte4" align="left" width="20%">%$id% :</td>
      <td class="textegras">%$userid%</td>
    </tr>
   </table> 
	<form method=post action="%$CGIADR%/modifuti.cgi">
	<table width="650" cellpadding="3" cellspacing="1">
	  <tr>
	  	<td class="ligne2" align="left" valign="middle">
	  	    * %$name% :&nbsp;&nbsp;
	  		<input name="usernamemod" type="text" value="%%$username%%" size="50">
	  	</td>
	  </tr>
	  <tr>	  
	  	<td class="ligne1" align="left" valign="middle">
	  	  *%$loginname% :&nbsp;&nbsp;
	  		<input name="userloginmod" type="text" value="%%$userlogin%%" size="50">
	  	</td>
	  </tr>
	  <tr>	  
	  	<td class="ligne2" align="left" valign="middle">
	  	  * %$wholename% :&nbsp;&nbsp;
	  		<input name="nomcompletmod" type="text" value="%%$nomcomplet%%" size="50">
	  	</td>
	  </tr>
	  <tr>
	  	<td class="ligne1" align="left" valign="middle">
	  	   * %$passwd% :&nbsp;&nbsp;
	  		<input name="userpasswdmod" type="password"  value="" size="50">
	  	</td>	  	
	  </tr>
	  <tr>
	  	<td class="ligne2" align="left" valign="middle">
	  		* %$confirmpassword% :&nbsp;&nbsp;
	  		<input name="userpasswdconfirmmod" type="password"  value="" size="50">
	  	</td>
	   </tr>	  
	  <tr>
	  	<td class="ligne1" align="left" valign="middle">
	  	    * %$role% :&nbsp;&nbsp;
	  		%$popuproleuti%
	  	</td>
	  </tr>
	  </table>
	 <table width="650" cellpadding="3" cellspacing="1">
	  <tr>
	   <td class="message" colspan="2">Si le rle est client :</td>
	  <tr>
	  	<td class="ligne1" align="left" valign="middle">
	  	   %$namecli% :&nbsp;&nbsp;
	  	   %$popuplisteclient%
	  	</td>
	  	<td>
	       <a href="%$CGIADR%/clientmodif.cgi?script=modifuti&boutonnavig=utilisateurs&username=%$login%&usertype=%$type%&userid=%$userid%&%$ch%"><img src="%$HTMLADRUNGICONES%/creercli.gif" border="0"></a>
		  </td>
	  </tr>
	 </table>	 
	 <input type="hidden" name="usertype" value="%$type%">
 	<input type="hidden" name="username" value="%$login%"> 
 	<input type="hidden" name="validermodif" value="10">
 	%$champscache%	
 	<table width="650" cellpadding="0" cellspacing="0">	 	
 		<tr> 
 		  <td valign="bottom" align="left" height="35"> 
 			<input name="validercreat" type="image" border="0" src="%$HTMLADRUNGICONES%/valider.gif">
 		    <span class="texterouge">%$messmod%</span>
 		  </td>	 	
 		</tr>
 	</table>
	</form>  
	%%$listeLigDroit%%
    %%$ajoutdroit%%
    <table width="650" cellpadding="0" cellspacing="0">
 	<tr>
 		<td valign="bottom" align="left" height="35">
 		   <a href="%$CGIADR%/utilisateur.cgi?idmod=%$userid%&usertype=%$type%&username=%$login%&%$ch%"><img src="%$HTMLADRUNGICONES%/retour.gif" border="0"></a>
 		</td>
 	</tr>
</table>
<!-- fin   $modifUser -->|;

########maj des droits pour visionner les taches de l'user maj#############

#########ajouter une tache###########
my $ajoutdroittache = q|
<!--debut ajout droit sur tache -->
<form method="post" action="%$CGIADR%/modifuti.cgi" name="form">
	<table width="650" border="0" cellspacing="0" cellpadding="0" class="ligne3">
      <tr>
        <td align="center">
          <table width="651" cellpadding="0" cellspacing="2">
            <tr>
              <td colspan="8" class="texte4" align="left" height="13">%$adddroit%</td>
            </tr>
            <tr>
              <td colspan="8" class="tetiere" align="left" height="3"></td>
            </tr>
          </table>
          <table width="650" cellpadding="0" cellspacing="0">
            <tr>
              <td>
                <table width="100%" cellspacing="2" cellpadding="0">
                  <tr>
                    <td height="69"  valign="middle" class="texte4" align="left">
                     *&nbsp;%$concerneduser%:
					 	%$popupuserconcerned%
					 </td>
                    <td valign="middle" class="texte4"  align="left">
                      %$libmaj% : %$popupmaj%
                    </td>
					<td valign="middle" class="texte4"  align="left">
                      %$libsupp% : %$popupsupp%
                      </td>
                  </tr>
                </table>
              </td>
              <td valign="middle" width="80" align="center" class="message">
                <input type="image" name="ajouter" src="%$HTMLADRUNGICONES%/ajouter.gif" border="0" width="39" height="30">
                <span class="texterouge">%$messajout%</span> </td>
          </table>
        </td>
      </tr>
    </table>
    <input type="hidden" name="usertype" value="%$type%">
	<input type="hidden" name="username" value="%$login%">
	<input type="hidden" name="ajouter" value="10">
	%$champscache%
	</form>
 <!-- fin ajout droit sur tache -->|;
#########fin ajouter une tache###########

######liste des taches##########
my $enteteligDroit = q|
<!-- debut $enteteligtache -->
<br><br>
    <form method="post" action="%$CGIADR%/modifuti.cgi">
      <table width="650" cellpadding="3" cellspacing="1">
      <tr>
	    <td class="tetiere"  align="center" valign="middle">%$concerneduser%</td>
        <td class="tetiere"  align="center" valign="middle">%$libmaj%</td>
        <td class="tetiere"  align="center" valign="middle">%$libsupp%</td>
        <td class="tetiere"  align="center" valign="middle">%$action%</td>
      </tr>
<!-- fin  $enteteligContact -->|;

my %ligneDroit =();
tie %ligneDroit,"Tie::IxHash";
$ligneDroit{'1'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand -->
<!-- debut $modlig -->
     <TR>
        <TD align="center" valign="middle" class="texte2">%$rangee[1]%</TD>
        <TD align="center" valign="middle" class="texte3">%$rangee[2]% </TD>
        <TD align="center" valign="middle" class="texte2">%$rangee[3]%</TD>
        <!-- barre action -->
        <TD align="center" class="texte2">
          <table>
            <tr>

              <TD align="left" valign="top">
                 <a href="%$CGIADR%/modifuti.cgi?mod=%$rangee[0]%&username=%$login%&usertype=%$type%&%$ch%"><img src="%$HTMLADRUNGICONES%/modifier.gif" border="0"></a>
              </TD>
<!-- fin $modlig -->|;

$ligneDroit{'2'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand, supp -->
<!-- debut supp -->
			  <td align="left" valign="top">
                 <a href="javascript:suppdroit(%$rangee[0]%,'%$login%','%$type%','%$ch%');"><img src="%$HTMLADRUNGICONES%/delete.gif" border="0" align="middle"></a>
              </TD>
<!-- fin  supp -->|;


$ligneDroit{'3'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: stand -->
<!-- debut fin barre action -->
            </TR>
          </table>
        </td>
     </tr>
<!-- fin fin barre action -->|;


$ligneDroit{'4'} = q|
<!-- Restricted-to: anybody -->
<!-- affich_on: mod -->
<!-- debut $modligmod -->
<TR>
	<td colspan="5">
	<table width="100%">
	<tr>
	    <TD align="center" valign="middle">
			%$popup_1%
        </TD>
        <TD align="center" valign="middle">
        	%$popup_2%
        </TD>
        <TD align="center" valign="middle">
			%$popup_3%
        </TD>
        <!-- barre action -->
        <TD align="center">
          <table>
            <tr>
              <TD>
                 <input type="image" name="valide" src="%$HTMLADRUNGICONES%/valider.gif" border="0">
                 <br><span class="texterouge">%$messmod%</span>
                 <input type="hidden" name="valide" value="%$rangee[0]%">
              </TD>
            </TR>
          </table>
        </td>
       </tr>
       </table>
      </td>
        <!-- fin barre action -->
</tr>
<!-- fin $modligmod -->|;


my $finlisteligDroit = q|
<input type="hidden" name="usertype" value="%$type%">
<input type="hidden" name="username" value="%$login%">
%$champscache%
</table>
</form>|;
######fin liste des taches##########

########maj des droits pour visionner les taches de l'user maj#############

#pour creer un utilisateur
sub AffichCreatUser{
	my ($userid,$type,$login,$refpara,$reframenechamps,
    $reftabcli,$reftabuserrole, $reftabuser, $reftabmaj, $reftabsupp,$reflistedroit,$mess) = @_;
    my $ch = '';	
	($refpara,$ch) = &getParam(%$refpara);
	my %para = %$refpara;
	my $champscache = &getHidden(%para) || '';;

	my $title = $titlemoduser;
	my ($client,$roleuti) = @para{"clientidusermod","userrolemod"};
	my $page = $body.&AffichLig(&affiche_barre($type,\%navigation,'utilisateurs'),$type,$login).$titrePage;
	if($mess){$page .= $messPage;}	
	 
	if($userid){;
    	$page .= &modifUser($reframenechamps,$reflistedroit,$type);
    	($client,$roleuti)= @$reframenechamps[3,1];
    }
    else{
    	$page .= &creatUser($refpara);
    }
    my $popuplisteclient = &getPopup($reftabcli,$client,"clientidusermod");
    my $popuproleuti = &getPopup($reftabuserrole,$roleuti,"userrolemod");
    my $popupuserconcerned = &getPopup($reftabuser,0,"useridliajout");
    my $popupmaj = &getPopup($reftabmaj,0,"droitmajajout");
	my $popupsupp = &getPopup($reftabsupp,0,"droitsuppajout");
    #my $onload = '';
	my $onload = exists ($para{'notexiste'}) ? $onloadEcran:'';
    $page =~ s/%(\$\w+\{\w+\})%/$1/gee;
	$page =~ s/%(\$\w+)%/$1/gee;


	#double substitution pour substituer les valeurs de liste
	$page =~ s/%(\$\w+)%/$1/gee;		 
	&AffichPageWeb($title,$page);
    return;   
}


sub creatUser{
	my ($refpara) = @_;
	my %para = %$refpara;
	my $page = $creatUser;
	$page =~ s/%(\$\w+\{\w+\})%/$1/gee;

	return $page;
}

sub modifUser{
	my ($reframenechamps,$reflistedroit,$type) = @_;
	my ($username, $userrole, $userlogin, $clientiduser, $nomcomplet) = @$reframenechamps;
	my $page = $modifUser;
	#on met droit sur taches si ce n'est pas un client
	my $ajoutdroit = '';
	if($clientiduser == -1){$ajoutdroit = $ajoutdroittache;}
    #liste des taches
	my $listeLigDroit = '';
    if(my @lignes = @$reflistedroit){
		my %ligLigneDroit=();
        tie %ligLigneDroit,"Tie::IxHash";
        %ligLigneDroit = &getHashAffich(\%ligneDroit,$type);
        #formater la liste des factures a afficher
        $listeLigDroit = &makeListe($reflistedroit,\%ligLigneDroit);
        $listeLigDroit = $enteteligDroit.$listeLigDroit.$finlisteligDroit;
        $page =~ s/%%\$listeLigDroit%%/$listeLigDroit/;
    }
	$page =~ s/%%(\$\w+)%%/$1/gee;
	return $page;
}

1;

END{}
